#if 0
***************************************************************************
*  Copyright 1985-1992 MetaWare Incorporated.  All rights reserved.	  *
*  This is an unpublished work, Copyright 1985-1992 by MetaWare           *
*  Incorporated.  Use, disclosure, or transfer without the express        *
*  written permission of MetaWare Incorporated is strictly prohibited.	  *
*  If all or part of this source code is incorporated into other source   *
*  code not authored by MetaWare, this copyright notice must          	  *
*  accompany it.							  *
***************************************************************************
*  MetaWare C Validation Suite : See suite0.c for more information.       *
***************************************************************************
#endif
/*
 * $Log: suite1.c,v $
 * Revision 1.17  1992/12/15  23:41:56  pickens
 * Fixed yet another fix to last fix
 *
 * Revision 1.16  1992/12/15  23:41:19  pickens
 * Fixed Tom's last change so that it compiles.
 *
 * Revision 1.15  1992/12/15  21:50:51  tom
 * Corrected \x test.
 *
 * Revision 1.14  1992/08/04  21:12:52  tom
 * *** empty log message ***
 *
 * Revision 1.12  1992/01/28  22:48:30  tom
 * Real check-in of 1.11
 *
 * Revision 1.11  1992/01/28  22:46:17  tom
 * Add 4 regression tests.
 *
 * Revision 1.10  1991/11/06  20:57:34  pickens
 * #ident not handled on SunOS 4.0
 *
 * Revision 1.9  91/09/10  17:15:37  pickens
 * Fixed last fix
 * 
 * Revision 1.8  91/09/10  16:59:45  pickens
 * Turn off "Silent" if argument "nosilent" is passed. Needed for debugging
 * 
 * Revision 1.7  91/07/26  15:16:05  tom
 * Make sure DATE doesn't start with quote (LOC regression test).
 * 
 * Revision 1.6  91/07/15  12:51:18  thomasn
 * setup_new_testlib
 * 
 * Revision 1.5  91/06/14  07:28:31  pickens
 * Restore ANSI compilability
 * 
 * Revision 1.4  91/06/13  15:58:48  tom
 * Restore from DOS version.  All sorts of tabs had been goofed up.
 * Insert the ANNOUNCE changes.
 * 
 * Revision 1.3  91/06/13  15:39:20  tom
 * Restore the nice right edge of *** (who misaligned it?).
 * 
 * Revision 1.2  91/04/04  08:00:11  pickens
 * Undo last change to make it ansi compilable.
 * 
 * Revision 1.1  91/03/29  17:01:09  donw
 * Initial revision
 * 
 */

#include "which.h"      /* Which compiler are we testing? */

#include "globals.h"

#ifdef QUIET
#define ANNOUNCE1(x)
#else
#define ANNOUNCE1(x)  announce(x)
#endif

#ifdef LATTICE
#define Sequence Seqwence	/* Lattice IDs are short. */
#endif

int Oops(char *msg)  {	/* Get type-checking. */
   equal(1,0,msg);
   return False;
   }

static int Called,Call_count,Sequence;

/* Flush is necessary on the 8086 since otherwise fun1 will have address 0 */
/* in small model and thus appear to be the null function.		*/

int dummy = 0;
void static flush() { if (dummy) ANNOUNCE1(""); }
		/* calls to this typically flush optimizers. */

/* Make sure sizeof returns an int -- it's never used for the size of a
   large object, and on some machines (notably 68K CPM C), an int is shorter
   than the result type of sizeof.
   We can't use "sizeof(x) ((int) sizeof(x))" since sometimes x has a comma
   in it, as in "struct {int a,b;}".  Therefore we have to be careful about
   how we use sizeof in this suite to avoid precedence problems.
*/
#define sizeof (int) sizeof

/* identity function. */
int id(i) {return i; }

/*
 * Earlier versions of Sun's OS cannot handle  ".ident" directive in
 * assembly deck.
 */
#if defined HIGHC && !defined _SPARC
#ident "some text"	// Must be supported for AT&T compatibility.
#endif

void fun1() {
   Call_count++;
   Called = 1;
   Sequence++;
   }
void fun2() {
   Call_count++;
   Called = 2;
   Sequence = (Sequence+1)*Called;
   }
void fun3() {
   Call_count++;
   Called = 3;
   Sequence = (Sequence+1)*Called;
   }
void fun4() {
   Call_count++;
   Called = 4;
   Sequence = (Sequence+1)*Called;
   }
int Sequence_value(i1,i2,i3,i4) int i1,i2,i3,i4; {
   /* This is the value of Sequence if the four functions are called in
      the order i1,i2,i3,i4, and if Sequence starts at 0. */
   return (((i1+1)*i2+1)*i3+1)*i4;
   }

void static Local_initialize() {   
   fp1 = fun1;
   fp2 = fun2;
   fp3 = fun3;
   fp4 = 0;
   fp4a = fun4;
   }

static int it1,it2,it3; static unsigned int uit1;
static uchar uct1,uct2; static int *pt1; static schar ct1,ct2;
static long lt1,lt2,lt3;

void linecat_test() {
   /* DON'T CONCATENATE THESE LINES TOGETHER!  It's the purpose of the test! */
   static char *s = "1\
2\
3\
4\
5\
6\
7\
8\
9\
a\
b\
c\
d\
e\
f\
g\
h\
i\
j\
k\
l\
m\
n\
o\
p";
   long i\
j\
k\
l\
m\
n\
o\
p\
q\
r\
s\
t    = 0\
x0\
0\
0\
0\
0\
0\
0\
0\
1\
2\
3\
4\
5\
6\
7\
8;
   ANNOUNCE1("Line concatenation.");
   equal(strcmp(s,"123456789abcdefghijklmnop"),0,"\\str");
  lequal(ijklmnopqrst,0x12345678,"\\int");
   }

void strcat_test() {
   static char *s2 = "abc" "def";
   #if !_LOC
   /* Old, bogus test: */
   /* static char *s  = "\01" "2" "\x3" "45"; */
   /* equal(strcmp(s,"\0012\x00345"),0,"scat 1"); */
   /* Octal is limited to 3, but hex is not. */
   static char *s  = "\01" "2" "\x45"; 
   equal(strcmp(s,"\0012\x000000000000000000000000045"),0,"scat 1"); 
   #endif
   equal(strcmp(s2,"abcdef"),0,"scat 2");
   }

/* static char *Lstring = L"wide string"; */
static char Lchar = L'c';              
#define ENDING_IN_L "ab"
static char *Lstring2 = ENDING_IN_L"other string";
#if 0	/* L's in skipped text as well. */
static char *Lstring = L"wide string"; 
static char Lchar = L'c';              
#endif

/************************************************************************** 
 * In previous ANSI drafts, it was possible to #define reserved words.    * 
 * This has been taken out.  I'm leaving the tests in here for now, since * 
 * I expect the committee will be surprised when they find this out and   * 
 * will want the ability back in the standard.			          * 
 * .... Update:  this ability was reinstated. 			          * 
 **************************************************************************/

static int P2(int i, int j, int k) { return i+j+k; } /* For below. */

void pp_test() {
   ANNOUNCE1("Test preprocessor.");
   /* Ensure no recursion in the preprocessor.	*/
   /* Additionally, test whitespace before & after #. */
			#			define f(x) ((x)+3)
   equal(f(f(4)),10,"f");
#	undef f
   /* Same test, but use reserved words. */
#define int(struct) ((struct)+3)
   equal(int(int(4)),10,"int/struct");
#undef int
#define f 3
   equal(f,3,"redef");
#undef f
			  #define f(x) x
   {int f = 3;	/* since no (), shouldn't expand. */
   equal(f,3,"noparms");
   equal(f(4),4,"noparms2");
#undef f
# /* comments are allowed
  */ define /* in many interesting
  places */ f /*
  in a define */ (g*2)
#define g (f*3)
   equal(f,18,"recurs");
#undef g
   }
#undef f
#		ifdef f
   equal(1,0,"undef");
#else
   equal(1,1,"undef");
#endif
   it1 = 33;
#define it1 22
   equal(it1,22,"#it1");
#undef it1
			#define it1 it1
   equal(it1,33,"recur macro");
#undef it1
   {
 # define int(struct) (++(struct))
   int j = 1;
   int i = int(j);	/* i = ++j. */
   int k = 2;		/* Dcln of k. */
   int(k);		/* Looks like a dcln?  It's not.  ++k. */
   equal(k,3,"int/k");
#ifdef int	/* Make sure can use keywords here. */
#endif
#undef int
   /* After expansion the replacement text should be considered with
    * the rest of the input. 
    */
#define f1 g1
#define g1(x) (x+3)
   equal(f1(3),6,"f1g1");
#undef f1   
#undef g1
   }
#define void 1
#if void
   equal(1,1,"#void");
#else
   equal(1,0,"#void");
#endif
#define int ==
#define if y
#define y 2
#if y int 2 
   equal(1,1,"#int");
#else
   equal(1,1,"#int");
#endif        
#if struct	/* Not currently defined. */
   equal(1,0,"#struct");
#else
   equal(1,1,"#struct");
#endif
#undef int
#undef y
#undef if
#undef void
#define m(a) int a 
   {
   m(
#if notdefined
   a,,,,,,,,
#else
   b
#endif
   );
   int c = b;
#undef m  
#define P2(x,y) x ## y
#define P3(x,y,z) x ## y ## z
   P3(i,n,t) i = P2(P,3)(1,2,3);
   equal(i,123,"P2/P3");
   /* P2(p,2) should stop expansion with P2 and call the function instead. */
   equal(P2(P,2)(1,2,3),6,"P2(1,2,3)");
   }
#undef P2
#undef P3
   }

void sharp_test() {
#define str(a) #a 
#define str2(a) str(a)
#define paste(a,b,c)  a ## b ## c 
#define debug(s,t) printf("x" # s "= %d, x" #t "= %s",x ## s,x ## t) 
#define INCFILE(n) vers ## n
#define glue(a,b) a ## b
#define glue2(a,b) glue(a, b)
#define HIGHLOW "hello"
#define LOW LOW ", world"
#define StrE(a,b) equal(strcmp(a,b)==0,True,b)
   glue(i,nt) voidint = 3;
   ANNOUNCE1("Test # and ##.");
   equal(glue(void,int) glue(!,=) 3, False, "g!=");
   StrE(str(hi  there (sportsfans+3)), "hi there (sportsfans+3)");
   StrE(str(#),"#");
   StrE(str2(paste(x,y,z)),"xyz");
   /* LOC only: The spacing might be off slightly here:  check the standard. */
   StrE(str2(debug(1,2)),str(printf("x" "1" "= %d, x" "2" "= %s",x1,x2)));
   StrE(str(strncmp("abc\0d", "abc", '\4') /* this goes away */ 
   		== 0) str(: @\n), 
   		"strncmp(\"abc\\0d\", \"abc\", '\\4') == 0" ": @\n");
   StrE(str2(INCFILE(2).h),"vers2.h");
   StrE(glue(HIGH,LOW),"hello");
   StrE(glue2(HIGH,LOW),"hello" ", world");
   /* The c and d get glued, but not the a b or e f. */
   StrE(str2(glue(a b c, d e f)),"a b cd e f"); 
#define G "goodbye " G
#define L L " world"
#define GL "cruel"
   StrE(glue(G,L),"cruel");
   StrE(glue2(G,L),"goodbye cruel world");
#define F H
#define H(x) x*F
   /*
    * !x--- means to not expand macro named x in the region of 
    * text underscored by the -s:     
    *
    * str2(F(x)(y)) -> str(H(x)(y)) -> str(x*F(y)) -> str(x*H(y)) -> 
    *   	         !F-             !H---          !H---
    * str(x*H(y)) => "x*H(y)" 
    */
   StrE(str2(F(x)(y)),"x*H(y)");
   /* Awful stuff, but possible:  construct FP or hex numbers from
    * pieces:
    */
   dequal(glue2(glue2(1,.),glue2(e,3)),1.e3,.01,"ppnums1");
   equal(glue2(glue2(0,x),glue2(3e3,1)),0x3e31,"ppnums2");
   equal(glue2(0x0,abc),0xabc,"ppnums3");
   StrE("3.x.e+3.",str(3.x.e+3.));
#undef str
#undef str2
#undef paste
#undef debug
#undef INCFILE
#undef glue
#undef glue2
#undef HIGHLOW 
#undef LOW 
#undef G
#undef L
#undef F
#undef H
#undef HL
   /* Regression testing. */
#define foo(x,y) x+y
   /* Don't delete the blank line above foo(). */
#ifdef not_defined

	foo();
#endif
   }	

/* Trigraphs are an ugly addition to the standard as a concession
 * to deficient character sets.
 */
#pragma On(Trigraphs);
void trigraph_test() {
   static char * s1 = "abc?\
?=";
   ??=define XYZ
   ??=ifdef XYZ
   static char *s2 = "abc??/
??=";
   #endif
   ??=undef XYZ
   static char *s3 = "??=??(??/x20??)??'??<??!??>??-????/"";
   ANNOUNCE1("Test trigraphs.");
   StrE(s1,"abc?" "?=");
   StrE(s2,"abc#");
   StrE(s3,"#[\x20]^{|}~??\"");
   equal('??=','#',"??=");
   }
#undef StrE

plus_plus () {
   register char **p;
   static char *a[] = {"1","2","3"};
   p = a;     
   *p++ = "s1";
   *p++ = "s2";
   *p++ = "s3";
   /* Regression test: ensure increment of reg var for 386. */
   equal(strcmp(a[0],"s1"),0,"p++");
   equal(strcmp(a[1],"s2"),0,"p++");
   equal(strcmp(a[2],"s3"),0,"p++");
   }

void assign_test() {
   ANNOUNCE1("Test assignment.");
   plus_plus();
   it3 = (it1 = i1) + (it1 = i2);
   equal(it3==i1+i2 || it3==i1+i1 || it3==i2+i2, True, "i=(=)(=)");
   equal((it1==i1) || (it1 == i2), True,"...");
   /* convert from signed to wider signed down to narrow unsigned. */
   equal(uct2 = it2 = c2, uc2, "uc=i=c");
   equal(it2 == i2, True,"...");
   uct2 = (it1 = i1) + (it1 = i2);
   equal(uct2==((i1+i2)&0xff) || uct2==((i1+i1)&0xff) || uct2==((i2+i2)&0xff), 
		1, "i=(=)(=)");
   equal((c2 = ui2) == c2, True, "(c=u)==c");
   Call_count = 0;
#ifdef HIGHC
   it1 = ((*fp1)(),it2) = ((*fp2)(),it3) = ((*fp3)(),it3) = i1;
#else
   /* ANSI standard no longer allows comma operator to yield an lvalue. */
   fp1(),fp2(),fp3();
   it1 = it2 = it3 = it3 = i1;
#endif
   equal((it1==it2) && (it2 == it3) && (it3 == i1),True,"i==i==i==i");
   equal(Call_count,3,"3 calls");
   it1 = uct1 = Neg;
   /* it1 shouldn't get Neg, but rather the value stored into uct1: */
   equal(it1,uct1,"it=uc=neg");
   }

/* The type is the type of the rightmost expression.  The mode is
   the mode of the rightmost expression.
*/
void comma_test() {
   int temp;
   ANNOUNCE1("Test comma operator.");
/* The standard used to support comma expressions as lvalues, but this has changed.
   Hence I've commented the tests out.  High C supports it, however.
*/      
#if COMMA_AS_LVALUE || defined(HIGHC)
   equal((i1,i2)==i2, True, "i1,i2");
   equal((ui1,ui2)==ui2, True, "ui1,ui2");
#ifndef LATTICE /* Bug in lattice 2.14 */
   equal((f1,f2)==f2, True, "f1,f2");
   equal((d1,d2)==d2, True, "d1,d2");
#endif
   equal((c1,c2)==c2, True, "c1,c2");
   equal((l1,l2)==l2, True, "l1,l2");
   equal((ul1,ul2)==ul2,True,"ul1,ul2");
#endif   
   Call_count = Sequence = 0;
   temp = (fp1(),fp2(),fp3(),fp4a(),i1);
   equal(temp,i1,"fpi,*");
   equal(Call_count,4,"fpi,*");
   /* Ensure left-to-right evaluation: */
   equal(Called,4,"fpi,*");
   equal(Sequence,Sequence_value(1,2,3,4),"fpi,*");
      {
      /* Not all compiler can initialize auto arrays, so we make apf static. */
      static void (*apf[])() = {fun1,fun2,fun3,fun4,0};
      void auto (**ptr)() = apf;
      Sequence = 0;
      for (; *ptr != 0;) (**ptr++)();
      equal(Sequence,Sequence_value(1,2,3,4),"apf loop");
      }
   /* Ensure no over-optimization. */
   i1,i3,ul4==f2,(*fp2)(),fp3,i1&&i2;
   equal(Called,2,", stmt");
#ifdef HIGHC
   /* ANSI standard no longer allows comma operator to yield an lvalue. */
   ((*fp3)(),i2) += 1;
#else
   (*fp3)(), (i2) += 1;
#endif
   equal(i2,s2+1,", +=");
   equal(i2 == us2+1,sizeof(i2) == sizeof(us2),", +=");
   i2--;
   equal(Called,3,", +=");
   /* Be sure that nested commas aren't mistaken as arguments. */
   equal((1,2,3),(4,5,3),",,,");
   }

/* Conditional expressions.
 * E1 ? E2 : E3:  E1 must be scalar; result type is Common(TE2,TE3)
 * if TE2 and TE3 are arithmetic, or TE2 if TE2 = TE3, or if one is
 * a pointer type and the other a constant expression evaluating to 0,
 * then the pointer type, or if both are similar types, then either
 * type.  The mode of the result is value.
 */

void ce_test() {
   ANNOUNCE1("Test conditional expressions.");
   equal(f1?1:2, 1, "?float 1");
   equal(f4?1:2, 2, "?float 0");
   equal(p1?1:2, 1, "?ptr 1");
   equal(p4?1:2, 2, "?ptr 0");
   equal(*(i1?p1:p2), *p1, "*?ptr 1");
   equal(*(i4?p1:p2), *p2, "*?ptr 2");
   equal((i4?p1:0) == 0, True, "?ptr1= 0");
   equal((i4?0:p1) == 0, False, "?ptr2= 0");
   /* Ensure the right sign from the two expressions: */
   equal((i1?i2:ui1) < 0, False, "?=>unsigned");
   equal((i1?i2:i2) < 0, True, "?=>signed");
   /* Should be able to have function pointers as parts of cond exprs. */
   (i1?fp1:fp2)();
   equal(Called,1,"?fcn ptr");
   (i4?fp1:fp2)();
   equal(Called,2,"?fcn ptr");
   equal_struct(uc1?str1:str2, str1, "? struct");
#ifndef MSC	/* MSC code generator bombs on this one. */
   /* structure select from ?: */
   equal((uc1?str3:str4).x,str3.x,"? struct.x");
#endif
   equal((i4 ? i1 : ui4 ? i1 : f1 ? f2 : f2) == f2, True, "?: cascaded");
   (i4 ? i1 : ui4 ? i1 : f1 ? f2 : f2) == f2;
   /* Test stack-pop deferral in tricky conditionals. */
   equal(  (id(1) || id(2) ? id(4) : id(5))
	 + (id(0) || id(1) ? id(4) : id(5)), /* 8 */
	   (id(0) ? id(1) : id(0)) ? id(1) : id(2)*4, "||?:?:");
   /* Complicated test to ensure no basic block breakage. */
   {uchar uc5 = 'c';
l: equal(uc5 + ((uc5 >= 'a' && uc5 <= 'z') || (uc5 == 'd')),
	 'd' - ((uc5 >= 'd' && uc5 <= 'x') || (uc5 == 'e')),"+?:=?:");
   }
   }

/* Sequential disjunction.  Each operand must be a scalar.  The type of the
   result is Signed-Int.  The mode is value.
*/
void disj_test() {
   ANNOUNCE1("Test sequential disjunction.");
   equal(i1 || i2, True, "|| i");
   equal(ui1 || ui2, True, "|| ui");
   equal(f1 || f2, True, "|| f");
   equal(d1 || d2, True, "|| d");
   equal(c1 || c2, True, "|| c");
   equal(l1 || l2, True, "|| l");
   equal(ul1 || ul2, True, "|| ul");
   equal(ul4 || l2, True, "|| ul 2");
   /* Be sure not to call a function: */
   equal(ul3 || Oops("|| fcn oops"), True, "|| fcn");
   equal(array[c1 || l4],*p1,"[||] 1");
   equal(array[c4 || l4],*p0,"[||] 0");
   /* Ensure the result is Signed-Int instead of Unsigned-Int. */
   equal((ui1 || ui2) > -1, True, "|| > ");
   i1 || i2 || f1 || f2 || fp1;
   equal(0 || 0 || fp1, True, "|| fp");
   { int a=0,b=0,c=1,d=2;
L: (a=b++) || (a=c++) || (a=d++);
   equal(a,1,"|| =");
   equal(b,1,"|| =");
   equal(c,2,"|| =");
   equal(d,2,"|| =");
   }
   { /* Over-optimization. */
   int i = 1;
L2:(i == 1) || i++;	/* if (i != 1) i++; */
   equal(i,1,"i&&i");
   }    
   }

/* Sequential conjunction.  Each operand must be a scalar.  The type of the
   result is Signed-Int.  The mode is value.
*/
void conj_test() {
   ANNOUNCE1("Test sequential conjunction.");
   equal(i1 && i2, True, "&& i");
   equal(ui1 && ui2, True, "&& ui");
   equal(f1 && f2, True, "&& f");
   equal(d1 && d2, True, "&& d");
   equal(c1 && c2, True, "&& c");
   equal(l1 && l2, True, "&& l");
   equal(ul1 && ul2, True, "&& ul");
   equal(ul4 && l2, False, "&& ul 2");
   /* Be sure not to call a function: */
   equal(ul4 && Oops("&& fcn oops"), False, "&& fcn");
   equal(array[c1 && l2],*p1,"[&&] 1");
   equal(array[c1 && f4],*p0,"[&&] 0");
   /* Ensure the result is Signed-Int instead of Unsigned-Int. */
   equal((ui1 && ui2) > -1, True, "&& > ");
   i1 && i2 && f1 && f2 && fp1;
   equal(1 && 1 && fp1, True, "&& fp");
   { int a=0,b=0,c=0,d=1;
L: (a=++b) && (a=c++) && (a=d++);
   equal(a,0,"&& =");
   equal(b,1,"&& =");
   equal(c,1,"&& =");
   equal(d,1,"&& =");
   }
   {int i = 1;
   /* Problem caused by over-optimization. */
   if (i++ && 0) i = 3;
   equal(i,2,"&&0");
   }
   { /* Once again, over-optimization. */
   int i = 1;
L2:(i == 0) && i++;	/* if (i == 0) i++; */
   equal(i,1,"i&&i");
   }    
   }

/* Bit-wise or.  Each operand must be integral.  The type of the
   result is the common type of the two operands.  The mode is value.
*/
void bit_or() {
   ANNOUNCE1("Test bit-wise or.");
   equal(i1 | i2, OR, "| i");
   equal(uc1 | uc2, OR & 0xff, "| uc");
   equal( c1 |	c2, OR , "| c");
   equal(ui1 | ui2, OR, "| ui");
   lequal(l1 | l2, (long int)OR, "| l");
   /* Ensure unsigned or signed result type: */
   equal((i1 | i2) > 0, False, "| > i");
   equal((ui1 | ui2) > 0, True, "| > ui");
   /* Test various mixtures to ensure proper optimization. */
   equal(i2 | uc2, i2, "| ui c");
   equal(i2 | c2, i2, "| i c");
   equal(c2 | uc2, c2, "| c uc");       /* Must extend with ones. */
  lequal((long)ui2 | i2,(long)i2,"| ui i");
  lequal((long)(ui2 | i2),(long)ui2,"| ui i");

   equal(uc1 | 0xff, 0xff, "| c ff");
   equal( c2 | 0xff, -1, "| c ff");
   equal(i1 | 0xff00, Pos | 0xff00, "| i ff00");
  lequal(ul2 | 0xfe00, (long)Neg | 0xfe00, "| l fe00");
   /* Test for any improper optimizations on in-memory operations. */
   lt1 = l1;
   lt1 |= 0x100001;	/* Could do two byte-ors. */
  lequal(lt1,l1 | 0x100001,"l |=");
   }

/* Bit-wise xor.  Each operand must be integral.  The type of the
   result is the common type of the two operands.  The mode is value.
*/
void bit_xor() {
   ANNOUNCE1("Test bit-wise xor.");
   equal(i1 ^ i2, XOR, "^ i");
   equal(uc1 ^ uc2, XOR & 0xff, "^ uc");
   /* This next test assumes signed char. */
   equal( c1 ^	c2, XOR , "^ c");
   equal(ui1 ^ ui2, XOR, "^ ui");
   lequal(l1 ^ l2, (long int)XOR, "^ l");
   /* Ensure unsigned or signed result type: */
   equal((i1 ^ i2) > 0, False, "^ > i");
   equal((ui1 ^ ui2) > 0, True, "^ > ui");

   equal(uc1 ^ 0xff, (Pos ^ 0xff) & 0xff, "^ c ff");
   equal( c1 ^ 0xff, Pos ^ 0xff, "^ c ff");
   equal(i1 ^ 0xff00, Pos ^ 0xff00, "^ i ff00");
  lequal(ul2 ^ 0xfe00, (long)Neg ^ 0xfe00, "^ l fe00");
   lt1 = l1;
   lt1 ^= 0xff00001;	 /* Could do two byte-ops. */
  lequal(lt1,l1 ^ 0xff00001,"l ^=");
   }

/* Bit-wise and.  Each operand must be integral.  The type of the
   result is the common type of the two operands.  The mode is value.
*/
void bit_and() {
   ANNOUNCE1("Test bit-wise and.");
   equal(i1 & i2, AND, "& i");
   equal(uc1 & uc2, AND & 0xff, "& uc");
   /* This next test assumes signed char. */
   equal( c1 &	c2, AND , "& c");
   equal(ui1 & ui2, AND, "& ui");
   lequal(l1 & l2, (long int)AND, "& l");
   /* Ensure unsigned or signed result type: */
   equal(-(i1 & i2) > 0, False, "& > i");
   equal(-(ui1 & ui2) > 0, True, "& > ui");
   /* Test various mixtures to ensure proper optimization. */
   equal(i2 & uc2, uc2, "& ui c");      /* Upper byte(s) killed due to uc2. */
   equal(i2 & c2, i2, "& i c");         /* c2 sign-extends with ones. */
  lequal((long)ui2 & i2,(long)ui2,"& ui i"); /* ui2 kills the sign. */
  lequal(l2 & i2,l2,"& l i");           /* i2 sign-extends with ones. */

   equal(uc1 & 0xff, uc1, "& c ff");
   equal( c1 & 0xff, uc1, "& c ff");
   equal(i1 & 0xff00, Pos & 0xff00, "& i ff00");
  lequal(ul2 & 0xfe00, (long)Neg & 0xfe00, "& l fe00");
   lt1 = l2;
   lt1 &= 0xff00001;	 /* Can't do two byte-ops. */
  lequal(lt1,l2 & 0xff00001,"l &=");
   if (sizeof(long) > sizeof(short int) && sizeof(short int) == 2) {
      long l=0x0000ffff; short int i=0xffff;
      flush();	
      /* The comparison below CANNOT be optimized into comparing the
         low two bytes of l1 with i, as some compilers (incorrectly) do.
         The comparison is done in longint, and (longint)i == ffff_ffff,
         which does not equal l.
      */   
      equal((l & 0xffff) == i,False,"l&C==i");
      }   	
   {static long ll = -1;
    /* Regression testing: 16-bit HC. */
    long mask;
    mask = 0xffff0000;
    if (ll & mask) equal(1,1,"mask"); else equal(1,0,"mask");
    if (ll & mask) equal(1,1,"mask"); else equal(1,0,"mask");
    mask = 0x0000ffff;
    if (ll & mask) equal(1,1,"mask"); else equal(1,0,"mask");
    if (ll & mask) equal(1,1,"mask"); else equal(1,0,"mask");
    if (ll & 0xffff) equal(1,1,"mask"); else equal(1,0,"mask");
    if (ll & 0xffff0000) equal(1,1,"mask"); else equal(1,0,"mask");
    }
   }

/* equality operators:	Both must be arithmetic, or pointers to similar types,
   or one a pointer and the other 0.
   Result is Signed-Int.
*/
void equality_ops() {
   ANNOUNCE1("Equality operators");
   equal(i1==i2,False,"== i1");
   equal(f1==d1,True,"== d");
   equal(f1==d2,False,"== d");
#ifndef LATTICE
   equal(f1==f1,True,"== f");
#endif
   equal(f1==f2,False,"== f");
   equal(ui1==i1,True,"== u/i");
   /* Conversion from unsigned long to float should preserve the large value. */
   /* Some implementations instead do a signed conversion.	*/
   equal(ul2==fli2,False,"== u/f");
   equal(ul1==fli1,True,"== u/f");
#if !_I860      /* 860 doesn't support unsigned long to double. */
   {double d1; uli l1;
   d1 = Big_uli;	/* Doubles should be able to hold biggest unsigned long. */
l: l1 = d1;		/* Force optimizer to forget...*/
   equal(l1==Big_uli,True,"== l1 uli");
   }
#endif
   equal(l2==fli2,True,"== s/f");
   equal(p1==0,False,"== p");
   equal(p1==p2,False,"== p");
   equal(p4==0,True,"== *f");
   equal(fp1==0,False,"== *fp");
   equal(fp4==0,True,"== *fp");
   /* The operators are left-associative. */
   equal(i1==i2==0, True,"== ==");
   equal(i1==ui1==1, True,"== ==");
   /* Result is signed.  Comparison would be < -1 if unsigned.	*/
   equal((i1==ui1) > -1, True,"== >");

   /* This must not use a byte comparison, since one is signed and the	*/
   /* other unsigned.  Conversion must be done to int.			*/
   equal(uc2==c2,False,"uc==c");
   equal((ui2&0xff)==uc2,True,"ui==uc");
   equal(c2==l2,True,"c==l");
   equal(c2==i2,True,"c=i");
   /* These are equal only if of the same size. */
   equal(ui2==l2,sizeof(l2) == sizeof(ui2),"ui==l");
   equal(us2==i2,sizeof(us2) == sizeof(i2),"us==i");
   /* Probably integers will be wider than chars, but...! */
   equal(ui2==uc2,sizeof(ui2) == sizeof(uc2),"ui==uc");
   equal( i2==uc2,sizeof(i2) == sizeof(uc2),"i=uc");
   equal(ui2==ul2,sizeof(ui2) == sizeof(ul2), "ui==ul");
   equal(i2==l2,True,"i==l");

   equal(i1!=i2,True,"!= i1");
   equal(f1!=d1,False,"!= d");
   equal(f1!=d2,True,"!= d");
#ifndef LATTICE
   equal(f1!=f1,False,"!= f");
#endif
   equal(f1!=f2,True,"!= f");
   equal(ui1!=i1,False,"!= u/i");
   /* Conversion from unsigned long to float should preserve the large value. */
   /* Some implementations instead do a signed conversion.	*/
/* We don't support uflt conversion yet. */
/* equal(ul2!=fli2,True,"!= u/f");     */
/* equal(ul1!=fli1,False,"!= u/f");      */
   equal(l2!=fli2,False,"!= s/f");
   equal(p1!=0,True,"!= p");
   equal(p1!=p2,True,"!= p");
   equal(p4!=0,False,"!= *f");
   equal(fp1!=0,True,"!= *fp");
   equal(fp4!=0,False,"!= *fp");
   /* The operators are left-associative. */
   equal(i1!=i2!=0, True,"!= !=");
   equal(i1!=ui1!=1, True,"!= !=");
   /* Result is signed.  Comparison would be < -1 if unsigned.	*/
   equal((i1!=ui2) > -1, True,"!= >");
   }

/* This tests some boundary cases for optimization against compares
   with 0, 1, or -1.  The High C x86 compiler often can use INC or DEC
   rather than the more expensive CMP instruction to do the compare.
*/

void Boundary_inequalities(Lo,Hi) int Lo,Hi; {
#define e(x,y) equal(x,y,Loc)
   char *Loc = "Boundaries";
   long int li; int i;
   Silent++;
   for (i = Lo;;) {
      e(int_ident(i) >	0, i >	0);
      e(int_ident(i) >= 0, i >= 0);
      e(int_ident(i) <	0, i <	0);
      e(int_ident(i) <= 0, i <= 0);
      e(int_ident(i) == 0, i == 0);
      e(int_ident(i) != 0, i != 0);

      e(int_ident(i) >	1, i >	1);
      e(int_ident(i) >= 1, i >= 1);
      e(int_ident(i) <	1, i <	1);
      e(int_ident(i) <= 1, i <= 1);
      e(int_ident(i) == 1, i == 1);
      e(int_ident(i) != 1, i != 1);

      e(int_ident(i) >	-1, i >  -1);
      e(int_ident(i) >= -1, i >= -1);
      e(int_ident(i) <	-1, i <  -1);
      e(int_ident(i) <= -1, i <= -1);
      e(int_ident(i) == -1, i == -1);
      e(int_ident(i) != -1, i != -1);
      /* C for-loops aren't really for-loops.
	 "for i := 32766 to 32767" fails.
      */
      if (i == Hi) break; else i++;
      }
   for (li = Lo; li <= Hi; li++) {
      e(longint_ident(li) >  0, li >  0);
      e(longint_ident(li) >= 0, li >= 0);
      e(longint_ident(li) <  0, li <  0);
      e(longint_ident(li) <= 0, li <= 0);
      e(longint_ident(li) == 0, li == 0);
      e(longint_ident(li) != 0, li != 0);

      e(longint_ident(li) >  1, li >  1);
      e(longint_ident(li) >= 1, li >= 1);
      e(longint_ident(li) <  1, li <  1);
      e(longint_ident(li) <= 1, li <= 1);
      e(longint_ident(li) == 1, li == 1);
      e(longint_ident(li) != 1, li != 1);

      e(longint_ident(li) >  -1, li >  -1);
      e(longint_ident(li) >= -1, li >= -1);
      e(longint_ident(li) <  -1, li <  -1);
      e(longint_ident(li) <= -1, li <= -1);
      e(longint_ident(li) == -1, li == -1);
      e(longint_ident(li) != -1, li != -1);
      }
   Silent--;
   }

/* inequality operators:  Both must be arithmetic, or pointers to similar types.
   Comparison of pointers is done with unsigned arithmetic.
   Result is Signed-Int.
*/
void inequality_ops() {
   ANNOUNCE1("Inequality operators");
   Boundary_inequalities(-2,2);
   /* Remember, 32768 is long int, and so is -32768. */
   Boundary_inequalities((int)-32768,-32767);
   Boundary_inequalities(32766,32767);
   equal(i1>=i2,True ,">= i1");
   equal(f1>=d1,True ,">= d 1");
   equal(f1>=d2,True ,">= d 2");
#ifndef LATTICE
   equal(f1>=f1,True ,">= f 1");
#endif
   equal(f1>=f2,True ,">= f 2");
   equal(ui1>=i1,True,">= u/i");
   equal(i1>=i2,!(i1<i2) ,">= i1!");
   equal(f1>=d1,!(f1<d1),">= d!");
   equal(f1>=d2,!(f1<d2),">= d!");

   /* Watch for operand swapping on comparisons (a previous bug). */
   equal(10 <= i1,10 <= Pos,"10<=i");
   equal(i1 <= 10,Pos <= 10,"i<=10");
   equal(10 <= i2,10 <= Neg,"10<=i");
   equal(i2 <= 10,Neg <= 10,"i<=10");

#ifndef LATTICE /* Avoid lattice bug. */
   equal(f1>=f1,!(f1<f1),">= f!");
#endif
   equal(f1>=f2,!(f1<f2),">= f!");
   equal(ui1>=i1,!(ui1<i1),">= u/i!");
   { /* regression */ 
    static unsigned long x = 0x10000;
    equal(x > 0xffffL,True,"x>0xffff");
   }
   /* left-associative: */
   equal(1 <= 2 <= 1, True, "<= <=");
   equal(i2 < i1 < (l2 > l1), False, "<<>");
   equal(ui2 > ui1, True, "ui>ui");
   equal(ui2 > i1, True, "ui > i");
   equal(c2 < c1, True, "c < c");
   equal(uc2 > uc1, True, "uc > uc");
   equal((unsigned) uc2 > uc1, True, "uc > uc");
   equal(ul2 > l1, True, "ul > l");
   equal(p1>p2,False,"p>p");
   equal(p3<p4,False,"p<p");
   /* Result is signed.  Comparison would be < -1 if unsigned.	*/
   equal((i1>i1) > -1, True,">= >");
   equal( (i1 < i1) <= (i1 < i1) <= (l1 < l1) <= (d1 < d1), True, "<=<=<=<=");
   /* UP rules use unsigned compare; VP rules use signed compare. */
#define UP 0    /* Old UNIX compilers used unsignedness-preserving. */
   equal(uc1 > -1, !UP, "uc > -1");
   /* Clever single-compare test for a character in the range 0..9: */
   for (uct1 = '0'-2; uct1 <= '9'+2; uct1++) {
#if UP
      equal(uct1 - '0' <= 9, (unsigned) (uct1 - '0') <= 9, "uc-<=");
			     /* ^^ tests if uct1 is in set {'0'..'9'}. */
#else
      equal(uct1 - '0' <= 9, (int) uct1 - '0' <= 9, "uc-<=");
#endif
      }
   /* Check for some over-optimizations. */
   equal(uc2 > Pos, True, "uc > pos");
   /* int compare required for VP rules;
      if unsigned byte compare is used the answer is wrong. */
   equal(uc2 < -Neg+1, UP, "uc > -");
   /* Requires int; signed byte comparison produces wrong answer
      since 129 looks negative. */
   equal( c1 < 129, Pos < 129, "c < 129");
   }

/* shift operators:  First is widened; second converted to signed-int.
   Result is the widened type of the first.
*/
void shift_ops(){
   int small = 3, medium = 5, zero = 0;
   ANNOUNCE1("Shift operators");
   /* Left-associative: */
   equal(i1 << 1 << 2, i1 << 3, "<< <<");
   equal(i1 >> 1 >> 2, i1 >> 3, ">> >>");
   equal(i1 << small << medium, i1 << (small+medium), "<< <<");
   lequal(ul2 << small << medium, ul2 << (small+medium), "<< <<");
   equal(i1 << zero,i1,"<< 0");
   equal(i1 << 0, i1, "<< 0");
   /* Result type is the widened type of argument 1. */
   /* Must do an unsigned comparison: */
   equal((ui2 << 1) < 0, False, "<< <");
   equal((i2 << 1) < 0, True, "<< <");
   /* Right shift must 0-fill on unsigned. */
   equal((ui2 >> 8) < 0, False, "<< >");        /* Knows that top bit of uc2 is on */
   equal(ui2 >> (sizeof(ui2)*8-1), 1, ">> = 1");
   /* No guarantee that right shifting of signeds drags the sign bit. */
   /* Unsigned shift left must be the same as multiplication. */
   equal(i1 << 3, i1*8, "<< *");
   equal((ct1 = (i2 >> sizeof(i2)*8-8)) < 0, True, "= >> <");
   equal(uct1 = (i2 >> sizeof(i2)*8-8), 0xff, "= >>");
   it2 = 0x808f;
   equal(uct1 = (i2 >> 3), (i2 >> 3) & 0xff, "= >> >> &");
   /* Ensure that any optimization doesn't shift only lower byte. */
   equal(uct1 = (it2 >> 3), (it2 >> 3) & 0xff, "= >> >> &");
   lt1 = l2;
   lt1 <<= 3;
  lequal(lt1,l2 << 3,"l &=");
   }

/* additive operators:	Both can be arithmetic => common type;
   One is pointer and the other an integer => pointer type -- the pointer
   type must not point to a fcn;
   both similar pointer types and the operator is - => implementation-defined
   integer type.
*/
long ffff() { return 0xffffL; }
long _10000() { return 0x10000L; }
void additive_ops() {
   ANNOUNCE1("Additive operators");
   /* Result of pointer subtraction must be signed, not unsigned. */
   equal((p1-p2) <= -1, True, "- >");
   equal((p1+1)==p2,True,"p+");
   /* Result must be unsigned if one operand is.	*/
   equal((ui2-i2)-1 < 0, False, "- - 0");
   equal(i2+i2,Neg+Neg,"+");
   equal(uct1 = (i1+i2), (i1+i2)&0xff, "= +");
   equal(uct1 = (l1+l2), (int) ((l1+l2)&0xff) ,"c=l+l");
   equal(d1+d1 < d1, False, "d+d<d");
   equal(d1*2.2 > f1, True, "d+d>f");
   equal(d1 > us2, False, "d>us");
   equal(d1 > i2, True, "d>i");
   equal(it1 = uct1 = c1+c1, (c1+c1)&0xff, "i=c=c+c");
  lequal((uli)(uct1=ul2),ul2&0xff,"c=ul");
   /* ++s must be done immediately to get the successive three values. */
   /* THIS TEST MAY BE ERRONEOUS.  The std allows all the increments to */
   /* occur at the ",", so *p1*3 is a valid answer. */
   pt1 = p1;
#if 0 /*No longer valid test */
   equal(*pt1++ + *pt1++ + *pt1++,*p1+*p2+*p3,"p+p+p");
#endif
   {int a[10],*p1 = &a[5],*p2 = &a[7];
    struct odd {char a,b,c;} b[10], *q1 = &b[5], *q2 = &b[7];
    struct pow2 {int a,b,c,d;} c[10], *r1 = &c[5], *r2 = &c[7];
    typedef char *cp; typedef cp x1; typedef x1 x2;
    char ch[2]; x2 c1 = &ch[0], c2 = &ch[1];
    struct {char a[32768];} *s32,*s33=s32+1;
forget_everything:
   equal(p1-p2,-2,"p1-p2");
   equal(p2-p1, 2,"p2-p1");
   equal(q1-q2,-2,"q1-q2");
   equal(q2-q1, 2,"q2-q1");
   equal(r1-r2,-2,"r1-r2");
   equal(r2-r1, 2,"r2-r1");
   equal(c2-c1, 1,"cp-");
  lequal((char *)s33-(char*)s32,32768L,"s32");
   }
   {
   /* On 16-bit machines such as the 8088, ensure that half of the add/sub to
      a long is not optimized to an "inc" or "dec" that does not 
      contribute to the carry (thus fouling up the other half of the add/sub).
   */
   long j = ffff() + 1;
  lequal(j,0x00010000L,"+opt"); 	
   j = _10000() - 1;
  lequal(j,0x0000FFFFL,"+opt"); 	
   }   	
   }

void regptr() {
   ANNOUNCE1("Regptr");
   /* The motivation behind this simple test is potential optmization on
      the 8088 for register variables that just happen to land in si
      and di.  "movsw" can be emitted instead of "mov ax,[si]; inc si,2".
      This also tests whether the post-increment is forgotten or not.
   */   	
   /* Ensure that register variables are incremented appropriately after
      use.  This is a separate function to ensure that the variables get
      allocated to a register if the compiler supports it. */
   {   
   static int x1[]={1,2}, x2[]={3,4};
   register int *p1=x1,*p2=x2;
   *p1++=*p2++;
   equal(p1==&x1[1],True,"p1++"); 
   equal(p2==&x2[1],True,"p2++"); 
L1:equal(x1[0],3,"x1[0]");
   }
   {   
   static char x1[]={1,2}, x2[]={3,4};
   register char *p1=x1,*p2=x2;
   *p1++=*p2++;
   equal(p1==&x1[1],True,"p1++"); 
   equal(p2==&x2[1],True,"p2++"); 
L2:equal(x1[0],3,"x1[0]");
   }
   /* Change order of declaration.  A decent compiler should allocate
      p1 and p2 below on top of the previous two. */
   {   
   static int x1[]={1,2}, x2[]={3,4};
   register int *p2=x2,*p1=x1;
   *p1++=*p2++;
   equal(p1==&x1[1],True,"p1++"); 
   equal(p2==&x2[1],True,"p2++"); 
L3:equal(x1[0],3,"x1[0]");
   }
   /* Change order of declaration.  A decent compiler should allocate
      p1 and p2 below on top of the previous two. */
   {   
   static char x1[]={1,2}, x2[]={3,4};
   register char *p2=x2,*p1=x1;
   *p1++=*p2++;
   equal(p1==&x1[1],True,"p1++"); 
   equal(p2==&x2[1],True,"p2++"); 
L4:equal(x1[0],3,"x1[0]");
   }
   }

static void test_char_asn() {
   /* Make sure that "char" doesn't get hidden by typedefs. */
   typedef char tchar;
   static tchar x[] = "1";
   typedef const tchar zchar;
   static zchar z[] = "1";
   }

void file_line_time() {
   char *f = __FILE__, *t = __TIME__, *d = __DATE__;
   char buf[250];  /* Allow space for replicates of file name. */
#if defined(NUMPROC) || defined(STANDALONE)
#define check(m,mptr) equal(strcmp(m,mptr)==0,1,"check" m)	
#else
#define check(m,mptr) {\
      sprintf(buf,"xyz%sxyz%sxyz",m,mptr); \
      equal(strcmp("xyz" m "xyz" m "xyz",buf)==0,1,"check" m);	}
#endif
   check(__FILE__,f);
   check(__TIME__,t);
   check(__DATE__,d);
   equal(*__DATE__ != '\"',True,"date1");
#undef check   
   }	

void main (argc,argv)
   int argc; char *argv[];
   {
   int i, lineno = __LINE__;
   announce("**** START OF TESTS, suite1 ****");
   Initialize();
   Local_initialize();
   ANNOUNCE1("__LINE__:");
   equal(__LINE__,lineno+5,"lineno");
   /*
    * Turn off Silent if argument "nosilent" is present
    */
   if (argc>1 && strcmp(argv[1],"nosilent")==0) Silent = 0;
#ifndef STANDALONE
   ANNOUNCE1("Argv test:");
   /* ANSI requires a null pointer at the end of the list of ptrs. */
   equal(argv[argc]==0,True,"argv");
#endif
   linecat_test();
   strcat_test();
   pp_test();
   sharp_test();
   trigraph_test();
   assign_test();
   comma_test();
   ce_test();
   disj_test();
   conj_test();
   bit_or();
   bit_xor();
   bit_and();
   equality_ops();
   inequality_ops();
   shift_ops();
   additive_ops();
   regptr();
   file_line_time();
   printf("Consider testing the large number of defines.\n");
   ANNOUNCE1("**** END OF TESTS, suite1 ****");
   exit(0);
   }
/* Make sure we can take lotsa defines. */
#define X1 1
#define X2 2
#define X3 3
#define X4 4
#define X5 5
#define X6 6
#define X7 7
#define X8 8
#define X9 9
#define X10 10
#define X11 11
#define X12 12
#define X13 13
#define X14 14
#define X15 15
#define X16 16
#define X17 17
#define X18 18
#define X19 19
#define X20 20
#define X21 21
#define X22 22
#define X23 23
#define X24 24
#define X25 25
#define X26 26
#define X27 27
#define X28 28
#define X29 29
#define X30 30
#define X31 31
#define X32 32
#define X33 33
#define X34 34
#define X35 35
#define X36 36
#define X37 37
#define X38 38
#define X39 39
#define X40 40
#define X41 41
#define X42 42
#define X43 43
#define X44 44
#define X45 45
#define X46 46
#define X47 47
#define X48 48
#define X49 49
#define X50 50
#define X51 51
#define X52 52
#define X53 53
#define X54 54
#define X55 55
#define X56 56
#define X57 57
#define X58 58
#define X59 59
#define X60 60
#define X61 61
#define X62 62
#define X63 63
#define X64 64
#define X65 65
#define X66 66
#define X67 67
#define X68 68
#define X69 69
#define X70 70
#define X71 71
#define X72 72
#define X73 73
#define X74 74
#define X75 75
#define X76 76
#define X77 77
#define X78 78
#define X79 79
#define X80 80
#define X81 81
#define X82 82
#define X83 83
#define X84 84
#define X85 85
#define X86 86
#define X87 87
#define X88 88
#define X89 89
#define X90 90
#define X91 91
#define X92 92
#define X93 93
#define X94 94
#define X95 95
#define X96 96
#define X97 97
#define X98 98
#define X99 99
#define X100 100
#define X101 101
#define X102 102
#define X103 103
#define X104 104
#define X105 105
#define X106 106
#define X107 107
#define X108 108
#define X109 109
#define X110 110
#define X111 111
#define X112 112
#define X113 113
#define X114 114
#define X115 115
#define X116 116
#define X117 117
#define X118 118
#define X119 119
#define X120 120
#define X121 121
#define X122 122
#define X123 123
#define X124 124
#define X125 125
#define X126 126
#define X127 127
#define X128 128
#define X129 129
#define X130 130
#define X131 131
#define X132 132
#define X133 133
#define X134 134
#define X135 135
#define X136 136
#define X137 137
#define X138 138
#define X139 139
#define X140 140
#define X141 141
#define X142 142
#define X143 143
#define X144 144
#define X145 145
#define X146 146
#define X147 147
#define X148 148
#define X149 149
#define X150 150
#define X151 151
#define X152 152
#define X153 153
#define X154 154
#define X155 155
#define X156 156
#define X157 157
#define X158 158
#define X159 159
#define X160 160
#define X161 161
#define X162 162
#define X163 163
#define X164 164
#define X165 165
#define X166 166
#define X167 167
#define X168 168
#define X169 169
#define X170 170
#define X171 171
#define X172 172
#define X173 173
#define X174 174
#define X175 175
#define X176 176
#define X177 177
#define X178 178
#define X179 179
#define X180 180
#define X181 181
#define X182 182
#define X183 183
#define X184 184
#define X185 185
#define X186 186
#define X187 187
#define X188 188
#define X189 189
#define X190 190
#define X191 191
#define X192 192
#define X193 193
#define X194 194
#define X195 195
#define X196 196
#define X197 197
#define X198 198
#define X199 199
#define X200 200
#define X201 201
#define X202 202
#define X203 203
#define X204 204
#define X205 205
#define X206 206
#define X207 207
#define X208 208
#define X209 209
#define X210 210
#define X211 211
#define X212 212
#define X213 213
#define X214 214
#define X215 215
#define X216 216
#define X217 217
#define X218 218
#define X219 219
#define X220 220
#define X221 221
#define X222 222
#define X223 223
#define X224 224
#define X225 225
#define X226 226
#define X227 227
#define X228 228
#define X229 229
#define X230 230
#define X231 231
#define X232 232
#define X233 233
#define X234 234
#define X235 235
#define X236 236
#define X237 237
#define X238 238
#define X239 239
#define X240 240
#define X241 241
#define X242 242
#define X243 243
#define X244 244
#define X245 245
#define X246 246
#define X247 247
#define X248 248
#define X249 249
#define X250 250
#define X251 251
#define X252 252
#define X253 253
#define X254 254
#define X255 255
#define X256 256
#define X257 257
#define X258 258
#define X259 259
#define X260 260
#define X261 261
#define X262 262
#define X263 263
#define X264 264
#define X265 265
#define X266 266
#define X267 267
#define X268 268
#define X269 269
#define X270 270
#define X271 271
#define X272 272
#define X273 273
#define X274 274
#define X275 275
#define X276 276
#define X277 277
#define X278 278
#define X279 279
#define X280 280
#define X281 281
#define X282 282
#define X283 283
#define X284 284
#define X285 285
#define X286 286
#define X287 287
#define X288 288
#define X289 289
#define X290 290
#define X291 291
#define X292 292
#define X293 293
#define X294 294
#define X295 295
#define X296 296
#define X297 297
#define X298 298
#define X299 299
#define X300 300
#define X301 301
#define X302 302
#define X303 303
#define X304 304
#define X305 305
#define X306 306
#define X307 307
#define X308 308
#define X309 309
#define X310 310
#define X311 311
#define X312 312
#define X313 313
#define X314 314
#define X315 315
#define X316 316
#define X317 317
#define X318 318
#define X319 319
#define X320 320
#define X321 321
#define X322 322
#define X323 323
#define X324 324
#define X325 325
#define X326 326
#define X327 327
#define X328 328
#define X329 329
#define X330 330
#define X331 331
#define X332 332
#define X333 333
#define X334 334
#define X335 335
#define X336 336
#define X337 337
#define X338 338
#define X339 339
#define X340 340
#define X341 341
#define X342 342
#define X343 343
#define X344 344
#define X345 345
#define X346 346
#define X347 347
#define X348 348
#define X349 349
#define X350 350
#define X351 351
#define X352 352
#define X353 353
#define X354 354
#define X355 355
#define X356 356
#define X357 357
#define X358 358
#define X359 359
#define X360 360
#define X361 361
#define X362 362
#define X363 363
#define X364 364
#define X365 365
#define X366 366
#define X367 367
#define X368 368
#define X369 369
#define X370 370
#define X371 371
#define X372 372
#define X373 373
#define X374 374
#define X375 375
#define X376 376
#define X377 377
#define X378 378
#define X379 379
#define X380 380
#define X381 381
#define X382 382
#define X383 383
#define X384 384
#define X385 385
#define X386 386
#define X387 387
#define X388 388
#define X389 389
#define X390 390
#define X391 391
#define X392 392
#define X393 393
#define X394 394
#define X395 395
#define X396 396
#define X397 397
#define X398 398
#define X399 399
#define X400 400
#define X401 401
#define X402 402
#define X403 403
#define X404 404
#define X405 405
#define X406 406
#define X407 407
#define X408 408
#define X409 409
#define X410 410
#define X411 411
#define X412 412
#define X413 413
#define X414 414
#define X415 415
#define X416 416
#define X417 417
#define X418 418
#define X419 419
#define X420 420
#define X421 421
#define X422 422
#define X423 423
#define X424 424
#define X425 425
#define X426 426
#define X427 427
#define X428 428
#define X429 429
#define X430 430
#define X431 431
#define X432 432
#define X433 433
#define X434 434
#define X435 435
#define X436 436
#define X437 437
#define X438 438
#define X439 439
#define X440 440
#define X441 441
#define X442 442
#define X443 443
#define X444 444
#define X445 445
#define X446 446
#define X447 447
#define X448 448
#define X449 449
#define X450 450
#define X451 451
#define X452 452
#define X453 453
#define X454 454
#define X455 455
#define X456 456
#define X457 457
#define X458 458
#define X459 459
#define X460 460
#define X461 461
#define X462 462
#define X463 463
#define X464 464
#define X465 465
#define X466 466
#define X467 467
#define X468 468
#define X469 469
#define X470 470
#define X471 471
#define X472 472
#define X473 473
#define X474 474
#define X475 475
#define X476 476
#define X477 477
#define X478 478
#define X479 479
#define X480 480
#define X481 481
#define X482 482
#define X483 483
#define X484 484
#define X485 485
#define X486 486
#define X487 487
#define X488 488
#define X489 489
#define X490 490
#define X491 491
#define X492 492
#define X493 493
#define X494 494
#define X495 495
#define X496 496
#define X497 497
#define X498 498
#define X499 499
#define X500 500
#define X501 501
#define X502 502
#define X503 503
#define X504 504
#define X505 505
#define X506 506
#define X507 507
#define X508 508
#define X509 509
#define X510 510
#define X511 511
#define X512 512
#define X513 513
#define X514 514
#define X515 515
#define X516 516
#define X517 517
#define X518 518
#define X519 519
#define X520 520
#define X521 521
#define X522 522
#define X523 523
#define X524 524
#define X525 525
#define X526 526
#define X527 527
#define X528 528
#define X529 529
#define X530 530
#define X531 531
#define X532 532
#define X533 533
#define X534 534
#define X535 535
#define X536 536
#define X537 537
#define X538 538
#define X539 539
#define X540 540
#define X541 541
#define X542 542
#define X543 543
#define X544 544
#define X545 545
#define X546 546
#define X547 547
#define X548 548
#define X549 549
#define X550 550
#define X551 551
#define X552 552
#define X553 553
#define X554 554
#define X555 555
#define X556 556
#define X557 557
#define X558 558
#define X559 559
#define X560 560
#define X561 561
#define X562 562
#define X563 563
#define X564 564
#define X565 565
#define X566 566
#define X567 567
#define X568 568
#define X569 569
#define X570 570
#define X571 571
#define X572 572
#define X573 573
#define X574 574
#define X575 575
#define X576 576
#define X577 577
#define X578 578
#define X579 579
#define X580 580
#define X581 581
#define X582 582
#define X583 583
#define X584 584
#define X585 585
#define X586 586
#define X587 587
#define X588 588
#define X589 589
#define X590 590
#define X591 591
#define X592 592
#define X593 593
#define X594 594
#define X595 595
#define X596 596
#define X597 597
#define X598 598
#define X599 599
#define X600 600
#define X601 601
#define X602 602
#define X603 603
#define X604 604
#define X605 605
#define X606 606
#define X607 607
#define X608 608
#define X609 609
#define X610 610
#define X611 611
#define X612 612
#define X613 613
#define X614 614
#define X615 615
#define X616 616
#define X617 617
#define X618 618
#define X619 619
#define X620 620
#define X621 621
#define X622 622
#define X623 623
#define X624 624
#define X625 625
#define X626 626
#define X627 627
#define X628 628
#define X629 629
#define X630 630
#define X631 631
#define X632 632
#define X633 633
#define X634 634
#define X635 635
#define X636 636
#define X637 637
#define X638 638
#define X639 639
#define X640 640
#define X641 641
#define X642 642
#define X643 643
#define X644 644
#define X645 645
#define X646 646
#define X647 647
#define X648 648
#define X649 649
#define X650 650
#define X651 651
#define X652 652
#define X653 653
#define X654 654
#define X655 655
#define X656 656
#define X657 657
#define X658 658
#define X659 659
#define X660 660
#define X661 661
#define X662 662
#define X663 663
#define X664 664
#define X665 665
#define X666 666
#define X667 667
#define X668 668
#define X669 669
#define X670 670
#define X671 671
#define X672 672
#define X673 673
#define X674 674
#define X675 675
#define X676 676
#define X677 677
#define X678 678
#define X679 679
#define X680 680
#define X681 681
#define X682 682
#define X683 683
#define X684 684
#define X685 685
#define X686 686
#define X687 687
#define X688 688
#define X689 689
#define X690 690
#define X691 691
#define X692 692
#define X693 693
#define X694 694
#define X695 695
#define X696 696
#define X697 697
#define X698 698
#define X699 699
#define X700 700
#define X701 701
#define X702 702
#define X703 703
#define X704 704
#define X705 705
#define X706 706
#define X707 707
#define X708 708
#define X709 709
#define X710 710
#define X711 711
#define X712 712
#define X713 713
#define X714 714
#define X715 715
#define X716 716
#define X717 717
#define X718 718
#define X719 719
#define X720 720
#define X721 721
#define X722 722
#define X723 723
#define X724 724
#define X725 725
#define X726 726
#define X727 727
#define X728 728
#define X729 729
#define X730 730
#define X731 731
#define X732 732
#define X733 733
#define X734 734
#define X735 735
#define X736 736
#define X737 737
#define X738 738
#define X739 739
#define X740 740
#define X741 741
#define X742 742
#define X743 743
#define X744 744
#define X745 745
#define X746 746
#define X747 747
#define X748 748
#define X749 749
#define X750 750
#define X751 751
#define X752 752
#define X753 753
#define X754 754
#define X755 755
#define X756 756
#define X757 757
#define X758 758
#define X759 759
#define X760 760
#define X761 761
#define X762 762
#define X763 763
#define X764 764
#define X765 765
#define X766 766
#define X767 767
#define X768 768
#define X769 769
#define X770 770
#define X771 771
#define X772 772
#define X773 773
#define X774 774
#define X775 775
#define X776 776
#define X777 777
#define X778 778
#define X779 779
#define X780 780
#define X781 781
#define X782 782
#define X783 783
#define X784 784
#define X785 785
#define X786 786
#define X787 787
#define X788 788
#define X789 789
#define X790 790
#define X791 791
#define X792 792
#define X793 793
#define X794 794
#define X795 795
#define X796 796
#define X797 797
#define X798 798
#define X799 799
#define X800 800

