#if 0
*********************************************************************
* Copyright 1985-1992 MetaWare Incorporated.  All rights reserved.  *
* This is an unpublished work by MetaWare Incorporated.  Use,       *
* disclosure, or transfer without the express written permission of *
* MetaWare Incorporated is strictly prohibited.  If all or part of  *
* this source code is incorporated into other source code not       *
* authored by MetaWare, this copyright notice must accompany it.    *
*********************************************************************
   See suite0.c for more information.
#endif
#ifndef lint
static const char rcsid[] = "$Header: /sun3/tlib/suite_c/RCS/suite2.c,v 1.20 1994/01/21 23:04:37 miker Exp $";
#endif
/* $Log: suite2.c,v $
 * Revision 1.20  1994/01/21  23:04:37  miker
 * make correction to unsigned bit field
 * test for CSPI, i860 big endian.
 *
 * Revision 1.19  1992/12/14  23:48:44  tom
 * True
 *
 * Revision 1.18  1992/12/14  23:48:10  tom
 * (void*)0 is like 0.
 *
 * Revision 1.17  1992/08/27  20:25:47  pickens
 * _HOBBIT is now ABI in bitfield mapping
 *
 * Revision 1.16  1992/08/18  16:21:31  pickens
 * Add _SOL to list of bit-field alignment
 * ,.
 * ,
 *
 * Revision 1.15  1992/08/04  21:12:31  tom
 * *** empty log message ***
 *
 * Revision 1.13  1992/03/26  17:36:32  pickens
 * Permit suite2 to compile under GOC with _LOC defined.
 *
 * Revision 1.12  1991/12/12  00:01:53  pickens
 * Fixed 68020 failiure
 *
 * Revision 1.11  1991/12/05  21:14:27  tom
 * fix bs4 test for att 860
 *
 * Revision 1.10  1991/12/04  19:34:30  pickens
 * Modify test to conform to PCC bit-field mapping
 *
 * Revision 1.9  1991/10/15  21:34:47  thomasn
 * LOC no longer fails
 *
 * Revision 1.8  1991/10/04  23:09:58  tom
 * Add test
 *
 * Revision 1.7  1991/09/25  19:44:07  donw
 * Fixed up tab problem
 *
 * Revision 1.6  1991/09/19  22:08:21  pickens
 * Turn off Silent if argument present so we can test
 *
 * Revision 1.5  1991/09/19  21:43:13  pickens
 * Removed spurious "pragma warning_level(3)"
 *
 * Revision 1.4  1991/09/19  19:35:35  donw
 * Fixed the stack probelm, got rid of some warnnings, added macro ANNOUNCE
 *
 * Revision 1.3  91/07/15  12:51:24  thomasn
 * setup_new_testlib
 *
 * Revision 1.2  91/04/09  09:33:55  jeronimo
 * Conditionalized test LOC fails.
 *
 * Revision 1.1  91/03/29  17:02:44  donw
 * Initial revision
 */

/* Which compiler are we testing? */
#include "which.h"
#include "globals.h"

#ifdef QUIET
#define ANNOUNCE(x)
#else
#define ANNOUNCE(x) announce(x)
#endif

char *time1 = __TIME__;

void static dummy() { }

/* Make sure sizeof returns an int -- it's never used for the size of a
   large object, and on some machines (notably 68K CPM C), an int is shorter
   than the result type of sizeof.
   We can't use "sizeof(x) ((int) sizeof(x))" since sometimes x has a comma
   in it, as in "struct {int a,b;}".  Therefore we have to be careful about
   how we use sizeof in this suite to avoid precedence problems.
*/
#define sizeof (int) sizeof

void xequal(i1, i2, msg,i)
   long i1, i2; char *msg; int i;
   {
   char oops;
   ++Testcount;
   if (!Silent || i1 != i2) {
#ifndef STANDALONE
      printf("Test # %3d (%13.13s) i1=%8lx i2=%8lx %s\n",
     	Testcount, msg, i1, i2, (oops = (i1 != i2)) ? "fail <--" : "OK");
      if (oops) printf("Test vector #%x failed.\n",i);
#else
      WMSG("Test "); WMSG(msg); WMSG(": "); PW(Testcount);
      WMSG(" i1="); PW(i1); WMSG(" i2="); PW(i2);
      WMSG(i1 != i2 ? "  fail <--" : "  OK");
      EOL();
      if (oops) WMSG("Test vector #%x failed.\n",i);
#endif
      }
   }

#if _SGL
#define OLAY(x)
#endif

OLAY("O1")
/* multiplicative operators:  Both can be arithmetic => common type;
   additionally, for %, both must be integral.
   Convert both operands to the common type, then perform the operation.
*/
void multiplicative_ops() {
   uchar uct1,uct2;

   ANNOUNCE("Multiplicative operators.");
   equal(i1*i2,Pos*Neg,"i*i");
   equal(i1*c1,Pos*Pos,"i*c");
   /* Two ints should be multiplied and the result should be int. */
   equal(c1*c2,Pos*Neg,"c*c");
   /* But here the result should be truncated.          */
   uct1 = c1*c2;
   equal(uct1,(Pos*Neg)&0Xff,"c=c*c");  /* Be sure upper-case X ok. */
  lequal(l1*l2,Pos * (long)Neg, "l*l+-");
  lequal(l1*l1,Pos * (long)Pos, "l*l++");
  lequal(l1*c2, l1*l2, "l*c");
#define SMALL 19   /* 65535 is not divisible by this. */
   uct2 = SMALL;
   equal(i1/i2,Pos/Neg,"i/i");
   equal(i1/c1,Pos/Pos,"i/c");
   /* Two ints should be divided and the result should be int.      */
   equal(c1/c2,Pos/Neg,"c/c");
   /* But here the result should be truncated.          */
   uct1 = Big_ui/uct2;
   equal(uct1,(Big_ui/SMALL)&0Xff,"c=c/c");
   uct1 = Big_uli/uct2;
   equal(uct1,(int)((Big_uli/SMALL)&0xff),"c=i/c");
  lequal(l1/l2,Pos / (long)Neg, "l/l+-");
  lequal(Big_li/l1,Big_li/Pos, "l/l++");
  lequal(Big_li/l2,Big_li/Neg, "l/l+-");
  lequal(l1/l1,Pos / (long)Pos, "l/l++");
  lequal(Big_li/c2, Big_li/l2, "l/c");
   /* Test divide by small powers of 2.  Shifting right isn't quite right */
   /* when the dividend is negative; one must compensate.     */
   equal(i2/2,Neg/2,"i/2");
   equal(i2/4,Neg/4,"i/4");
   equal(i2/8,Neg/8,"i/8");
   equal(i2/16,Neg/16,"i/16");
   equal(i1/2,Pos/2,"i/2");
   equal(i1/4,Pos/4,"i/4");
   equal(i1/8,Pos/8,"i/8");
   equal(i1/16,Pos/16,"i/16");
   /* Test same for unsigned ints. */
   equal(ui2/2,((unsigned)Neg)/2,"ui/2");
   equal(ui2/4,((unsigned)Neg)/4,"ui/4");
   equal(ui2/8,((unsigned)Neg)/8,"ui/8");
   equal(ui2/16,((unsigned)Neg)/16,"ui/16");
   equal(ui1/2,Pos/2,"ui/2");
   equal(ui1/4,Pos/4,"ui/4");
   equal(ui1/8,Pos/8,"ui/8");
   equal(ui1/16,Pos/16,"ui/16");

   /* Test same for longs. */
  lequal(l2/2,(long)Neg/2,"l/2");
  lequal(l2/4,(long)Neg/4,"l/4");
  lequal(l2/8,(long)Neg/8,"l/8");
  lequal(l2/16,(long)Neg/16,"l/16");
  lequal(l1/2,(long)Pos/2,"l/2");
  lequal(l1/4,(long)Pos/4,"l/4");
  lequal(l1/8,(long)Pos/8,"l/8");
  lequal(l1/16,(long)Pos/16,"l/16");
  lequal(ul2/2,(uli)Neg/2,"ul/2");
  lequal(ul2/4,(uli)Neg/4,"ul/4");
  lequal(ul2/8,(uli)Neg/8,"ul/8");
  lequal(ul2/16,(uli)Neg/16,"ul/16");
  lequal(ul1/2,(uli)Pos/2,"ul/2");
  lequal(ul1/4,(uli)Pos/4,"ul/4");
  lequal(ul1/8,(uli)Pos/8,"ul/8");
  lequal(ul1/16,(uli)Pos/16,"ul/16");

   uct2 = SMALL;
   equal(i1%i2,Pos%Neg,"i%i");
   equal(i1%c1,Pos%Pos,"i%c");
   /* Two ints should be mod-ed and the result should be int.     */
   equal(c1%c2,Pos%Neg,"c%c");
   /* But here the result should be truncated.          */
   uct1 = Big_ui%uct2;
   equal(uct1,(Big_ui%SMALL)&0xff,"c=c%c");
   uct1 = Big_uli%uct2;
   equal(uct1,(int)((Big_uli%SMALL)&0xff),"c=c%c");
  lequal(l1%l2,Pos % (long)Neg, "l%l+-");
  lequal(Big_li%l1,Big_li%Pos, "l%l++");
  lequal(Big_li%l2,Big_li%Neg, "l%l+-");
  lequal(l1%l1,Pos % (long)Pos, "l%l++");
  lequal(Big_li%c2, Big_li%l2, "l%c");

   /* Test relationship between % and /        */
   uct2 = SMALL;
   equal(i1%i2,Pos - (Pos/Neg)*Pos,"i%i vs -/*");
   equal(i1%c1,Pos - (Pos/Pos)*Pos,"i%c vs -/*");
   /* Two ints should be mod-ed and the result should be int.     */
   equal(c1%c2,Pos - (Pos/Neg)*Neg,"c%c vs -/*");
   equal(Big_i%c2, Big_i - (Big_i/c2)*c2,"Bigi%c vs -/*");
   /* But here the result should be truncated.          */
   uct1 = Big_ui%uct2;
   equal(uct1,(Big_ui - (Big_ui/SMALL)*SMALL)&0xff,"c=ui%c vs -/*");
   uct1 = Big_uli%uct2;
   equal(uct1,(int)((Big_uli - (Big_uli/SMALL)*SMALL)&0xff),"c=uli%c vs -/*");
  lequal(l1%l2,Pos - ((long)Pos/Neg)*Neg, "l%l+- vs -/*");
  lequal(Big_li%l1,Big_li - (Big_li/Pos)*Pos, "l%l++ vs -/*");
  lequal(Big_li%l2,Big_li - (Big_li/Neg)*Neg, "l%l+- vs -/*");
   /* Should be negative of above: */
  lequal((-Big_li)%l2,-(Big_li - (Big_li/Neg)*Neg), "l%l-- vs -/*");
  lequal(l2%l1, l2 - (l2/Pos)*Pos, "l%l-+ vs -/*");
  lequal(l1%l1,Pos - ((long)Pos/Pos)*Pos, "l%l++ vs -/*");
  lequal(Big_li%c2, Big_li - (Big_li/l2)*l2, "l%c vs -/*");

  lequal(l2%2,(long)Neg%2,"l%2");
  lequal(l2%4,(long)Neg%4,"l%4");
  lequal(l2%8,(long)Neg%8,"l%8");
  lequal(l2%16,(long)Neg%16,"l%16");
  lequal(l1%2,(long)Pos%2,"l%2");
  lequal(l1%4,(long)Pos%4,"l%4");
  lequal(l1%8,(long)Pos%8,"l%8");
  lequal(l1%16,(long)Pos%16,"l%16");
  lequal(ul2%2,(uli)Neg%2,"ul%2");
  lequal(ul2%4,(uli)Neg%4,"ul%4");
  lequal(ul2%8,(uli)Neg%8,"ul%8");
  lequal(ul2%16,(uli)Neg%16,"ul%16");
  lequal(ul1%2,(uli)Pos%2,"ul%2");
  lequal(ul1%4,(uli)Pos%4,"ul%4");
  lequal(ul1%8,(uli)Pos%8,"ul%8");
  lequal(ul1%16,(uli)Pos%16,"ul%16");
   /* MetaWare compilers combine div-rem where the hardware supports it; i.e.  */
   /* x = a / b; y = a % b; causes only one division.  Check that this is done  */
   /* properly.                          */
   {int x1,x2; long y1,y2;
   x1 = Big_i / 10; x2 = Big_i % 10;
   equal(Big_i,x1*10+x2,"/% 1");
   x1 = Big_i / Neg; x2 = Big_i % Neg;
   equal(Big_i,x1*Neg+x2,"/% 2");
   x1 = Big_i / Pos; x2 = Big_i % Pos;
   equal(Big_i,x1*Pos+x2,"/% 3");
   x1 = Big_i / Big_c; x2 = Big_i % Big_c;
   equal(Big_i,x1*Big_c+x2,"/% 4");

   y1 = Big_li / Big_c; y2 = Big_li % Big_c;
  lequal(Big_li,(long)y1*Big_c+y2,"/% 5");
   y1 = Big_li / 10; y2 = Big_li % 10;
  lequal(Big_li,(long)y1*10+y2,"/% 6");
   y1 = Big_li / Neg; y2 = Big_li % Neg;
  lequal(Big_li,(long)y1*Neg+y2,"/% 7");
   y1 = Big_li / Pos; y2 = Big_li % Pos;
  lequal(Big_li,(long)y1*Pos+y2,"/% 8");

   {uli y1,y2;
   y1 = Big_uli / Big_c; y2 = Big_uli % Big_c;
  lequal(Big_uli,y1*Big_c+y2,"/% 9");
   y1 = Big_uli / 10; y2 = Big_uli % 10;
  lequal(Big_uli,y1*10+y2,"/%10");
   y1 = Big_uli / Neg; y2 = Big_uli % Neg;
  lequal(Big_uli,y1*Neg+y2,"/%11");
   y1 = Big_uli / Pos; y2 = Big_uli % Pos;
  lequal(Big_uli,y1*Pos+y2,"/%12");
   }

   x1 = Big_c / 10; x2 = Big_c % 10;
   equal(Big_c,x1*10+x2,"/%13");
   x1 = Big_uc / 10; x2 = Big_uc % 10;
   equal(Big_uc,x1*10+x2,"/%14");
   x1 = Big_c / Neg; x2 = Big_c % Neg;
   equal(Big_c,x1*Neg+x2,"/%15");
   x1 = Big_uc / Neg; x2 = Big_uc % Neg;
   equal(Big_uc,x1*Neg+x2,"/%16");
   x1 = Big_c / Pos; x2 = Big_c % Pos;
   equal(Big_c,x1*Pos+x2,"/%17");
   x1 = Big_uc / Pos; x2 = Big_uc % Pos;
   equal(Big_uc,x1*Pos+x2,"/%18");
   }
   {
   /* Regression test. */
   static long l1 = 7;
   l1 *= -1;
  lequal(l1,-7L,"l*=");
   }
   /* Ensure that no incorrect signedness or optimization is done for */
   /* non-int divisions -- e.g., using signed division when unsigned is */
   /* called for. */
   {
#define NEG (-21)
   unsigned char  uc = NEG;
     schar        sc = NEG;
   unsigned short us = NEG;
            short ss = NEG;
   unsigned int   ui = NEG;
            int   si = NEG;
   uli            ul = NEG;
            long  sl = NEG;
Forget: ;       /* For some code generators. */
   equal(uc / 4, 0x3a, "uc/");
   equal(uc % 4,    3, "uc%");
   equal(sc / 4,   -5, "sc/");
   equal(sc % 4, sc - (NEG / 4)*4, "sc%");
   equal(us / 4, (unsigned short)NEG / 4, "us/");
   equal(us % 4, (unsigned short)NEG % 4, "us%");
   equal(ss / 4,   -5, "ss/");
   equal(ss % 4, ss - (NEG / 4)*4, "ss%");
   equal(ui / 4, (unsigned int)NEG / 4, "ui/");
   equal(ui % 4, (unsigned int)NEG % 4, "ui%");
   equal(si / 4,   -5, "si/");
   equal(si % 4, si - (NEG / 4)*4, "si%");
  lequal(sl / 4,   -5L, "sl/");
  lequal(sl % 4, sl - (NEG / 4)*4, "sl%");
  lequal(ul / 4, (unsigned long)NEG / 4, "ul/");
  lequal(ul % 4, (unsigned long)NEG % 4, "ul%");
   }
#undef NEG
   }

more_multiplicative_ops() {
   /* Test long division. */
/* Macros to compute signed and unsigned long division at compilation time. */
#define SD(l1,l2) ((long)l1/(long)l2)
#define UD(l1,l2) ( (uli)l1/ (uli)l2)
#define SR(l1,l2) ((long)l1%(long)l2)
#define UR(l1,l2) ( (uli)l1% (uli)l2)
#define Compiler(l1,l2) {UD(l1,l2),SD(l1,l2),UR(l1,l2),SR(l1,l2)}
   /* static needed for other C compilers; HC can initialize auto arrays. */
#ifndef HC
static
#endif
   /* Check correct answer for division and remainder, signed and unsigned. */
   /* This is biased towards machine where the remainder is the same sign   */
   /* as the quotient.  This is not required in C.             */
   /* The 8086 is this way, so 8086 compilers should pass this test.        */
   struct Divide_text {
      long dividend,divisor;
      uli  unsigned_div;
      long   signed_div;
      uli  unsigned_rem;
      long   signed_rem;
      /* Compare the correct answer against the compiler's answer. */
      /* For some compilers, the run time works right, but the compiler */
      /* doesn't.                     */
      struct {
         uli  unsigned_div;
         long   signed_div;
         uli  unsigned_rem;
         long   signed_rem;
         } Compilers_answer;
      } Divide_vector[] = {
/* Use "L" in case some compilers (e.g., Lattice) interpret 0xffff as */
/* -1 rather than 65535 (as required by current standard).  */
/* 0*/{0x00000000L, 0x00000001L, 0x00000000L, 0x00000000L, 0x00000000L, 0x00000000L,
       Compiler(0x00000000L,0x00000001L)},
/* 1*/{0xfffefffeL, 0x00000332L, 0x00501dbbL, 0xffffffb0L, 0x00000078L, 0xffffff9eL,
       Compiler(0xfffefffeL,0x00000332L)},
/* 2*/{0x00000332L, 0xfffefffeL, 0x00000000L, 0x00000000L, 0x00000332L, 0x00000332L,
       Compiler(0x00000332L,0xfffefffeL)},
/* 3*/{0x0ffe0ffeL, 0x00000332L, 0x00050145L, 0x00050145L, 0x00000184L, 0x00000184L,
       Compiler(0x0ffe0ffeL,0x00000332L)},
/* 4*/{0x00000332L, 0x0ffe0ffeL, 0x00000000L, 0x00000000L, 0x00000332L, 0x00000332L,
       Compiler(0x00000332L,0x0ffe0ffeL)},
/* 5*/{0x70fe88abL, 0x00000317L, 0x002491cfL, 0x002491cfL, 0x00000212L, 0x00000212L,
       Compiler(0x70fe88abL,0x00000317L)},
/* 6*/{0x00000317L, 0x70fe88abL, 0x00000000L, 0x00000000L, 0x00000317L, 0x00000317L,
       Compiler(0x00000317L,0x70fe88abL)},
/* 7*/{0x30107cffL, 0x00023303L, 0x000015daL, 0x000015daL, 0x0001cd71L, 0x0001cd71L,
       Compiler(0x30107cffL,0x00023303L)},
/* 8*/{0x00023303L, 0x30107cffL, 0x00000000L, 0x00000000L, 0x00023303L, 0x00023303L,
       Compiler(0x00023303L,0x30107cffL)},
/* 9*/{0x0000fffeL, 0x00000332L, 0x00000050L, 0x00000050L, 0x0000005eL, 0x0000005eL,
       Compiler(0x0000fffeL,0x00000332L)},
/* a*/{0x00000332L, 0x0000fffeL, 0x00000000L, 0x00000000L, 0x00000332L, 0x00000332L,
       Compiler(0x00000332L,0x0000fffeL)},
/* b*/{0x0000fffeL, 0x00010000L, 0x00000000L, 0x00000000L, 0x0000fffeL, 0x0000fffeL,
       Compiler(0x0000fffeL,0x00010000L)},
/* c*/{0x00010000L, 0x0000fffeL, 0x00000001L, 0x00000001L, 0x00000002L, 0x00000002L,
       Compiler(0x00010000L,0x0000fffeL)},
/* d*/{0xffffffffL, 0x00000001L, 0xffffffffL, 0xffffffffL, 0x00000000L, 0x00000000L,
       Compiler(0xffffffffL,0x00000001L)},
/* e*/{0x00000001L, 0xffffffffL, 0x00000000L, 0xffffffffL, 0x00000001L, 0x00000000L,
       Compiler(0x00000001L,0xffffffffL)},
/* f*/{0x00000001L, 0x00000001L, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0x00000001L,0x00000001L)},
/*10*/{0x00000001L, 0x00000001L, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0x00000001L,0x00000001L)},
/*11*/{0x00000001L, 0xffffffffL, 0x00000000L, 0xffffffffL, 0x00000001L, 0x00000000L,
       Compiler(0x00000001L,0xffffffffL)},
/*12*/{0xffffffffL, 0x00000001L, 0xffffffffL, 0xffffffffL, 0x00000000L, 0x00000000L,
       Compiler(0xffffffffL,0x00000001L)},
/*13*/{0xffffffffL, 0xffffffffL, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0xffffffffL,0xffffffffL)},
/*14*/{0xffffffffL, 0xffffffffL, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0xffffffffL,0xffffffffL)},
/*15*/{0xffc70103L, 0x00000332L, 0x00500c34L, 0xffffee2aL, 0x000002dbL, 0xfffffecfL,
       Compiler(0xffc70103L,0x00000332L)},
/*16*/{0x00000332L, 0xffc70103L, 0x00000000L, 0x00000000L, 0x00000332L, 0x00000332L,
       Compiler(0x00000332L,0xffc70103L)},
/*17*/{0xffc70103L, 0x00030332L, 0x000054e7L, 0xffffffeeL, 0x0002b6e5L, 0xfffd3a87L,
       Compiler(0xffc70103L,0x00030332L)},
/*18*/{0x00030332L, 0xffc70103L, 0x00000000L, 0x00000000L, 0x00030332L, 0x00030332L,
       Compiler(0x00030332L,0xffc70103L)},
/*19*/{0x00010800L, 0x00002716L, 0x00000006L, 0x00000006L, 0x00001d7cL, 0x00001d7cL,
       Compiler(0x00010800L,0x00002716L)},
/*1a*/{0x00002716L, 0x00010800L, 0x00000000L, 0x00000000L, 0x00002716L, 0x00002716L,
       Compiler(0x00002716L,0x00010800L)},
/*1b*/{0x001feeeeL, 0x00008000L, 0x0000003fL, 0x0000003fL, 0x00006eeeL, 0x00006eeeL,
       Compiler(0x001feeeeL,0x00008000L)},
/*1c*/{0x00008000L, 0x001feeeeL, 0x00000000L, 0x00000000L, 0x00008000L, 0x00008000L,
       Compiler(0x00008000L,0x001feeeeL)},
/*1d*/{0x173bddabL, 0x00310033L, 0x00000079L, 0x00000079L, 0x0012c590L, 0x0012c590L,
       Compiler(0x173bddabL,0x00310033L)},
/*1e*/{0x00310033L, 0x173bddabL, 0x00000000L, 0x00000000L, 0x00310033L, 0x00310033L,
       Compiler(0x00310033L,0x173bddabL)},
/*1f*/{0x80001000L, 0x80002000L, 0x00000000L, 0x00000001L, 0x80001000L, 0xfffff000L,
       Compiler(0x80001000L,0x80002000L)},
/*20*/{0x80002000L, 0x80001000L, 0x00000001L, 0x00000000L, 0x00001000L, 0x80002000L,
       Compiler(0x80002000L,0x80001000L)},
/*21*/{0x70001000L, 0x70002000L, 0x00000000L, 0x00000000L, 0x70001000L, 0x70001000L,
       Compiler(0x70001000L,0x70002000L)},
/*22*/{0x70002000L, 0x70001000L, 0x00000001L, 0x00000001L, 0x00001000L, 0x00001000L,
       Compiler(0x70002000L,0x70001000L)},
/*23*/{0x80001000L, 0x80010000L, 0x00000000L, 0x00000001L, 0x80001000L, 0xffff1000L,
       Compiler(0x80001000L,0x80010000L)},
/*24*/{0x80010000L, 0x80001000L, 0x00000001L, 0x00000000L, 0x0000f000L, 0x80010000L,
       Compiler(0x80010000L,0x80001000L)},
/*25*/{0x80001000L, 0x80001000L, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0x80001000L,0x80001000L)},
/*26*/{0x80001000L, 0x80001000L, 0x00000001L, 0x00000001L, 0x00000000L, 0x00000000L,
       Compiler(0x80001000L,0x80001000L)}};
   int i;
   ANNOUNCE("More multiplicative operators.");
   Silent++;
   for (i = 0; i < sizeof(Divide_vector)/sizeof(Divide_vector[0]); i++) {
      long l1=Divide_vector[i].dividend,l2=Divide_vector[i].divisor;
#define z(x) Divide_vector[i].x
#define zz(x) Divide_vector[i].Compilers_answer.x
#if 0  /* If you enable this, it'll print out the above table. */
      printf("/*%2x*/{0x%08lxL, 0x%08lxL, 0x%08lxL, 0x%08lxL, 0x%08lxL, 0x%08lxL, \n       Compiler(0x%08lxL,0x%08lxL)},\n",
        i,l1,l2,
       	z(unsigned_div),z(signed_div),z(unsigned_rem),z(signed_rem),
       	l1,l2),
#endif
     xequal( (uli)l1/(uli)l2,   z(unsigned_div),  "udiv",i),
     xequal( l1/l2,       z(signed_div),    "sdiv",i),
     xequal( (uli)l1%(uli)l2,   z(unsigned_rem),  "urem",i),
     xequal( l1%l2,       z(signed_rem),    "srem",i),
      /* Now make sure compile time = run time. */
     xequal( z(unsigned_div),   zz(unsigned_div), "c:udiv",i),
     xequal( z(signed_div),     zz(signed_div),      "c:sdiv",i),
     xequal( z(unsigned_rem),   zz(unsigned_rem), "c:urem",i),
     xequal( z(signed_rem),  zz(signed_rem),      "c:srem",i);
      }
#undef SD
#undef UD
#undef SR
#undef UR
#undef Compiler
#undef E
#undef Two
#undef z
#undef zz
   Silent--;
   }

const_mpys() {
   /* Check any attempted optimization at strength-reduction of
      multiplies by using shifts and adds. */
   int i= 1;
   unsigned char c = 1;
   schar sc = 1;
#define sctest(val) {equal(sc*-val,-val,"*-con c");}
   short s = 1;

   ANNOUNCE("Mpy by const.");
#define test(i,val) {equal(i*val,val,"*con i"); equal(i*-val,-val,"*-con i");}
#define ctest(val) {equal(c*val,val,"*con c");}
L: test(i,1); test(i,2); test(i,3); test(i,4); test(i,5); test(i,6); test(i,7);
   test(i,8); test(i,9); test(i,10); test(i,11); test(i,13); test(i,15); test(i,22);
   test(i,31); test(i,127);     /* Regression on these last two! */
   test(i,57); test(i,101); test(i,200); test(i,1000); test(i,3002); test(i,4117);
   test(i,5000); test(i,6779); test(i,10000); test(i,23320);
   ctest(1); ctest(2); ctest(3); ctest(4); ctest(5); ctest(6); ctest(7);
   ctest(8); ctest(9); ctest(10); ctest(11); ctest(13); ctest(15); ctest(22);
   ctest(57); ctest(101); ctest(240);
   sctest(1); sctest(2); sctest(3); sctest(4); sctest(5); sctest(6); sctest(7);
   sctest(8); sctest(9); sctest(10); sctest(11); sctest(13); sctest(15); sctest(22);
   sctest(57); sctest(101);
   test(s,1); test(s,2); test(s,3); test(s,4); test(s,5); test(s,6); test(s,7);
   test(s,8); test(s,9); test(s,10); test(s,11); test(s,13); test(s,15); test(s,22);
   test(s,57); test(s,101); test(s,200); test(s,1000); test(s,3002); test(s,4117);
   test(s,5000); test(s,6779); test(s,10000); test(s,23320);
   }
#undef test
#undef ctest
#undef sctest

OLAY("O2")
void signed_bit_fields() {
   struct s{signed i9:9,i1:1,i11:11,i10:10;} x;
   int i1; long l1;
   ANNOUNCE("Signed bit fields.");
   x.i9 = x.i11 = 0;
   x.i1 = -1;
   equal(x.i1,-1,"i1==-1");
   equal(x.i1==-1,True,"i1==-1'");
   /* Make sure the -1 doesn't wipe out part of i11 or i9. */
   equal(x.i9,0,"i9:0");
   equal(x.i11,0,"i11:0");
   x.i9 = x.i11 = x.i10 = Neg;
   equal(x.i9,x.i11,"i9:i11");
   equal(x.i11,x.i10,"i11:i10");
   x.i11 = x.i10++ +1;
   equal(x.i11,x.i10,"11:10");
   equal(x.i9+1,x.i11,"9+:11");
   x.i11 = ++x.i10 + 1;
   equal(x.i11,x.i10+1,"11:10+");
   /* Test comparison with constant.  This can be optimized for unsigned */
   /* by not doing */
   /* the shift in the extraction, and correspondingly shifting the constant.*/
   /* But ensure no optimization for signed comparison. */
   equal(x.i10 > Neg,True,"10>");
   equal(x.i10 < Neg+3,True,"10<");
   equal(x.i9 == Neg,True,"9==");
   equal(x.i9 <= Neg,True,"9<=");
   x.i11 = x.i10;
   equal(x.i11,x.i10,"11:10");

   equal(x.i1 >=-1,True,"1>=");
   equal(x.i1 > -1,False,"1>");
   equal(x.i1 < -1,False,"1<");
   equal(x.i1 <=-1,True,"1<=");
   equal(x.i1 ==-1,True,"1==");
   equal(x.i1 !=-1,False,"1!=");
   x.i1 = ~x.i1;        /* -1 becomes 0. */
   equal(x.i1 >=-1,True ,"1>=");
   equal(x.i1 > -1,True ,"1>");
   equal(x.i1 < -1,False,"1<");
   equal(x.i1 <=-1,False,"1<=");
   equal(x.i1 ==-1,False,"1==");
   equal(x.i1 !=-1,True ,"1!=");

   x.i9 = 0;
   x.i9--;   /* Should wrap and be some number < 0, depending upon # */
       /* of bits used to store i9.            */
   equal(x.i9 < 0,True,"9>0");
   /* Ensure i1 hasn't been affected. */
   equal(x.i1,0,"i1:0");
   i1 = x.i9;
   x.i9 /= 3;
   equal(x.i9,i1/3,"i9:/3");
   x.i9 *= 3;
   equal(x.i9,(i1/3)*3,"9:/*3");
   {unsigned char c;  /* Had problem when extracting a field into a character. */
   c = x.i9; x.i1 = 1;
L1:equal(c,x.i9 & 0xff,"c=.:9");
   c = x.i1;
L2:equal(c,(unsigned char)x.i1,"c=.:1");
   }
   {
   long long0 = 0;
   struct s{signed long i25:25; signed int i1:1;
      signed long i27:27,i26:26;} x;
   ANNOUNCE("Long signed bit fields.");
   x.i25 = x.i27 = 0;
   x.i1 = -1;
   equal(x.i1,-1,"i1==1");
   equal(x.i1==-1,True,"i1==1'");
   /* Actually, the standard permits x.i1 to hold -3; it merely says that*/
   /* the size of the bit field be no more than that of unsigned int. */
   /* But the standard forgets to define the least set of values storeable */
   /* in a field. */
   /* Make sure the -3 doesn't wipe out part of i27 or i25. */
  lequal(x.i25,long0,"i25:0");
  lequal(x.i27,long0,"i27:0");
   x.i25 = x.i27 = x.i26 = Neg;
  lequal(x.i25,x.i27,"i25:i27");
  lequal(x.i27,x.i26,"i27:i26");
   x.i27 = x.i26++ +1;
  lequal(x.i27,x.i26,"27:26");
  lequal(x.i25+1,x.i27,"25+:27");
   x.i27 = ++x.i26 + 1;
  lequal(x.i27,x.i26+1,"27:26+");

   /* Test comparison with constant.  This can be optimized for unsigned */
   /* bit fields by not doing */
   /* the shift in the extraction, and correspondingly shifting the constant.*/
   /* Make sure no optimization attempted for signed. */
   equal(x.i26 > Neg,True,"26>");
   equal(x.i26 < Neg+3,True,"26<");
   equal(x.i25 == Neg,True,"25==");
   equal(x.i25 <= Neg,True,"25<=");
   x.i27 = x.i26;
   x.i1 = ~x.i1;   /* -1 goes to 0. */
  lequal(x.i27,x.i26,"27:26");

#if 0
   /* The ANSI standard is silent on whether unsigned long bit fields
      extend to signed long.  We've omitted the test for now. */
   /* Since x.i25 is unsigned long, Neg is converted to unsigned long, so the */
   /* comparison is unsigned, turning Neg into a big number. */
   equal(x.i25 <= Neg,True,"25<=N");
#endif

   x.i25 = 0;
   x.i25--;   /* Should wrap and be some number < 0, depending upon # */
       /* of bits used to store i25.            */
   equal(x.i25 < 0,True,"25>0");
   /* Ensure i1 hasn't been affected. */
   equal(x.i1,0,"i1:0");
   l1 = x.i25;
   x.i25 /= 3;
  lequal(x.i25,l1/3,"i25:/3");
   x.i25 *= 3;
  lequal(x.i25,(l1/3)*3,"25:/*3");
   }
   /* Ensure proper initialization of static bit fields. */
   ANNOUNCE("Static signed bit fields.");
   {
   struct s1{signed i9:9,i1:1,i11:11,i10:10;};
   /* Make sure that some fields do not slop into others. */
   static struct s1
      x = {0x0fe, -1, 0xfffffffe, 0xffffffff},
      y = {0, 0xffffffff, 0, 0x1ff},
      z = {-256, -1, 0x3ff, -0x200};
   equal(x.i9,0x0fe,"xi9");
   equal(x.i1,-1,"xi1");
   /* This should work for short = 16 or 32, and int any size. */
   equal(x.i11,(short)0xfffffffe,"xi11");
   equal(x.i10,(short)0xffffffff,"xi10");

   equal(y.i9,0,"yi9");
   equal(y.i1,(short)0xffffffff,"yi1");
   equal(y.i11,0,"yi11");
   equal(y.i10,0x1ff,"yi10");

   equal(z.i9,-256,"zi9");
   equal(z.i1,-1,"zi1");
   equal(z.i11,0x3ff,"zi11");
   equal(z.i10,-0x200,"zi10");
   }
   }

void unsigned_bit_fields() {
   struct s{unsigned i9:9,i1:1,i11:11,i10:10;} x;
   ANNOUNCE("Unsigned bit fields.");
   x.i9 = x.i11 = 0;
   x.i1 = 3;
   equal(x.i1,1,"i1==1");
   equal(x.i1==1,True,"i1==1'");
   /* Actually, the standard permits x.i1 to hold 3; it merely says that*/
   /* the size of the bit field be no more than that of unsigned int. */
   /* But the standard forgets to define the least set of values storeable */
   /* in a field.*/
   /* Make sure the 3 doesn't wipe out part of i11 or i9. */
   equal(x.i9,0,"i9:0");
   equal(x.i11,0,"i11:0");
   x.i9 = x.i11 = x.i10 = Pos;
   equal(x.i9,x.i11,"i9:i11");
   equal(x.i11,x.i10,"i11:i10");
   x.i11 = x.i10++ +1;
   equal(x.i11,x.i10,"11:10");
   equal(x.i9+1,x.i11,"9+:11");
   x.i11 = ++x.i10 + 1;
   equal(x.i11,x.i10+1,"11:10+");
   /* Test comparison with constant.  This can be optimized by not doing */
   /* the shift in the extraction, and correspondingly shifting the constant.*/
   equal(x.i10 > Pos,True,"10>");
   equal(x.i10 < Pos+3,True,"10<");
   equal(x.i9 == Pos,True,"9==");
   equal(x.i9 <= Pos,True,"9<=");
   x.i11 = x.i10;
   equal(x.i11,x.i10,"11:10");

   equal(x.i1 >=1,True,"1>=");
   equal(x.i1 > 1,False,"1>");
   equal(x.i1 < 1,False,"1<");
   equal(x.i1 <=1,True,"1<=");
   equal(x.i1 ==1,True,"1==");
   equal(x.i1 !=1,False,"1!=");
   x.i1 = ~x.i1;
   equal(x.i1 >=1,False,"1>=");
   equal(x.i1 > 1,False,"1>");
   equal(x.i1 < 1,True ,"1<");
   equal(x.i1 <=1,True,"1<=");
   equal(x.i1 ==1,False,"1==");
   equal(x.i1 !=1,True ,"1!=");

   /* Since x.i9 is unsigned int, Neg is converted to unsigned int, so the */
   /* comparison is unsigned, turning Neg into a big number. */
/* equal(x.i9 <= Neg,True,"9<=N");      */
   /* ^^ As of Feb. 20, 1987, this changed; bit fields of size less than that
      of "int" are promoted to signed int, not unsigned int, even if the
      bit field is unsigned.  This is consistent with "value-preserving" rules.
      So here is the new test:
   */
   equal(x.i9 <= Neg,False,"9<=N");
   x.i9 = 0;
   x.i9--;   /* Should wrap and be some number > 0, depending upon # */
       /* of bits used to store i9.            */
   equal(x.i9 > 0,True,"9>0");
   /* Ensure i1 hasn't been affected. */
   equal(x.i1,0,"i1:0");
   ui1 = x.i9;
   x.i9 /= 3;
   equal(x.i9,ui1/3,"i9:/3");
   x.i9 *= 3;
   equal(x.i9,(ui1/3)*3,"9:/*3");
   {unsigned char c;  /* Had problem when extracting a field into a character. */
   c = x.i9; x.i1 = 1;
L1:equal(c,x.i9 & 0xff,"c=.:9");
   c = x.i1;
L2:equal(c,x.i1,"c=.:1");
   }
   {
   long long0 = 0;
   struct s{unsigned long i25:25; unsigned int i1:1;
      unsigned long i27:27,i26:26;} x;
   ANNOUNCE("Unsigned long bit fields.");
   x.i25 = x.i27 = 0;
   x.i1 = 3;
   equal(x.i1,1,"i1==1");
   equal(x.i1==1,True,"i1==1'");
   /* Actually, the standard permits x.i1 to hold 3; it merely says that*/
   /* the size of the bit field be no more than that of unsigned int. */
   /* But the standard forgets to define the least set of values storeable */
   /* in a field. */
   /* Make sure the 3 doesn't wipe out part of i27 or i25. */
  lequal(x.i25,long0,"i25:0");
  lequal(x.i27,long0,"i27:0");
   x.i25 = x.i27 = x.i26 = Pos;
  lequal(x.i25,x.i27,"i25:i27");
  lequal(x.i27,x.i26,"i27:i26");
   x.i27 = x.i26++ +1;
  lequal(x.i27,x.i26,"27:26");
  lequal(x.i25+1,x.i27,"25+:27");
   x.i27 = ++x.i26 + 1;
  lequal(x.i27,x.i26+1,"27:26+");

   /* Test comparison with constant.  This can be optimized by not doing */
   /* the shift in the extraction, and correspondingly shifting the constant.*/
   equal(x.i26 > Pos,True,"26>");
   equal(x.i26 < Pos+3,True,"26<");
   equal(x.i25 == Pos,True,"25==");
   equal(x.i25 <= Pos,True,"25<=");
   x.i27 = x.i26;
   x.i1 = ~x.i1;
  lequal(x.i27,x.i26,"27:26");

   /* Since x.i25 is unsigned long, Neg is converted to unsigned long, so the */
   /* comparison is unsigned, turning Neg into a big number. */
   /***** The standard is probably inconsistent on this matter. */
   /* On 4-byte int machines, although the field is declared long int,
      it fits within an int.  Should we promote to signed or unsigned? */
   /* The standard now looks like it has been "fixed" to cover this case. */
   equal(x.i25 <= Neg,False,"25<=N");

   x.i25 = 0;
   x.i25--;   /* Should wrap and be some number > 0, depending upon # */
       /* of bits used to store i25.            */
   equal(x.i25 > 0,True,"25>0");
   /* Ensure i1 hasn't been affected. */
   equal(x.i1,0,"i1:0");
   ul1 = x.i25;
   x.i25 /= 3;
  lequal(x.i25,ul1/3,"i25:/3");
   x.i25 *= 3;
  lequal(x.i25,(ul1/3)*3,"25:/*3");
   }
   /* Be sure that fields are packed tightly enough. */
#ifdef HIGHC
   /* Make sure bit-field alignment matches PCC on UNIX */
#  if (_ATT && _I860BE) || (_ATT && !_I860) || _ATT4 || _SUN || _SOL || _HOBBIT
#      if _MC68
#          define SI sizeof(short)
#      else
#          define SI sizeof(unsigned)
#      endif
       equal(sizeof(struct {unsigned i:7,j:1;}),SI,"bs1");
       equal(sizeof(struct {unsigned i:1,j:9,k:6;}),SI,"bs4");
#      undef SI
#  else
       equal(sizeof(struct {unsigned i:7,j:1;}),1,"bs1");
       equal(sizeof(struct {unsigned i:1,j:9,k:6;}),2,"bs4");
#  endif
   /* On the 370 i:23 and j:1 generates 4 bytes, whereas 3 chars generate 3
      bytes.  Thus we have to pad with another byte. */
   equal(sizeof(struct {unsigned long i:23,j:1; char c4;}) ==
     sizeof(struct {char c1,c2,c3,c4;}),True,"bs2");
   equal(sizeof(struct {unsigned long i:23; unsigned j:8,k:1;}),4,"bs3");
   equal(sizeof(struct {unsigned short a:16,b:8,c:1,d:7;}),4,"bs5");
#endif
   /* Ensure proper initialization of static bit fields. */
   ANNOUNCE("Static unsigned bit fields.");
   {
   struct s1{unsigned i9:9,i1:1,i11:11,i10:10;};
   /* Make sure that some fields do not slop into others. */
   /* Only_bits obtains V with all bits above Bitlen zeroed. */
#define Only_bits(V,Bitlen) (V & ( (1 << Bitlen))-1 )
   static struct s1
      x = {0x1fe, 3, 0xfffe, 0xffff},
      y = {0, 0xffff, 0, 0xffff},
      z = {0xaaaa, 0xbbbb, 0xcccc, 0xdddd};
   equal(x.i9,0x1fe,"xi9");
   equal(x.i1,1,"xi1");
   equal(x.i11,Only_bits(0xfffe,11),"xi11");
   equal(x.i10,Only_bits(0xffff,10),"xi10");

   equal(y.i9,0,"yi9");
   equal(y.i1,1,"yi1");
   equal(y.i11,0,"yi11");
   equal(y.i10,0x3ff,"yi10");

   equal(z.i9,Only_bits(0xaaaa,9),"zi9");
   equal(z.i1,Only_bits(0xbbbb,1),"zi1");
   equal(z.i11,Only_bits(0xcccc,11),"zi11");
   equal(z.i10,Only_bits(0xdddd,10),"zi10");
   }

   {
   struct s2{unsigned i3:3,i7:7,i6:6;};  /* Most likely fits in 2 bytes, no pad. */
   static struct s2
      x = {0xfffe, 0xfffe, 0xfffe},
      y = {0, 0xffff, 0},
      z = {0xaaaa, 0xbbbb, 0xcccc};
   equal(x.i3,Only_bits(0xfffe,3),"xi3");
   equal(x.i7,Only_bits(0xfffe,7),"xi7");
   equal(x.i6,Only_bits(0xfffe,6),"xi6");
   equal(y.i3,Only_bits(0x0   ,3),"yi3");
   equal(y.i7,Only_bits(0xffff,7),"yi7");
   equal(y.i6,Only_bits(0x0   ,6),"yi6");
   equal(z.i3,Only_bits(0xaaaa,3),"zi3");
   equal(z.i7,Only_bits(0xbbbb,7),"zi7");
   equal(z.i6,Only_bits(0xcccc,6),"zi6");
   }

   {
   /* Skip :0 fields for initialization.  Initialize unnamed fields
      of length > 0. */
   /* Standard now requires skipping of unnamed fields (poor decision, but ...) */
   static struct s{unsigned char c; int :1,:0,:0,i:5,:0,j:6,:1,k:7;} x
#if defined _LOC && !defined _GOC
        = {0xff,1,16,17,1,18};  /* LOC compiler still doesn't skip. */
#else
        = {0xff,16,17,18};
#endif
L: equal(x.c,0xff,"c=");
   equal(x.i,16,"x.i=");
   equal(x.j,17,"x.j=");
   equal(x.k,18,"x.k=");
   }
   }

OLAY("O3")
/* The tests from here to the end are fragmentary and need to be increased. */

void casts () {
   ANNOUNCE("Casts.");
   /* Casts should always do the conversion, even not in the presence of */
   /* an assignment. */
  lequal((long)(unsigned int) Big_uli, (long)Big_ui, "shorten 1");
   equal((uchar) Big_uli, 0xFF, "shorten 2");
   equal((uchar) Big_ui, 0xFF, "shorten 3");
   /* Truncating Big_li should produce -1 if sizeof(long)>sizeof(int),
      and Big_i if their sizes are the same.  Thus we shift right by
      1 iff the sizes are distinct, to get Big_i. */
   equal( ((unsigned)(int) Big_li) >> (sizeof(int)!=sizeof(long)),
      Big_i, "shorten 4");
   /* Function pointers can be converted to one another, as can data pointers. */
   /* Integers can be converted to and from function and data pointers. */
   /* But data pointers cannot be converted to function pointers, and vice-versa. */
   /* The conversion is implementation-defined, so we can't test the correctness here */
   /* unless the size of the objects converted is the same; we then assume. */
   /* that no conversion occurs.               */
   {void (*f)() = (void(*)()) 1; int *i = (int *)0;
    f = (void (*)()) 2;
    i = (int *)32;
    if (sizeof(f) == sizeof(int))
       equal((int)f,2,"fp==i");
    if (sizeof(int*) == sizeof(int))
       equal((int)i,32,"ip==i");
   }
   { /* Test lack of casting conversion that can crop up due to "optimizing". */
     /* Here the compiler might remember the value of constants. */
   unsigned short int u; short ii;
   unsigned char c1;
   signed char c2;
   c1 = 255; c2 = -1;
   /* Here we must compare 255 to 255, not 255 to 65535, e.g. */
   equal((unsigned char)c1 != (unsigned char)c2,False,"co 1");
   c1 = 250; c2 = -10;
   /* Sign-extend c2 and don't c1.  Thus c2 is much bigger than c1. */
   equal((unsigned short)c1 > (unsigned short)c2,False,"co 2");
   /* Since we cast c2 to unsigned char first, it isn't sign-extended */
   /* and so should be smaller than c1 unsignedly. */
   c1 = 250; c2 = -10;
   equal((unsigned)c1 < (unsigned)(unsigned char)c2,False,"co 3");
   if (sizeof(int) == 2) {
      /* Testing should be done unsignedly, since u is unsigned. */
      u = 65535; ii = -1;
      equal(u != ii,False,"co 4");
      u = 65530; ii = -1;
      equal((int)u > (int)ii,False,"co 5");
      }
   u = 65530; ii = -10;
   /* Since we convert ii to unsigned short first, it is not sign extended
      past the size of a short.  */
   equal((unsigned long)u < (unsigned long)(unsigned short)ii,
       sizeof(short) > 2,"co 6");
   }
   {
   /* Check short things to float/double conversion in case of optimization
    * in this area.
    */
   static signed char esc=-1;
   static unsigned char euc=2;
   static signed short ess=-3;
   static unsigned short eus=4;
   float fsave = f1; double dsave = d1;
   f1 = esc; dequal(f1,(double) -1,0,"esc");
   f1 = euc; dequal(f1,2,0,"esc");
   f1 = ess; dequal(f1,-3,0,"esc");
   f1 = eus; dequal(f1,4,0,"esc");
   d1 = esc; dequal(d1,-1,0,"esc");
   d1 = euc; dequal(d1,2,0,"esc");
   d1 = ess; dequal(d1,-3,0,"esc");
   d1 = eus; dequal(d1,4,0,"esc");
   f1 = fsave; d1 = dsave;
   }
   {
   static signed char ch = 0;
   static unsigned short us = 0;
   static long l1 = 0;
   static long l2 = 0;
   ch = 0246;
   l1 = (unsigned short) ch;
   us = ch; l2 = us;
   lequal(l1,l2,"sc->l");
   }
   /* (void*)0 is a null pointer constant and as such can be assigned into
    * a function pointer.
    */
   {
   int (*fp)() = (void*)0;	/* Initialization allowed. */
   fp = (void *)0;	/* Assignment allowed. */
   equal(fp == (void*)0 && (void*)0 == fp,True,"void*0");
   }
   }

int axx,bxx,cxx,dxx,exx,fxx;
int cf_called;
int cf() { cf_called = 1; return cxx; }
NCtest () {
   int ans,ans2;
   cf_called = 0;
   if (axx ? ( (bxx ? cf() : dxx), exx) : fxx) ans = 1;
   else ans = 0;
   if (!axx) ans2 = fxx;
   else ans2 = exx;
   Silent++;
   equal(ans,ans2,"condx1");
   equal(axx && bxx, cf_called, "condx2");
#ifndef STANDALONE
   if ((ans != ans2) || (axx && bxx && !cf_called) ) {
      printf("a:%d b:%d c:%d d:%d e:%d f:%d ans:%d ans2:%d cf_called:%d\n",
       axx,bxx,cxx,dxx,exx,fxx,ans,ans2,cf_called);
      }
#endif
   Silent--;
   }

void nested_conditionals() {
   for (axx = 0; axx <= 1; axx++)
      for (bxx = 0; bxx <= 1; bxx++)
         for (cxx = 0; cxx <= 1; cxx++)
            for (dxx = 0; dxx <= 1; dxx++)
               for (exx = 0; exx <= 1; exx++)
                  for (fxx = 0; fxx <= 1; fxx++)
                     NCtest();
   }

int False_fcn() {return 0; }

/* Be sure the ++ doesn't kill the condition code. */
testcond(i,p) char *p; {*p++ = ((i&64) != 0);}
long reml(long x, long y) {return x % y; }
int  rem(int x, int y) {return x % y; }

void misc_expns() {
#define Len ((sizeof("abcdef"))-1)
   int i,j,k,l,m;
   static struct {
      struct { int a:7; int b:1; } F2;
      int i;
      } FF = {{2},7};

   ANNOUNCE("Misc. expns.");
   equal(FF.F2.a,2,"FF.F2"); equal(FF.i,7,"FF.F2.i");
   equal(Len,6,"sz str");
   for (i = 0; i < Len; ++i)
      equal( *("abcdef"+i), ((union {char c[Len];}*)"fedcba") ->c[Len-i-1],"m1");
   equal(sizeof(&*"abc"),sizeof(char*),"m2");
   /* Check out some sequence points. */
   j = i = 0;
   dummy(i++,i++,i++);
   equal(j+3,i,"m3");
   m = i;
   (i++,j=i++,k=i++), dummy(l=i++);
   equal(j,m+1,"m4");
   equal(k,j+1,"m5");
   equal(l,k+1,"m6");
   equal(*(&*(&*"abc"+0)+2),'c',"m7");
   /* No longer allowed in the standard. */
/* equal(sizeof(misc_expns),sizeof(fp1),"m8"); */
   equal(sizeof(int [3][4]), sizeof(struct {int a[4];} [3]),"m9");
   j = i = 1;
   equal(i+++ ++j, 3, "m10");
   if (j == i-1) {
      /* Regression:  complicated in 8086 big model. */
      struct s1 {struct s1 *L; char *X; } *p;
      if (p -> L)
     	p->L->X += (int)p->X;   /* 3 instructions on 8086 code gen! */
      }
   equal((!1&&0) || !(!0||1) || !(1||0&&0),0,"cfold");
   { /* Regression test for 8086 code gen. */
   static struct s {struct s *p1,*p2,*p3,*p4,*p5,*p6,*p7,*p8;} x[8]
      = { {&x[1]},{0,&x[2]},{0,0,&x[3]},{0,0,0,&x[4]},
          {0,0,0,0,&x[5]},{0,0,0,0,0,&x[6]},{0,0,0,0,0,0,&x[7]},
          {0,0,0,0,0,0,0,&x[0]} }
      , *p = &x[0];
   equal(p->p1->p2->p3->p4->p5->p6->p7->p8 == p,1,"ptr chain");
   }
   {/* Regression. */ static int i = 7; equal(1 + -i, -6, "1+-");
   }
   {
   /* ANSI says that char constants must be sign-extended if chars are signed,
    	and vice-versa. */
   /* First test if chars are signed.  Then check appropriate extension. */
   static char c = '\xff'; int i;
   char *s = "\xff\x83\x17";
   if (c < 0) equal(i = '\xff', -1, "chs");
   else equal(i = '\xff',255,"chs");
   equal(s[0],'\xff',"chs s1");
   equal(s[1],'\x83',"chs s2");
   equal(s[2],'\x17',"chs s3");
   }
   nested_conditionals();
   /* Regression: */
   {int x = False_fcn() ? strlen((char *)NCtest()) : 0; }
   {char c;
   testcond(64,&c);
   equal(c,1,"Cond1");
   testcond(0,&c);
   equal(c,0,"Cond0");
   }
   {
   long l; int i;
#define test(modulus) {\
   for (l = -24, i = -24; i <= 24; i++,l++) {\
      lequal(l % (modulus), reml(l,(modulus)), "sreml");\
       equal(i % (modulus), rem (i,(modulus)), "sremi");\
       } }
   test(8); test(2); test(3); test(-4);
   l = -(65536L*2)*2;
   lequal(l % (65536L*2),reml(l,(65536L*2)),"sreml");
   l++;
   lequal(l % (65536L*2),reml(l,(65536L*2)),"sreml");
   l = -65536L*2;
   lequal(l % 65536,reml(l,65536),"sreml");
   l++;
   lequal(l % 65536,reml(l,65536),"sreml");
   l = -65536L*4;
   lequal(l % 65536,reml(l,65536),"sreml");
   l++;
   lequal(l % 65536,reml(l,65536),"sreml");
   l = -32768L*2;
   lequal(l % 32768,reml(l,32768),"sreml");
   l++;
   lequal(l % 32768,reml(l,32768),"sreml");
   }
#undef test
   /* Assume 2's complement machine. */
   if (sizeof(long) == 4)
      /* -2...8 doesn't fit in long, hence is unsigned long, hence > 0. */
      equal(-2147483648 > 0, True, "-2^31>0");
   /* GOC regression error. */
   {static j[2] = {2,3};
   int *p1=j;
   printf("",&p1);      /* Just force p1 in memory. */
   p1++;
   *p1 = (int)p1;
   equal(*p1 == 3,False,"*p");
   p1++;
   }
   {static int x = 1, y = 2, z = -1;
   equal(1/x,1,"1/x");
   equal(1/y,0,"1/y");
   equal(1/z,-1,"1/z");
   }
   {
   int i = 7 || 1/0;  /* Be sure /0 OK. */
   int j = 0 && 1/0;
   equal(i,True,"1/0");
   equal(j,False,"1/0");
   }
   {
   unsigned char *a[3]={(unsigned char *)"abc",0,0}; int j = 0,k = 0;
   /* Be sure that the side-effect of ++ happens even though the compiler
    * knows that the comparison is useless.
    */
   while (*a[j]) if (*a[j]++ < 0) ; else k++;
   equal(k,3,"< side-eff");
   }
   }


/* The ANSI standard allows &a to generate type "pointer to array" */
/* where a is an array. */
static char an_array[3];
char (*arrayp)[3] = &an_array;
    /* You used to have to say (char (*)[3])an_array. */

struct strange {int x;} *(*strange_array[3])[10];

struct strange *(  (*strange_fcn(x)) [10]) int x; {
   /* A function returning a pointer to an array of 10 pointers to struct stranges. */
   return strange_array[0];
   }

/* stranger is a function that can return the above function. */

struct strange *((*(*stranger_fcn(y))())[10]) int y; {
   return strange_fcn;
   }
/* Finally, this one can return the stranger_fcn. */
struct strange  *((*(*(*strangest_fcn(z))())())[10]) int z; {
   return stranger_fcn;
   }

/* By the way, you can parenthesize identifiers in declarator, exemplified
   below.  Some compilers erroneously don't accept this. */

void (((Parened_fcn_id))) (a) int a; {a = 1;}
int *(((Parened_f_id2))) (a) int a; {return &a;}

#ifdef HIGHC
extern routine_that_pops_its_own_stack();   /* Actually, declared later. */
#endif

/* Standard (unfortunately) allows a prototype dcln to override an old-style
   definition. */
void need_int(int);
void need_int(i) {
int j;
   equal(i,1,"pr 1");        /* Ensure truncation. */
   }
int  foo(int x1, int x2, int x3)
{
  return (x1+x3);
}

void need_int2(int i) {
   equal(i,2,"pr 2");        /* Ensure truncation. */
   }
/* ANSI says parm names need not agree. */
void need_int3(int parmname);
void need_int3(int parmname2) {
   equal(parmname2,3,"pr 3");
   }
void need_long(long l) {
  lequal(l,4L,"pr 4");
   }
enum eee{chardonnay,chartreuse,street = Neg,einstein = Pos};
void two_ints(enum eee i, enum eee j) {
   equal(i,j,"2i");
   }
extern double fabs(double x);
void two_floats(float i, float j) {
   equal(fabs(i - j) < .01,1,"2f");
   }
struct Record {int i; struct Record *Next; };
typedef struct Record     RecordType;
typedef RecordType *  RecordPtr;
typedef RecordPtr * RecordPtrPtr;
static redeclare() {
   struct Record *p;
   RecordPtrPtr RecordPtr;   /* Redeclaring a typedef. */
   p-> Next = p;
   p-> Next = *RecordPtr;
   }
void zz(struct Record ** x); /* Two ways of saying the same thing. */
void zz(RecordPtrPtr x) {}      /* Should be allowed. */

/* If you override, you should change the type for purposes of type compatibility. */
int Zf1(i){}       int (*Zf1p)();
int Zf2(int i){}   int (*Zf2p)(int);
int Zf3(int i,...){}  int (*Zf3p)(int,...);

int Zh2(int i);     int Zh2(i) int i; {}    int (*Zh2p)(int);
#if __HIGHC__ || !_GOC /* Remove this when GOC bug is fixed. */
int Zh3(int i,...); int Zh3(i,...)int i; {} int (*Zh3p)(int,...);
#endif

void check_override() {
   Zf1p = Zf1;
   Zf2p = Zf2;
   Zf3p = Zf3;
   Zh2p = Zh2;
#if __HIGHC__ || !_GOC /* See comment above */
   Zh3p = Zh3;
#endif
   }

/* Typedefs can be used to declare external functions, but not fcn definitions. */
typedef int ff();
ff gg;
gg() {}

/* Test re-declaration abilities. */

typedef long arrae[2];
extern long (*table)[];
arrae *table;
typedef int *(*Array_type [ ])[ ];
extern Array_type b1;
extern int *(*b1[ ])[5];
       int *(*b1[3])[ ];
extern Array_type b2;
extern int *(*b2[ ])[9];
       int *(*b2[4])[ ];
extern int *(b3[ ])[6];
       int *(b3[7])[6];
typedef char ch_array_type[];
typedef char chr;
extern ch_array_type ch_array;
chr ch_array[5];

void test_redecl() {
   /* Here we assume that all pointers to arrays are of the same size. */
   equal(sizeof(*table), 2*sizeof(long),  "tr0");
   equal(sizeof(b1),  3*sizeof(int (*)[]),"tr1");
   equal(sizeof(**b1),5*sizeof(int *),    "tr2");
   equal(sizeof(b2),  4*sizeof(int(*)[]), "tr3");
   equal(sizeof(**b2),9*sizeof(int *),    "tr4");
   equal(sizeof(b3),  42*sizeof(int *),   "tr5");
   equal(sizeof(*b3), 6*sizeof(int *),    "tr6");
   }

enum_sizes() {
   enum A {A1,A2};
   enum B {B1=4000,B2};
   enum C {C1=(int)-32768,C2};
   enum D {D1=-32769,D2};
   enum E {E1 = 2147483648};
   equal(sizeof(enum A) >= 1,True,"e1");
   equal(sizeof(enum B) >= 2,True,"e2");
   equal(sizeof(enum C) >= 2,True,"e3");
   /* If your 16-bit compiler fails these two tests, you may be OK; */
   /* ANSI doesn't say what happens when the enum value exceeds signed int. */
   /* MetaWare compilers allocates 4 bytes to the enums in that case, */
   /* treating their type as signed long. */
   equal(sizeof(enum D) >= 4,True,"e4");
   equal(sizeof(enum E) >= 4,True,"e5");
   equal(sizeof(A1),sizeof(int),"e6");  /* ANSI says constants are of type int. */
   equal(sizeof(C1),sizeof(int),"e7");
   }

void dcln_tests() {
   typedef int x;  /* x = int. */
   ANNOUNCE("Dcln tests.");
   gg();
   test_redecl();
   enum_sizes();
   /* Prototype checks. */
   need_int(1.1);  /* Should truncate to 1. */
   need_int2(2.2);
   need_int3(3.3);
   need_long(4.4);
   need_long(4);   /* Convert int to long. */
   two_ints(f1,1);
   two_ints(1,f1);
   two_ints(fli1,Pos); two_ints(fli2,Neg);
   ui1 = Pos;
   two_floats(1,1);
   two_floats(ui1,Pos);
   /* Check forward-dcln of structures & their resolution. */
   {struct s1 *p;
    struct s1{int x,y;} *q;
    q = p;
   }
   {struct s1 *p;
    struct r{struct s1{int x,y;} *q;} r;
    r.q = p;
   }
   {union s1 *p;
    union s1{int x,y;} *q;
    q = p;
   }
   {union s1 *p;
    union r{union s1{int x,y;} *q;} r;
    r.q = p;
   }
   {x x;     /* should declare x as int. */
    x = 3;
   }
   {int y = (x) 3; /* Try it again in case typdef scoping doesn't work. */
    x x[10];
    x[3] = 4;
    {typedef int x;   /* should be able to get a typedef again. */
     {
      x(((x)));    /* Looks like a fcn call, eh?  It isn't.  */
      x = 3;
     }
    }
   }

   {
   /* ANSI may not know what they have implied by saying that
      "The scope of an enumeration constant is the same as that of the enum
      of which it is a member."  It might exclude "white-1" below:
      white might not be defined until the }.  We take the attitude that
      the ID is defined as soon as it is mentioned. */
   enum color {color,red = 33, white = 99, blue, green = white-1, chartreuse}
      kolor = color;
   equal(kolor,color,"en 1");
   equal(blue,100,"en 2");
   equal(chartreuse,white,"en 3");
   }
   {
   int y = 3, *x = &y;
   /* Pretend x is a pointer to an array of 5 ints.  Dereferencing x should */
   /* obtain the array, which is immediately converted to a pointer to the  */
   /* first element.  Dereferencing that should yield the first element:3.  */
   equal(** (int (*)[5]) x, 3,"casts");
   }
   /* Test difficult-to-read functions. */
   equal(strange_fcn(0) == strange_array[0], True, "strange 1");
   /* Here we call with fewer than normal parms, but that should be OK. */
   equal(stranger_fcn() == strange_fcn, True, "strange 2");
   equal(strangest_fcn() == stranger_fcn, True, "strange 3");

   {
   static char c10[10] = ". ";
   static char c3[3] = ". ";
   static char c2[2] = ". ";    /* Omits the terminating 0. */
   static char c[] = ". ";
   equal(strlen(c10),2,"c10");
   equal(strlen(c3),2,"c3");
   equal(strlen(c),2,"c");
   equal(sizeof c2,2,"c2");
   }
#ifdef HIGHC
   {
   void test() {
      /* Forwarded routine pops his own stack. Therefore we shouldn't. */
      routine_that_pops_its_own_stack(1);
   L:; /* Force any deferred pops to happen. */
      }
   test();
   void crash(void f()!) {
      int i;
      for (i = 0; i <= 32766; i++) f();
      }
   /* Previous bug:  This private procedure used a short calling convention
      on the 8086 rather than a long as required, as it is passed as a parm.
      The stack kept getting bigger.  Now the above loop will run the stack
      65K over the edge, since each invocation chews up 1 word. */
   #pragma on(check_stack);
   /* need to fairly close to 8K with a little room to spare */
   void f() {int a[1500];}
#ifndef STANDALONE
   crash(f);
#endif
   #pragma pop(check_stack);
   }
   {
/* int x; */      /* override typedef. */
   struct s {int a,b,c;};
   void test1() {
      struct s x = {1,2,3};
      void test2() {
        equal(x.a,1,"x.a");
        equal(x.b,2,"x.b");
        equal(x.c,3,"x.c");
        }
      test2();
      }
   /* Be sure up-level structure refs work with 860 ABI calling-convention. */
   test1();
   }
#endif
   /* Check out some initializations. */
   {
   static char *a1 = "bletch"+1;
   static char *a2 = 1+"bletch";
   static char *a3 = &"bletch"[1];
   char *d = a1+3;
   char *e = -4+&(d[1]);
   equal(strcmp(a1,a2),0,"I1");
   equal(strcmp(a2,a3),0,"I2");
   equal(*d,'c',"I3");
   equal(*e,'l',"I4");
   }
   /* ANSI standard:  when initializing unions, the first element is */
   /* initialized.  Also, a dynamic structure can be initialized with static */
   /* values.  */
   {
   struct s{union {int x,y; int z;} u; int q;} s[2] =
      {1, 2, 3, 4};
   equal(s[0].u.x == 1 && s[0].q == 2 && s[1].u.x == 3 && s[1].q == 4,True,
         "uinit");
   }
   {
   struct sb { char c[10]; }xx;
      {
      /* This next line does NOT introduce a new struct.  Only
       * "struct sb" can.
       */
      const struct sb;
      struct sa { struct sb *pb; } a;
      struct sb { struct sa *pa; } b;
      equal(sizeof(*a.pb),sizeof(xx),"struct ref");
      }
   }
   {
   /* The type of an enum literal must be int, not the type of the enum.
    * We indirectly check this via checking the size of the enum lit.
    */
   enum {red,white,blue} color;
   equal(sizeof(red),sizeof(int),"enumlit");
   }
   }

#ifdef HIGHC
#pragma on(callee_pops_when_possible);
static int routine_that_pops_its_own_stack(i) int i; {return i; }
#pragma pop(callee_pops_when_possible);
#endif

OLAY("O4")

stmt_tests() {
   enum L2 {L2} L3 = L2;
   ANNOUNCE("Statements.");
   /* labels should be distinct from other variables. */
   goto L2;
L2:L3 = L2;
   {
   int a[] = {1,3,5,7,11},j,prod = 1;
   for (j = 0; j < sizeof(a)/sizeof(int); j++) {
      int i;
      switch(a[j]) {
     	case 1: i = 1; break;
     	case 3: /* both 3 and 5 produce 5. */
     	   if (1) case 5: i=5;
     	   else case 7: i = 7;
     	   /* break not necessary due to while(0). */
   	 	while (0) {
     	   int j = 7; /* initialization won't be done. */
    	   case 11: i = 11;  /* We fall through to 13. */
     	   case 13: i = 13;
       	   }
     	}
      prod *= i;
      }
   equal(prod,1*5*5*7*13,"switch 1");
   }
   {
   int i,result = 0;
   for (i = -1; i <= 11; i++)
      switch(i)
     	default:
       	  if (i > 0)
            	case 2: case 3: case 5: case 7:
       	      result += 1;
      	  else
      	        case 4: case 6: case 8: case 9: case 10:
      	      result += 2;

   /*         -1 0 1 2 3 4 5 6 7 8 9 10 11  */
   equal(result,2+2+1+1+1+2+1+2+1+2+2+2 +1 ,"switch 2");
   }
   {
   int i = 0,j = 0;
   switch(1) i = 10; /* legal but strange. */
   switch(2) {
      default: i = 20;
      }
   switch(i++) {}  /* Can't throw entire swith away:  side effect. */
   switch(j=1,i+j,i++) {
      L: j--,i--;
      break;
      i--;   /* non-reachable statement */
      }
   if (j > 0) goto L;
   /* i is now 21:  we've incremented twice and decremented once. */
   equal(i,21,"switch 3");
   }

   {
   int j = 0;
   /* Can't "optimize" away any part of the switch except the switching. */
   switch(0) {
      case 0: j = 1; break;
      case 1:
     L4: j = 2;
      }
   if (j == 1) goto L4;
   equal(j,2,"switch 4");
   }
   {
   int i = 0,j;
   while (0) {
      L3: i++;
      }
   if (i <= 10) goto L3;
   equal(i,11,"while 0");
   for (i = 0; ; i++) if (i == 10) break;
   equal(i,10,"infinite for");
   for (;;) if (i++ == 20) break;
   equal(i,21,"inf for 2");
   while (0) while (1) while (0) while (1) while (0)
   while (0) while (1) while (0) while (1) while (0) i = 22;
   equal(i,21,"while^10");
   i = 0;
   /* Can't replace the loop by the loop body without making sure the break works. */
   do { if (i == 0) break; } while (0);
   j = 1;
   for (i = 0; ;) {
      if (++i < 10) continue;   /* Be sure continue continues. */
      if (i == 10) break; /* Be sure break breaks.   */
      j = 0;       /* should never set j to 0. */
      }
   equal(j,1,"cont");
   }
   /* ANSI requires being able to switch on any integral type, including long. */
   {long i; int result = 0;
   /* Does the switch code use only the lower 16 bits of the long?
    * ANSI standard requires any integral type for the switch.
    */
   i = 0xffff0000;
   i = i+1;
Forget:
   switch(i) {
      case 1: result = 1; break;   /* only 16 bits used. */
      case 0xffff0001: result = 2; break; /* all 16 bits used. */
      }
   equal(result,2,"long sw 1");
   }
   {
   long i; int result = 0;
#define Bignum 100000
   for (i = -1-Bignum; i <= 11-Bignum; i++)
      switch(i)
     	default:
     	   if (i-2 >= -1-Bignum)
     	      case 2-Bignum: case 3-Bignum: case 5-Bignum: case 7-Bignum:
     	    result += 1;
     	   else
     	      case 4-Bignum: case 6-Bignum: case 8-Bignum:
     	      case 9-Bignum: case 10-Bignum:
     	    result += 2;
   /*         -1 0 1 2 3 4 5 6 7 8 9 10 11  */
   equal(result,2+2+1+1+1+2+1+2+1+2+2+2 +1 ,"long sw 2");
   }
   {
   int j,k,l;
   unsigned uk;
   /* ANSI allows initializing auto arrays with constants only. */
   int cases[] = {0,6,74,14,16,15,17,-17,18,56,19,21,31,32,36,45,43,40,
      61,-15,59,60,71,72,81,99,-2,-18,-81,4,7,23,1000};
   Silent++;
#define case break; case
   for (l = 0; l < sizeof(cases)/sizeof(cases[0]); l++) {
      k = -999;
      switch(cases[l]) {
     	case 0: k = 0;   case 6: k = 6;         case 74:k = 74;
     	case 14:k = 14;  case 16: k = 16;       case 15: k = 15;
     	case 17: k = 17; case -17: k = -17;     case 18: k = 18;
     	case 56: k = 56; case 19: k = 19;       case 21: k = 21;
     	case 31: k = 31; case 32: k = 32;       case 36: k = 36;
     	case 45: k = 45; case 43: k = 43;       case 40: k = 40;
     	case 61: k = 61; case -15: k = -15;     case 59: k = 59;
     	case 60: k = 60; case 71: k = 71;       case 72: k = 72;
     	case 81: k = 81; case 99: k = 99;       case -2: k = -2;
     	case -18: k = -18;   case -81: k = -81;   case 4: k = 4;
     	case 7: k = 7;   case 23: k = 23; break;
     	default: k = 1000;
     	}
      equal(k,cases[l],"case 1");
      }
   for (l = 0; l < sizeof(cases)/sizeof(cases[0]); l++) {
      uk = -999;
      switch((unsigned) cases[l]) {
     	case 0: uk = 0;   case 6: uk = 6;    case 74:uk = 74;
     	case 14:uk = 14;  case 16: uk = 16;  case 15: uk = 15;
     	case 17: uk = 17;     case -17: uk = -17;  case 18: uk = 18;
     	case 56: uk = 56;     case 19: uk = 19;    case 21: uk = 21;
     	case 31: uk = 31;     case 32: uk = 32;    case 36: uk = 36;
     	case 45: uk = 45;     case 43: uk = 43;    case 40: uk = 40;
     	case 61: uk = 61;     case -15: uk = -15;  case 59: uk = 59;
     	case 60: uk = 60;     case 71: uk = 71;    case 72: uk = 72;
     	case 81: uk = 81;     case 99: uk = 99;    case -2: uk = -2;
     	case -18: uk = -18;   case -81: uk = -81;  case 4: uk = 4;
     	case 7: uk = 7;   case 23: uk = 23; break;
     	default: uk = 1000;
     	}
      equal(uk,(unsigned)cases[l],"case 2");
      }
   }
   {
   int j,l; long k;
   uli uk;
   /* ANSI allows initializing auto arrays with constants only. */
   long cases[] = {0,0x0fff0000,6,74,14,16,15,17,-17,18,56,19,21,31,32,36,45,43,40,
      61,-15,59,59+0x0fff0000,60,71,72,81,99,-2,-18,-81,4,7,23,1000,
      0x80000000,0x80000001,0x80000002,0x70000000};

   for (l = 0; l < sizeof(cases)/sizeof(cases[0]); l++) {
      k = -999;
      switch(cases[l]) {
        case 0x0fff0000: k = 0x0fff0000;
     	case 0: k = 0;   case 6: k = 6;         case 74:k = 74;
     	case 14:k = 14;  case 16: k = 16;       case 15: k = 15;
     	case 17: k = 17; case -17: k = -17;     case 18: k = 18;
     	case 56: k = 56; case 19: k = 19;       case 21: k = 21;
     	case 31: k = 31; case 32: k = 32;       case 36: k = 36;
     	case 45: k = 45; case 43: k = 43;       case 40: k = 40;
     	case 61: k = 61; case -15: k = -15;     case 59: k = 59;
     	case 59+0x0fff0000: k = 59+0x0fff0000;
     	case 60: k = 60; case 71: k = 71;       case 72: k = 72;
     	case 81: k = 81; case 99: k = 99;       case -2: k = -2;
     	case -18: k = -18;   case -81: k = -81;   case 4: k = 4;
     	case 7: k = 7;   case 23: k = 23; break;
     	default: k = 1000; break;    /* default can go anywhere. */
         case 0x80000000: k = 0x80000000; case 0x80000001: k = 0x80000001;
         case 0x80000002: k = 0x80000002; case 0x70000000: k = 0x70000000;
     	}
      lequal(k,cases[l],"lcase 1");
      }
   for (l = 0; l < sizeof(cases)/sizeof(cases[0]); l++) {
      uk = -999;
      switch((uli) cases[l]) {
        case 0x0fff0000: uk = 0x0fff0000;
     	case 0: uk = 0;   case 6: uk = 6;    case 74:uk = 74;
     	case 14:uk = 14;  case 16: uk = 16;  case 15: uk = 15;
     	case 17: uk = 17;     case -17: uk = -17;  case 18: uk = 18;
     	case 56: uk = 56;     case 19: uk = 19;    case 21: uk = 21;
     	case 31: uk = 31;     case 32: uk = 32;    case 36: uk = 36;
     	case 45: uk = 45;     case 43: uk = 43;    case 40: uk = 40;
     	case 61: uk = 61;     case -15: uk = -15;  case 59: uk = 59;
     	case 59+0x0fff0000: uk = 59+0x0fff0000;
     	case 60: uk = 60;     case 71: uk = 71;    case 72: uk = 72;
     	case 81: uk = 81;     case 99: uk = 99;    case -2: uk = -2;
     	case -18: uk = -18;   case -81: uk = -81;  case 4: uk = 4;
     	case 7: uk = 7;   case 23: uk = 23; break;
     	default: uk = 1000; break;    /* default can go anywhere. */
         case 0x80000000: uk = 0x80000000;
         case 0x80000001: uk = 0x80000001;
         case 0x80000002: uk = 0x80000002;
         case 0x70000000: uk = 0x70000000;
     	}
      lequal(uk,(uli)cases[l],"lcase 2");
      }
#undef case
   Silent--;
   }
   {static x,z=10;
    static *y[4] = {&z,&z,&z,0};
   for (x = 0; y[x]; x++)
      *y[x] += x ? x : *y[x];
   equal(x,3,"for");
   equal(z,23,"for");
   }
   {static x,z=0;
    static *y[4] = {&z,&z,&z,0};
   for (x = 0; y[x]; x++)
      *y[x] += *y[x] ? *y[x] : x;
   equal(x,3,"for");
   equal(z,2,"for");
   }
   {
   static int i=0,j=1,x=0;
   static int *a[10]={&i,&j};
   i = int_ident(i);
   *a[i] = *a[i] + (*a[i]==1 || x || *a[j]==1);
   equal(i,1,"*a||");
   }
   }

struct s return_str1() { return str1; }
#ifdef HC
/* High C extension only. */
/* Test out the UNIX convention of return structure via address of static.
   It's a space and time waster, but we have to match UNIX sometimes. */
#pragma calling_convention(_CALLING_CONVENTION | _RETURN_AGGREGATE_AS_POINTER);
struct s return_str1_() { return str1; }
#pragma calling_convention();   /* pop. */
#endif

typedef void (*func_type)();
int afunc() {}
/* Test casts of function types in initializations. */
func_type f = (func_type) afunc;

void calls() {
   int i;
   ANNOUNCE("Function calls");
   equal_struct(return_str1(),str1,"str rtn");
#ifdef HC
   equal_struct(return_str1_(),str1,"str rtn_");
#endif
   /* Check optimization of long int constants on the 8088. */
   i = int_ident(0);
#define Check(x,y,i2) \
   lequal(longint_ident(i?(x):(y)),(long) ((i2*(x)) + ((1-i2)*(y))) ,"lic")
   Check(23L,32768L,0);
   Check(65000L,-34000L,0);
   Check(0xFFFFFFFF,0xFFFF8000,0);
   Check(0xfffefffe,0xfffe8000,0);
   Check(-3L,32767L,0);
   Check(-1L,32766L,0);
   i = int_ident(1);
   Check(23L,32768L,1);
   Check(65000L,-34000L,1);
   Check(0xFFFFFFFF,0xFFFF8000,1);
   Check(0xfffefffe,0xfffe8000,1);
   Check(-3L,32767L,1);
   Check(-1L,32766L,1);
#undef Check
   }

CV2() {
   int i;       /* An int. */
   int *pi;     /* A pointer to an int. */
   const int ci;      /* A const int. */
   const int *pci;    /* A pointer to a const int. */
   int *const cpi = &i;    /* A const pointer to an int. */
   const int *const cpci   /* A const pointer to a const int. */
          = &ci;
   struct s {int x;} *ps; const struct s* cps;
   /* More to follow; see new "errors.c" in the suite when it's finished. */
   /* ci = 1;  */       /* Illegal. */
   /* *pci = 1; */      /* Illegal. */
   pci = &ci;      /* Legal to assign into pci. */
   pci = &i; /* Legal: pointer-to-non-const into a pointer-to-const. */
   cps = ps;
   /* pi = &ci;  */     /* Illegal: pointer-to-const can't go into pointer. */
   /* cpi = &ci;  */    /* Illegal:  cpi is a const. */
   /* cpci = &ci; */    /* Illegal: same reason. */
   /* Check support of void intermixed with const/volatile. */
   { typedef void VOID;   /* Just to make things more confusing. */
     { VOID *vp; int *ip; vp = ip; ip = vp; }
     { const VOID *vp; const int *ip; vp = ip; ip = vp; }
     { const volatile VOID *vp; const volatile int *ip; vp = ip; ip = vp; }
     { volatile VOID *vp; volatile int *ip; vp = ip; ip = vp; }
   }
   /* The standard now allows array[] to be "type equivalent" to array[10]. */
   { char (*a1)[], (*a2)[10]; a1 = a2; a2 = a1; if (a1 == a2) a1; }
#ifdef HIGHC
#ifdef _LOC  /* GOC doesn't support this yet. */
   /* Regression. */ /* High C permits non-static initializers. */
   { int a[10]; const struct {int *p;} x = {a}; x.p[3] = 3; }
#endif
#endif
   {
   #define addr ((timer*)0x40)
   typedef struct{char t0,t1,t2;char ct1;} timer;
   /* Strange address computation. */
   equal((unsigned int) &addr->ct1, 0x40+3, "timer*");
   }
   }

const_volatile() {
   ANNOUNCE("Const/volatile.");
   /* Ensure no syntax error for legal declarations. */
   CV2();
   }

/* Don't ever call this; just be sure we can compile.  Regression test. */
regress1() {
   char log_on,time_on;
   int ii;
   int j =   ii ? (( log_on || time_on ? regress1(1): 0), 0) : 0;
   regress1(j);
   }
regress2() {
   int foo[10], *fooptr = foo;
   int i;
   for (i=0; i < 10; i++) foo[i]=i+1;
   i = 10;
   while (i--) *(fooptr++) *= 10;
   for (i=0; i < 10; i++) equal(foo[i],(i+1)*10,"re2");
   }
regress3() {
   char *p = "hi";
   *p++ != 0;
   /* Make sure we didn't throw away all of the above stmt. */
   equal(*p,'i',"++|");
   {
   static int q[] = {3,4},k,*p=q;
   *p = (k=*p++);
   equal(k,3,"*p*p");
   }
   }
regress4(int x, int y, int z, int a, int b, int c) {
       /*  A  B  C  D  E  F      B C D E F */
   int cnt[2][2][2][2][2][2] = { { { { { {0} } } } },
          /*     B     C     D     E     F */
              { {0},{ {0},{ {0},{ {0},{0,7} } } } }
                 };
   cnt[x][y][z][a][b][c]++;
   cnt[x][y][z][a][b][c]+=1;
   equal(cnt[x][y][z][a][b][c],9,"6[]s");
   }

/* Make sure no artificial limit on number of parameters. */
void lotsaparms(
   p00, p01, p02, p03, p04, p05, p06, p07, p08, p09,
   p10, p11, p12, p13, p14, p15, p16, p17, p18, p19,
   p20, p21, p22, p23, p24, p25, p26, p27, p28, p29,
   p30, p31, p32, p33, p34, p35, p36, p37, p38, p39,
   p40, p41, p42, p43, p44, p45, p46, p47, p48, p49,
   p50, p51, p52, p53, p54, p55, p56, p57, p58, p59,
   p60, p61, p62, p63, p64, p65, p66, p67, p68, p69,
   p70, p71, p72, p73, p74, p75, p76, p77, p78, p79,
   p80, p81, p82, p83, p84, p85, p86, p87, p88, p89,
   p90, p91, p92, p93, p94, p95, p96, p97, p98, p99,
   pa0, pa1, pa2, pa3, pa4, pa5, pa6, pa7, pa8, pa9,
   pb0, pb1, pb2, pb3, pb4, pb5, pb6, pb7, pb8, pb9,
   pc0, pc1, pc2, pc3, pc4, pc5, pc6, pc7, pc8, pc9) {
   /* Make sure parameter passing on weird machines works with lots of parms. */
   /* Spot check the various parms. */
   /* We could use var args and get them all ... */
   equal(p00,0x00,"p00");
   equal(p10,0x10,"p10");
   equal(p20,0x20,"p20");
   equal(p30,0x30,"p30");
   equal(p40,0x40,"p40");
   equal(p50,0x50,"p50");
   }

void far_tests() {
#if defined HIGHC && (defined _MSDOS || defined _OS2) && _I286
   if (sizeof(int) != 2) return;   // Test only for 16-bit 8086.
   static _far uli x,*p = &x;
   int f(uli a, uli b, uli _far *p) {
      if (a && b > *p) return 1;
      return 0;
      }
   equal(1,f(1,2,p),"_far");
#endif

   }

char *time2 = __TIME__;

void main (argc,argv)
   int argc; char *argv[];
   {
   announce("**** START OF TESTS, suite2 ****");
   if (argc > 1) Silent = 0;  /* For purposes of testing */
   Initialize();
   /* __TIME__ should not differ during compilation. */
   equal(strcmp(time1,time2),0,"times");
   multiplicative_ops();
   more_multiplicative_ops();
   const_mpys();
   unsigned_bit_fields();
   signed_bit_fields();
   casts();
   const_volatile();
   misc_expns();
   dcln_tests();
   stmt_tests();
   calls();
   far_tests();
   lotsaparms(
    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
    0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19,
    0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29,
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
    0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
    0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
    0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
    0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
    0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
    0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,
    0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
    0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
    0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9);
   regress2();
   regress3();
   regress4(1,1,1,1,1,1);
   announce("**** END OF TESTS, suite2 ****");
   exit(0);
   }
