#if 0
***************************************************************************
*  Copyright 1985-1992 MetaWare Incorporated.  All rights reserved.       *
*  This is an unpublished work, Copyright 1985-1992 by MetaWare           *
*  Use, disclosure, or transfer without the express written permission    *
*  of MetaWare Incorporated is strictly prohibited.                       *
*  If any or part of this source code is incorporated into other source   *
*  code not authored by MetaWare, this copyright notice must              *
*  accompany it.                                                          *
***************************************************************************
*  See file "suite0.c" for more information.                              *
***************************************************************************
#endif

#ifndef lint
static const char rcsid[] = "$Header: /sun3/tlib/suite_c/RCS/suite3.c,v 1.24 1993/07/07 14:27:51 pickens Exp $";
#endif

/*
 * $Log: suite3.c,v $
 * Revision 1.24  1993/07/07  14:27:51  pickens
 * removed an integer constant folding overflow
 *
 * Revision 1.23  1993/05/28  20:01:21  pickens
 * ifdef out _stricmp for non-HighC
 *
 * Revision 1.22  1993/03/15  21:38:50  marcusm
 * Blocked out renaming an open file for _MSNT and _OS2.
 *
 * Revision 1.21  1993/03/05  19:38:51  tom
 * setjmp_right_size
 *
 * Revision 1.20  1993/02/05  16:09:30  pickens
 * Fixed bogus test: stdarg2_test
 *
 * Revision 1.19  1993/02/04  17:03:06  pickens
 * stdarg3 is a non-ANSI test that fails for _SPARC; ifdef'd it out for SPARC
 *
 * Revision 1.18  1992/12/24  23:03:41  marcusm
 * Now uses setjmp.h for jmp_buf, setjmp, and longjmp declarations
 *
 * Revision 1.17  1992/12/16  23:44:03  pickens
 * NOLONGDOUBLE
 *
 * Revision 1.16  1992/12/14  19:40:47  marcusm
 * Modified  a file i/o test to close all files it opens.  Was causing
 * a failure on Hobbit, where very few files can be opened at a time.
 *
 * Revision 1.15  1992/11/04  05:30:32  marcusm
 * Corrected _rstrncpy test which was unreliable due to documented
 * "undefined behavior" under the conditions of the test.
 *
 * Revision 1.14  1992/11/03  22:39:50  marcusm
 * Added _stricmp tests
 *
 * Revision 1.13  1992/08/04  21:12:14  tom
 * *** empty log message ***
 *
 * Revision 1.11  1992/08/03  20:48:25  pickens
 * Restore ansi-ability
 *
 * Revision 1.10  1992/07/30  15:45:25  pickens
 * Don't assume MW's esoteric functions for Solaris
 *
 * Revision 1.9  1992/07/09  06:25:48  tom
 * Make thomasn's test ansi.
 *
 * Revision 1.8  1992/06/29  14:36:30  thomasn
 * add unget-fseek test
 *
 * Revision 1.7  1991/11/26  02:20:33  tom
 * Fix bug in s2meg test on machines with generous padding.
 *
 * Revision 1.6  1991/11/25  15:35:25  thomasn
 * eliminated special MSDOS logic for fscanf eof 3
 *
 * Revision 1.5  1991/07/15  12:51:34  thomasn
 * setup_new_testlib
 *
 * Revision 1.4  91/06/07  15:12:03  pickens
 * change "equal(a==b,TRUE,...)"  to equal(a,b,...)
 * 
 * Revision 1.3  91/05/15  09:05:28  donw
 * Fixed strncat bug in test program.
 * 
 * Revision 1.2  91/04/04  08:01:15  pickens
 * Undo last change the render file uncompilable from ANSI
 *
 * Revision 1.1  91/03/29  17:03:29  donw
 * Initial revision
 *
 */


#define ANSI

#ifdef QUIET
#define ANNOUNCE1(x)
#else
#define ANNOUNCE1(x)  announce(x)
#endif

/* THIS TEST assumes an ANSI library.
 * There are tests of _functions in the MetaWare library
 * that other users of this suite can easily delete.
 */

#if !(defined PARTA || defined PARTB)
#define PARTA
#define PARTB
#endif

extern int isalnum(),isalpha(),iscntrl(),isdigit(),isgraph(),islower(),
               isprint(),isspace(),isupper(),isxdigit(),tolower(),toupper(),
               ispunct();

#define glue(a,b) a ## b
#define glue2(a,b) glue(a,b)
#if 0
#define X <glue2(glue2(str,in),g).  h  /* include
          string.h
           */>    /* <- here is the rangle. */
#include X
#endif
#define STRING_H <string.h>
#include STRING_H
#include <stdarg.h>
#include <stddef.h>
#include <ctype.h>
#include <time.h>
#include "which.h"
#include "globals.h"
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <limits.h>
#include <float.h>
#include <setjmp.h>

#if !_SGL
OLAY("LIBTEST") /* Force public segment for overlaying purposes. */
#endif

void test_heap();
void stdio_tests(int use_setvbuf);
void stdarg_tests();
void time_tests();
void locale();
void Initialize();
/*
int longjmp(void *, int);
int setjmp(void *);
*/
void EOL_stdio_test();

#define nil ((void *)0)

#include <stdio.h>

void spot_trans() {
#ifdef PARTA
   /* Check both in-line and out-of-line; in-line code might be different. */
   double d1,d2,f,g; int i,j;
#ifdef HIGHC
#define PI 3.14159_26535_89793_23846_26433_83279_50288_41971_69399_37510
#define E  2.71828_18284_59045_23536_02874_71352_66249_77572_47093_69995
#else
#define PI 3.14159265358979323846264338327950288419716939937510
#define E  2.71828182845904523536028747135266249775724709369995
#endif
#define dtol .000001
#define TT(f,fmsg,in,out) {\
        d1 = in; d2 = f(d1); dequal(d2,(double)out,dtol,fmsg);\
        dequal(f((double)in),(double)out,dtol,fmsg);}
                /* 2nd call can do CSEs for the input. */
   printf("Spot check of transcendentals.\n");
   TT(acos,"acos",-1,PI);
   TT(asin,"asin",-1,-PI/2);
   TT(atan,"atan",-1,-PI/4);
   TT(tan,"tan",-PI/4,-1);
   TT(sin,"sin",-PI/2,-1);
   TT(cos,"cos",PI,-1);
   dequal(sin(2.2),.8084964038,dtol,"sin2");
   dequal(cos(2.2),-.5885011173,dtol,"cos2");
   TT(cosh,"cosh",-1.2318879e-6,1);
   TT(sinh,"sinh",-1.2318879e-6,-1.2318879e-6);
   TT(tanh,"tanh",-7.7831234832e-1,-6.517369705676921e-1);
   TT(sqrt,"sqrt",7e+2,2.645751311064591e+1);
   TT(log10,"log10",5.503e-1,-2.594004871888435e-1);
   TT(log,"log",1.3312423,2.861125664213119e-1);
   TT(exp,"exp",-2.342340032e-3,9.976604011057695e-1);
   dequal(atan2(-3.34211234,3.536218182219072e-2),-1.560215933714556,dtol,"atan2");
   dequal(pow(-2.03323232e+1,-1.0),-4.918277120442389e-2,dtol,"pow");
   /* tests included by prakash are below */
   equal((int)ceil(1.55741),2,"ceil1");
   equal((int)ceil(0.55741),1,"ceil2");
   dequal(fabs(-2.0),2.0,dtol,"fabs1");
   dequal(fabs(0.0),0.0,dtol,"fabs2");
   dequal(fabs(-0.052),0.052,dtol,"fabs3");
   dequal(floor(0.052),0.0,dtol,"floor1");
   dequal(floor(2.999),2.0,dtol,"floor2");
   dequal(fmod(0.0,3.987),0.0,dtol,"fmod1");
   dequal(fmod(-2.0,1.987),-(2.0-1.987),dtol,"fmod2");
   dequal(fmod(20.1,4.019),20.1-(5 * 4.019),dtol,"fmod3");
   dequal(frexp(2.4,&i),0.6,dtol,"frexp1");
   dequal(frexp(3.6,&j),0.9,dtol,"frexp2");
   dequal(ldexp(3.6,2),14.4,dtol,"ldexp1");
   dequal(ldexp(-3.6,3),-28.8,dtol,"ldexp2");
   dequal(modf(3.6235,&f),0.6235,dtol,"modf1");
   dequal(modf(362.135,&g),0.135,dtol,"modf2");

#undef TT
#undef dtol
#endif
   }
struct info {            /* struct info & function compare are */
   char name[8];         /* used in bsearch & qsort tests. */
   int age;
   char phone[9];
   };
static int compare(const void *item1, const void *item2) {
   const struct info *a;
   const struct info *b;
   a = (const struct info *)item1;
   b = (const struct info *)item2;
   if (a->age < b->age) return (-1);
   else if (a->age > b->age) return (1);
   else return(strcmp(a->name, b->name));
   }

/* Note that this does NOT work in general for sorting short ints
 * due to possible overflow.
 */
static int compare_shorts(const void *item1, const void *item2) {
   const short *a = item1, *b = item2;
   return (*a - *b);
   }


/* This buffer ought to be big enough for most systems. */
/*
    Now includes setjmp.h for this definition.
typedef int jmp_buf[40];
*/

jmp_buf Buf; int loopcnt=0;
static void loop(j) {
   if (++loopcnt < j) loop(j);
   else longjmp(Buf,1);
   }

void Doit(str,proc) char *str; void (*proc)(); {
   FILE *F;
   proc(False,0);
   F = tmpfile();
   fwrite(str,strlen(str),1,F);
   fwrite(str,0,1,F);   /* Write 0 bytes; make sure it works. */
/* fseek(F,0,SEEK_SET); UNIX doesn't have SEEK_SET. */
   fseek(F,0,SEEK_SET);
   proc(True,F);
   fclose(F);
   }

char *input1 =
   "eleven char10 %-11 stuff up to za-string  fff 0xffe 0777 6.6e2";

void Check1(which,file) int which; FILE *file; {
#ifdef PARTB
   static char *fmat  = "%11c%d %%%d %50[^z]%s%X%i%i%f";
   int items;
   typedef char space[50];
   space s1, s2, s3;
   int d1,d2,d3,d4,d5; float f1;
   char * s1copy = memset(s1,0,sizeof(s1));
   equal(s1copy==s1,True,"memsetrtn");
   items = which == 0 ?
           sscanf(input1,fmat,s1,&d1,&d2,s2,s3,&d3,&d4,&d5,&f1) :
           fscanf(file,fmat,s1,&d1,&d2,s2,s3,&d3,&d4,&d5,&f1);
        printf("%s\n",s1);
   equal(strcmp(s1,"eleven char"),0,"sf1");
   equal(d1,10,"sf2");
   equal(d2,-11,"sf3");
   equal(strcmp(s2,"stuff up to "),0,"sf4");
   equal(strcmp(s3,"za-string"),0,"sf5");
   equal(d3,0xfff,"sf6");
   equal(d4,0xffe,"sf7");
   equal(d5,0777,"sf8");
   equal(f1 == 6.6e2,1,"sf9");
   equal(items,9,"sf10");
#endif
   }

char input2[80] = "10 0xff 06 4 1e string cabc 0.2%abcbcbcafor nought.d more";

void Check2(which,file) int which; FILE *file; {
#ifdef PARTB
   int i,j,items; char *s, *t, *u, *x, *y;
   char line1[50], line2[50];
   char line3[50];
   char line4[50], line5[50],Bigbuf[512];
   static char fmat[] = "%d %i%o%u%x %s %c%3c%lf%n%%%[abc]%[^d]";
   int k,l,m,n;
   double f;
   line2[0] = line3[0] = 0;
   s = line1; t = line2; u = line3, x = line4, y = line5;
   items = which == 0 ?
           sscanf(input2, fmat, &i,&j,&k,&l,&m,s,t,u,&f,&n,x,y) :
           fscanf(file, fmat, &i,&j,&k,&l,&m,s,t,u,&f,&n,x,y);
   sprintf(Bigbuf,"%1d %1i %1o %1u %1x %s %.1s %.3s %f %d %% %s %s",
          i,j,k,l,m,s,t,u,f,n,x,y);
   equal(strcmp(Bigbuf,
      "10 255 6 4 1e string c abc 0.200000 31 % abcbcbca for nought."),
      0,"sf II");
   equal(items,11,"sf IIa");
#endif
   }

void scanf_tests() {
   /* test of scanf, according to ANSI standard. Brief for now. */
   Doit(input1,Check1);
   Doit(input2,Check2);
   /* Regression */
   { int i;
   sscanf("X 123","%*1s%d",&i);
   equal(i,123,"X 123");
   }
   }

void string_comparisons() {
#ifdef PARTA
   char *s1 = "abcd", *s2 = "abce", *s3 = "abc";
   ANNOUNCE1("String comparisons\n");
   /* String comparisons */
   equal(strcmp(s1,s2) < 0,True,"s1:s2");
   equal(strcmp(s2,s1) > 0,True,"s1:s2");
   equal(strcmp(s3,s1) < 0,True,"s3:s1");
   equal(strcmp(s1,s3) > 0,True,"s1:s3");
   equal(strcmp(s1,s1) == 0,True,"s1:s2");
   equal(strncmp(s1,s3,2) == 0,True,"s1:s3:2");
   equal(strncmp(s1,s2,5) < 0,True,"s1:s2:5");

   /* Check for sloppily optimized strcmps: */

   equal(strcmp("abcd","abce") < 0,True,"sc0");
   equal(strcmp("abce","abcd") > 0,True,"sc1");
   equal(strcmp("abcd","abcd") == 0,True,"sc2");

   equal(strcmp("abdd","abed") < 0,True,"sc3");
   equal(strcmp("abed","abdd") > 0,True,"sc4");

   equal(strcmp("adcd","aecd") < 0,True,"sc5");
   equal(strcmp("aecd","adcd") > 0,True,"sc6");

   equal(strcmp("dbcd","ebcd") < 0,True,"sc7");
   equal(strcmp("ebcd","dbcd") > 0,True,"sc8");

   /* Max's tests: */
   {
   char S2[80], S3[80], S4[80];
   char S1[80]= "abcdefghijklmnopqrstuvwxyz 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   equal(memcpy(S2, S1, 26) == S2,True,"mc 21");
   equal(memset(&S2[26],'@',10) == &S2[26],True,"ms 26@");
   S2[36] = 0;
   equal(strcpy(S3, S1) == S3,True,"cpy 31");
   equal(strncpy(S4, S2, 40) == S4,True,"ncpy 42");
   }
   {
   char S1[80]= "abcdefghijklmnopqrstuvwxyz 0123456789";
   char S2[80] = " catenation";
   char S3[80];
   sequal(strcat(S1, S2),S1,"cat 12");
   sequal(strncat(S1, S2, 4),S1,"ncat 12");
   sequal(strcpy(S3, S1),S3,"cpy 31");
   equal(memcmp(S3, S1, 26),0,"mc 1");
   S1[2] = 'a';
   equal(memcmp(S3, S1, 26)>0,1,"mc 2");
   S1[2] = 'b';
   S3[2] = 'a';
   equal(memcmp(S3, S1, 26)<0,1,"mc 3");
   S3[2] = 'b';
   equal(strcmp(S3, S1),0,"sc 1");
   S1[2] = 'a';
   equal(strcmp(S3, S1)>0,True,"sc 2");
   S1[2] = 'b';
   S3[2] = 'a';
   equal(strcmp(S3, S1)<0,True,"sc 3");
   S3[2] = 0;
   equal(strcmp(S3, S1)<0,True,"sc 4");
   equal(strlen(S3),2,"sl 1");
   equal(strlen(S2),11,"sl 2");
   S3[2] = 'b';
   equal(strncmp(S3, S1, 26),0,"snc 1");
   S1[2] = 'a';
   equal(strncmp(S3, S1, 26) > 0,True,"snc 2");
   S1[2] = 'b';
   S3[2] = 'a';
   equal(strncmp(S3, S1, 26) < 0,True,"snc 3");
   S3[2] = 0;
   equal(strncmp(S3, S1, 26) < 0,True,"snc 4");
   }
   {
   char S1[80]= "abcdefghijklmnopqrstuvwxyz 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   char Tokenized[100];
   char S2[80] = "fghij";
   char S3[80] = "abcde";
   char S4[80] = "abclo6RSTVY";
   char *P5;

   equal((* (char *)memchr(S1, 'i', 26)),'i',"mc 1");
   equal(memchr(S1, '?', 26) == NULL,True,"mc 2");
   equal(*strchr(S1, 'i'),'i',"stc 1");
   equal(strchr(S1, '?') == 0,True,"stc 2");

   equal(strcspn(S1,S2),5,"strc 1");
   equal(strcspn(S1,S3),0,"strc 2");
   equal(strspn(S1,S2),0,"strs 1");
   equal(strspn(S1,S3),5,"strs 2");
   equal(*strpbrk(S1,S2),'f',"strp 1");
   equal(strpbrk(S1,"") == nil,True,"strp 2");

   strcpy(Tokenized,strtok(S1,S4));
   while ( (P5 = strtok((char *)0,S4)) != 0)
      {strcat(Tokenized,P5); strcat(Tokenized," ");}
   equal(strcmp(Tokenized,
      "defghijk mn pqrstuvwxyz 012345 789 ABCDEFGHIJKLMNOPQ U WX Z ")>0,
      True,"strtok");
   }
   #if defined HIGHC && !_SOL	/*We don't use MW library on Solaris*/
   {   /* included by prakash */
   char S7[]= "abcde";
   char S8[]="efghcbh453xAghghc";
   char s2[]="56789";
   char s3[]="983516279156112";
   char s4[]="a9b8c3d6";

   equal(strcmp(_rstrncpy(s2,&s2[3],3),s2)==0 && strcmp(s2,"89")==0,1,"rstrncpy3");
   equal(strcmp(_rstrncpy(S8,&S8[10],4),S8)==0,1,"rstrncpy4");
   equal(strcmp(_rmemcpy(S7,&S7[3],2),S7)==0 && strcmp(S7,"decde")==0,1,"rmemcpy3");
   equal(strcmp(_rstrcpy(s3,&s3[10]),s3)==0 && strcmp(s3,"56112")==0,1,"rstrcpy3");
   equal(strcmp(_rstrcpy(s4,&s4[5]),s4)==0 && strcmp(s4,"3d6")==0,1,"rstrcpy4");
   }
   {  /*included by Prakash */
   char s1[]="983516279156112";
   char t5[]="983516279156112433";

   equal(*(strrchr(t5,'1'))=='1' && strrchr(&t5[14],'1')==NULL,1,"strrchr1");
   equal(*(strrchr(s1,'9'))== '9' && strrchr(&s1[9],'9')==NULL,1,"strrchr2");
   }
   {   /* included by prakash */
   char S7[]= "abcde";
   char S1[]="abcdefghijklmnopqrstuvwxyz 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   char S8[]="efghcbh453xAghghc";
   char s2[]="5678";
   char s3[]="983516279156112";

   equal(strcmp(_rstrncpy(S8,s2,3),S8)==0 && strcmp(&S8[3],&s2[3])!=0,1,"rstrncpy1");
   equal(strcmp(_rstrncpy(S1,s2,4),S1)==0 && strcmp(&S1[4],&s2[4])!=0,1,"rstrncpy2");

   equal(strcmp(_rmemcpy(S8,s3,10),S8)==0 && strcmp(&S8[10],&s3[10])!=0,1,"rmemcpy1");
   equal(strcmp(_rmemcpy(&s3[5],s3,6),&s3[5])==0,1,"rmemcpy2");

   equal(strcmp(_rstrcpy(S8, s2), S8)==0,1,"rstrcpy1");
   equal(strcmp(_rstrcpy(S7, s2), S7)==0,1,"rstrcpy2");
   }
   { /*included by Prakash */
         char s1[21]= "this ";
         char s2[]="string ";
        char s3[17]="contains ";
   s1[18]=0;
#if _MSDOS
   sequal("this string contai",_strcats(19,s1,s2,s3,NULL),"_strcats");
   sequal(_strncat(s3,s2,17),"contains string ","_strncat");
#else
   equal(strcmp("this string conta",_strcats(18,s1,s2,s3,NULL)),0,"_strcats");
   /*
    * Here we assume that _strncat does not null-terminate if the string
    * exceeds its designated length. This convention is subject to change.
    */
   s3[15]='\0';
   sequal(_strncat(s3,s2,15),"contains strin","_strncat");
#endif
   }
   #endif
   {
   char s1[]= "qabcdeabcfgabc";
   char s2[]= "abc";
   char s3[]="";
   char s4[]="abcd";
   char s7[]="a thing of beauty is a joy for ever..!";
   char *p;
   /* Problem in test?
   p = strstr(s1, s2);
   equal(strcmp(strstr(s1,s2),"abcdeabcfgabc"),0,"strstr 1");
   equal(strcmp(strstr(s1,s3),s1),0,"strstr 2");
      strstr(s1,s2) doesn't return s1 when s2 points to a string with zero
        length which it is supposed to.
   equal(strstr(s7,s4),0,"strstr 3");
   */
   equal(strcmp((p=memmove(s7,&s7[18],11)),s7),0,"memmove 1");
   /* memove(s1,s2,n) writes n bytes from s1 to s2 & not from s2 to s1
      which it is supposed to. */
   equal((p==s7), True, "memmove 2");
   equal(strcoll(s2,s4)<0,1,"strcoll1");
   equal(strcoll(s4,s2)>0,1,"strcoll2");
   {int i = strxfrm(s4,s2,4);
   equal(i>0,1,"strxfrm1");
   equal(strlen(s4),i,"strxfrm2");
   }
   }
#endif
   {
   /* Ensure correct code generation for special cases that may be
    * (possibly incorrectly) optimized.
    */
   char a[10];
   strcpy(a,"x");
   equal(strcmp(a,"x"),0,"x");
   strcpy(a,"xy");
   equal(strcmp(a,"xy"),0,"xy");
   strcpy(a,"xyz");
   equal(strcmp(a,"xyz"),0,"xyz");
   strcpy(a,"xyza");
   equal(strcmp(a,"xyza"),0,"xyza");
   strcpy(a,"xyzab");
   equal(strcmp(a,"xyzab"),0,"xyzab");
   strcpy(a,"xyzabc");
   equal(strcmp(a,"xyzabc"),0,"xyzabc");
   strcpy(a,"xyzabcd");
   equal(strcmp(a,"xyzabcd"),0,"xyzabcd");

#ifdef __HIGHC__
   equal(_stricmp("Unsigned", "void") < 0, 1, "_stricmp1" );
   equal(_stricmp("void", "Unsigned") > 0, 1, "_stricmp2" );
   equal(_stricmp("Unsigned", "uNSignEd"), 0, "_stricmp3" );
   equal(_stricmp("unsigned", "VOID") < 0, 1, "_stricmp4" );
   equal(_stricmp("VOID", "unsigned") > 0, 1, "_stricmp5" );
   equal(_stricmp("unsigned", "void") < 0, 1, "_stricmp6" );
   equal(_stricmp("void", "unsigned") > 0, 1, "_stricmp7" );
#endif
   }
   }

/* ctype_tests included by prakash */

void ctype_tests() {
#ifdef PARTB
#define ctype_equal(fcn,test,x,y) equal(fcn test,x,y), equal((fcn)test,x,y)
        ctype_equal(isalnum,('6')!=0,1,"isalnum1");
        ctype_equal(isalnum,('0')!=0,1,"isalnum2");
        ctype_equal(isalnum,('a')!=0,1,"isalnum3");
        ctype_equal(isalnum,('#')==0,1,"isalnum4");

        ctype_equal(isalpha,('A')!=0,1,"isalpha1");
        ctype_equal(isalpha,('@')==0,1,"isalpha2");

        ctype_equal(iscntrl,('')!=0,1,"iscntrl1");
        ctype_equal(iscntrl,('#')==0,1,"iscntrl2");

        ctype_equal(isdigit,('6')!=0,1,"isdigit1");
        ctype_equal(isdigit,('0')!=0,1,"isdigit2");
        ctype_equal(isdigit,('a')==0,1,"isdigit3");
        ctype_equal(isdigit,('#')==0,1,"isdigit4");

        ctype_equal(isgraph,('A')!=0,1,"isgraph1");
        ctype_equal(isgraph,(' ')==0,1,"isgraph2");
        ctype_equal(isgraph,('*')!=0,1,"isgraph3");
        ctype_equal(isgraph,('#')!=0,1,"isgraph4");

        ctype_equal(islower,('6')==0,1,"islower1");
        ctype_equal(islower,('a')!=0,1,"islower2");
        ctype_equal(islower,('A')==0,1,"islower3");
        ctype_equal(islower,('z')!=0,1,"islower4");

        ctype_equal(isprint,('A')!=0,1,"isprint1");
        ctype_equal(isprint,('@')!=0,1,"isprint2");
        ctype_equal(isprint,('-')!=0,1,"isprint3");
        ctype_equal(isprint,('=')!=0,1,"isprint4");

        ctype_equal(ispunct,('!')!=0,1,"ispunct1");
        ctype_equal(ispunct,('/')!=0,1,"ispunct2");
        ctype_equal(ispunct,('a')==0,1,"ispunct3");
        ctype_equal(ispunct,(' ')==0,1,"ispunct4");
        ctype_equal(ispunct,('~')!=0,1,"ispunct5");

        ctype_equal(isspace,(' ')!=0,1,"isspace1");
        ctype_equal(isspace,('\f')!=0,1,"isspace2");
        ctype_equal(isspace,('\t')!=0,1,"isspace3");
        ctype_equal(isspace,('\n')!=0,1,"isspace4");
        ctype_equal(isspace,('\r')!=0,1,"isspace5");
        ctype_equal(isspace,('\v')!=0,1,"isspace6");
        ctype_equal(isspace,('d')==0,1,"isspace7");

        ctype_equal(isupper,('A')!=0,1,"isupper1");
        ctype_equal(isupper,('D')!=0,1,"isupper2");
        ctype_equal(isupper,('a')==0,1,"isupper3");
        ctype_equal(isupper,(' ')==0,1,"isupper4");

        ctype_equal(isxdigit,('F')!=0,1,"isxdigit1");
        ctype_equal(isxdigit,('c')!=0,1,"isxdigit2");
        ctype_equal(isxdigit,('g')==0,1,"isxdigit3");
        ctype_equal(isxdigit,('9')!=0,1,"isxdigit4");

        ctype_equal(toupper,('a')=='A',1,"toupper1");
        ctype_equal(toupper,('D')=='D',1,"toupper2");
        ctype_equal(toupper,('v')=='V',1,"toupper3");
        ctype_equal(toupper,(' ')==' ',1,"toupper4");

        ctype_equal(tolower,('F')=='f',1,"tolower1");
        ctype_equal(tolower,('c')=='c',1,"tolower2");
        ctype_equal(tolower,('Z')=='z',1,"tolower3");
        ctype_equal(tolower,('9')=='9',1,"tolower4");
#endif
}

void setjmp_right_size() {
    struct s {
	jmp_buf buf;
	int i; 
	} x;
    x.i = 0xdeadbeef;
    setjmp(x.buf);
    /* Make sure our header files agree with the conventions on the system. */
    /* In particular, we need to get the jmp_buf size correct. */
    equal(x.i,0xdeadbeef,"setjmp size");
    }

void libtest() {
   printf("Library test\n");
#ifdef PARTA
   {
   int j;
   for (j = 7; j <= 10; j++) {
      loopcnt = 0;
      switch (setjmp(Buf)) {
         case 0: loop(j); break;
         case 1: equal(loopcnt,j,"setjmp"); break;
         default: equal(1,0,"oops:setjmp");
         }
      }
   setjmp_right_size();
   }
   string_comparisons();
   {
   extern long strtol();
   char *p = " -0xfffe",*p2;
   long l1;
   l1 = strtol(p,&p2,16);
  lequal(l1,-65534,"sl 1");
   equal(p2 == p+8,True,"sl 1 after");
   l1 = strtol(p,&p2,0);
  lequal(l1,-65534,"sl 2");
   l1 = strtol(p+4,nil,20);
  lequal(l1,126314,"sl base 20");
  lequal(strtol(p,nil,1),0l,"strtol 1");
  lequal(strtol("00001111",nil,2),15l,"strtol 2");
  lequal(strtol("0000abbb",nil,11),10l,"strtol 3");
   }
   {
   /* extern double strtod();
   extern long atol();
   extern int atoi();
   extern double atof();              */
   char *real = " 1.25x",*p;

   ANNOUNCE1("atof tests...");
   equal(atof(" 1.25") == 1.25,True,"atof 1");
   equal(atof("-1.25") == -1.25,True,"atof 2");
   equal(atof("1e-0000") == 1.0, True,"atof 3");
   equal(atof("+1e+0") == 1.0,True,"atof 4");
   equal(atof("x") == 0.0,True,"atof 5");
   equal(atoi("32767"),32767,"atoi 1");
   equal(atoi("-32768"),(int)-32768,"atoi 2");
   equal(atoi(" 1"),1,"atoi 3");
   equal(atoi("x"),0,"atoi 4");
   equal(strtod(real,&p)==1.25,True,"strtod 1");
   equal(p == real+5,True,"strtod 2");
   equal(strtod(" -1.25",nil)== -1.25,True,"strtod 3");
  lequal(atol("2000000"),2000000,"atol 1");
  lequal(atol("-2000000000"),-2000000000,"atol 2");
  lequal(atol(" -122xfas"),-122l,"atol 3");
  lequal(atol(" "),0l,"atol 4");
          /* following tests are included by Prakash */
   equal(abs(-23),23,"abs1");
   equal(abs(23),23,"abs2");
   equal((int)labs(23121278),(int)23121278,"labs1");
   equal((int)labs(-500000),(int)500000,"labs2");
   if (sizeof(int) == 2) {
      /*
      ** More thorough and ANSI implementation checking
      ** Based on algo published on pp. 155 of ANSI X3J11, Dec 7, 1988
      ** 04-18-89, 13:39, Tue, Thuan-Tit Ewe
      ** This happens to be High C's 8086 rand() algorithm.
      ** If it is not yours, these tests won't run properly.
      */
      static int set[][40]={
        {
         16838,5758,10113,17515,31051,5627,23010,7419,16212,4086,
         2749,12767,9084,12060,32225,17543,25089,21183,25137,25566,
         26966,4978,20495,10311,11367,30054,17031,13145,19882,25736,
         30524,28505,28394,22102,24851,19067,12754,11653,6561,27096
        },
        {
         16606,3436,13558,3002,3773,28126,30176,30358,14501,4065,
         15803,27510,12285,19746,28721,10138,25965,8727,32672,8416,
         22642,29843,1409,21438,5025,10284,30108,29947,8634,7245,
         22510,816,18292,28697,13653,29698,3586,10246,8961,31004
        }
        };
      register int x;
      printf("\nrand - srand tests\n");

      srand(1);
      for(x=0; x<40; x++)
        equal(set[0][x]==rand(), True, "rand set 1");

      srand(289);
      for(x=0; x<40; x++)
        equal(set[1][x]==rand(), True, "rand set 289");
      }

   }

   {
   unsigned long x;
   char *pp, *qq;
   errno = 0;
   equal((strtoul("sdjht", nil, 10)==0) && !errno, True, "strtoul 1");

   errno = 0;
   x = strtoul("3487987987989898798798324", nil, 10);
   equal(x==ULONG_MAX && errno==ERANGE, True, "strtoul 2");

   errno = 0;
   x = strtol("3487987987989898798798324", nil, 10);
   equal(x==LONG_MAX && errno==ERANGE,  True, "strtol 2");

   errno = 0;
   x = strtol("-3487987987989898798798324", nil, 10);
   equal(x==LONG_MIN && errno==ERANGE,  True, "strtol 2");
   errno = 0;
   equal(strtoul(qq="700001x", &pp, 10)==700001L && !errno, True, "strtoul 3");
   equal((pp==(qq+6)),                          True,   "strtoul 4");
   equal((strtoul("0x10", nil, 16)==16),        True,   "strtoul 5");
   equal((strtoul("0x10", nil, 0)==16),         True,   "strtoul 6");
   equal((strtoul("077", nil, 0)==63),          True,   "strtoul 7");
   equal((strtoul("b",  nil, 16)==11),          True,   "strtoul 8");
   equal((strtoul("B",  nil, 16)==11),          True,   "strtoul 9");
   equal((strtoul("fffe", nil, 16)==65534),     True,   "strtoul 10");
   }
#endif
#ifdef PARTB
   {     /* included by prakash : bsearch & qsort tests */
     {
     struct info data[] = {
        {"abc",   19, "555-7979"},
        {"don",   27, "555-1221"},
        {"tim",   30, "555-1965"},
        {"john",  32, "555-4299"},
        {"mike",  36, "555-1976"},
        };

        struct info key = {"john",  32, ""};
        struct info *p;
        p = bsearch(&key,data,sizeof(data)/sizeof(*data),sizeof(*data),compare);
        equal((!strcmp("john",p->name))&& p->age==32 && (!strcmp(p->phone,
        "555-4299")),1,"bsearch");
     }
     {
      struct info datas[] = {
        {"john",  32, "555-4299"},
        {"don",   27, "555-1221"},
        {"tim",   30, "555-1965"},
        {"abc",   19, "555-7979"},
        {"mike",  36, "555-1976"},
        };
        int i;
        struct info *p ;
        qsort(datas, sizeof(datas)/sizeof(*datas), sizeof(*datas),compare);
        for(i=0;i<sizeof(datas)/sizeof(*datas)-1; ++i)
           equal(compare(&datas[i],&datas[i+1]) <= 0,True,"qsort");
    {
        char * compare[] = {
           "abc     , 19, 555-7979",
           "don     , 27, 555-1221",
           "tim     , 30, 555-1965",
           "john    , 32, 555-4299",
           "mike    , 36, 555-1976",
           }, **cp = compare;
        for(i=0;i<sizeof(datas)/sizeof(*datas); ++i){
           char buf[80];
           p = &datas[i];
           sprintf(buf,"%-8s, %d, %s", p->name, p->age, p->phone);
           equal(strcmp(buf,*cp++),0,"qsort");
           }
    }
      }
      {
      /* Many qsorts swap the end element with the middle to avoid problems
       * with already sorted lists.  Construct a case that causes n log n
       * under such an assumption.  Ensure that recursion is not taken
       * on the larger half so that we don't run out of stack.
       */
#if _SGL
      #define LIM 100
#else
      #define LIM 1000
#endif
      short a[LIM], i;
      /* Make in ascending order. */
      for (i = 0; i < LIM; i++) a[i]=i;
      /* Now pervert. */
      for (i = 2; i < LIM; i++) {
         int mid = (0+i)/2;
         int T = a[i]; a[i] = a[mid]; a[mid] = T;
         }
      /* Will probably take LIM log(LIM). */
      qsort(a,LIM,sizeof(a[0]),compare_shorts);
      for (i = 0; i < LIM-1; i++)
         if (a[i] > a[i+1]) {
            equal(a[i] > a[i+1],False,"qsorta");
            printf("  i=%d a[i]=%d a[i+1]=%d\n",i,a[i],a[i+1]);
            }
      #undef LIM
      }
   }
   {
   /* Test of printf.  Supply format, flags (comment), and the answer: */
   /* Test taken from Harbison & Steele page 302. */
   /*printf("Value     45    45    45  12.678     12.678     12.678\n");*/
   /*printf("Operation 5d    5o    5x    7.2f      10.2e      10.4g\n");*/
   /*printf("Flags\n");                                                 */
   static struct stuff {char *fmat, *flags,*answer;} tprintf[] = {
   {"%6s|%5d|%5o|%5x|%7.2f|%10.2e|%10.4g|","%",
      "     %|   45|   55|   2d|  12.68|  1.27e+01|     12.68|"},
   {"%6s|%05d|%05o|%05x|%07.2f|%010.2e|%010.4g|","%0",
      "    %0|00045|00055|0002d|0012.68|001.27e+01|0000012.68|"},
   {"%6s|%#5d|%#5o|%#5x|%#7.2f|%#10.2e|%#10.4g|","%#",
      "    %#|   45|  055| 0x2d|  12.68|  1.27e+01|     12.68|"},
   {"%6s|%#05d|%#05o|%#05x|%#07.2f|%#010.2e|%#010.4g|","%#0",
      "   %#0|00045|00055|0x02d|0012.68|001.27e+01|0000012.68|"},
   {"%6s|% 5d|% 5o|% 5x|% 7.2f|% 10.2e|% 10.4g|","% ",
      "    % |   45|   55|   2d|  12.68|  1.27e+01|     12.68|"},
   {"%6s|% 05d|% 05o|% 05x|% 07.2f|% 010.2e|% 010.4g|","% 0",
      "   % 0| 0045|00055|0002d| 012.68| 01.27e+01| 000012.68|"},
   {"%6s|% #5d|% #5o|% #5x|% #7.2f|% #10.2e|% #10.4g|","% #",
      "   % #|   45|  055| 0x2d|  12.68|  1.27e+01|     12.68|"},
   {"%6s|% #05d|% #05o|% #05x|% #07.2f|% #010.2e|% #010.4g|","% #0",
      "  % #0| 0045|00055|0x02d| 012.68| 01.27e+01| 000012.68|"},
  {"%6s|%+5d|%+5o|%+5x|%+7.2f|%+10.2e|%+10.4g|","%+",
      "    %+|  +45|   55|   2d| +12.68| +1.27e+01|    +12.68|"},
   {"%6s|%+05d|%+05o|%+05x|%+07.2f|%+010.2e|%+010.4g|","%+0",
      "   %+0|+0045|00055|0002d|+012.68|+01.27e+01|+000012.68|"},
   {"%6s|%+#5d|%+#5o|%+#5x|%+#7.2f|%+#10.2e|%+#10.4g|","%+#",
      "   %+#|  +45|  055| 0x2d| +12.68| +1.27e+01|    +12.68|"},
   {"%6s|%+#05d|%+#05o|%+#05x|%+#07.2f|%+#010.2e|%+#010.4g|","%+#0",
      "  %+#0|+0045|00055|0x02d|+012.68|+01.27e+01|+000012.68|"},
   {"%6s|%+ 5d|%+ 5o|%+ 5x|%+ 7.2f|%+ 10.2e|%+ 10.4g|","%+ ",
      "   %+ |  +45|   55|   2d| +12.68| +1.27e+01|    +12.68|"},
   {"%6s|%+ 05d|%+ 05o|%+ 05x|%+ 07.2f|%+ 010.2e|%+ 010.4g|","%+ 0",
      "  %+ 0|+0045|00055|0002d|+012.68|+01.27e+01|+000012.68|"},
   {"%6s|%+ #5d|%+ #5o|%+ #5x|%+ #7.2f|%+ #10.2e|%+ #10.4g|","%+ #",
      "  %+ #|  +45|  055| 0x2d| +12.68| +1.27e+01|    +12.68|"},
   {"%6s|%+ #05d|%+ #05o|%+ #05x|%+ #07.2f|%+ #010.2e|%+ #010.4g|","%+ #0",
      " %+ #0|+0045|00055|0x02d|+012.68|+01.27e+01|+000012.68|"},
   {"%6s|%-5d|%-5o|%-5x|%-7.2f|%-10.2e|%-10.4g|","%-",
      "    %-|45   |55   |2d   |12.68  |1.27e+01  |12.68     |"},
   {"%6s|%-05d|%-05o|%-05x|%-07.2f|%-010.2e|%-010.4g|","%-0",
      "   %-0|45   |55   |2d   |12.68  |1.27e+01  |12.68     |"},
   {"%6s|%-#5d|%-#5o|%-#5x|%-#7.2f|%-#10.2e|%-#10.4g|","%-#",
      "   %-#|45   |055  |0x2d |12.68  |1.27e+01  |12.68     |"},
   {"%6s|%-#05d|%-#05o|%-#05x|%-#07.2f|%-#010.2e|%-#010.4g|","%-#0",
      "  %-#0|45   |055  |0x2d |12.68  |1.27e+01  |12.68     |"},
   {"%6s|%- 5d|%- 5o|%- 5x|%- 7.2f|%- 10.2e|%- 10.4g|","%- ",
      "   %- | 45  |55   |2d   | 12.68 | 1.27e+01 | 12.68    |"},
   {"%6s|%- 05d|%- 05o|%- 05x|%- 07.2f|%- 010.2e|%- 010.4g|","%- 0",
      "  %- 0| 45  |55   |2d   | 12.68 | 1.27e+01 | 12.68    |"},
   {"%6s|%- #5d|%- #5o|%- #5x|%- #7.2f|%- #10.2e|%- #10.4g|","%- #",
      "  %- #| 45  |055  |0x2d | 12.68 | 1.27e+01 | 12.68    |"},
   {"%6s|%- #05d|%- #05o|%- #05x|%- #07.2f|%- #010.2e|%- #010.4g|","%- #0",
      " %- #0| 45  |055  |0x2d | 12.68 | 1.27e+01 | 12.68    |"},
   {"%6s|%-+5d|%-+5o|%-+5x|%-+7.2f|%-+10.2e|%-+10.4g|","%-+",
      "   %-+|+45  |55   |2d   |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+05d|%-+05o|%-+05x|%-+07.2f|%-+010.2e|%-+010.4g|","%-+0",
      "  %-+0|+45  |55   |2d   |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+#5d|%-+#5o|%-+#5x|%-+#7.2f|%-+#10.2e|%-+#10.4g|","%-+#",
      "  %-+#|+45  |055  |0x2d |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+#05d|%-+#05o|%-+#05x|%-+#07.2f|%-+#010.2e|%-+#010.4g|","%-+#0",
      " %-+#0|+45  |055  |0x2d |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+ 5d|%-+ 5o|%-+ 5x|%-+ 7.2f|%-+ 10.2e|%-+ 10.4g|","%-+ ",
      "  %-+ |+45  |55   |2d   |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+ 05d|%-+ 05o|%-+ 05x|%-+ 07.2f|%-+ 010.2e|%-+ 010.4g|","%-+ 0",
      " %-+ 0|+45  |55   |2d   |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+ #5d|%-+ #5o|%-+ #5x|%-+ #7.2f|%-+ #10.2e|%-+ #10.4g|","%-+ #",
      " %-+ #|+45  |055  |0x2d |+12.68 |+1.27e+01 |+12.68    |"},
   {"%6s|%-+ #05d|%-+ #05o|%-+ #05x|%-+ #07.2f|%-+ #010.2e|%-+ #010.4g|",
      "%-+ #0",
      "%-+ #0|+45  |055  |0x2d |+12.68 |+1.27e+01 |+12.68    |"},
   };
#if _SGL
   ANNOUNCE1("Test taken from Harbison & Steele page 302.");
#endif
   int i;
   Silent++;
   for (i = 0; i < sizeof(tprintf)/sizeof(struct stuff); i++) {
      char buf[200],*Loc = "printf test#1";
      sprintf(buf,tprintf[i].fmat,tprintf[i].flags,45,45,45,12.678,12.678,12.678);
      equal(strcmp(buf,tprintf[i].answer),0,Loc);
      if (strcmp(buf,tprintf[i].answer) != 0)
          printf("Expected=\"%s\"\nReceived=\"%s\"\n",tprintf[i].answer,buf);
     }
   Silent--;
   }
   { /* Another, more thorough, test of printf.  MetaWare-authored.
        Many UNIX systems do not agree with the correct answers.
        In particular, %13.4g format for "1.4" produces "1.4000" on some
        UNIX systems, instead of "1.400" (with some leading blanks).
        You may wish to carefully read the ANSI standard to see if you
        believe MetaWare's "interpretation" of the standard.
        (Yes, the standard should not need "interpretation", but English
        is a poor device for communicating technical information.)
     */
     /* In each of the tests, 5 copies of a format is made for 5 sets
        of inputs.
        The ANSI-standard string concatenation is used for ease
        of presentability.
     */
      static struct stuff {char *fmat, *flags,*answer;} tprintf2[] = {
{
"%6s|%13.4e|%13.4f|%13.4g|\n"
, "%",
"     %|  -1.4000e+05| -140000.0000|     -1.4e+05|\n"
"     %|   1.4000e-08|       0.0000|      1.4e-08|\n"
"     %|   1.4000e-02|       0.0140|        0.014|\n"
"     %|   1.4000e+05|  140000.0000|      1.4e+05|\n"
"     %|   1.4000e+02|     140.0000|          140|\n"
},
{
"%6s|%013.4e|%013.4f|%013.4g|\n"
, "%0",
"    %0|-001.4000e+05|-0140000.0000|-000001.4e+05|\n"
"    %0|0001.4000e-08|00000000.0000|0000001.4e-08|\n"
"    %0|0001.4000e-02|00000000.0140|000000000.014|\n"
"    %0|0001.4000e+05|00140000.0000|0000001.4e+05|\n"
"    %0|0001.4000e+02|00000140.0000|0000000000140|\n"
},
{
"%6s|%#13.4e|%#13.4f|%#13.4g|\n"
, "%#",
"    %#|  -1.4000e+05| -140000.0000|   -1.400e+05|\n"
"    %#|   1.4000e-08|       0.0000|    1.400e-08|\n"
"    %#|   1.4000e-02|       0.0140|      0.01400|\n"
"    %#|   1.4000e+05|  140000.0000|    1.400e+05|\n"
"    %#|   1.4000e+02|     140.0000|        140.0|\n"
},
{
"%6s|%#013.4e|%#013.4f|%#013.4g|\n"
, "%#0",
"   %#0|-001.4000e+05|-0140000.0000|-0001.400e+05|\n"
"   %#0|0001.4000e-08|00000000.0000|00001.400e-08|\n"
"   %#0|0001.4000e-02|00000000.0140|0000000.01400|\n"
"   %#0|0001.4000e+05|00140000.0000|00001.400e+05|\n"
"   %#0|0001.4000e+02|00000140.0000|00000000140.0|\n"
},
{
"%6s|% 13.4e|% 13.4f|% 13.4g|\n"
, "% ",
"    % |  -1.4000e+05| -140000.0000|     -1.4e+05|\n"
"    % |   1.4000e-08|       0.0000|      1.4e-08|\n"
"    % |   1.4000e-02|       0.0140|        0.014|\n"
"    % |   1.4000e+05|  140000.0000|      1.4e+05|\n"
"    % |   1.4000e+02|     140.0000|          140|\n"
},
{
"%6s|% 013.4e|% 013.4f|% 013.4g|\n"
, "% 0",
"   % 0|-001.4000e+05|-0140000.0000|-000001.4e+05|\n"
"   % 0| 001.4000e-08| 0000000.0000| 000001.4e-08|\n"
"   % 0| 001.4000e-02| 0000000.0140| 00000000.014|\n"
"   % 0| 001.4000e+05| 0140000.0000| 000001.4e+05|\n"
"   % 0| 001.4000e+02| 0000140.0000| 000000000140|\n"
},
{
"%6s|% #13.4e|% #13.4f|% #13.4g|\n"
, "% #",
"   % #|  -1.4000e+05| -140000.0000|   -1.400e+05|\n"
"   % #|   1.4000e-08|       0.0000|    1.400e-08|\n"
"   % #|   1.4000e-02|       0.0140|      0.01400|\n"
"   % #|   1.4000e+05|  140000.0000|    1.400e+05|\n"
"   % #|   1.4000e+02|     140.0000|        140.0|\n"
},
{
"%6s|% #013.4e|% #013.4f|% #013.4g|\n"
, "% #0",
"  % #0|-001.4000e+05|-0140000.0000|-0001.400e+05|\n"
"  % #0| 001.4000e-08| 0000000.0000| 0001.400e-08|\n"
"  % #0| 001.4000e-02| 0000000.0140| 000000.01400|\n"
"  % #0| 001.4000e+05| 0140000.0000| 0001.400e+05|\n"
"  % #0| 001.4000e+02| 0000140.0000| 0000000140.0|\n"
},
{
"%6s|%+13.4e|%+13.4f|%+13.4g|\n"
, "%+",
"    %+|  -1.4000e+05| -140000.0000|     -1.4e+05|\n"
"    %+|  +1.4000e-08|      +0.0000|     +1.4e-08|\n"
"    %+|  +1.4000e-02|      +0.0140|       +0.014|\n"
"    %+|  +1.4000e+05| +140000.0000|     +1.4e+05|\n"
"    %+|  +1.4000e+02|    +140.0000|         +140|\n"
},
{
"%6s|%+013.4e|%+013.4f|%+013.4g|\n"
, "%+0",
"   %+0|-001.4000e+05|-0140000.0000|-000001.4e+05|\n"
"   %+0|+001.4000e-08|+0000000.0000|+000001.4e-08|\n"
"   %+0|+001.4000e-02|+0000000.0140|+00000000.014|\n"
"   %+0|+001.4000e+05|+0140000.0000|+000001.4e+05|\n"
"   %+0|+001.4000e+02|+0000140.0000|+000000000140|\n"
},
{
"%6s|%+#13.4e|%+#13.4f|%+#13.4g|\n"
, "%+#",
"   %+#|  -1.4000e+05| -140000.0000|   -1.400e+05|\n"
"   %+#|  +1.4000e-08|      +0.0000|   +1.400e-08|\n"
"   %+#|  +1.4000e-02|      +0.0140|     +0.01400|\n"
"   %+#|  +1.4000e+05| +140000.0000|   +1.400e+05|\n"
"   %+#|  +1.4000e+02|    +140.0000|       +140.0|\n"
},
{
"%6s|%+#013.4e|%+#013.4f|%+#013.4g|\n"
, "%+#0",
"  %+#0|-001.4000e+05|-0140000.0000|-0001.400e+05|\n"
"  %+#0|+001.4000e-08|+0000000.0000|+0001.400e-08|\n"
"  %+#0|+001.4000e-02|+0000000.0140|+000000.01400|\n"
"  %+#0|+001.4000e+05|+0140000.0000|+0001.400e+05|\n"
"  %+#0|+001.4000e+02|+0000140.0000|+0000000140.0|\n"
},
{
"%6s|%+ 13.4e|%+ 13.4f|%+ 13.4g|\n"
, "%+ ",
"   %+ |  -1.4000e+05| -140000.0000|     -1.4e+05|\n"
"   %+ |  +1.4000e-08|      +0.0000|     +1.4e-08|\n"
"   %+ |  +1.4000e-02|      +0.0140|       +0.014|\n"
"   %+ |  +1.4000e+05| +140000.0000|     +1.4e+05|\n"
"   %+ |  +1.4000e+02|    +140.0000|         +140|\n"
},
{
"%6s|%+ 013.4e|%+ 013.4f|%+ 013.4g|\n"
, "%+ 0",
"  %+ 0|-001.4000e+05|-0140000.0000|-000001.4e+05|\n"
"  %+ 0|+001.4000e-08|+0000000.0000|+000001.4e-08|\n"
"  %+ 0|+001.4000e-02|+0000000.0140|+00000000.014|\n"
"  %+ 0|+001.4000e+05|+0140000.0000|+000001.4e+05|\n"
"  %+ 0|+001.4000e+02|+0000140.0000|+000000000140|\n"
},
{
"%6s|%+ #13.4e|%+ #13.4f|%+ #13.4g|\n"
, "%+ #",
"  %+ #|  -1.4000e+05| -140000.0000|   -1.400e+05|\n"
"  %+ #|  +1.4000e-08|      +0.0000|   +1.400e-08|\n"
"  %+ #|  +1.4000e-02|      +0.0140|     +0.01400|\n"
"  %+ #|  +1.4000e+05| +140000.0000|   +1.400e+05|\n"
"  %+ #|  +1.4000e+02|    +140.0000|       +140.0|\n"
},
{
"%6s|%+ #013.4e|%+ #013.4f|%+ #013.4g|\n"
, "%+ #0",
" %+ #0|-001.4000e+05|-0140000.0000|-0001.400e+05|\n"
" %+ #0|+001.4000e-08|+0000000.0000|+0001.400e-08|\n"
" %+ #0|+001.4000e-02|+0000000.0140|+000000.01400|\n"
" %+ #0|+001.4000e+05|+0140000.0000|+0001.400e+05|\n"
" %+ #0|+001.4000e+02|+0000140.0000|+0000000140.0|\n"
},
{
"%6s|%-13.4e|%-13.4f|%-13.4g|\n"
, "%-",
"    %-|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"    %-|1.4000e-08   |0.0000       |1.4e-08      |\n"
"    %-|1.4000e-02   |0.0140       |0.014        |\n"
"    %-|1.4000e+05   |140000.0000  |1.4e+05      |\n"
"    %-|1.4000e+02   |140.0000     |140          |\n"
},
{
"%6s|%-013.4e|%-013.4f|%-013.4g|\n"
, "%-0",
"   %-0|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"   %-0|1.4000e-08   |0.0000       |1.4e-08      |\n"
"   %-0|1.4000e-02   |0.0140       |0.014        |\n"
"   %-0|1.4000e+05   |140000.0000  |1.4e+05      |\n"
"   %-0|1.4000e+02   |140.0000     |140          |\n"
},
{
"%6s|%-#13.4e|%-#13.4f|%-#13.4g|\n"
, "%-#",
"   %-#|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"   %-#|1.4000e-08   |0.0000       |1.400e-08    |\n"
"   %-#|1.4000e-02   |0.0140       |0.01400      |\n"
"   %-#|1.4000e+05   |140000.0000  |1.400e+05    |\n"
"   %-#|1.4000e+02   |140.0000     |140.0        |\n"
},
{
"%6s|%-#013.4e|%-#013.4f|%-#013.4g|\n"
, "%-#0",
"  %-#0|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"  %-#0|1.4000e-08   |0.0000       |1.400e-08    |\n"
"  %-#0|1.4000e-02   |0.0140       |0.01400      |\n"
"  %-#0|1.4000e+05   |140000.0000  |1.400e+05    |\n"
"  %-#0|1.4000e+02   |140.0000     |140.0        |\n"
},
{
"%6s|%- 13.4e|%- 13.4f|%- 13.4g|\n"
, "%- ",
"   %- |-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"   %- | 1.4000e-08  | 0.0000      | 1.4e-08     |\n"
"   %- | 1.4000e-02  | 0.0140      | 0.014       |\n"
"   %- | 1.4000e+05  | 140000.0000 | 1.4e+05     |\n"
"   %- | 1.4000e+02  | 140.0000    | 140         |\n"
},
{
"%6s|%- 013.4e|%- 013.4f|%- 013.4g|\n"
, "%- 0",
"  %- 0|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"  %- 0| 1.4000e-08  | 0.0000      | 1.4e-08     |\n"
"  %- 0| 1.4000e-02  | 0.0140      | 0.014       |\n"
"  %- 0| 1.4000e+05  | 140000.0000 | 1.4e+05     |\n"
"  %- 0| 1.4000e+02  | 140.0000    | 140         |\n"
},
{
"%6s|%- #13.4e|%- #13.4f|%- #13.4g|\n"
, "%- #",
"  %- #|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"  %- #| 1.4000e-08  | 0.0000      | 1.400e-08   |\n"
"  %- #| 1.4000e-02  | 0.0140      | 0.01400     |\n"
"  %- #| 1.4000e+05  | 140000.0000 | 1.400e+05   |\n"
"  %- #| 1.4000e+02  | 140.0000    | 140.0       |\n"
},
{
"%6s|%- #013.4e|%- #013.4f|%- #013.4g|\n"
, "%- #0",
" %- #0|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
" %- #0| 1.4000e-08  | 0.0000      | 1.400e-08   |\n"
" %- #0| 1.4000e-02  | 0.0140      | 0.01400     |\n"
" %- #0| 1.4000e+05  | 140000.0000 | 1.400e+05   |\n"
" %- #0| 1.4000e+02  | 140.0000    | 140.0       |\n"
},
{
"%6s|%-+13.4e|%-+13.4f|%-+13.4g|\n"
, "%-+",
"   %-+|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"   %-+|+1.4000e-08  |+0.0000      |+1.4e-08     |\n"
"   %-+|+1.4000e-02  |+0.0140      |+0.014       |\n"
"   %-+|+1.4000e+05  |+140000.0000 |+1.4e+05     |\n"
"   %-+|+1.4000e+02  |+140.0000    |+140         |\n"
},
{
"%6s|%-+013.4e|%-+013.4f|%-+013.4g|\n"
, "%-+0",
"  %-+0|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"  %-+0|+1.4000e-08  |+0.0000      |+1.4e-08     |\n"
"  %-+0|+1.4000e-02  |+0.0140      |+0.014       |\n"
"  %-+0|+1.4000e+05  |+140000.0000 |+1.4e+05     |\n"
"  %-+0|+1.4000e+02  |+140.0000    |+140         |\n"
},
{
"%6s|%-+#13.4e|%-+#13.4f|%-+#13.4g|\n"
, "%-+#",
"  %-+#|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"  %-+#|+1.4000e-08  |+0.0000      |+1.400e-08   |\n"
"  %-+#|+1.4000e-02  |+0.0140      |+0.01400     |\n"
"  %-+#|+1.4000e+05  |+140000.0000 |+1.400e+05   |\n"
"  %-+#|+1.4000e+02  |+140.0000    |+140.0       |\n"
},
{
"%6s|%-+#013.4e|%-+#013.4f|%-+#013.4g|\n"
, "%-+#0",
" %-+#0|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
" %-+#0|+1.4000e-08  |+0.0000      |+1.400e-08   |\n"
" %-+#0|+1.4000e-02  |+0.0140      |+0.01400     |\n"
" %-+#0|+1.4000e+05  |+140000.0000 |+1.400e+05   |\n"
" %-+#0|+1.4000e+02  |+140.0000    |+140.0       |\n"
},
{
"%6s|%-+ 13.4e|%-+ 13.4f|%-+ 13.4g|\n"
, "%-+ ",
"  %-+ |-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
"  %-+ |+1.4000e-08  |+0.0000      |+1.4e-08     |\n"
"  %-+ |+1.4000e-02  |+0.0140      |+0.014       |\n"
"  %-+ |+1.4000e+05  |+140000.0000 |+1.4e+05     |\n"
"  %-+ |+1.4000e+02  |+140.0000    |+140         |\n"
},
{
"%6s|%-+ 013.4e|%-+ 013.4f|%-+ 013.4g|\n"
, "%-+ 0",
" %-+ 0|-1.4000e+05  |-140000.0000 |-1.4e+05     |\n"
" %-+ 0|+1.4000e-08  |+0.0000      |+1.4e-08     |\n"
" %-+ 0|+1.4000e-02  |+0.0140      |+0.014       |\n"
" %-+ 0|+1.4000e+05  |+140000.0000 |+1.4e+05     |\n"
" %-+ 0|+1.4000e+02  |+140.0000    |+140         |\n"
},
{
"%6s|%-+ #13.4e|%-+ #13.4f|%-+ #13.4g|\n"
, "%-+ #",
" %-+ #|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
" %-+ #|+1.4000e-08  |+0.0000      |+1.400e-08   |\n"
" %-+ #|+1.4000e-02  |+0.0140      |+0.01400     |\n"
" %-+ #|+1.4000e+05  |+140000.0000 |+1.400e+05   |\n"
" %-+ #|+1.4000e+02  |+140.0000    |+140.0       |\n"
},
{
"%6s|%-+ #013.4e|%-+ #013.4f|%-+ #013.4g|\n"
, "%-+ #0",
"%-+ #0|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"%-+ #0|+1.4000e-08  |+0.0000      |+1.400e-08   |\n"
"%-+ #0|+1.4000e-02  |+0.0140      |+0.01400     |\n"
"%-+ #0|+1.4000e+05  |+140000.0000 |+1.400e+05   |\n"
"%-+ #0|+1.4000e+02  |+140.0000    |+140.0       |\n"
},
{
"%6s|%-+ #013.4e|%-+ #013.4f|%-+ #013.4g|\n"
, "%-+ #0",
"%-+ #0|-1.4000e+05  |-140000.0000 |-1.400e+05   |\n"
"%-+ #0|+1.4000e-08  |+0.0000      |+1.400e-08   |\n"
"%-+ #0|+1.4000e-02  |+0.0140      |+0.01400     |\n"
"%-+ #0|+1.4000e+05  |+140000.0000 |+1.400e+05   |\n"
"%-+ #0|+1.4000e+02  |+140.0000    |+140.0       |\n"
},
   };
#if _SGL
   ANNOUNCE1("printf from Metaware");
#endif
   int i;
   Silent++;
   for (i = 0; i < sizeof(tprintf2)/sizeof(struct stuff); i++) {
      char buf[512],*Loc = "printf test#2",bigfmat[512]; int j;
      bigfmat[0]=0;
      /* Make 5 copies of the format string. */
      for (j = 0; j<5; j++) strcat(bigfmat,tprintf2[i].fmat);
      sprintf(buf, bigfmat,
              tprintf2[i].flags, -1.4e5, -1.4e5, -1.4e5,
              tprintf2[i].flags, 1.4e-8,  1.4e-8, 1.4e-8,
              tprintf2[i].flags, 1.4e-2,  1.4e-2, 1.4e-2,
              tprintf2[i].flags, 1.4e5,   1.4e5,  1.4e5,
              tprintf2[i].flags, 1.4e2,   1.4e2,  1.4e2);
#if 0
      if (argc > 1) {
         /* Print the table for inclusion in the program. */
         printf("{\n");
         PS(tprintf2[i].fmat); printf(", \"%s\",\n",tprintf2[i].flags);
         PS(buf); printf("},\n");
         }
      else
#endif
         {
         equal(strcmp(buf,tprintf2[i].answer),0,Loc);
         if (strcmp(buf,tprintf2[i].answer) != 0)
            printf("Got=\n%sExpected=\n%s\n",buf,tprintf2[i].answer);
/*       printf("Fmat (x5):%sOK:\n%s??:\n%s", tprintf2[i].fmat, tprintf2[i].answer,buf);*/
         }
      }
     Silent--;
#if 0
/* This can be used along with the commented-out code above to
   create the table for inclusion int the program.
*/
PS(F) char *F; {
   char c, needq=0;
   printf("\"");
L: c = *F++;
   if (c == '\n') {printf("\\n\"\n"); needq = 1; }
   else if (c == 0) return;
   else needq?printf("\""),needq=0:0, printf("%c",c);
   goto L;
   }
}
#endif
   }
   { /* And yet another printf test, by MetaWare. */
#ifdef PARTB
#define NEXT -99        /* Indicates new format coming up. */
   static struct stuff { double input; char *output; } tests[] = {
      {NEXT, "%7.3f"},
      {123.556, "123.556"},
      {23.556,  " 23.556"},
      {23.4567, " 23.457"},
      {0,       "  0.000"},
      {1234,    "1234.000"},
      {-123.536,"-123.536"},
      {-23.556, "-23.556"},
      {-23.4567,"-23.457"},
      {.001,    "  0.001"},
      {.0001,   "  0.000"},
      {NEXT,    "%1.3f"},
      /* Results should be same as for 7.3f above except for padding. */
      {123.556, "123.556"},
      {23.556,  "23.556"},
      {23.4567, "23.457"},
      {0,       "0.000"},
      {1234,    "1234.000"},
      {-123.536,"-123.536"},
      {-23.556, "-23.556"},
      {-23.4567,"-23.457"},
      {.001,    "0.001"},
      {.0001,   "0.000"},
      {NEXT,    "%7.0f"},
      {123.556, "    124"},
      {23.556,  "     24"},
      {23.4567, "     23"},
      {0,       "      0"},
      {1234,    "   1234"},
      {1234567, "1234567"},
      {-123.536,"   -124"},
      {-23.556, "    -24"},
      {12345678.9,"12345679"},
      {-.001,   "     -0"},      /* Should we get -0 here?  Standard doesn't say. */
      {.0001,   "      0"},
      {NEXT,    "%#7.0f"},
      {123.556, "   124."},
      {23.556,  "    24."},
      {23.4567, "    23."},
      {0,       "     0."},
      {1234,    "  1234."},
      {1234567, "1234567."},
      {-123.536,"  -124."},
      {-23.556, "   -24."},
      {12345678.9,"12345679."},
      {-.001,   "    -0."},      /* Should we get -0 here?  Standard doesn't say. */
      {.0001,   "     0."},
      {NEXT,    "%-#7.0f"},
      {123.556, "124.   "},
      {23.556,  "24.    "},
      {23.4567, "23.    "},
      {0,       "0.     "},
      {1234,    "1234.  "},
      {1234567, "1234567."},
      {-123.536,"-124.  "},
      {-23.556, "-24.   "},
      {12345678.9,"12345679."},
      {-.001,   "-0.    "},      /* Should we get -0 here?  Standard doesn't say. */
      {.0001,   "0.     "},
      {123456.7,"123457."},
      {-12346., "-12346."},
      {NEXT,    "%.10g"},
      {123.556, "123.556"},
      {23.556,  "23.556"},
      {23.4567, "23.4567"},
      {0,       "0"},
      {1234,    "1234"},
      {1234567, "1234567"},
      {-123.536,"-123.536"},
      {-23.556, "-23.556"},
      {12345678.9,"12345678.9"},
      {-.001,   "-0.001"},
      {.0001,   "0.0001"},
      {NEXT,    "%#.10g"},
      {123.556, "123.5560000"},
      {23.556,  "23.55600000"},
      {23.4567, "23.45670000"},
      {0,       "0.000000000"},
      {1234,    "1234.000000"},
      {1234567, "1234567.000"},
      {-123.536,"-123.5360000"},
      {-23.556, "-23.55600000"},
      {12345678.9,"12345678.90"},
      {-.001,   "-0.001000000000"},
      {.0001,   "0.0001000000000"},
      {NEXT,    "%10.10g"},
      {123.556, "   123.556"},
      {23.556,  "    23.556"},
      {23.4567, "   23.4567"},
      {0,       "         0"},
      {1234,    "      1234"},
      {1234567, "   1234567"},
      {-123.536,"  -123.536"},
      {-23.556, "   -23.556"},
      {12345678.9,"12345678.9"},
      {-.001,   "    -0.001"},
      {.0001,   "    0.0001"},
      };
   int i;
   char *Current_format;
   Silent++;
   for (i = 0; i < sizeof(tests)/sizeof(struct stuff); i++) {
      char buf[512],*Loc = "printf test#3";
      if (tests[i].input == NEXT) {
         Current_format = tests[i].output;
#if 0
         if (argc > 1) printf("%6c{NEXT, \"%s\"},\n", ' ', Current_format);
#endif
         }
      else {
         sprintf(buf, Current_format,tests[i].input);
#if 0
         if (argc > 1) {
            /* Print the table for inclusion in the program. */
            printf("%6c{%.15g,\t\"%s\"},\n",' ',tests[i].input,tests[i].output);
            }
         else
#endif
            {int OK = strcmp(buf,tests[i].output);
            equal(OK,0,Loc);
            if (OK != 0)
               printf("Fmat='%s' Input=%.15g Expected='%s' Got='%s'\n",
                  Current_format, tests[i].input, tests[i].output, buf);
            }
         }
      }
     Silent--;
   }
   { /* %g tests.  UNIX fails these miserably, esp. w.r.t rounding. */
   static double a[] = {.5,0.5000094,0.5000095,0.5000096,
                1.5,1.5000094,1.5000095,1.5000096,
                1.5e-3,1.5000094e-3,1.5000095e-3,1.5000096e-3};
   static char *b[] = {
        "0.500000 0.5    0.500000000",
        "0.500009 0.500009    0.500009400",
        "0.500010 0.50001    0.500009500",
        "0.500010 0.50001    0.500009600",
        "1.500000 1.5    1.500000000",
        "1.500009 1.50001    1.500009400",
        "1.500010 1.50001    1.500009500",
        "1.500010 1.50001    1.500009600",
        "0.001500 0.0015    0.001500000",
        "0.001500 0.00150001    0.001500009",
        "0.001500 0.00150001    0.001500010",
        "0.001500 0.00150001    0.001500010"
        };
   int i;
   char s[100];
   for (i = 0; i < sizeof(a)/sizeof(a[0]); i++) {
      sprintf(s,"%f %g %14.9f\n",a[i],a[i],a[i]);
      if (!strcmp(s,b[i])) equal(1,0,"%gtest");
      }
#endif
   }
#endif
#ifndef NOLONGDOUBLE
   {char buf[50];
   sprintf(buf,"%.30Le",(long double)2.0);
   equal(strncmp(buf,"2.000000000000000000000000000000e+00",36)==0,True,"30Le");
   }
#endif
   {
   test_heap();
   }
   stdio_tests(False);
   stdio_tests(True);
   ctype_tests();
   stdarg_tests();
   ANNOUNCE1("scanf tests..");
   scanf_tests();
   }
/* stdio.h tests, included by prakash */
void stdio_tests(int use_setvbuf) {
#ifdef PARTA
   char mybuf[10]; /* For use in setvbuf. */
   {
        FILE *f1, *f2;
        int c;
        char d[10], t[20];
        char s[] = "love everybody";
        fpos_t T;
        char test[]="abcdefghijklmnopqrstuvwxyz 1234567890 0987654321asdf";
#define DATA1FILE "data1"
    f1 = fopen(DATA1FILE,"w");
    if (f1){
#if !defined(_VMS)
        if (use_setvbuf)
           equal(setvbuf(f1,mybuf,_IOFBF,sizeof(mybuf)),0,"setvbuf1");
#endif
        equal(fwrite(test,1,50,f1),50,"fwrite1");
        fclose(f1);
        }
    else{
        equal(1,0,"DATA1");
        perror(DATA1FILE);
        }
        f1= fopen(DATA1FILE, "r");
    if (f1==NULL) perror(DATA1FILE), equal(2,0,"DATA1");
    else{
        equal(strcmp(fgets(d,9,f1),d),0,"fgets");
        equal(fread(t, 1,9,f1),9,"fread");
        equal((c=getc(f1))!=EOF,1,"getc");
        fclose(f1);
        }
#define DATA2FILE "data2"
        f2= fopen(DATA2FILE, "w");
    if (f2==NULL) perror(DATA2FILE), equal(2,3,"DATA2");
    else{
#if !defined(_VMS)
        if (use_setvbuf)
           equal(setvbuf(f2,mybuf,_IOFBF,sizeof(mybuf)),0,"setvbuf2");
#endif
        equal(fwrite(s,1,14,f2),14,"fwrite2");
        equal(fputc('v',f2)=='v',1,"fputc");
        equal(putc('v',f2)=='v',1,"putc");
        equal(putchar('v')=='v',1,"putchar");
        fclose(f2);
        }

        f2= fopen(DATA2FILE, "r");
    if (f2==NULL) perror(DATA2FILE),equal(3,4,"DATA2");
    else{
        fgetpos(f2,&T); /* Trivial test: make sure functions there. */
        fsetpos(f2,&T);
        equal(fseek(f2, 10, SEEK_SET),0,"fseek");
        equal(ftell(f2)!= -1,1,"ftell");

	/* check fseek after unget */
	{	/* Must be ANSI. */
	char c1, c2;
	fseek(f2, 0, SEEK_SET);
	c1 = getc(f2);
	ungetc(c1, f2);
	fseek(f2, 0, 1);
	c2 = getc(f2);
	equal (c1, c2, "unget-fseek");
	}

	fclose(f2);
        }
        remove(DATA2FILE);
    }

    {
        FILE *f1, *f2, *f3, *f4, *f5, *f6;
        char s[]= "testing string";
        #define FILENAME "trial.tmp"
        /* There is some problem on FlexOS 286:  2nd time through
         * we cannot remove this file.  It appears to still be open.
         */
        remove(FILENAME);       /* Remove if already there. */
        equal((f1 = fopen(FILENAME, "r"))==NULL,True,"fopen1");
        equal((f2 = fopen(FILENAME, "w"))!=NULL,True,"fopen2");
        equal((f3 = fopen(FILENAME, "r"))!=NULL,True,"fopen3");
        /* This test is not valid on all systems:  on FlexOS 286, can't
         * remove an open file.
         * equal(remove(FILENAME),0,"remove");
         */
#define XXXXFILE "xxxx.c"
        equal((f5 = freopen(XXXXFILE, "w",f2))==f2,1,"freopen1");
        if (f3) fclose(f3);
        equal((f3 = freopen(XXXXFILE, "w",f5))==f5,1,"freopen2");
        equal((f4 = freopen("zzzz.c", "a",f2))==f2,1,"freopen3");

        f6 = fopen(DATA1FILE, "r");
        equal(f6 != NULL,True,"fopenf6");
        if (f6) equal(feof(f6),0,"feof1");
        if (f4) {
           clearerr(f4);
           equal(ferror(f4)==0 && feof(f4)==0,1,"clearerr");

           equal(ferror(f4),0,"ferror1");
           }
        if (f6) equal(ferror(f6),0,"ferror2");

        f1 = fopen(DATA2FILE, "w");
        equal(fflush(f1),0,"fflush");

        equal(fprintf(f1,"test fprintf : %s\n",s)>0,1,"fprintf");
        equal(fputs(s,f1),0,"fputs");
        equal(puts(s)>=0,1,"puts");
        equal(fclose(f2),0,"fclose1");
        equal((fclose(f5)!=0),1,"fclose2");
        if (f1) fclose(f1);
        if (f3) fclose(f3);
        if (f4) fclose(f4);
        if (f6) fclose(f6);

        remove(XXXXFILE), remove("zzzz.c"), remove(DATA2FILE), remove(FILENAME);
     }
     {
        FILE *f1,*f2;
        char test[]="abcdefghijklmnopqrstuvwxyz 1234567890 0987654321asdf";
        char s[] = "love everybody";
        char t[25];
        char a[10],b[10], d[10];
        int i,c;
        for(i=0;i<10;i++)
                {a[i]=0,b[i]=0,d[i]=0;}
        f1 = fopen (DATA1FILE, "r");
    if (f1==NULL) perror(DATA1FILE), equal(1,2,"data1");
    else{
        equal(fgetc(f1)=='a',1,"fgetc");
        equal(ungetc('a',f1)=='a',1,"ungetc");
#define F "junk.fil"
        f2 = fopen (F, "w");
        if (f2==NULL) perror(F), equal(100,200,"F");
        else{
#if !defined(_VMS)
       if (use_setvbuf)
          equal(setvbuf(f2,mybuf,_IOFBF,sizeof(mybuf)),0,"setvbuf3");
#endif
       equal(fwrite(test,1,50,f2),50,"fwrite3");
       /* This test is not valid on all systems:  on FlexOS 286, can't
        * remove an open file.
        * equal(remove(F),0,"remove");
        */
       fclose(f2);
       }

   /* Some systems don't support renaming an open file.
      Not supported by host-link software yet. */
#if !_I860 && !_MSNT && !_OS2
        equal(rename(DATA1FILE,"data1.c"),0,"rename1");
        equal(rename("data1.c",DATA1FILE),0,"rename2");
#endif
	equal( (f2 = tmpfile()) !=NULL,1,"tmpfile");
/*          equal((c=getchar())!=EOF,1,"getchar"); */
        equal((c=getc(f1))!=EOF,1,"getc");

        equal(printf("this is a printf test...\n"),25,"printf");
        equal(sprintf(t,"these are 24 characters."),24,"sprintf");
        fclose(f1);
	if (f2) fclose(f2);
        remove(DATA1FILE);remove(F);
        }
     }
#endif
}

#define MAXARGS 10
struct dummy {int a,b,c;};
/* struct-returning functions have an additional secret parameter.
 * Make sure that the var-args macros understand this.
 */
struct dummy starg_test(char **args, int n_args,...) {
  va_list ap;
  int ptr =0;
  if (n_args > MAXARGS) n_args = MAXARGS ;
  va_start(ap,n_args);
  while (ptr < n_args) args[ptr++] = va_arg(ap, char *);
  va_end(ap);
  }

void stdarg3_test(int i00,
    int i01, int i02, int i03, int i04, int i05,
    int i06, int i07, int i08, int i09, int i10,
    int i11, int i12, int i13, int i14, int i15,
    int i16, int i17, int i18, int i19, int i20, ...) {
   va_list ap;   int i;
#if !_SPARC  /* This is a NON-ansi test! */
   va_start(ap,i19);
   equal(va_arg(ap,int),21,"stdarg3");
#else
   va_start(ap,i20);
   equal(va_arg(ap,int),22,"stdarg3");
#endif
   }

void stdarg2_test(int *args2,
    int i01, int i02, int i03, int i04, int i05,
    int i06, int i07, int i08, int i09, int i10,
    int i11, int i12, int i13, int i14, int i15,
    int i16, int i17, int i18, int i19, int i20, ...) {
   va_list ap;   int i;
   /* Be sure you can call another routine before doing va_start here. */
   stdarg3_test(1, 2, 3, 4, 5, 6, 7, 8, 9,10,
           11,12,13,14,15,16,17,18,19,20,21,22);
   va_start(ap,i20);
   for (i = 21; i < 30; i++) args2[i] = va_arg(ap,int);
   }

void stdarg_tests() {
  char *args[MAXARGS];  int args2[30]; int i;
   char *s1 = "va_start", *s2 = "va_arg", *s3 = "va_end";
   struct dummy d = starg_test(args,3,s1,s2,s3);
   equal(args[0]==s1,1,s1);
   equal(args[1]==s2,1,s2);
   equal(args[2]==s3,1,s3);
   /* Make sure varargs works when va_start accesses something already
    * in memory as opposed to registers.
    */
   stdarg2_test(args2,
    1, 2, 3, 4, 5, 6, 7, 8, 9,10,
       11,12,13,14,15,16,17,18,19,20,
       21,22,23,24,25,26,27,28,29,30);
   for (i = 21; i < 30; i++) equal(args2[i],i,"30args");
   }

#define size_t unsigned int

void test_calloc(p,esize) char **p; size_t esize; {
   char *p2;
   #define testsize (sizeof(int) == 4 ? 10000 : 100)
   p2 = *p = calloc(testsize,esize);
   /* Ensure that p is 0 for all testsize bytes. */
   /* Increment p2 until non-zero. */
   while (p2 < *p+testsize*esize && !*(p2++));
   if (p2 != *p+testsize*esize) equal(1,0,"test_calloc");
   #undef testsize
   }

void test_realloc(p,newsize) char **p; size_t newsize; {
   int i;
   char *p2;
   #define testsize 100
   /* realloc(0) should allocate. */
   p2 = *p = realloc(0,testsize);
   for (i = 0; i < testsize; i++) p2[i] = i;
   p2 = *p = realloc(p2,newsize);
   for (i = 0; i < (testsize < newsize ? testsize : newsize); i++)
      if (p2[i] != i) equal(1,0,"test_realloc");
   }

void test_heap() {
   /* Test the heap. */
   int i;
   char *p1,*p2,*p3;
#ifdef HIGHC
   void free_3() {
      /* Try different freeing orders. */
      if (i & 1) {free(p1); free(p3); free(p2); }
      else {free(p2); free(p3); free(p1);}
      }
#else
#define free_3() {if (i&1) {free(p1); free(p3); free(p2);} \
                  else {free(p2); free(p3); free(p1);}}
#endif
#if _SGL
#define LIM  2
#else
#define LIM  25
#endif
   for (i = 0; i <= LIM; i++) {
#if _SGL
      printf("[testheap1] %d\n", i);
#endif
      test_calloc(&p1,3);
      test_calloc(&p2,1);
      test_calloc(&p3,5);
      free_3();
      }
#undef LIM
   for (i = 0; i <= 700; i++) {
#if _SGL
      if(!(i % 50)) printf("[testheap2] %d\n", i);
#endif
      /* If free doesn't work, we should be allocating
         900*700 = 630_000 bytes, which should kill most PC Cs. */
      p1 = malloc(300);
      p2 = malloc(300);
      p3 = malloc(300);
      free_3();
      }

   for (i = 0; i <= 25; i++) {
#if _SGL
      printf("[testheap3] %d\n", i);
#endif
      test_realloc(&p1,300);
      test_realloc(&p2,75);
      test_realloc(&p3,200);
      free_3();
      }

   spot_trans();
 }

static char f_called = 0;

static void FF1(void) {
   printf("END OF RUN\n");
   if (f_called == 2) f_called = 1;
   else printf("fail, FF1 not called in proper order by atexit.\n");
   }
static void FF2(void) {
   if (f_called == 3) f_called = 2;
   else printf("fail, FF2 not called in proper order by atexit.\n");
   }
static void FF3(void) {
   if (f_called == 0) f_called = 3;
   else printf("fail, FF3 not called in proper order by atexit.\n");
   }

#include <locale.h>
void locale() {
   /* Make sure we can return something from setlocale. */
   equal(setlocale(LC_ALL,"C") != 0, True, "setlocale");
   /* Make sure we get something back for each of the fields: */
   Silent++;
#define Check(f) equal(S->f != 0, True,"localeconv");
   { struct lconv *S = localeconv();
     Check(decimal_point); Check(thousands_sep); Check(grouping);
     Check(int_curr_symbol); Check(currency_symbol); Check(mon_decimal_point);
     Check(mon_thousands_sep); Check(mon_grouping); Check(positive_sign);
     Check(negative_sign);
   }
   Silent--;
   }

static void MBdummy(){}
void multibyte() {
   char *p = 0, s[2],a[5],b[5],e[5];
   wchar_t pwc[1],pwd[1],pwe[1],pwcs[5],pwds[5],pwbs[5],d,g=0;
   d = 'c';

   /* Just make sure the functions are there (i.e., not defined as macros only). */
   MBdummy(mblen,mbtowc,wctomb,mbstowcs,wcstombs);

   /* mbtowc */

   equal(mbtowc(pwc,"v",0),-1,"mbtowc1");
   equal((int)mbtowc(pwd,"z",1) && pwd[0]=='z',1,"mbtowc2");
   equal(mbtowc(pwe,p,1),0,"mbtowc3");

   /* mblen */

   equal(mblen("b",0),-1,"mblen1");
   equal(1,mblen("q",3),"mblen2");
   equal(0,mblen(p,5),"mblen3");

   /* wctomb */

   equal(wctomb(s,d) && s[0]=='c',1,"wctomb1");
   equal(wctomb(p,g),0,"wctomb2");

   /* wcstombs */

   a[3] = 0; /* Prepare for partial copy. */
   equal((int)wcstombs(a,L"test",3)==3 && strcmp("tes",a)==0,1,"wcstombs1");
   equal((int)wcstombs(b,L"test",6)==4 && strcmp("test",b)==0,1,"wcstombs2");
   equal((int)wcstombs(e,L"test",0),0,"wcstombs3");

   /* mbstowcs */

   pwcs[3] = 0; /* Prepare for partial copy. */
   equal((int)mbstowcs(pwcs,"test",3) == 3 && pwcs[0]==L't' &&
        pwcs[1]==L'e' && pwcs[2] == L's' && pwcs[3]==L'\0', 1,"mbstowcs1");
   equal((int)mbstowcs(pwbs,"test",6)== 4 && pwbs[0]==L't' &&
       pwbs[1]==L'e' && pwbs[2]==L's' && pwbs[3]==L't' &&
       pwbs[4]==L'\0', 1,"mbstowcs2");
   equal((int)mbstowcs(pwds,"test",0),0,"mbstowcs3");
   }

void misctest() {
#ifdef PARTB
   div_t ina;
   ldiv_t lna;
   int x;
   struct STR{
     int x;
     long y;
     char z;
     };

   equal((getenv("PATH")!=nil), True, "getenv 1");
   /*
   ** Presumably nobody would have an env variable called
   ** FOO BAR
   */
   equal((getenv("FOO BAR")==nil), True, "getenv 2");

/*
#define offsetof(type, member)  (size_t)(&(((type *)0)->member))
*/
   /*
   ** offsetof macro test
   */
   equal((offsetof(struct STR, x)==0), True, "offsetof x" );
   equal((offsetof(struct STR, y)==((sizeof(int)==4)?4:2)), True, "offsetof y" );
   equal((offsetof(struct STR, z)==(((sizeof(int)==4)?4:2)+4)), True, "offsetof z" );
   {
   struct include_entry {short x,y[3];};
/*static long l =
 *    ((unsigned long)(int) offsetof(struct include_entry,y[2])) << (sizeof(short)*8);
 */
   }
   /*
   ** div and ldiv as well as div_t and ldiv_t
   */
   for(x=0; x<10; x++) {
     ina = div(25721+x, 17);
     equal( ina.quot,1513, "div a");
     equal( ina.rem,x, "div b");
     }
   for(x=0; x<10; x++) {
     lna = ldiv((long)804089+x, (long)11);
     lequal( lna.quot,73099, "ldiv a");
     equal( lna.rem,x, "ldiv b");
     }

/*equal(system("hello.exe")==0, False, "system");*/
   {
   struct {char a[INT_MAX];} *s2meg;
   unsigned long s = sizeof(*s2meg);
   unsigned long low = INT_MAX, high = (unsigned long)INT_MAX+32;
   /* Allow for compiler padding to nice even boundary. */
   equal(s >= low && s <= high, True, "s2meg");
   }
#endif
   /* These must be macros: */
#ifndef _IOFBF
   equal(1,0,"_IOFBF");
#endif
#ifndef _IOLBF
   equal(1,0,"_IOLBF");
#endif
#ifndef _IONBF
   equal(1,0,"_IONBF");
#endif
   return;
   }

#ifdef PARTA
/**********************************
Additional test to test for the added functionality for HIGHC library
04-25-89, 11:31, Tue, Thuan-Tit Ewe
**********************************/

char *pp[]={
"#include <stdio.h>",
"",
"extern char EOL1, EOL2;",
"main()",
"{",
"  FILE *x;",
"  EOL1 = 'r';",
"doread()",
"{",
"  FILE *x;",
"  char bn[90];",
"  x = fopen(\"TEST1FIL\", \"r\");",
"  while(fgets(bn, 90, x))",
"    printf(\"%s\", bn);",
"  fclose(x);",
"}",
"",
"dofseek()",
"{",
"  FILE *x;",

"  char bn[80];",
"  long ftell();",
"  x = fopen(\"test.fil\", w+);",
"  printf(\"ftell returns %lu (12)n\", ftell(x));",
"  printf(\"fseek returns %dn\", fseek(x, 0L, 1));",
"  printf(\"ftell returns %lu (12)n\", ftell(x));",
"  printf(\"fseek returns %dn\", fseek(x, 4L, 0));",
"  printf(\"ftell returns %lu (4)n\", ftell(x));",
"  fprintf(x, \"hello world\");",
"  printf(\"ftell returns %lu (20)n\", ftell(x));",
"  printf(\"fseek returns %dn\", fseek(x, 4L, 1));",
"  printf(\"ftell returns %lu (4)n\", ftell(x));",
"  fgets(bn, 90, x);",
"  printf(bn);",
"  printf(\"ftell returns %lu (18)\\n\", ftell(x));",
"  fclose(x);",
"}",
"",
""
};

void dowrite(), doread(), dofseek(), aotest();

static int EOL_out_len = 1;

#define TEST1FIL "test1.fil"

void test_text_RW() {
  FILE *x; char buf[10];
  /* First discover the length of the external representation of \n
   * in text files.
   */
  x = fopen(TEST1FIL, "w");
  fprintf(x,"\n");
  fclose(x);
  x = fopen(TEST1FIL, "rb");
  EOL_out_len = fread(buf,1,sizeof buf,x);
  fclose(x);
  dowrite();
  doread();

  /* Check for correct seeking around \ns. */
  dofseek();
  /* Make sure we haven't changed behavior of binary files. */
  aotest();
  /*
  ** before we're thru call stdio_tests again
  */
  stdio_tests(False);
  }

void EOL_stdio_test()
{
  test_text_RW();       /* For all ANSI libraries. */

  /* Not implemented yet in the library. */
#if (0 && defined(HIGHC) && !defined DOS && !defined _I860)
  /* These are strictly High C tests in which the library can support
   * various end-of-line conventions.
   */
  extern struct _eol {char EOLC, REOL1, REOL2, WEOL1, WEOL2; } _EOL;

  struct _eol teol;
  teol = _EOL;  /* Save state. */

  _EOL.WEOL1 = '\r'; _EOL.WEOL2 = '\n'; _EOL.REOL1 = '\r'; _EOL.REOL2 = '\n';

  test_text_RW();

  Silent++;
  _EOL.WEOL1 = '\2'; _EOL.WEOL2 = '\3'; _EOL.REOL1 = '\2'; _EOL.REOL2 = '\3';

  test_text_RW();

  /*
   * Do a pseudo dos2unix and unix2dos to see if we get the same results
   */

  _EOL.WEOL1 = '\4'; _EOL.WEOL2 = '\0'; _EOL.REOL1 = '\5'; _EOL.REOL2 = '\0';

  dowrite();

  _EOL.WEOL1 = '\5'; _EOL.WEOL2 = '\0'; _EOL.REOL1 = '\4'; _EOL.REOL2 = '\0';

  doread();

  Silent--;
  _EOL = teol;

#endif
  remove(TEST1FIL); remove("test.fil"); remove("test3.fil");
}

void dowrite() {
  register int i;
  FILE *x;
  /* First test: just write out a group of lines and be sure they come
   * back in the same way.
   */
  x = fopen(TEST1FIL, "w");
  for(i=0; i<(sizeof(pp)/sizeof(char *)); i++)
    fprintf(x, "%s\n", pp[i]);
  fclose(x);
  }

int _doreadite = 0;
void doread() {
#if _VMS && !defined(DOS_TARG)
  struct _iobuf *xp;
#endif
  FILE *x;
  register int i=0, j;
  int cn;
  char bn[90];
  _doreadite++;
  x = fopen(TEST1FIL, "r");
  for(i=0; i<(sizeof(pp)/sizeof(char *)); i++) {
    char tmp[90];
#if _VMS && !defined(DOS_TARG)
    xp = *x;
    cn = xp->_cnt;
#else
    cn = x->_cnt;
#endif
    fgets(bn, sizeof bn, x);
    bn[strlen(bn)-1] = '\0';
    sprintf(tmp, "ffputs %d, %d", _doreadite, i);
    equal(j=strcmp(bn, pp[i]), 0, tmp);
    if(j)
      printf("%s\n%s\n", pp[i], bn);
    }
  fclose(x);
  }

void dofseek() {
#define el(x)   (EOL_out_len*x)
  FILE *x;
  char bn[80];
  x = fopen("test.fil", "w+");
  fprintf(x, "\n\n\n\n\n\n");

  lequal(ftell(x),(long)el(6), "ftell 1");
  equal(fseek(x, 10L, 0), 0, "fseek 1");
  lequal(ftell(x), 10L, "ftell 2");

  equal(fseek(x, 12L, 0), 0, "fseek 2");
  lequal(ftell(x), 12L, "ftell 3");

  equal(fseek(x, 4L, 0), 0, "fseek 3");
  lequal(ftell(x), 4L, "ftell 4");

  fprintf(x, "hello world\n\n");
  lequal(ftell(x), (long)(el(2)+15), "ftell 5a");

  equal(fseek(x, 4L, 0), 0, "fseek 4");
  lequal(ftell(x), 4L, "ftell 5b");
  fgets(bn, 80, x);
  equal(strcmp(bn, "hello world\n"), 0, "fgets 1");
  lequal(ftell(x), (long)(el(1)+15), "ftell 6");
  equal(fscanf(x, "%c", bn), 1, "fscanf eof 1");
  equal((bn[0]=='\n'), True, "fscanf eof 2");
  equal(fscanf(x, "\n"), 0, "fscanf eof 3");
  fclose(x);
#undef el
  }

void aotest() {
  FILE *x;
  x = fopen("test3.fil", "wb+");
  fprintf(x, "\n\n\n\n\n\n");

  lequal(ftell(x), 6L, "ftell 7");
  fclose(x);
  }
#endif

/* Verify the macro is correct with NDEBUG set. */
#define NDEBUG
#include <assert.h>
/* Also, assert must be an expression, so (0,assert) below. */
void assert_test() {int x=0; x ? (0,assert(3)) : (void)0; }

/* Straight from the ANSI standard document: */
char *asctime_std (const struct tm *T) {
   static const char wday_name[7][3] = {
      "Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
   static const char mon_name[12][3] = {
      "Jan","Feb","Mar","Apr","May","Jun",
      "Jul","Aug","Sep","Oct","Nov","Dec"};
   static char result[26];
   sprintf(result,"%.3s %.3s%3d %.2d:%.2d:%.2d %d\n",
      wday_name[T->tm_wday],
      mon_name[T->tm_mon],
      T->tm_mday, T->tm_hour, T->tm_min, T->tm_sec,
      1900+T->tm_year);
   return result;
   }

#define StrE(a,b) equal(strcmp(a,b)==0,True,b)

void timetests() {
   time_t t1,t2;
   long l,m; int i;
   char strfbuf[512];

   ANNOUNCE1("time test.\n");

   time(&t1);
   time(&t2);
   equal(strcmp(asctime(localtime(&t1)),ctime(&t1)),0,"asc/local/ctime");
   dequal(difftime(t1,t2),0.0,0.001,"difftime");
   l=clock() / CLOCKS_PER_SEC;
   m=l/3600;
   i = strftime(strfbuf,sizeof(strfbuf),
        "\tAbbreviated weekday name:\t%a\n"
        "\tWeekday name:\t\t%A\n"
        "\tAbbreviated month name:\t%b\n"
        "\tFull month name:\t%B\n"
        "\tDate and time:\t\t%c\n"
        "\tDay of the month:\t%d\n"
        "\t24-hour clock:\t\t%H\n"
        "\t12-hour clock:\t\t%I\n"
        "\tDay of the year:\t%j\n"
        "\tMonth number:\t\t%m\n"
        "\tMinute:\t\t\t%M\n"
        "\tAM/PM designation:\t%p\n"
        "\tSecond:\t\t\t%S\n"
        "\tWeek number of year:\t%U\n"
        "\tWeekday:\t\t%W\n"
        "\tDate representation:\t%x\n"
        "\tTime representation:\t%X\n"
        "\tYear w/out century:\t%y\n"
        "\tYear with  century:\t%Y\n"
        "\tTime zone name:\t%Z\n"
        "\t%%:\t%%\n",
    localtime(&t1));
   equal(i>300,True,"strftime1");
   equal(0,strftime(strfbuf,1,"xx",localtime(&t1)),"strftime2");
   /* From the standard:  What day of the week is July 4, 2001? */
   {struct tm T,T_; time_t T2;
   T.tm_year = 2001-1900;
   T.tm_mon = 7-1;
   T.tm_mday = 4;
   T.tm_hour = 0;
   T.tm_min = 0;
   T.tm_sec = 1;
   T.tm_isdst = -1;
   T2 = mktime(&T);
   equal(T.tm_wday,3,"mktime");
   T_ = *localtime(&T2);
   StrE(asctime(&T_),"Wed Jul  4 00:00:01 2001\n");
   StrE(asctime(&T_),asctime_std(&T_));
   }
   /* What day of the week is Sep. 20, 1989, and the 100 days thereafter? */
   {struct tm T,T_; time_t T2;
   T.tm_year = 1989-1900;
   T.tm_mon = 9-1;
   T.tm_mday = 20;
   T.tm_hour = 0;
   T.tm_min = 0;
   T.tm_sec = 1;
   T.tm_isdst = -1;
   {int d = 3;
   Silent++;
   for (i = 0; i < 100; i++, d++, d == 7 ? d = 0 : 0, T.tm_mday++) {
      T2 = mktime(&T);
      equal(T.tm_wday,d,"mktime");
      if (i == 0) {
        /* Check the first one to ensure that it's Sep 20. */
         T_ = *localtime(&T2);
         StrE(asctime(&T_),"Wed Sep 20 00:00:01 1989\n");
         StrE(asctime(&T_),asctime_std(&T_));
         }
      }
   Silent--;
   }
   }
   }


main () {
   announce("**** START OF TESTS, suite3 ****\n");
   Initialize();
   equal(atexit(FF1),0,"atexit");
   equal(atexit(FF2),0,"atexit");
   equal(atexit(FF3),0,"atexit");
   libtest();
   locale();
   multibyte();
   misctest();
   timetests();
#ifdef PARTA
   EOL_stdio_test();
#endif
   announce("**** END OF TESTS, suite3 ****: the line END OF RUN must appear below.\n");
   /* Now f1, f2, and f3 must be called in reverse order of registration. */
   f_called = 0;
   return 0;
}
