/**************************************************************************
*  Copyright 1985-1992 MetaWare Incorporated.  All rights reserved.       *
*  This is an unpublished work, Copyright 1985-1992 by MetaWare           *
*  Use, disclosure, or transfer without the express written permission    *
*  of MetaWare Incorporated is strictly prohibited.                       *
*  If any or part of this source code is incorporated into other source   *
*  code not authored by MetaWare, this copyright notice must              *
*  accompany it.                                                          *
***************************************************************************
*  See file "suite0.c" for more information.                              *
**************************************************************************/
#ifndef lint
static const char rcsid[] = "$Header: /sun3/tlib/suite_c/RCS/suite4.c,v 1.26 1993/07/01 15:02:53 pickens Exp $";
#endif

/*
 * $Log: suite4.c,v $
 * Revision 1.26  1993/07/01  15:02:53  pickens
 * ifdef'd non-ansi code
 *
 * Revision 1.25  1992/12/16  23:44:51  pickens
 * NOLONGDOUBLE
 *
 * Revision 1.24  1992/12/11  05:23:54  tom
 * Got rid of lots of "static"s for functions so I could debug at asm level.
 *
 * Revision 1.23  1992/09/18  14:11:30  pickens
 * Undo damage made by last change
 *
 * Revision 1.22  1992/09/17  21:18:18  tom
 * Add sieve to suite, since it caused unroller to bomb once.
 *
 * Revision 1.21  1992/08/04  21:11:43  tom
 * *** empty log message ***
 *
 *
 * Revision 1.18  1992/03/26  17:57:01  pickens
 * Enable to be compiler by GOC with _LOC specified
 *
 * Revision 1.17  1991/11/26  02:13:38  tom
 * Fix bug in test_large_structs that fails when compiler does big alignment.
 *
 * Revision 1.16  1991/10/24  19:07:50  tom
 * loop unrolling test only if HC.
 *
 * Revision 1.15  1991/10/24  16:40:26  pickens
 * Make it ansi compilable.
 *
 * Revision 1.14  1991/10/23  14:50:04  pickens
 * Fixed last change to make it ansiable
 *
 * Revision 1.13  1991/10/23  14:06:42  thomasn
 * restore dst_test
 *
 * Revision 1.12  1991/10/23  02:15:25  tom
 * Regression test for unroller
 *
 * Revision 1.11  1991/10/04  15:41:10  thomasn
 * remove dst_test, as it won't work in October...
 *
 * Revision 1.10  1991/09/26  20:24:28  pickens
 * If argument is passed, turn off silent
 *
 * Revision 1.9  91/09/18  12:20:59  pickens
 * HOBBIT doesn't handle alloca
 * 
 * Revision 1.8  91/07/23  11:59:07  thomasn
 * removed stuff that prints time and placed in view_g/view1.c
 * 
 * Revision 1.7  91/07/15  12:51:43  thomasn
 * setup_new_testlib
 * 
 * Revision 1.6  91/06/13  16:17:53  tom
 * Fix totally screwed up tabs.
 * DO NOT EDIT THIS FILE unless your editor preserve all tab characters
 * exactly as they were originally.
 * 
 * Revision 1.5  91/06/05  08:25:18  pickens
 * "pragma" ==> "#pragma"
 * 
 * Revision 1.4  91/06/03  15:20:49  pickens
 * "pragma" ==> "#pragma"
 * 
 * Revision 1.3  91/05/08  14:48:47  pickens
 * Added NO_STRUCT_CONST so that older front-ends will work.
 * 
 * Revision 1.2  91/04/29  12:22:47  tom
 * Add regression test on forward structs.
 * 
 * Revision 1.1  91/03/29  17:04:08  donw
 * Initial revision
 * 
 */


/*
 * The following tests should be added. They are failures caught by
 * HCR suite when run agains new HC.
 * Use define _LOC to turn off stuff supported only by HC2x.
 */
#include "which.h"
#include "globals.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#ifdef QUIET
#define ANNOUNCE1(x)
#else
#define ANNOUNCE1(x)  announce(x)
#endif

struct struct_s {int a,b,c,d,e,f,g;};
static int struct_i = 2;
static void dummy(struct struct_s x){
   equal(3,struct_i,"foo(s[i++])");
   }

struct ss {int a[17];};

struct ss f(s) struct ss s; {
    s.a[16]++;
    s.a[15]--;
    return s;
    }

void newtests()
    {
    unsigned char b1,b2;
    signed char sb1,sb2;
    printf("New tests.\n");
    b1 = 255;
    b2 = 255;
    b1 += b2;
    equal(b1,254,"b1+=b2");
    sb1 = 127;
    sb2 = 127;
    sb1 += sb2;
    equal(sb1,(signed char)(254),"b1+=b2");

    {
    int x[10];
    static int i = 5;
    x[5] = 12345;  /*buggy optimizer may throw away*/
    equal(x[i],12345,"x[5]=");
    }

    {
    static int i = 5;
    int x[10];
    struct struct_s s[10];
    x[5] = 123;
    equal(x[i++],123,"foo(x[i++])");
    equal(i++,6,"foo(i++)");
    equal(i++,7,"foo( i++ )");
    dummy(s[struct_i++]);
    equal(struct_i,3,"s[i++]");
    }

    {
    static signed char ssc;
    static unsigned char suc;
    ssc = -1;
    suc = 255;
    equal((unsigned char)ssc,suc,"suc");
    }

    {
    char a[30];
    int i=0;
    if ((a) && ("b")) i = 1;
    equal(i,1,"&& \"b\"");
    }

    {
    static int si=8;
    int i = si;
    int mask;
    mask = ~(i = 1<<i);
    equal(i,1<<8,"1<<i");
    equal(mask,~(1<<8),"~(1<<i)");
    }
    }

static int b[2] = {2,9};
void inplace()
    {
    unsigned char uc=101;
    static signed char sc=-92;
    static unsigned short us=60000;
    int j;
    uc *= 0.5;
    equal(uc,50,"uc*=0.5");

    us *= 0.5;
    equal(us,30000,"us*=0.5");

    sc *= 0.3333333333;
    equal(sc,-30,"sc*=0.33333");

    b[0] = 6;
    j = 0;
    b[j] *= 0.5;
    equal(b[0],3,"b[0]*=0.5");
    b[j+1]*=0.5;
    equal(b[1],4,"b[1]*=0.5");
    b[1] = 10;
    b[j+1]*=0.5;
    equal(b[1],5,"!b[1]*=0.5");
    }

#ifdef __HIGHC__
/*
 * Test High C intrinsics
 */
static int ii1 = -1;
static int ii2 = 1;
static unsigned long uu1 = -1;
static unsigned long uu2 = 1;
static unsigned short us1a=1,us2a=0x8000;
static float ff1 = -1.0;
static float ff2 = 1.0;
static double dd1 = 1.0;
static double dd2 = -2.0;
void hctests()
    {
    equal(_min(ii1,ii2),-1,"_min(-1,1)");
    equal(_min(ii2,ii1),-1,"_min(1,-1)");
    equal(_min((unsigned)ii1,ii2),1,"_min(-1U,1)");
    equal(_min(ii1,(unsigned)ii2),1,"_min(-1,1U)");

    lequal(_min(uu1,ii2),1L,"_min(-1UU,1)");
    lequal(_min(ii1,uu2),1L,"_min(-1,1UU)");

    equal(_min(-1,100),-1,"_min(-1,100)");
    equal(_min(100,-1),-1,"_min(100,-1)");
    equal(_min((unsigned)ii1,ii2),1,"_min(-1U,1)");
    equal(_min(ii1,(unsigned)ii2),1,"_min(-1,1U)");

    equal(_max(ii1,ii2),1,"_max(-1,1)");
    equal(_max(ii2,ii1),1,"_max(-1,1)");
    equal(_max((unsigned)ii1,ii2),-1,"_max(-1U,1)");
    equal(_max(ii1,(unsigned)ii2),-1,"_max(-1,1U)");
    equal(_max(us1a,us2a),0x8000u,"_max(1,0x8000)");
    equal(_min(us1a,us2a),1,"_min(1,0x8000)");

    lequal(_max(uu1,ii2),-1L,"_max(-1UU,1)");
    lequal(_max(ii1,uu2),-1L,"_max(-1,1UU)");

    dequal(_min(dd1,dd2),dd2,0.0,"_min(1.0,-2.0)");
    dequal(_min(dd2,dd1),dd2,0.0,"_min(-2.0,1.0)");
    dequal(_min(ff1,ff2),ff1,0.0,"_min(1.0F,-1.0F)");
    dequal(_min(ff2,ff1),ff1,0.0,"_min(-1.,1.)");
    dequal(_min(1.0,2.0),1.0,0.0,"_min(1.0,2.0)");
    dequal(_min(2.0,1.0),1.0,0.0,"_min(2.0,1.0)");
    dequal(_max(dd1,dd2),dd1,0.0,"_max(1.0,-2.0)");
    dequal(_max(dd2,dd1),dd1,0.0,"_max(-2.0,1.0)");
    dequal(_max(ff1,ff2),ff2,0.0,"_max(1.0F,-1.0F)");
    dequal(_max(ff2,ff1),ff2,0.0,"_max(-1.,1.)");
    dequal(_max(1.0,2.0),2.0,0.0,"_max(1.0,2.0)");
    dequal(_max(2.0,1.0),2.0,0.0,"_max(2.0,1.0)");

    equal(_abs(-1),1,"abs(-1)");
    equal(_abs(1),1,"abs(1)");
    lequal(_abs(uu1),uu1,"abs(uu1)");
    equal(_abs(ii1),-ii1,"abs(ii1)");
    equal(_abs(ii2),ii2,"abs(ii2)");

    dequal(_abs(2.0),2.0,0.0,"_abs(2.0)");
    dequal(_abs(-2.0),2.0,0.0,"_abs(-2.0)");
    dequal(_abs(dd2),-dd2,0.0,"_abs(dd2)");
    dequal(_abs(ff1),-ff1,0.0,"_abs(ff1)");
    dequal(_abs(ff2),ff2,0.0,"_abs(ff2)");

    /*
     * Test switch of (i++). HC2.0 failed this at one point
     */
    {
       int i = 1;
       switch(i++){
       case 1: equal(1,1,"swit++"); break;
    default: equal(i,1,"swit++"); break;
    }
    }
    {  /*The following test failed miserably on AM29000 HC2.0t:*/
    struct ss s;
    s.a[16] = 123;
    s.a[15] = -123;
    s = f(s);
    equal(s.a[16],124,"s.a[16]");
    equal(s.a[15],-124,"s.a[16]");
    }

    }

void test_uplevel_addressing(void) {
    int a,b;
    void fop(){
	a = b+1;
	}
    void goo(){
	a = 10;
	fop();
	equal(a,b+1,"uplevel1");
	}
    a = 0;
    b = 1;
    goo();
    equal(a,2,"uplevel2");
    a = 100;
    fop();
    equal(a,2,"uplevel3");
    void proc() {a = 3; equal(a,3,"uplevel 4");}
    /* Bug in compiler:  didn't pass static link here. */
    call_forward_fcn(proc);
    }
int call_forward_fcn(void p()!) {p();}
#endif

void preproc() {
    int i;
    #define ELIF_TEST
    #if defined BLETCH
    i = 1;
    #elif defined GEEK
    i = 2;
    #elif defined ELIF_TEST
    i = 3;
    #elif defined GOOSE
    i = 4;
    #else
    i = 5;
    #endif
    equal(i,3,"#elif");
    #undef ELIF_TEST
    #if -1 < 1u
    i = -1;
    #else
    i = 1;
    #endif
    equal(i,1,"-1<1u");
    }

void longdoub() {
#ifndef NOLONGDOUBLE
    char s[1000];
    long double d = 3.142;
    sprintf(s,"%.3Le %.3Le",(long double)3.14159,d);
    equal(strcmp(s,"3.142e+00 3.142e+00")==0 ||
	  strcmp(s,"3.142e+000 3.142e+000")==0,1,"LDprint");
#endif
    }

#ifdef __HIGHC__

#ifndef _LOC
#pragma data(COMMON,"Common");
static int C_a,C_b,C_c;
#pragma data;
void testcommon() {
    static void init_common();
    init_common();
    equal(C_a+C_b+C_c,6,"common");
    }

static void init_common()  /*<== This needs to be in another module*/
    {
    C_a = 1;
    C_b = 2;
    C_c = 3;
    }
#else
void testcommon(){}
#endif


void testgoto() {
    int i;
    char array[30];
    static foo(int j)
	{
	void googoo(int i)
	    {
	    if (i==0) goto L3;
	    googoo(i-1);
	    }
	void foofoo(int i)
	    {
	    if (i==0) googoo(40);
	    foofoo(i-1);
	    }
	if (j<0)foo(-j);
	switch(j){
	    case 1: goto L1;
	    case 2: goto L2;
	    case 3: foofoo(40); break;
	    }
	}

    static test(int a, int b) {
	equal(a,b,"goto");
	equal(strcmp(array,"STUFF"),0,"goto_");
	}

    static goo(int j) {
	foo(-j);
	}
    strcpy(array,"STUFF");
    i = 1;
    goo(1);
    printf("Failed!\n");
    return;

L1:
    test(i,1);
    i = 2;
    goo(2);

L2: test(i,2);
    i=3;
    goo(3);

L3: test(i,3);
    i = 4;
    goo(4);
    test(i,4);
    }

static int goto_cnt;
void testgoto2 () {
   void q(void r()!) {
      r();
      }
   void P() {
      int h(){ return 8; }
      void r() {
	 int i = h();
	 if (i == 8) goto out;
	 equal(1,0,"bad 1");
	 }
      q(r);
      equal(1,0,"bad 2");
      goto_cnt++;
   out: ;
      goto_cnt++;
      }
   P();
   }

do_testgoto2(){
    goto_cnt = 5;
    testgoto2();
    equal(6,goto_cnt,"goto 2");
    }

testgoto3(){
    void f2(){
	void f1(a,b,c,d,e)
	    {
	    goto L;
	    }
	int x=1,y=2;
	f1(1,2,3,4,5);
	equal(x,y,"goto3-0"); /*<==should fail, never gets here*/
	L:   ;
	}
    static int i10=10, i100=100;
    int i=i10,j=i100;
    f2();	/*Make sure registers containing i and j restored*/
    equal(i,10,"goto3-1");
    equal(j,100,"goto3-2");
    }

#if !defined _LOC && !defined _HOBBIT
#include <alloca.h>

static void swap_arrays(char a[],char b[], int len)
    {
    char *p = alloca(len);
    memcpy(p,a,len);
    memcpy(a,b,len);
    memcpy(b,p,len);
    }

testalloca()
    {

#   define FIRST "This is first message"
#   define SECOND "THIS IS SECOND MESSAGE"
    char first[40]=FIRST;
    char second[40]=SECOND;
    swap_arrays(first,second,sizeof first);
    equal(strcmp(FIRST,second),0,"alloca 1");
    equal(strcmp(SECOND,first),0,"alloca 2");
    }
#else
testalloca(){}
#endif
#endif /*__HIGHC__*/

test_auto_init(void) {
    auto int a[10] = {1};
    int i;
    for (i=1; i<10;++i) {
	equal(a[i],0,"auto init");
#if _LOC
	if (i == 1) break;    /* No more msgs for LOC.  We know it fails. */
#endif
	}
    }

#define MS1 "abcdefghijklmno"
#define MS2 "ABCDEFGHIJKLMNO"
struct misaligned {char a[15];};
struct { char a; struct misaligned m;} m1,m2;
struct misaligned *mp1=&m1.m,*mp2=&m2.m;
void misaligned(int a, int b, struct misaligned ms1,
		int c, int d, struct misaligned ms2)
    {
    equal(0,strncmp(ms1.a,MS1,sizeof ms1.a),"misaligned1");
    equal(0,strncmp(ms2.a,MS2,sizeof ms2.a),"misaligned2");
    }

test_misalign_arg(void)
    {
    strncpy(m1.m.a,MS1,sizeof m1.m.a);
    strncpy(m2.m.a,MS2,sizeof m2.m.a);
    misaligned(1,2,*mp1,3,4,*mp2);
    misaligned(1,2,m1.m,3,4,m2.m);
    }

void testsd(double a, double b)
    {
    equal(1,a==b,"short to double");
    }
static short fs(int i) { return i; }

void test_short_to_double_conversion(void)
    {
    double d = fs(123);
    testsd(123.0,d);
    }

static int big = 2147483647;
static int F(int a, int b) {return a+b;}

test_narrowing() {
    signed char sc;
    unsigned char uc;
    short s;
    unsigned short us;

    static unsigned short sus;
    static unsigned char suc;

    uc=F(-1,0);
    equal(uc,255,"uchar cnv");

    suc=F(-1,0);
    equal(suc,255,"suchar cnv");

    sc=F(255,0);
    equal(sc,-1,"schar cnv");

    s=F(2147483647,0);
    equal(s,-1,"short cnv");

    us=F(2147483647,0);
    /* u is required for 16-bit ints. */
    equal(us,65535u,"ushort cnv");

    sus=F(2147483647,0);
    equal(sus,65535u,"sushort cnv");

    uc=big;
    equal(uc,255,"uchar big");

    sc=big;
    equal(sc,-1,"schar big");

    s=big;
    equal(s,-1,"short big");

    us=big;
    equal(us,65535u,"ushort big");

    sus=-1;
    equal(sus,65535u,"sushort big");

    }

/*
 * The following test failed on the RT in 2.1g
 */
static double dr(double d)
    {
    return d;
    }
void test_double_result()
    {
    static double a,b=1.0,c=2.0;
    a = dr(b)/dr(c);
    equal(a==0.5,1,"dresult");
    }

#ifndef _LOC
void test_mutually_recursive_structs()
    {
    struct s {struct s *p; char c;};
    static struct s x;
    static struct s y = {&x,'y'};
    static struct s x = {&y,'x'};
    equal(y.c,'y',"recurs1");
    equal(y.p->c,'x',"recurs2");
    equal(x.p->c,'y',"recurs3");
    equal(x.c,'x',"recurs3");
    equal((int)&x,(int)y.p,"recurs4");
    equal((int)&y,(int)x.p,"recurs4");
    }
#else
void test_mutually_recursive_structs(){}
#endif
void test_memcpy()  /*This test failed on RT in 2.1j */
    {
    static char week[][3]={"sun","mon","tue","wed","thu","fri","sat"};
    static char buf[30];
    static int i = 3;
    int j;
    strcpy(buf,"XXXXXXXXXXXX");
    memcpy(buf,week+i,3);
    equal(strcmp(buf,"wedXXXXXXXXX")==0,1,"memcpy1");
    memcpy(buf,week+i+1,3);
    equal(strcmp(buf,"thuXXXXXXXXX")==0,1,"memcpy2");
    memcpy(buf,week[6],3);
    memcpy(buf+3,week[5],3);
    memcpy(buf+6,week[4],3);
    memcpy(buf+9,week[3],3);
    memcpy(buf+12,week[2],3);
    memcpy(buf+15,week[1],3);
    memcpy(buf+18,week[0],3);
    equal(strncmp(buf,"satfrithuwedtuemonsun",21)==0,1,"memcpy3");
    for(j=0;j<7;j++)
	memcpy(buf+j*3,week+j,3);
    equal(strncmp(buf,"sunmontuewedthufrisat",21)==0,1,"memcpy4");
    }

void test_autoinc()
    {
    static int fieldnum=1;
    register        char    *a;
    register        char    *b;
    register        int     i;
    static          char    f[20];
    a = "abcdef:ghi:jkl:";
    for(i = 0 ; i < fieldnum ; i++)
        while(*a && *a++ !=         ':');
    b = f;
    while(*a !=         ':' && *a != '\0')
        *b++ = *a++;
    *b = '\0';
    equal(strcmp(f,"ghi"),0,"autoinc");
    }

#ifndef _LOC
static shouldnt_complain();
void test_func_decl()
    {
    static shouldnt_complain();
    shouldnt_complain();
    }
static shouldnt_complain(){
    }
#else
void test_func_decl(){}
#endif

static int s_Var;
static int sfunc(int a)
    {
    s_Var += a;
    return a;
    }
static int (*sfunc_ptr(int a, int b))(int a)
    {
    return sfunc;
    }
static int (*(*func_ptr_ptr)(int a,int b))(int a) = sfunc_ptr;
void test_func_ptr()
    {
    int s,t;
    s_Var = 10;
    (*(*func_ptr_ptr)(1,2))(sfunc(-1));
    equal(s_Var,8,"*(*f)()()");
    s = sfunc(-2);
    s_Var = 100;
    (*sfunc_ptr(2,3))(sfunc(-2));
    equal(s_Var,96,"(*f)()");
    s_Var = 1000;
    (*sfunc_ptr(4,5))(s);
    t = sfunc(-3);
    s_Var = 4;
    (*sfunc_ptr(7,8))(t);
    equal(s_Var,4-3,"(*f)()<<");
    }

static struct s4 { int a;} ss4;
static struct s8 { int a,b;} ss8;
static struct s72 { int a[72/sizeof(int)];} ss72;
static struct s4 fs4(){
    ss4.a++;
    return ss4;
    }

static struct s4 ffs4(){ return fs4(); }

static struct s8 fs8(){
    ss8.b++;
    ss8.a++;
    return ss8;
    }

static struct s8 ffs8(){ return fs8(); }

static struct s72 fs72(){
    ss72.a[17]++;
    ss72.a[1]++;
    return ss72;
    }

static struct s72 ffs72(){ return fs72(); }

static int s8i = -1;
static struct s8 func1_8()
    {
    struct s8 x;
    x.a = 50; x.b=51;
    return x;
    }
static struct s8 func2_8()
    {
    struct s8 x;
    x.a = 150; x.b=-51;
    return x;
    }
void test_func_struct()
    {
    struct s8 x8;
    x8 = s8i>0?func1_8():func2_8();
    equal(x8.a,150,"func2");
    equal(x8.b,-51,"func2+");
    x8 = s8i<0?func1_8():func2_8();
    equal(x8.a,50,"func2'");
    equal(x8.b,51,"func2'+");
    ss4.a = 10;
    equal(ffs4().a,11,"ffs4");
    ss8.a = 12;
    ss8.b = 112;
    equal(ffs8().a,13,"ffs8");
    equal(ffs8().b,114,"ffs8+");
#if __HIGHC__	/* Non-ANSI  code: */
    ss72.a[1] = 100;
    ss72.a[17] = 200;
    equal(ffs72().a[1],101,"fs72");
    equal(ffs72().a[17],202,"fs72+");
#endif
    }

void test_macro_expansion()
    {
#undef ABS
#undef MAX
#undef STR
#define ABS(x) ((x)>=0?(x):-(x))
#define MAX(x,y) ((x)>=(y)?(x):(y))
#define STR(x) #x
    equal(ABS(-ABS    (10)),10,"macro 1");
    equal(10,ABS(-ABS   (ABS        (-10))),"macro 2");
    equal(100,MAX(ABS(10),ABS (-100)),"macro 3");
#ifndef _LOC
    equal(strcmp(STR(ABS    x),"ABS x")==0,1,"macro 4");
#endif
#undef ABS
#undef MAX
#undef STR
    }

static int shhoo(int i){ return i; }
static int shfoo(int i){ return i<<shhoo(1); }
int test_shift()
    {
    static int i = 16;
    equal(i<<shhoo(1),32,"shift");
    equal(shfoo(10),20,"shift1");
    }

static int if1=1;
static int if2=0;
static void iff1(int i)
    {
    if1 = i;
    }
static void iff2(int i)
    {
    if2 = i;
    }
void test_ifexpr()
    {
    if1?iff1(10):iff1(20);
    equal(if1,10,"if1");
    if2?iff2(100):iff2(200);
    equal(if2,200,"if2");
    }

static long sci = 10;
static short scs = 10;
void test_shortcmp()
    {
    equal(scs==(short)sci,1,"s==i"); /*Failed on Sun 3*/
    }

void test_icmp()
    {
    static long l = (unsigned long)(-1L)>>1;
    static long h = ~((unsigned long)(-1L)>>1);
    if (l+1<0) equal(l,l,"7FFFFFFF++");
    else equal(l+1,~l,"7FFFFFFF++"); /*<==Force failure*/
    if (h-1>0) equal(h-1,h-1,"7FFFFFFF--");
    else equal(h-1,~h,"7FFFFFFF--"); /*<==Force failure*/
    }

void test_multibyte() {
#ifdef __HIGHC__
    int x = '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0xy';
    long y = '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0xyz';
    long z = 'abcdefghijklmnopqrstuvwxyz'; /* Semantics: last four. */
    int x1 = '\xaa\xbb';
    equal(x,'xy',"xy");
    lequal(y,'xyz',"xyz");
    lequal(z,'wxyz',"wxyz");
    equal(x1,(unsigned char)'\xaa'*256+(unsigned char)'\xbb',"aabb");
#endif
    }

void test_Lstrings() {
#if !defined(_NO_WCHAR) && __HIGHC__
    wchar_t *s1=L"abcdefghijk";
    static wchar_t *s2=L"lmnopqrstuvw";
    long y = L'\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0xyz';
    equal((strcmp((char *)L"abcdefghijklmnopqrstuvw",
       (char *)L"abcdefghijkl" L"mnopqrstuvw")==0),1,"lstring");
    equal(L"abc"[2],'c',"lstring[i]");
    equal(sizeof(L'a'),sizeof(wchar_t),"sizeof(wchar_t)");
    lequal(y,L'xyz',"Lxyz");
#endif
    }

#ifdef __HIGHC__
/*
This program analyzes a directed graph and "breaks" all loops in
the graph.  The program marks a set of nodes in the graph such that
if the ingoing edges to the nodes are deleted, the graph is acyclic.
The technique is as follows:
	For each strongly-connected component (SCC) of the graph,
	mark the root (where the SCC was first entered).
	This reduces the number of loop paths in the SCC,
	breaking the SCC into a set of smaller SCCs.
	Recursively find the SCCs of this reduced SCC, breaking
	loops in the same way.	When finished, all loops in the original
	SCC will be broken.  When each SCC is thus processed,
	the graph will contain no loops.
The algorithm was used as part of a scheme
for generating ultra-fast LR parsers.
It also is a good test for Pascal compilers.

The SCC algorithm was derived from one by Eve and Kurki-Suonio.
See paper by DeRemer and Pennello in Oct. 1982 TOPLAS.

Author:  Tom Pennello of MetaWare Incorporated.

This version is in MetaWare High C.  The ()! syntax denotes a full
function value -- the equivalent of the Pascal procedural parameter --
that consists of the entry point AND the environment pointer.

I challenge any C programmer that feels up to it to re-program this in standard
C.

This version of the program is written using High C iterators.
There is another version supplied that uses only nested procedures.
*/

/* For this sample application, the node size is small. */
/* The graph is represented in code.  See below 	*/
#define Nullnode 0
#define Maxnodes 100
#define Maxnodesp1 101
#define Firstnode 1
#define Lastnode 8

typedef int Integer;

typedef Integer /*Subrange!!:Nullnode..Maxnodesp1*/ Node;
/* For translation into C we need to convert sets to arrays of booleans. */
typedef Boolean Nodeset[Maxnodesp1+1];
Nodeset Marked;

void Eachscc(/* of relation R */
      /* Pass in the relation on the nodes; yield each SCC found. */
		    void Eachnode() -> (Node)!,
		    void R(Node) -> (Node)!,
		    Boolean Yieldtrivialsccs)  /* Yield SCCs of one node?	     */
    -> (Node Root, void Each() -> (Node)!)! {
#  define Infinity Maxnodesp1
   Integer /*Subrange!!:0..Maxnodesp1*/ N[Maxnodesp1+1];
   Node Stack[Maxnodes+1];
   Integer /*Subrange!!:0..Maxnodes*/ Sp;

   void Search(Node V) {
      Boolean Vhaspathtoitself; Integer I,T;

      void Eachmember() -> (Node) {
	 Integer I;
	/* yield each member of current SCC */
	 for (I = Sp; I >= T; I--)
	    yield(Stack[I]);
	 } /*Eachmember*/
      if (N[V] == 0) {	     /* stack the node */
	 Vhaspathtoitself = False;
	 Sp++;
	 Stack[Sp] = V; N[V] = Sp;
	 for W <- R(V) do {
	    Search(W);
	    if (W == V)
	       Vhaspathtoitself = True;
	    if (N[W] < N[V])
	       N[V] = N[W];
	    }
	 if (V == Stack[N[V]]) {/* V is root of an SCC */
	    T = N[V];
	    for (I = Sp; I >= T; I--)
	       N[Stack[I]] = Infinity;
	    if (Sp != T || /* single node; V R+ V ? */
		Vhaspathtoitself && Yieldtrivialsccs)
	       yield(V,Eachmember);
	    Sp = T-1;
	    }
	 }
      } /*Search*/
   for Q <- Eachnode() do N[Q] = 0;
   Sp = 0;
   for V <- Eachnode() do Search(V);
   } /*Eachscc*/

/*
The sample graph to be analyzed is as follows:

	1
	V
	2 <--- 3
	|      A
	V      |
	+->4-->+
	A  V   A
	|  5   |
	|  V   |
	+<-6-->7-->+-->8-->+
	       A   V   A   V
	       +<--+   +<--+

Thus, there are eight nodes.
Marking nodes 2, 4, 7, and 8 breaks all loops.
*/

#define MAX_STRING 80
static char strings[10][MAX_STRING]; int last_string=0;
static char *should_be[] = {
	"Marking node 2\n",
	"Marking node 7\n",
	"Marking node 6\n",
	"SCC of 6 nodes detected, having 2 contained SCCs.\n",
	"Marking node 8\n",
	"SCC of 1 nodes detected, having 0 contained SCCs.\n",
	0};
	
#define STATIC
#include <stdarg.h>
STATIC void stash_printf(char * format, ...) {
   va_list ap;
   va_start(ap,format);
   vsprintf(strings[last_string++],format,ap);
   va_end(ap);
   }

static void Analyzegraph()
   {
   Integer Subsccs;
   Integer Cnt;

   /* The graph is represented by these two procedures. */
   void Eachstate() -> (Node) {
      Node N;
      for (N = Firstnode; N <= Lastnode; N++)
	 yield(N);
      } /*Eachstate*/
   void Successors(Node N) -> (Node) {
      switch (N) {
	 case 1:
	    yield(2);
	    break;
	 case 2:
	    yield(4);
	    break;
	 case 3:
	    yield(2);
	    break;
	 case 4:
	    yield(5);
	    break;
	 case 5:
	    yield(6);
	    break;
	 case 6: {
	    yield(7); yield(4);
	    }
	    break;
	 case 7: {
	    yield(7); yield(3);
	    }
	    break;
	 case 8:
	    yield(8);
	    break;
	 }
      } /*Successors*/
   static void P(Node Root, void Scc() -> (Node)!)
      {
      Nodeset Inscclessroot;
      void Successors2(Node N) -> (Node) {
	 for N2 <- Successors(N) do if (Inscclessroot[N2]) yield(N2);
	 } /*Successors2*/
      void Scclessroot() -> (Node) {
	 for N <- Scc() do {
	    if (Inscclessroot[N]) yield(N);
	    }   	 	  
	 } /*Scclessroot*/
      /* Break the SCC at the root, then recursively do leftover SCCs. */
      /* We run EachSCC only on nodes & edges in SCC, less the root.	*/
      for N <- Eachstate() do Inscclessroot[N] = False;
      for N <- Scc() do {
	 if (N != Root)
	    Inscclessroot[N] = True;
	 } /*Body*/
      Marked[Root] = True;
      stash_printf("Marking node %d\n",Root);
      for Root2, Scc2 <- Eachscc(Scclessroot,Successors2,True) do {
	 Subsccs++;
	 P(Root2,Scc2);
	 } 
      } /*P*/
   for N <- Eachstate() do Marked[N] = False;
   for Root,Scc <- Eachscc(Eachstate,Successors,True) do {
      Subsccs = 0;
      P(Root,Scc);
      Cnt = 0; 
      for N <- Scc() do Cnt++;
      stash_printf("SCC of %d nodes detected, having %d contained SCCs.\n",
				 Cnt, Subsccs);
      } 
   } /*Analyzegraph*/

test_graph_analyze() {
   Analyzegraph();
   char (*p1)[MAX_STRING] = strings, **p2 = should_be;
   while (*p2) {
      if (strcmp(*p1,*p2) != 0) 
         printf("Analyzegraph error: \n received  '%s'\n should be '%s'\n",
            *p1,*p2);
      p1++,p2++;
      }      
   }
#else
test_graph_analyze() {}
#endif
/*
 * The following test failed in MC68020 compiler
 */
test_mod(){
    unsigned char uc;
    unsigned char *puc;
    unsigned char **ppuc;
    unsigned short us;
    unsigned short *pus;
    unsigned short **ppus;

    uc = 10;
    puc = &uc;
    ppuc = &puc;
    us = 17;
    pus = &us;
    ppus = &pus;

    **ppus %= **ppuc;
    equal(us,7,"**%**");
    {
        unsigned char uc;
        char c, *pc, **ppc;

        uc = 128;
        c = 20;
        pc = &c;
        ppc = &pc;

        equal(uc /= **ppc,6,"/=**");
        }

    {
        static unsigned char u = 255;
        static unsigned char r = 255;
        static unsigned char d = 254;
        static unsigned char e = 254;
        r  %= e;
        equal(r,1,"255%=254");
        equal(u % d,1,"255%254");
        }

    {
        static unsigned short ui=65535;
        unsigned char uc= 255;
        ui = ui / uc;
        equal(ui,257,"65535%255");
        }

    }

#ifndef _LOC
struct t { int a;};
/*The following should compile without error */
static void tfunc (struct t {float b;}x)
    {
    float *fp = &x.b;
    }

extern struct t ptfunc(union t {int xx;} );  /*Should compile without error*/

/*The following should compile without error */
static void ufunc(union t *tp)
    {
    union t {int tt;};
    int i = tp->tt;
    }

enum enum_s {AA,BB};
void test_pscope(enum enum_s {BB,AA} x)
    {
    /*
     * Make sure we're using the latest enum_s definition.
     */
    equal(BB,0,"BB");
    equal(AA,1,"AA");
    equal(x != AA,1,"AA!");

    /* NOTE: AA  that is passed in is 0 not 1!!! */
    equal(x,0,"AA0");
#ifdef __HIGHC__
    {
    struct fwd_s  *sp;
    { union s *up;
       union s {int uu;};
       equal(sizeof(int),sizeof(up->uu),"uu");
       }
    struct fwd_s {char ss;};
    equal(sizeof(char),sizeof(sp->ss),"ss");
    }
#endif
    }
struct s9 { int x; };
sub () { 
    int i = sizeof(struct s9);
    /* What appears below is NOT a new struct s9,
       since "const" appears, even though it appears at end. */
#ifndef NO_STRUCT_CONST
    struct s9 const; 
#endif
    struct s9 p; 
    equal(sizeof(p),i,"fwd struct");
    { struct s9;	/* True forward struct. */
      struct s9 *q;
      struct s9 { int y,z; } v9;
      equal(sizeof(*q),sizeof(v9),"fwd struct2");
    }
    }
#endif

typedef int INT;
typedef double FLOAT;

#ifndef _LOC
FLOAT test_typedefs(int FLOAT, double INT)
    {
    equal(FLOAT,123,"FLOAT");
    equal(sizeof(FLOAT),sizeof(int),"sFLOAT");
    equal(sizeof(INT),sizeof(double),"sINT");
    return 0.0;
    }

/* Make sure scope above closed correctly*/
void post_typedef_test()
    {
    INT i;
    FLOAT f;
    equal(sizeof(INT),sizeof(int),"ssINT");
    equal(sizeof(FLOAT),sizeof(double),"ssFLOAT");
    equal(sizeof(i),sizeof(int),"sssINT");
    equal(sizeof(f),sizeof(double),"sssFLOAT");
    }

static FLOAT (*a_complex_case(int FLOAT, double INT))(FLOAT f, INT i)
    {
    equal(sizeof(FLOAT),sizeof(int),"cFLOAT");
    equal(sizeof(INT),sizeof(double),"cINT");
    return 0;
    }
#endif

void test_lstrings()
    {
#ifndef _NO_WCHAR
    wchar_t c = L'a';
    wchar_t *cp = L"abcdef";
    equal(c,cp[0],"Lstring");
#endif
    }

/* The following failed with HC 2.1 on 386 */
static struct eight { int a,b;} ss1elem[2] = {{0,0},{123,456}};
static struct eight ss2elem[2] = {{0,0},{654,-321}};
static struct ssmove {
       struct eight *elem;
       int index;
       } ss1 = { ss1elem, 1 }, *ss1p = &ss1,
         ss2 = { ss2elem, 1 },  *ss2p = &ss2;

void test_struct_move()
    {
    equal(ss1p->elem[ss1p->index].a,123,"smove1");
    equal(ss1p->elem[1].b,456,"smove2");
    ss1p->elem[ss1p->index] = ss2p->elem[ss2p->index];
    equal(ss1p->elem[1].a,654,"smove3");
    equal(ss1p->elem[1].b,-321,"smove4");
    }

static fmath1(a,b,c,d,e,f,g,h)
double a,b,c,d,e,f,g,h;
{
    char buf[80];
    char correct[] = "1 2 2.05 3.6 3.625 5.975 4.4125 7.1625\n";
    int i;
    sprintf(buf,"%g %g %g %g %g %g %g %g\n",a,b,c,d,e,f,g,h);
    i = strcmp(buf,correct);
    if (i)
        printf("%s%s",buf,correct);
    equal(i,0,"fmath");
    }

/*
 * The following test broke our 387 support
 */
static void fmath(x0,y0,x1,y1,x2,y2,x3,y3)
	double x0,y0,x1,y1,x2,y2,x3,y3; {
    double mx1,my1,mx2,my2,mx3,my3,mx4,my4,mlx,mly,mrx,mry,cx,cy;

    mx1=(x0+x1)/2.0;
    my1=(y0+y1)/2.0;
    mx2=(x1+x2)/2.0;
    my2=(y1+y2)/2.0;
    mx3=(x2+x1)/2.0;
    my3=(y2+y1)/2.0;
    mx4=(x3+x2)/2.0;
    my4=(y3+y2)/2.0;
    mlx=(mx1+mx2)/2.0;
    mly=(my1+my2)/2.0;
    mrx=(mx2+mx3)/2.0;
    mry=(my2+my3)/2.0;
    cx=(mlx+mrx)/2.0;
    cy=(mly+mry)/2.0;
    fmath1(x0,y0,mx1,my1,mlx,mly,cx,cy);
    }

void test_float_arithmetic() {
    fmath(1.0, 2.0, 3.1, 5.2, 7.3, 11.5, 13.01, 17.03);
/*  printf("Should be\n"
    "1 2 2.05 3.6 3.625 5.975 4.4125 7.1625\n");*/
    }

void pptest(double a, double b, char *msg)
    {
    if (a != b)
    equal(0,1,msg);
    }

void test_pp_numbers()
    {
#   define paste(a,b,c) a ##b## c
    pptest(1.25,paste(1,.,25),"1 . 25");
    pptest(1.25,paste(1,.2,5),"1 .2 5");
    pptest(1.25,paste(1,.25,E0),"1 .25 E0");
    pptest(1.25,paste(1,.2,5e+0),"1 .2 5e+0");
    pptest(1.25,paste(.12,5,e1),".12 5 e1");
    pptest(1.25,paste(.,00125,0000e+3),". 00125 e3");
    equal(125,paste(1,2,5),"1 2 5");
    equal(0125,paste(01,2,5),"01 2 5");
    equal(0x12F,paste(0x1,2,F),"0x12F");
    equal(0x12F,paste(0x,1,2F),"0x1,2F");
    equal(0xABC,paste(0x,Ab,c),"0xABC");
    equal(0xABC,paste(0x0a,b,C),"0x0ABC");
    }

/*
 * The following should compile
 */
#ifndef _LOC
static struct s01 *s01;
test_struct_resolutions()
    {
    struct s01;
    struct { struct s01 *p; } x;
    struct s01 { int a,b; }v;
    x.p = &v;
    x.p->a = 0;
    x.p->b = 0;
    }
static struct s01 { float x, y; };
test_struct_resolution2()
    {
    struct { struct s01 *p; } x;
    x.p->x = 0;
    x.p->y = 0;
    }
#else
test_struct_resolutions() {}
test_struct_resolution2() {}
#endif

void test_short_circuiting()
    {
    int i = 10 || 1/0;
    static js = 0?1-100/0+1:10;
    equal(i,1,"1||1/0");
    if (0 && 10+1-100/0) equal(1,0,"0&&1/0");
    switch(js){
	case (1?10:10/0): equal(js,10,"&&s"); break;
	default: equal(1,0,"&&s"); break;
	}
    }

void test_init_bit_fields()
    {
    static struct {
       int :0;
       int :1;
       int a:2;
       int :3;
       int b:4;
       }x =
#if defined _LOC && !defined _GOC
	{0,2,0,10};
#else
	{2,10};
#endif
    equal(x.a,2,"x.a");
    equal(x.b,10,"x.b");
    }

#ifdef _LOC
#define LARGE_NUMBER (sizeof(int)==2?32000:0x20000000)
#else
#define LARGE_NUMBER (sizeof(int)==2?32000:0x40000000)
#endif
void test_large_structs() {
    struct {
	int padk[16];
	char x[LARGE_NUMBER];
	int padi[16];	/* Put reasonable size pad here so that
			 * if a compiler aligns fields to big boundaries
			 * we are OK.
			 */
	char y[LARGE_NUMBER];
	int j;
	} *p = 0;
    equal((long)&p->j,(long)&p->padi+sizeof(p->padi)+sizeof(p->y),"large1");
    equal((long)&p->padi,(long)&p->padk+sizeof(p->padi)+sizeof(p->x),"large2");
    }

void test_strstr()
    {
    char *p = "abc";
    equal(strstr(p,"")==p,1,"strstr(\"\")");
    }

/*
 * Make sure full space is allocated for partially initialized struct
 */
static struct sinit { int a,b,c:1,d:1,e,f,g; } sinits = {1,2,3};
static char sinita[] = "THIS IS GARBAGE";
void test_struct_init()
    {
    equal(sinits.d,0,"sinit.d");
    equal(sinits.f,0,"sinit.f");
    equal(sinits.g,0,"sinit.g");
    }

#ifndef _LOC
void test_func_two_ptr(void)
    {
    void (*f)(void) = test_func_ptr;
    equal(1,f==test_func_ptr,"funcptr");
    equal(1,&*f==test_func_ptr,"funcptr1");
    }
#else
void test_func_two_ptr(void) {}
#endif


void test_strcpy()
    {
    static char buf[] = "xxxxxxxxxx";
    strcpy(buf,"yy\0yyy");  /*Should move 3 bytes only */
    equal(memcmp(buf,"yy\0xxxxxxx",10),0,"strcpy");
    }

void test_bit_fields()
    {
    struct s {char c; long i:24;} x;
    struct s1 {long i:32;} y;
    struct s2 {long l;} z;
    equal(sizeof(x),sizeof(y),"fields");
    equal(sizeof(x),sizeof(z),"fields1");
    }

/*
 * Test that names are being correctly overriden
 */
void test_override()
{
     static float x_x = 5.;
#ifndef _LOC
     {
	extern int x_x;
	equal(x_x,56,"x_x");
     }
     dequal(x_x,5.,x_x,"x_xf");
#endif
     }
int x_x = 56;

static const char *str_data0[] = {
    "abcdefghijklmnop",     /* dst+0, src+0, 0 */
    "0bcdefghijklmnop",     /* dst+0, src+0, 1 */
    "01cdefghijklmnop",     /* dst+0, src+0, 2 */
    "012defghijklmnop",     /* dst+0, src+0, 3 */
    "0123efghijklmnop",     /* dst+0, src+0, 4 */
    "01234fghijklmnop",     /* dst+0, src+0, 5 */
    "012345ghijklmnop",     /* dst+0, src+0, 6 */
    "0123456hijklmnop",     /* dst+0, src+0, 7 */
    "01234567ijklmnop",     /* dst+0, src+0, 8 */
    "012345678jklmnop",     /* dst+0, src+0, 9 */
    "abcdefghijklmnop",     /* dst+0, src+1, 0 */
    "1bcdefghijklmnop",     /* dst+0, src+1, 1 */
    "12cdefghijklmnop",     /* dst+0, src+1, 2 */
    "123defghijklmnop",     /* dst+0, src+1, 3 */
    "1234efghijklmnop",     /* dst+0, src+1, 4 */
    "12345fghijklmnop",     /* dst+0, src+1, 5 */
    "123456ghijklmnop",     /* dst+0, src+1, 6 */
    "1234567hijklmnop",     /* dst+0, src+1, 7 */
    "12345678ijklmnop",     /* dst+0, src+1, 8 */
    "123456789jklmnop",     /* dst+0, src+1, 9 */
    "abcdefghijklmnop",     /* dst+0, src+2, 0 */
    "2bcdefghijklmnop",     /* dst+0, src+2, 1 */
    "23cdefghijklmnop",     /* dst+0, src+2, 2 */
    "234defghijklmnop",     /* dst+0, src+2, 3 */
    "2345efghijklmnop",     /* dst+0, src+2, 4 */
    "23456fghijklmnop",     /* dst+0, src+2, 5 */
    "234567ghijklmnop",     /* dst+0, src+2, 6 */
    "2345678hijklmnop",     /* dst+0, src+2, 7 */
    "23456789ijklmnop",     /* dst+0, src+2, 8 */
    "23456789Ajklmnop",     /* dst+0, src+2, 9 */
    "abcdefghijklmnop",     /* dst+0, src+3, 0 */
    "3bcdefghijklmnop",     /* dst+0, src+3, 1 */
    "34cdefghijklmnop",     /* dst+0, src+3, 2 */
    "345defghijklmnop",     /* dst+0, src+3, 3 */
    "3456efghijklmnop",     /* dst+0, src+3, 4 */
    "34567fghijklmnop",     /* dst+0, src+3, 5 */
    "345678ghijklmnop",     /* dst+0, src+3, 6 */
    "3456789hijklmnop",     /* dst+0, src+3, 7 */
    "3456789Aijklmnop",     /* dst+0, src+3, 8 */
    "3456789ABjklmnop",     /* dst+0, src+3, 9 */

    "abcdefghijklmnop",     /* dst+1, src+0, 0 */
    "a0cdefghijklmnop",     /* dst+1, src+0, 1 */
    "a01defghijklmnop",     /* dst+1, src+0, 2 */
    "a012efghijklmnop",     /* dst+1, src+0, 3 */
    "a0123fghijklmnop",     /* dst+1, src+0, 4 */
    "a01234ghijklmnop",     /* dst+1, src+0, 5 */
    "a012345hijklmnop",     /* dst+1, src+0, 6 */
    "a0123456ijklmnop",     /* dst+1, src+0, 7 */
    "a01234567jklmnop",     /* dst+1, src+0, 8 */
    "a012345678klmnop",     /* dst+1, src+0, 9 */
    "abcdefghijklmnop",     /* dst+1, src+1, 0 */
    "a1cdefghijklmnop",     /* dst+1, src+1, 1 */
    "a12defghijklmnop",     /* dst+1, src+1, 2 */
    "a123efghijklmnop",     /* dst+1, src+1, 3 */
    "a1234fghijklmnop",     /* dst+1, src+1, 4 */
    "a12345ghijklmnop",     /* dst+1, src+1, 5 */
    "a123456hijklmnop",     /* dst+1, src+1, 6 */
    "a1234567ijklmnop",     /* dst+1, src+1, 7 */
    "a12345678jklmnop",     /* dst+1, src+1, 8 */
    "a123456789klmnop",     /* dst+1, src+1, 9 */
    "abcdefghijklmnop",     /* dst+1, src+2, 0 */
    "a2cdefghijklmnop",     /* dst+1, src+2, 1 */
    "a23defghijklmnop",     /* dst+1, src+2, 2 */
    "a234efghijklmnop",     /* dst+1, src+2, 3 */
    "a2345fghijklmnop",     /* dst+1, src+2, 4 */
    "a23456ghijklmnop",     /* dst+1, src+2, 5 */
    "a234567hijklmnop",     /* dst+1, src+2, 6 */
    "a2345678ijklmnop",     /* dst+1, src+2, 7 */
    "a23456789jklmnop",     /* dst+1, src+2, 8 */
    "a23456789Aklmnop",     /* dst+1, src+2, 9 */
    "abcdefghijklmnop",     /* dst+1, src+3, 0 */
    "a3cdefghijklmnop",     /* dst+1, src+3, 1 */
    "a34defghijklmnop",     /* dst+1, src+3, 2 */
    "a345efghijklmnop",     /* dst+1, src+3, 3 */
    "a3456fghijklmnop",     /* dst+1, src+3, 4 */
    "a34567ghijklmnop",     /* dst+1, src+3, 5 */
    "a345678hijklmnop",     /* dst+1, src+3, 6 */
    "a3456789ijklmnop",     /* dst+1, src+3, 7 */
    "a3456789Ajklmnop",     /* dst+1, src+3, 8 */
    "a3456789ABklmnop",     /* dst+1, src+3, 9 */

    "abcdefghijklmnop",     /* dst+2, src+0, 0 */
    "ab0defghijklmnop",     /* dst+2, src+0, 1 */
    "ab01efghijklmnop",     /* dst+2, src+0, 2 */
    "ab012fghijklmnop",     /* dst+2, src+0, 3 */
    "ab0123ghijklmnop",     /* dst+2, src+0, 4 */
    "ab01234hijklmnop",     /* dst+2, src+0, 5 */
    "ab012345ijklmnop",     /* dst+2, src+0, 6 */
    "ab0123456jklmnop",     /* dst+2, src+0, 7 */
    "ab01234567klmnop",     /* dst+2, src+0, 8 */
    "ab012345678lmnop",     /* dst+2, src+0, 9 */
    "abcdefghijklmnop",     /* dst+2, src+1, 0 */
    "ab1defghijklmnop",     /* dst+2, src+1, 1 */
    "ab12efghijklmnop",     /* dst+2, src+1, 2 */
    "ab123fghijklmnop",     /* dst+2, src+1, 3 */
    "ab1234ghijklmnop",     /* dst+2, src+1, 4 */
    "ab12345hijklmnop",     /* dst+2, src+1, 5 */
    "ab123456ijklmnop",     /* dst+2, src+1, 6 */
    "ab1234567jklmnop",     /* dst+2, src+1, 7 */
    "ab12345678klmnop",     /* dst+2, src+1, 8 */
    "ab123456789lmnop",     /* dst+2, src+1, 9 */
    "abcdefghijklmnop",     /* dst+2, src+2, 0 */
    "ab2defghijklmnop",     /* dst+2, src+2, 1 */
    "ab23efghijklmnop",     /* dst+2, src+2, 2 */
    "ab234fghijklmnop",     /* dst+2, src+2, 3 */
    "ab2345ghijklmnop",     /* dst+2, src+2, 4 */
    "ab23456hijklmnop",     /* dst+2, src+2, 5 */
    "ab234567ijklmnop",     /* dst+2, src+2, 6 */
    "ab2345678jklmnop",     /* dst+2, src+2, 7 */
    "ab23456789klmnop",     /* dst+2, src+2, 8 */
    "ab23456789Almnop",     /* dst+2, src+2, 9 */
    "abcdefghijklmnop",     /* dst+2, src+3, 0 */
    "ab3defghijklmnop",     /* dst+2, src+3, 1 */
    "ab34efghijklmnop",     /* dst+2, src+3, 2 */
    "ab345fghijklmnop",     /* dst+2, src+3, 3 */
    "ab3456ghijklmnop",     /* dst+2, src+3, 4 */
    "ab34567hijklmnop",     /* dst+2, src+3, 5 */
    "ab345678ijklmnop",     /* dst+2, src+3, 6 */
    "ab3456789jklmnop",     /* dst+2, src+3, 7 */
    "ab3456789Aklmnop",     /* dst+2, src+3, 8 */
    "ab3456789ABlmnop",     /* dst+2, src+3, 9 */

    "abcdefghijklmnop",     /* dst+3, src+0, 0 */
    "abc0efghijklmnop",     /* dst+3, src+0, 1 */
    "abc01fghijklmnop",     /* dst+3, src+0, 2 */
    "abc012ghijklmnop",     /* dst+3, src+0, 3 */
    "abc0123hijklmnop",     /* dst+3, src+0, 4 */
    "abc01234ijklmnop",     /* dst+3, src+0, 5 */
    "abc012345jklmnop",     /* dst+3, src+0, 6 */
    "abc0123456klmnop",     /* dst+3, src+0, 7 */
    "abc01234567lmnop",     /* dst+3, src+0, 8 */
    "abc012345678mnop",     /* dst+3, src+0, 9 */
    "abcdefghijklmnop",     /* dst+3, src+1, 0 */
    "abc1efghijklmnop",     /* dst+3, src+1, 1 */
    "abc12fghijklmnop",     /* dst+3, src+1, 2 */
    "abc123ghijklmnop",     /* dst+3, src+1, 3 */
    "abc1234hijklmnop",     /* dst+3, src+1, 4 */
    "abc12345ijklmnop",     /* dst+3, src+1, 5 */
    "abc123456jklmnop",     /* dst+3, src+1, 6 */
    "abc1234567klmnop",     /* dst+3, src+1, 7 */
    "abc12345678lmnop",     /* dst+3, src+1, 8 */
    "abc123456789mnop",     /* dst+3, src+1, 9 */
    "abcdefghijklmnop",     /* dst+3, src+2, 0 */
    "abc2efghijklmnop",     /* dst+3, src+2, 1 */
    "abc23fghijklmnop",     /* dst+3, src+2, 2 */
    "abc234ghijklmnop",     /* dst+3, src+2, 3 */
    "abc2345hijklmnop",     /* dst+3, src+2, 4 */
    "abc23456ijklmnop",     /* dst+3, src+2, 5 */
    "abc234567jklmnop",     /* dst+3, src+2, 6 */
    "abc2345678klmnop",     /* dst+3, src+2, 7 */
    "abc23456789lmnop",     /* dst+3, src+2, 8 */
    "abc23456789Amnop",     /* dst+3, src+2, 9 */
    "abcdefghijklmnop",     /* dst+3, src+3, 0 */
    "abc3efghijklmnop",     /* dst+3, src+3, 1 */
    "abc34fghijklmnop",     /* dst+3, src+3, 2 */
    "abc345ghijklmnop",     /* dst+3, src+3, 3 */
    "abc3456hijklmnop",     /* dst+3, src+3, 4 */
    "abc34567ijklmnop",     /* dst+3, src+3, 5 */
    "abc345678jklmnop",     /* dst+3, src+3, 6 */
    "abc3456789klmnop",     /* dst+3, src+3, 7 */
    "abc3456789Almnop",     /* dst+3, src+3, 8 */
    "abc3456789ABmnop",     /* dst+3, src+3, 9 */
    } ;

/* strncpy_test:
 * Need to check strncpy, memcpy, etc. for all possible boundary conditions
 *  correct results in str_data0[].
 */
void strncpy_test() {
    const char *data = "abcdefghijklmnop";
    const char *src  = "0123456789ABCDEFG";
    char dst[40], num[7];
    int i, j, k;

    Silent++;
    ANNOUNCE1("Test strncpy.");
    strcpy(dst, data);
    for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
        for (k = 0; k < 10; k++) {
	   sprintf(num, "%d-%d-%d", i, j, k);
	   strncpy(dst+i, src+j, k);
	   equal(strcmp(dst, str_data0[i*40 + j*10 + k]), 0, num);
	   strcpy(dst, data);
	   }
    Silent--;
    }

static float fvalue();
static double dvalue();

/* The following test failed in 387 code generation (from Plum Hall)*/
void test_more_float()
    {
    auto float f3;
    auto float * pf3;
    auto float f4;
    auto float * pf4;
    auto double d1;
    auto double d2;
    auto double d5;
    auto double * pd5;
    auto double d6;

    f3 = fvalue(3.000000E+000);
    pf3 = &f3;
    f4 = fvalue(4.000000E+000);
    pf4 = &f4;
    d1 = dvalue(1.000000000000000E+000);
    d2 = dvalue(2.000000000000000E+000);
    d5 = dvalue(5.000000000000000E+000);
    pd5 = &d5;
    d6 = dvalue(6.000000000000000E+000);
    (void) dequal((((d1 * d1) + *pd5) - (f4 += (d6 /= *pf3))), 0.000E+000,
          0.0,"morefloat");
    }


#define ZERO 0.0

static float fvalue(x) float x; {
    return x + ZERO;
    }

static double dvalue(x) double x; {
    return x + ZERO;
    }

/*
 * This test broke version 2.3A of the AM29050 compiler
 */
void test_050_1()
    {
    static int z=0;
    equal(z ? 1 : z ? 2 : z ? 3 : z ? 4 : 5, 5,"050_1" );
    }

/*
 * This test failed in version 2.3A of the AM29050 compiler
 */
void test_050_2()
    {
    dequal( log10( pow( 10.0, 1.234 )), 1.234 , .00001, "050_2");
    }

/*
 * Larry Breed failures
 */
void test_breed()
    {
    auto unsigned char (*PaB0);
    auto unsigned char paB0;
    register unsigned char (*PrB0);
    auto unsigned char prB0;

    paB0 = 255;
    PaB0 = &paB0;
    (*PaB0) /= 3L;
    equal((*PaB0), 85, "breed1");

    paB0 = 255;
    PaB0 = &paB0;
    (*PaB0) /= 127L;
    equal((*PaB0), 2, "breed2");

    prB0 = 255;
    PrB0 = &prB0;
    (*PrB0) /= 3L;
    equal((*PrB0),85, "breed3");

    prB0 = 255;
    PrB0 = &prB0;
    (*PrB0) /= 127L;
    equal((*PrB0), 2,"breed4");
    }

/* This test makes sure that daylight savings time is properly
 * computed.  To run this test the environment variable TZ should be
 * appropriately set, to something like PST8PDT.  If it is not set
 * this test won't bother executing, since it's purpose is to find
 * the boundary points.
 */

#include <time.h>
dst_test() {
    /* Check that daylight savings time code works properly.
     * We scan for a period of a year, incrementing the time by
     * an hour each time.  We verify that at some
     * time the hour time skips by 2, and at another time
     * the hour time stays the same.
     */
    char *cp = getenv("TZ");
    int found_spring_forward = 0, found_fall_back = 0;
    time_t t;
    struct tm *p;
    int i, h = 100;

    if (!cp || !strstr(cp,"DT")) return;

    time(&t);

    for (i = 0; i < 24 * 365; i++) {/* loop for one year */
	p = localtime(&t);
	t += 3600;     /* add one hour */
	if (h == p->tm_hour) {
	    found_fall_back++;
	    equal(p->tm_isdst,0,"not dst");
	    /* Must fall back at 1 am -- i.e. 2 am goes to 1 am. */
	    equal(p->tm_hour,1,"back");
	    }
	else if (p->tm_hour - h > 1) {
	    found_spring_forward++;
	    equal(p->tm_isdst,1,"is dst");
	    /* Must spring forward at 3 -- i.e. 2 am goes to 3 am. */
	    equal(p->tm_hour,3,"forward");
	    }
	h = p->tm_hour;
	}
    equal(found_spring_forward,1,"dst F");
    equal(found_fall_back,1,"dst B");
    }

void based_numbers() {
#if __HIGHC__
    /* Non-ansi. */
    equal(0x2x111,7,"2x111");
    equal(0x10xff,0xff,"xff");
    equal(0xax999,999,"999");
#endif
    }

static char sorta[30];

static int bs(int lo, int hi, char c) {
    int mid = (lo+hi)/2;
    if (sorta[mid] == c) return mid;
    else if (sorta[mid] > c)
	return bs(lo,mid-1,c);
    else
	return bs(mid+1,hi,c);
    }

static int bs1(int lo, int hi, int i) {
    if (lo > hi) return bs1(hi,lo,i);
    else return bs(lo,hi,i);
    }

static void tail_recursion () {
    int i; int cnt = sizeof(sorta)/sizeof(sorta[0]);
    for (i = 0; i < cnt; i++) sorta[i] = i;
    for (i = 0; i < cnt; i++)
       equal(bs1(0,cnt-1,i),i,"bs"),equal(bs1(cnt-1,0,i),i,"bs");
    }

#if _GOC && __HIGHC__
#pragma loop_factor(3,25);
int unroll_regression(float *af, int aflength) {
    int afi;
    for (afi=0; afi<aflength && *af == 0.0; afi++, af++);
    return afi;  // return index of 1st non-zero element
    }
   
void test_unroll() {
    float af[5]={0,0,1,1,1};
    equal(unroll_regression(af,5),2,"unroll");
    }
#pragma loop_factor(0,0);
#else
void test_unroll() {}
#endif

/* This caused the unroller to bomb (!) once, so we now include it as a
 * standard test.
 */
void sieve_test() {
   static unsigned char answers[] = { 3, 5, 7, 11, 13, 17, 19, 23, 
	29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 
	89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 
	149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199};
   unsigned char *p = answers;
   #define SIZE 100
   static char Primes[SIZE+1];
   int iter,I,Count;
   ANNOUNCE1("Test sieve.");
   for (iter = 1; iter <= 1; iter++) {
      Count = 0;
      for (I = 0; I <= SIZE; I++) Primes[I] = 1;
      for (I = 0; I <= SIZE; I++)
	 if (Primes[I]) {
	    int Prime = 2*I+3;
	    int K = I+Prime;
	    while (K <= SIZE) {
	       Primes[K] = 0;
	       K += Prime;
	       }
	    Count++;
	    }
      }
   equal(Count,45,"primecount");
   for (I = 0; I <= SIZE; I++) if (Primes[I]) equal(*p++,2*I+3,"prime");
   #undef SIZE 
   }

main(int argc) {
    if (argc > 1 ) Silent = 0;
    announce("START OF TESTS, suite4");
    Initialize();
    newtests();
    inplace();
    preproc();
    #ifdef __HIGHC__
    hctests();
    test_uplevel_addressing();
    testgoto(); /*test non-local goto's*/
    testgoto2();
    testalloca();
    testgoto3();
    testcommon();
    #endif
    ANNOUNCE1("Miscellaneous tests");
    longdoub();
    test_auto_init();
    test_misalign_arg();
    test_short_to_double_conversion();
    test_narrowing();
    test_double_result();
    test_mutually_recursive_structs();
    test_memcpy();
    test_autoinc();
    test_func_decl();
    test_func_ptr();
    test_func_struct();
    test_macro_expansion();
    test_shift();
    test_ifexpr();
    test_shortcmp();
    test_icmp();
    test_multibyte();
    test_graph_analyze();
    test_mod();
    #ifndef _LOC
    test_pscope(AA);
    test_typedefs(123,0);
    post_typedef_test();
    a_complex_case(123,0);
    #endif
    test_struct_move();
    test_lstrings();
    test_Lstrings();
    test_float_arithmetic();
    test_pp_numbers();
    test_short_circuiting();
    test_init_bit_fields();
    test_large_structs();
    test_strstr();
    test_struct_init();
    test_func_two_ptr();
    test_strcpy();
    test_bit_fields();
    test_override();
    strncpy_test();
    test_more_float();
    test_050_1();
    test_050_2();
    test_breed();
    based_numbers();
    dst_test();
    tail_recursion();
    test_unroll();
    sieve_test();
    announce("END OF TESTS, suite4");
    exit(0);
    }
