/**************************************************************************
*  Copyright 1985-1993 MetaWare Incorporated.  All rights reserved.       *
*  This is an unpublished work, Copyright 1985-1993 by MetaWare           *
*  Use, disclosure, or transfer without the express written permission    *
*  of MetaWare Incorporated is strictly prohibited.                       *
*  If any or part of this source code is incorporated into other source   *
*  code not authored by MetaWare, this copyright notice must              *
*  accompany it.                                                          *
***************************************************************************
*  See file "suite0.c" for more information.                              *
**************************************************************************/
#ifndef lint
static const char rcsid[] = "$Header: /sol/test/tlib/suite_c/RCS/suite5.c,v 1.23 1993/08/06 00:56:38 kevink Exp $";
#endif

/*
 * $Log: suite5.c,v $
 * Revision 1.23  1993/08/06  00:56:38  kevink
 * ifdef'd out the call to ncr as well...
 *
 * Revision 1.22  1993/08/06  00:42:57  kevink
 * The ncr1(), etc. functions were being optimized out with -Hansi.
 *
 * Revision 1.21  1993/07/24  09:16:18  tom
 * Confound compilers that use L01 as a temp label.
 *
 * Revision 1.20  1993/07/08  01:10:56  marcusm
 * Moved unicode tests to suiteu.c
 *
 * Revision 1.19  1993/06/23  02:48:29  tom
 * New unicode tests conforming to newer set of xlation tables.
 *
 * Revision 1.18  1993/06/08  14:53:38  pickens
 * Fixed ANSI problem
 *
 * Revision 1.17  1993/06/01  17:45:22  tom
 * Fix non-ANSI coments I accidentally introduced.
 *
 * Revision 1.16  1993/05/18  06:40:09  tom
 * Add unicode tests.
 *
 * Revision 1.15  1993/04/29  08:50:41  tom
 * Add struct of 4 bytes to varargs tests for 860 BE regression
 *
 * Revision 1.14  1993/02/04  16:58:24  pickens
 * Ditto
 *
 * Revision 1.13  1993/02/04  16:56:35  pickens
 * #ifdef'd out non-ansi case for SPARC
 *
 * Revision 1.12  1993/02/03  18:43:56  pickens
 * Remove cheat for SPARC
 *
 * Revision 1.11  1992/08/04  21:10:01  tom
 * add copyright
 *
 * Revision 1.10  1992/07/30  16:19:13  pickens
 * Solaris is more strictly ANSI-conforming in stdarg.h; ifdef around code
 *
 * Revision 1.9  1992/04/23  01:13:09  tom
 * Insert #undef test
 *
 * Revision 1.8  1992/04/23  00:01:25  tom
 * Test under mask, esp. for 16-bit.
 *
 * Revision 1.7  1992/03/07  16:03:55  tom
 * Test passing lots of floats in registers and in memory.
 *
 * Revision 1.6  1991/11/27  20:19:25  tom
 * Make tests I added ANSI.
 *
 * Revision 1.5  1991/10/26  08:13:50  tom
 * Added loop boundary tests.
 *
 * Revision 1.4  1991/10/01  17:55:44  pickens
 * Fix a test that is not portable to 16-bit segmented machines.
 *
 * Revision 1.3  91/07/15  12:51:51  thomasn
 * setup_new_testlib
 * 
 * Revision 1.2  91/05/20  08:10:20  pickens
 * Make sure PCC toggle is on for such things as "extern int x; static int x;"
 * 
 * Revision 1.1  91/03/29  17:05:11  donw
 * Initial revision
 * 
 */

/* The following tests should be added. They are failures caught by
 * HCR suite when run agains new HC.
 * Use define _LOC to turn off stuff supported only by HC2x.
 */
#include "which.h"
#include "globals.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <setjmp.h>
#include <stdarg.h>
#include <errno.h>
#include <math.h>

/*
**	This file demonstrates a codegen bug in High-C 2.2p.
**	See the comments near the end of the file.  The file was
**	compiled with:
**		hc29k -S -Hanno abug.c
**	Direct COFF output has the same problem.
**	Attempts to further reduce the test by removing additional
**	assignment statements made the problem go away.
*/
#define Implies(x,y) ((!x)||y)

#if Implies(_I286,__HIGHC__)    	/* Require HIGHC if 286. */
#if _I286
_Far
/* For Intel 286 we don't enough data space to store e in the 
 * default data area.
 */
#endif
static int e[27933];

static void bd5() ;
static test_bd5()
{

	bd5() ;
	equal(e[9169],7,"bd5");
}

static void bd5() {
#if _I286
_Far
#endif
	int *ie;

	ie = e;

	ie[9034] = 9059;
	ie[9035] = 9012;
	ie[9036] = 99;
	ie[9038] = 4;
	ie[9039] = 2;
	ie[9040] = 1;
	ie[9042] = 1;
	ie[9050] = 8898;
	ie[9052] = 8936;
	ie[9054] = 8974;
	ie[9056] = 9012;
	ie[9058] = 9676;
	ie[9059] = 9039;
	ie[9060] = 100;
	ie[9062] = 9233;
	ie[9063] = 9196;
	ie[9069] = 9270;
	ie[9078] = 9159;
	ie[9079] = 54;
	ie[9082] = 53;
	ie[9083] = 5;
	ie[9091] = 13;
	ie[9093] = 55;
	ie[9108] = 12187;
	ie[9111] = 11539;
	ie[9114] = 9307;
	ie[9117] = 8382;
	ie[9143] = 9532;
	ie[9158] = 7;
	ie[9163] = 7;
	ie[9167] = 7;
	ie[9169] = 7;		/* Address saved in GR96 */
	ie[9170] = 7;
	ie[9171] = 7;
	ie[9195] = 7;
	ie[9200] = 7;
	ie[9204] = 7;
	ie[9206] = 7;
	ie[9207] = 7;
	ie[9208] = 7;
	ie[9232] = 7;
	ie[9237] = 7;
	ie[9241] = 7;
	ie[9243] = 7;
	ie[9244] = 7;
	ie[9245] = 7;
	ie[9269] = 7;
	ie[9274] = 7;
	ie[9278] = 7;
	ie[9280] = 7;
	ie[9281] = 7;
	ie[9282] = 7;
	ie[9306] = 9714;
	ie[9309] = 1;
	ie[9320] = 1;
	ie[9347] = 20309;
	ie[9349] = 1;
	ie[9365] = 1;
	ie[9370] = 1;
	ie[9373] = 9647;
	ie[9382] = 11458;
	ie[9384] = 11482;
	ie[9386] = 9483;
	ie[9408] = 9781;
	ie[9419] = 1;
	ie[9433] = 10445;
	ie[9435] = 11148;
	ie[9436] = 11094;
	ie[9447] = 1;
	ie[9462] = 1;
	ie[9484] = 1;
	ie[9499] = 9501;
	ie[9502] = 1;
	ie[9518] = 12643;
	ie[9519] = 9063;
	ie[9520] = 20371;
	ie[9522] = 330;
	ie[9525] = 1;
	ie[9526] = 9105;
	ie[9527] = 1;
	ie[9528] = 54;
	ie[9529] = 10;
	ie[9531] = 12645;
	ie[9532] = 54;
	ie[9533] = 5;
	ie[9534] = 9121;
	ie[9537] = 12651;
	ie[9538] = 42;
	ie[9539] = 9063;
	ie[9540] = 9544;
	ie[9541] = 11297;
	ie[9542] = 9544;
	ie[9544] = 5;
	ie[9547] = 9549;
	ie[9548] = 9557;
	ie[9550] = 83;
	ie[9551] = 9339;
	ie[9554] = 9554;
	ie[9555] = 1;
	ie[9556] = 9565;
	ie[9559] = 9561;
	ie[9562] = 9554;
	ie[9563] = 1;
	ie[9564] = 9573;
	ie[9566] = 32;
	ie[9567] = 20914;
	ie[9570] = 9570;
	ie[9572] = 9582;
	ie[9573] = 21;
	ie[9574] = 8;
	ie[9575] = 9570;
	ie[9578] = 9580;
	ie[9580] = 9590;
	ie[9581] = 9590;
	ie[9584] = 9586;
	ie[9587] = 9554;
	ie[9588] = 1;
	ie[9589] = 9592;
	ie[9590] = 40;
	ie[9591] = 9601;
	ie[9592] = 21;
	ie[9593] = 8;
	ie[9594] = 9570;
	ie[9597] = 9599;
	ie[9599] = 9609;
	ie[9600] = 9609;
	ie[9603] = 9605;
	ie[9606] = 9554;
	ie[9607] = 1;
	ie[9609] = 40;
	ie[9646] = 17;
	ie[9647] = 1;
	ie[9648] = 1;
	ie[9649] = 9659;
	ie[9650] = 1;
	ie[9652] = 9612;
	ie[9653] = 9629;
	ie[9675] = 9743;
	ie[9676] = 9647;
	ie[9677] = 101;
	ie[9713] = 17;
	ie[9714] = 1;
	ie[9715] = 1;
	ie[9716] = 9726;
	ie[9717] = 1;
	ie[9719] = 9679;
	ie[9720] = 9696;
	ie[9742] = 9810;
	ie[9743] = 9714;
	ie[9744] = 102;
	ie[9780] = 17;
	ie[9781] = 1;
	ie[9782] = 1;
	ie[9783] = 9793;
	ie[9784] = 1;
	ie[9786] = 9746;
	ie[9787] = 9763;
	ie[9809] = 9865;
	ie[9810] = 9781;
	ie[9811] = 103;
	ie[9827] = 7;
	ie[9828] = 1;
	ie[9829] = 1;
	ie[9830] = 9840;
	ie[9831] = 3;
	ie[9832] = 2;
	ie[9833] = 9813;
	ie[9834] = 9820;
	ie[9864] = 9913;
	ie[9865] = 9828;
	ie[9866] = 104;
	ie[9875] = 7;
	ie[9876] = 1;
	ie[9877] = 1;
	ie[9878] = 9888;
	ie[9879] = 3;
	ie[9880] = 2;
	ie[9881] = 9868;
	ie[9882] = 9820;
	ie[9912] = 9961;
	ie[9913] = 9876;
	ie[9914] = 105;
	ie[9923] = 7;
	ie[9924] = 1;
	ie[9925] = 1;
	ie[9926] = 9936;
	ie[9927] = 3;
	ie[9928] = 2;
	ie[9929] = 9916;
	ie[9930] = 9820;
	ie[9960] = 10009;
	ie[9961] = 9924;
	ie[9962] = 106;
	ie[9971] = 7;
	ie[9972] = 1;
	ie[9973] = 1;
	ie[9974] = 9984;
	ie[9975] = 3;
	ie[9976] = 2;
	ie[9977] = 9964;
	ie[9978] = 9820;
	ie[10008] = 10057;
	ie[10009] = 9972;
	ie[10010] = 107;
	ie[10019] = 7;
	ie[10020] = 1;
	ie[10021] = 1;
	ie[10022] = 10032;
	ie[10023] = 3;
	ie[10024] = 2;
	ie[10025] = 10012;
	ie[10026] = 9820;
	ie[10056] = 10105;
	ie[10057] = 10020;
	ie[10058] = 108;
	ie[10067] = 7;
	ie[10068] = 1;
	ie[10069] = 1;
	ie[10070] = 10080;
	ie[10071] = 3;
	ie[10072] = 2;
	ie[10073] = 10060;
	ie[10074] = 9820;
	ie[10104] = 10153;
	ie[10105] = 10068;
	ie[10106] = 109;
	ie[10115] = 7;
	ie[10116] = 1;
	ie[10117] = 1;
	ie[10118] = 10128;
	ie[10119] = 3;
	ie[10120] = 2;
	ie[10121] = 10108;
	ie[10122] = 9820;
	ie[10152] = 10201;
	ie[10153] = 10116;
	ie[10154] = 110;
	ie[10163] = 7;
	ie[10164] = 1;
	ie[10165] = 1;
	ie[10166] = 10176;
	ie[10167] = 3;
	ie[10168] = 2;
	ie[10169] = 10156;
	ie[10170] = 9820;
	ie[10200] = 10249;
	ie[10201] = 10164;
	ie[10202] = 111;
	ie[10211] = 7;
	ie[10212] = 1;
	ie[10213] = 1;
	ie[10214] = 10224;
	ie[10215] = 3;
	ie[10216] = 2;
	ie[10217] = 10204;
	ie[10218] = 9820;
	ie[10248] = 10297;
	ie[10249] = 10212;
	ie[10250] = 112;
	ie[10259] = 7;
	ie[10260] = 1;
	ie[10261] = 1;
	ie[10262] = 10272;
	ie[10263] = 3;
	ie[10264] = 2;
	ie[10265] = 10252;
	ie[10266] = 9820;
	ie[10296] = 10345;
	ie[10297] = 10260;
	ie[10298] = 113;
	ie[10307] = 7;
	ie[10308] = 1;
	ie[10309] = 1;
	ie[10310] = 10320;
	ie[10311] = 3;
	ie[10312] = 2;
	ie[10313] = 10300;
	ie[10314] = 9820;
	ie[10344] = 10393;
	ie[10345] = 10308;
	ie[10346] = 114;
	ie[10355] = 7;
	ie[10356] = 1;
	ie[10357] = 1;
	ie[10358] = 10368;
	ie[10359] = 3;
	ie[10360] = 2;
	ie[10361] = 10348;
	ie[10362] = 9820;
	ie[10392] = 10441;
	ie[10393] = 10356;
	ie[10394] = 115;
	ie[10403] = 7;
	ie[10404] = 1;
	ie[10405] = 1;
	ie[10406] = 10416;
	ie[10407] = 3;
	ie[10408] = 2;
	ie[10409] = 10396;
	ie[10410] = 9820;
	ie[10440] = 10531;
	ie[10441] = 10404;
	ie[10442] = 116;
	ie[10444] = 13;
	ie[10445] = 2;
	ie[10446] = 1;
	ie[10448] = 3;
	ie[10449] = 2;
	ie[10450] = 10482;
	ie[10456] = 9828;
	ie[10458] = 9876;
	ie[10460] = 9924;
	ie[10462] = 9972;
	ie[10464] = 10020;
	ie[10466] = 10068;
	ie[10468] = 10116;
	ie[10470] = 10164;
	ie[10472] = 10212;
	ie[10474] = 10260;
	ie[10476] = 10308;
	ie[10478] = 10356;
	ie[10480] = 10404;
	ie[10530] = 10622;
	ie[10531] = 10445;
	ie[10532] = 117;
	ie[10560] = 13;
	ie[10561] = 1;
	ie[10562] = 1;
	ie[10563] = 10573;
	ie[10564] = 3;
	ie[10565] = 2;
	ie[10566] = 10534;
	ie[10567] = 10547;
	ie[10621] = 10700;
	ie[10622] = 10561;
	ie[10623] = 118;
	ie[10638] = 13;
	ie[10639] = 1;
	ie[10640] = 1;
	ie[10641] = 10651;
	ie[10642] = 3;
	ie[10643] = 2;
	ie[10644] = 10625;
	ie[10645] = 10547;
	ie[10699] = 10778;
	ie[10700] = 10639;
	ie[10701] = 119;
	ie[10716] = 13;
	ie[10717] = 1;
	ie[10718] = 1;
	ie[10719] = 10729;
	ie[10720] = 3;
	ie[10721] = 2;
	ie[10722] = 10703;
	/*
	**	The code generated for the following assignment fails to set
	**	up the target address in GR96.  The result is that an earlier
	**	array element (9169) is overwritten.
	*/
	ie[10723] = 10547;
	ie[10777] = 10856;
	ie[10778] = 10717;
	ie[10779] = 120;

	ie[11030] = 1;

	} /* end of function */
#else 
static test_bd5() {}
#endif


static double xx(double d)
    {
    return d;
    }

/* Failed in am29050 compiler R2.3C */
static void test_0508(void)
    {
    double a;
    float b;
    a = xx( 10.0 );
    b = xx( 11.0 );
    dequal(a+b,21.0,0.0,"0508");
    }

static void dptr(double *p, double d)
    {
    dequal(*p,d,0.0,"dptr");
    }
/*
 * The following breaks on Sun 4
 */
static void test_misaligned_doubles(double a, double b)
    {
    dptr(&a,a);
    dptr(&b,b);
    }

/*
 * Test various combinations of moves
 */
static void test_moves(void)
    {
    int *bufa = malloc(10000);  /*ints so that memcpy's will be done inline */
    int *bufb = malloc(2000);

#   define Bufa ((char *)bufa)
#   define Bufb ((char *)bufb)
    int i;
    if (bufa==0 || bufb==0) {equal(1,0,"malloc"); return; }
    memset(bufb,'o',2000);
    memset(bufa,'X',10000);
    memcpy(bufa+16/sizeof(int),bufb,500);

    equal(Bufa[15],'X',"move1");
    equal(Bufa[16],'o',"move2");
    equal(Bufa[16+500],'X',"move3");
    equal(Bufa[16+499],'o',"move4");
    for (i=16; i<16+500;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"move5");

    memcpy(bufa+1000/sizeof(int),bufb,501);
    equal(Bufa[1000-1],'X',"move11");
    equal(Bufa[1000+501],'X',"move22");
    for (i=1000; i<1000+501;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"move33");

    memcpy(bufa+2000/sizeof(int),bufb,1502);
    equal(Bufa[2000-1],'X',"move111");
    equal(Bufa[2000+1502],'X',"move222");
    for (i=2000; i<2000+1502;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"move333");

    memcpy(bufa+4000/sizeof(int),bufb,1003);
    equal(Bufa[4000-1],'X',"M3");
    equal(Bufa[4000+1003],'X',"M3-1");
    for (i=4000; i<4000+1003;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"M3-2");

    memcpy(bufa+6000/sizeof(int),bufb,128);
    equal(Bufa[6000-1],'X',"MM3");
    equal(Bufa[6000+128],'X',"MM3-1");
    for (i=6000; i<6000+128;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"MM3-2");

    memcpy(bufa+6500/sizeof(int),bufb,133);
    equal(Bufa[6500-1],'X',"MMM3");
    equal(Bufa[6500+133],'X',"MMM3-1");
    for (i=6500; i<6500+133;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"MMM3-2");

    memcpy(bufa+7000/sizeof(int),bufb,134);
    equal(Bufa[7000-1],'X',"MMM4");
    equal(Bufa[7000+134],'X',"MMM4-1");
    for (i=7000; i<7000+134;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"MMM4-2");

    memcpy(bufa+7500/sizeof(int),bufb,135);
    equal(Bufa[7500-1],'X',"MMM5");
    equal(Bufa[7500+135],'X',"MMM5-1");
    for (i=7500; i<7500+135;i++)
	if (Bufa[i] != 'o')
	    equal(Bufa[i],'o',"MMM5-2");
    free(bufa);
    free(bufb);
    }

/*
 * Failure in AM29K 2.3E
 */
static void test_pairs(int line, double d)
    {
    float f = d;
    equal(f == 3.5F,1,"pairs");
    }

/*
 * This messed up in all optimizers that expand STRLEN in line
 */
static char name[] = "name";
static void test_pseudos()
    {
    int i = strlen(name[0]=='n'?name:"NAME1");
    equal(i,4,"strlen");
    }

static int add3(int i)
    {
    int a,b,c;
    a = b = c = i;
    return a+b+c;
    }

static void test_add3(void)
    {
    equal(3*10,add3(10),"add3");
    }

static struct struct1 { char a; } struct1 = {23};
static struct struct3 { char c,b,a; } struct3 = {-1,-2,24};
static struct struct0 { char x[9],a; } struct10 = {" ",25};

static void test_stdarg(const char *format,...)
    {
    int last = 0;
    va_list ap;
    va_start(ap,format);
    while (1){
	switch (*format++){
	    case 'c': equal(1,va_arg(ap,int),"varg1"); break;
	    case 'i': equal(2,va_arg(ap,int),"varg2"); break;
	    case 's': equal(-3,va_arg(ap,int),"varg3"); break;
	    case 'd': dequal(-2.0,va_arg(ap,double),0,"vargd"); break;
	    case 'u': equal(65535,va_arg(ap,int),"varg4"); break;
	    case 'f': dequal(1.0,va_arg(ap,double),0,"vargf"); break;
	    case 'b': equal((char)254,va_arg(ap,int),"varg5"); break;
	    case '1': {
		struct struct1 s1 = va_arg(ap,struct struct1); 
		equal(s1.a,23,"s1");
		break;
		}
	    case '3': {
		struct struct3 s3 = va_arg(ap,struct struct3); 
		equal(s3.a,24,"s3");
		break;
		}
	    case '0': {
		struct struct0 s0 = va_arg(ap,struct struct0); 
		equal(s0.a,25,"s0");
		last=1;
		break;
		}
	    case '\0': equal(last,1,"var6"); return;
	    default: equal(1,0,"var7"); break;
	    }
	}
    va_end(ap);
    }

/* Varargs test. */
/* There may be times in which you wish to test a new varargs convention
 * but are linking with a library whose printf uses an old convention.
 * In this case you will want to insert #defines to change names, where
 * applicable, after including stdarg.h.
 */
#include <stdarg.h>

/* If you don't have printf in the library yet you may wish to use
   this version: */
#if NEWVA
#define _860_ABI 1
#define _va_arg __va_arg
#include <stdio.h>
#define printf printff
   void pc(char c) {fputc(c,stdout);}
   void put_int(long i, int base) {
      /* Assume not negative; otherwise problems! */
      if (i < 0) pc('-'), put_int(-i, base);
      else if (i == 0) pc('0');
      else put_int(i / base, base), pc('0' + i % base);
      }
void printf(char *format, ...) {
   va_list ap;
   va_start(ap,format);
   char *p = format;
   for (; *p != 0; ) {
      switch (*p) {
      	 default: pc(*p++); break;
      	 case '%': {
      	    p++;
      	  RETRY: ;  
      	    switch(*p) {
      	       case 'd':
      	          put_int(va_arg(ap,int),10); p++; break;
      	       case 'x':
      	          put_int(va_arg(ap,int),16); p++; break;
      	       case 'l': {
      	          switch(p[1]) {
      	             case 'd': 
      	                put_int(va_arg(ap,long),10); p+=2; break;
      	             case 'x': 
      	                put_int(va_arg(ap,long),16); p+=2; break;
      	             }
      	          break;
      	          }
      	       case 'f': {
      	       	  union {double d; struct {long a,b;} ab; } olay;
      	       	  olay.d = va_arg(ap,double);
      	       	  pc('x');  put_int(olay.ab.a,16); 
      	       	  pc(':');  put_int(olay.ab.b,16); 
      	       	  p++;
      	       	  break;
      	       	  }
      	       case '0'..'9': {
      	          /* Field spec.  Ignore it generally. */
      	          while (*p >= '0' && *p <= '9') p++;
      	          if (*p == '.') p++;
      	          goto RETRY; 
      	          }
      	       case 's': {
      	          char * s = va_arg(ap,char *);
      	          while (*s != 0) pc(*s++);
      	          p++;
      	          break;
      	          }
      	       }
      	    }
         }	
      }
   }	
#endif 

#define Printf if (!Silent)printf

typedef struct {int first, last;} Two_word_struct;
typedef struct {int first, x,y, last;} Four_word_struct;
typedef struct {char first, x1,x2,x3, last; } Five_byte_struct;
/* Some compilers do funny things in passing small structs in registers,
   such as alignment them in weird ways.  Attempt to break such compilers. */
typedef struct {char first, x1, last; } Three_byte_struct;
typedef struct {char first, x1, last, x2; } Four_byte_struct;

/* Use P to distinguish from printf; but just in case we have a non-case-
   sensitive linker, insert the x. */

int failcnt = 0;
   
void vxPrintf(char *s, va_list ap) {
   /* This is fake printf that demonstrates that va_arg and v_start work. */
   /* We use fake macros, since the compiler needs to provide parameter-register
      usage information that we can't actually write a macro for here. */
   /* The format string is representative:  it consists of a series of
      formats of the form
        c       -- for 1-byte character.
      	d	-- for int.
      	l	-- for long.
      	F	-- for 4-byte float (yes, this is not standard).
      	f	-- for 8-byte double.
      	2	-- for 2reg = 8-byte structure, 8-byte aligned.
      	3       -- for 3-byte struct.
      	5       -- for 5-byte struct.
      	4	-- for 4reg = 16-byte structure, 8-byte aligned.
      		-- For the structures we print the first and last cell.
      	We expect to find the ordinal value of the parameter (1..#parms)
      	stored in the parameter.  For structures, the first slot is this
      	number and the last slot the negation of it.  
    */
   int cp = 0, cnt = 0;
   Printf("formatstring=%s\n",s);
   #define oops(c) printf("fail:OOPS:%c\n",c), failcnt++;
   for (;;) {
      #define NL '\n'	
      cnt++;
      if (s[cp] && s[cp] != NL && !Silent) printf("#%d:",cnt);
      switch (s[cp++]) {
         case 'c': {
            char l = va_arg(ap,char);
            /* Now print the integer. */
            Printf("%d",l);
            if (l != cnt) oops('c');
            }
            break;
         case 'd': {
            int l = va_arg(ap,int);
            /* Now print the integer. */
            Printf("%d",l);
            if (l != cnt) oops('d');
            }
            break;
         case 'l': {
            long l = va_arg(ap,long);
            /* Now print the integer. */
            Printf("%ld",l);
            if (l != cnt) oops('l');
            }
            break;
         case 'f': {
            double d = va_arg(ap,double);
            Printf("%5.2f",d);
            if (d != cnt) oops('f');
            }
            break;
         case 'F': {
            float f = va_arg(ap,float);
            Printf("%5.2f",f);
            if (f != cnt) oops('F');
            }
            break;
         case '2': {
            Two_word_struct T;
            T = va_arg(ap,Two_word_struct);
            Printf("<%d,%d>",T.first, T.last);
            if (T.first != cnt) oops('2');
            if (T.first != -T.last) oops('2');
            }
   	    break;
         case '4': {
            Four_word_struct T;
            T = va_arg(ap,Four_word_struct);
            Printf("<%d,%d>",T.first, T.last);
            if (T.first != cnt) oops('4');
            if (T.first != -T.last) printf("OOPS");
            }
   	    break;
         case '5': {
            Five_byte_struct T;
            T = va_arg(ap,Five_byte_struct);
            Printf("<%d,%d>",T.first, T.last);
            if (T.first != cnt) oops('5');
            if (T.last != (char)(-T.first)) printf("OOPS");
            }
   	    break;
         case '3': {
            Three_byte_struct T;
            T = va_arg(ap,Three_byte_struct);
            Printf("<%d,%d>",T.first, T.last);
	    equal(T.first,cnt,"OOPS3");
	    equal(T.last,(char)(-T.first),"OOPS3.");
            }
   	    break;
   	 /* Don't include the \n for testing purposes in the correspondence count. */
   	 case NL: Printf("\n"); cnt--; break; 
         case 0: Printf("\n"); return;	/* all done. */   
         default:
            printf("??");
         }
      Printf("  ");
      }
   }

void xPrintf(char *s, ...) {
   va_list ap;
   va_start(ap,s);
   vxPrintf(s,ap);
   }

#define genit(type,name) type name(int cnt) \
       { type s; s.first = cnt; s.last = -cnt; return s; }

genit(Two_word_struct,do_struct2)
genit(Four_word_struct,do_struct4)
genit(Five_byte_struct,do_struct5)
genit(Four_byte_struct,do_struct4b)
genit(Three_byte_struct,do_struct3)

#define do_long(cnt) ((long)(cnt))
#define do_int(cnt) ((int)(cnt))
#define do_char(cnt) ((char)(cnt))
#define do_double(cnt) ((double)(cnt))

void For_testing_floats(char dummy,
	int i, float f, Five_byte_struct s5, long l, ...) {
   va_list ap;
   va_start(ap,dummy);
   vxPrintf("dF5l",ap);
   }

/* Test printf with a given set of arguments. */

void test_printf() {
   xPrintf("d2fcl4",do_int(1), do_struct2(2), do_double(3), 
   	do_char(4), do_long(5), do_struct4(6)); 
   /* Now attempt to blow the register banks of some machines by passing
      lots of stuff. 14 ints/chars/longs, 7 doubles, then some structs. */
   xPrintf("ddddddd\n53cclll\nfffffff\n245\ndcl43",
      do_int(1), do_int(2), do_int(3), do_int(4),
      do_int(5), do_int(6), do_int(7), do_struct5(8),
      do_struct3(9), do_char(10), do_char(11),
      do_long(12), do_long(13), do_long(14),
      do_double(15), do_double(16), do_double(17), do_double(18),
      do_double(19), do_double(20), do_double(21),
      do_struct2(22), do_struct4(23), do_struct5(24),
      do_int(25), do_char(26), do_long(27), do_struct4(28), do_struct3(29),
      /* Regression: 4-byte structs made 860 BE fail. */
      do_struct4b(30));
#if !_SPARC	/* This test is NOT ansi conforming; SPARC fails it*/
   For_testing_floats(0,1,2,do_struct5(3),4);
#endif
   }

struct s1 {int a,b,c; } x;
void test_pstruct(struct s1 dummy, /*int i,*/ ...) {
   va_list ap;
   va_start(ap,dummy);
   equal(va_arg(ap,int),55,"test_pstruct");
   }

/* Test passing lots of single-prcision floats.  This is especially
 * interesting on big-endian machines where (a) floating-point values
 * are passed in registers and (b) the floating-point bank is stored
 * with instructions that get doubles right but reverse the floats.
 */
void lots_of_floats(
	char dummy,float f1,float f2, float f3, float f4,
	float f5, float f6, float f7, float f8,
	float m1, float m2, float m3, float m4, float m5, ...) {
    va_list ap;
    int i;
    static float expected[] = {1,2,3,4,5,6,7,8,9,10,11,12,13};
    va_start(ap,dummy);
    for (i = 0; i < sizeof(expected)/sizeof(*expected); i++) {
	float f = va_arg(ap,float);
	if (f != expected[i]) 
	    printf("OOPS: %f %f at %d\n",f,expected[i],__LINE__), failcnt++;
	}
    }

test_many_floats() { 
#if !_SPARC	/* This test is NOT ansi conforming; Solaris fails it*/
    lots_of_floats(1,
	1., 2., 3., 4., 5., 6., 7., 8., 9., 10., 11., 12., 13.);
#endif
    }

void vtest () {
   test_printf();
   test_pstruct(x,55);
   test_many_floats();
   if (failcnt==0) Printf("No failures in vtest.\n");
   }	

/*
 * The following used to fail in GOC front-end bug
 */
static void test_macro(void)
   {
   static char A='b';
#  define A 'a'
#  define ISA(a) ((a)==A)
#  define cat(a,b) (a b)
   equal(cat(ISA,('a')),1,"macroA");
#  undef ISA
#  undef cat
#  undef A
   }

/*
 * The following failed on GOC DOS when 8-byte structs are returned in 
 * registers.
 */
struct s8 {int a,b;};
static struct s8 s8_foo1(){
    struct s8 x;
    x.a = -123;
    x.b = 123;
    return x;
    }
static struct s8 s8_foo2(){
    static struct s8 x;
    return x;
    }

static void test_struct_ret(int i)
    {
    struct s8 s = i?s8_foo1():s8_foo2();
    equal(s.a,-123,"sret1");
    equal(s.b,+123,"sret2");
    }

static void test_setjmp(void)
    {
    long i;
    jmp_buf buf;
    if (setjmp(buf)){
	equal(i,0xABCDEF,"setjmp");
	}
    else{
	i = 0xABCDEF;
	longjmp(buf,1);
	}
    }

/*
 * The following failed in 68020 compiler:
 */
static int au_i,au_j;
static char *au_foo(void)
    {
    static char x[] = {1,2,3,4,5};
    return x+4;
    }
static void test_autoinc(void)
    {
    char *p = au_foo();
    p -= 4;
    au_i = *p++;
    au_j = *p++;
    equal(au_i,1,"au_i");
    equal(au_j,2,"au_j");
    }

#ifdef GOC
#pragma on(use_up_rules)
static void test_up(void)
    {
    static unsigned char uc = 1;
    equal(uc < -1, 1,"UP_UV");
    equal(uc-1 < -1, 1,"UP_UV1");
    }
#pragma pop(use_up_rules)
#endif

/*
 * This function caused optimzer to blow sky high because
 * Global CSE  mistakenly thought there was no virtual registers
 * when infact there is one.
 */
/*
 * This is ifdef'd because with Hansi the functions ncr?() get 
 * optimized out.  :-).  KBK
 */
#ifdef __HIGHC__
static void test_ncr_failure()
    {
    ncr1();
    L: ncr2();
    assert(1);
    ncr3();
    }
static int ncr1(){}
static int ncr2(){}
static int ncr3(){}
#endif

/*
 * This test showed failure of our constant folding of a double to unsigned int
 */
static void test_folding(void)
    {
    double d = -1.2;
    unsigned u = d;
    equal(d,(unsigned)(-1),"truncu");
    }

/* Following failed to compile on SPARC: */
static void test_mod()
    {
    static long x = 1234567;
    equal(x % 32768L,1234567&32767,"mod32768");
    }

static void test_wchar(void)
    {
    wchar_t w[] = L"ABC";
    static wchar_t ws[] = L"ABC";
    equal(w[0],L'A',"L_A");
    equal(w[1],L'B',"L_B");
    equal(w[2],L'C',"L_C");
    equal(w[3],L'\0',"L_D");
    equal(sizeof(w),4*sizeof(wchar_t),"Lsize");
    equal(ws[0],L'A',"L_sA");
    equal(ws[1],L'B',"L_sB");
    equal(ws[2],L'C',"L_sC");
    equal(ws[3],L'\0',"L_sD");
    equal(sizeof(ws),4*sizeof(wchar_t),"Lsizes");
    }

/* The following caused a core-dump on Sun 3: */
static void test_memcpy(void)
    {
#   if _MSDOS || _OS2
#      define NEAR _Near
#   else
#      define NEAR
#   endif
    static int q[2] = {(long)"AB",2};
    static char buf[2];
    int *p = q;
    char *a = (NEAR char*)(p+=1)[-1];  /* Make "near" to force widening if*/
					/* targeting to 286 big-model */
    int b = (p+=1)[-1];
    memcpy(buf,a,b);
    equal(buf[0],'A',"BufA");
    equal(buf[1],'B',"BufB");
    }

#ifndef _LOC
/*On GOC DOS, this fell apart all over the place: */
#pragma on(PCC)
extern int segfoo;
static void test_segbug(void) {
	equal(segfoo,0,"segfoo");
	segfoo = 1;
	}
static int segfoo = 0;
#pragma pop(PCC)
#else
static void test_segbug(void) {}
#endif

static struct tstruct {
    char  s1[2][2][2][2];
    int   s2[2][2][2][2];
    float s3[2][2][2][2];
    long  s4[2][2][2][2];
    char  s5;
    int   s6;
    float s7;
    long  s8;
    };
static struct tstruct t1 = {
    'b','c','d','e','f','g','h','i','j','k','l','m','n','o', 'p','q',
    1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597,
    .55, .89, 1.44, 2.33, 3.77, 6.10, 9.87, 1.597,
    2.584, 4.181, 6.765, 10.946, 17.711, 28.657, 46.368, 75.025,
    2584, 4181, 6765, 10946, 17711, 28657, 46368, 75025, 121393,
    196418, 317811, 514229, 832040, 1346269, 2178309, 3524578,
    'a', 9, .9, 19
    };

static void test_init(void) {
    equal(t1.s2[1][1][1][0],987,"init1");
    equal(t1.s1[1][1][1][0],'p',"init2");
    equal(t1.s1[0][0][0][1],'c',"init3");
    equal(t1.s4[1][1][1][0],2178309,"init4");
    equal(t1.s5,'a',"init5");
    equal(t1.s6,9,"init6");
    equal(t1.s8,19,"init7");
    }

/* Following failed for 386: */
static double zero = 0.0;
static void test_sincos(void)
    {
    double d = zero;
    equal(cos(d)==1.0,1,"cos(0.0)");
    equal(sin(d)==0.0,1,"sin(0.0)");
    }

#if _I387
#pragma on(ansi_fp);
#endif
static void test_math(void)
    {
#if !((_ATT && _I386) || _WEITEK)
    static double a,b,c;
    errno = 0;
    a = log(-1.0);
    equal(errno,EDOM,"log(-1)");
    errno = 0;
    sqrt(-1.0);
    equal(errno,EDOM,"sqrt(-1)");
    c = exp(999999.0);
    equal(errno,ERANGE,"exp(big)");
    errno = 0;
    exp(-999999.0);
    equal(errno,ERANGE,"exp(small)");
    asin(1.1);
    equal(errno,EDOM,"asin(1.1)");
    errno = 0;
    b = acos(-1.1);
    equal(errno,EDOM,"acos(-1.1)");
#endif
    }

static void fvoid(x) int *x;
    {
    *x = 1982;
    }
/* The following failed if inlining on: */
static void test_inline(void)
    {
    int x;
    if ( (fvoid(&x),x) != 1982 )
	equal(x,1982,"inline");
    }

/* This blew up when compiled with 386  */
static void test_memset1(char buf[])
    {
    int zero = 0;
    int ten = 10;
    int i;
    char *cp;
    i = 172;
    memset(buf,zero,i);
    cp = memset(buf+25,ten,125);
    equal(cp==buf+25,1,"memset");
    Silent++;
    for (i=0; i<25;i++)
	equal(buf[i],0,"memset1");
    for (i=25; i < 150; i++)
	equal(buf[i],10,"memset2");
    Silent--;
    }

static void test_memset(void)
    {
    char buf[300];
    test_memset1(buf);
    }

#if __HIGHC__ && !defined(_LOC)
#pragma on PCC
#define Q(x) 'x'
static void test_quote(void)
    {
    equal(Q(a),'a',"'a'");
    equal(Q(Z),'Z',"'a'");
    }
#pragma pop PCC
#endif

typedef int INT;
struct SS {
    int a:1, b:1, INT:1;
    };
#if !(_ATT && _I386)
/*
 * The following use to fail to compile
 */
static char dc[] = {1.1,2.2,-3.9};
static int di[] = {1.1,-2.2,-3.9};
static void test_string_init(void)
    {
    equal(dc[0],1,"dc1");
    equal(dc[1],2,"dc2");
    equal(dc[2],(char)-3,"dc3");
    equal(di[0],1,"di1");
    equal(di[1],-2,"di2");
    equal(di[2],-3,"di3");
    }
#endif

#define A_MACRO  1 + 2
#define A_MACRO  1 +/**/2  /*Should be a valid redefinition*/

/* Loop boundary tests, in case the compiler has attempted to 
   optimize loops in any fashion.
 */

int loop_tcnt;
#define loop_debug False
static void check(int OK, char *fname, char *kind, char *op, 
		int iterations, int cnt, int low, int high, int stride) {
    if (!OK || loop_debug) 
        printf("%6s%2s(op %2s) %s; expected=%2d actual=%2d low=%2d high=%2d "
		"stride=%2d\n",
		fname,kind,op, OK ? "OK" : "failed",iterations,cnt,
		low,high,stride);
    loop_tcnt++;
    }
int highv, lowv;
void set_high(int i) { highv = i; }
void set_low(int i) { lowv = i; }

#define testt(fname,low,high,stride,test_operator,iterations) 	\
void fname() {                                                	\
    int i,cnt; 							\
    i = low; cnt = 0;                                 		\
    while (i test_operator high) cnt++, i += stride;		\
    check(cnt == iterations,#fname,"",#test_operator,iterations,cnt,low,high,stride);\
    i = low; cnt = 0; set_high(high);				\
    while (i test_operator highv) cnt++, i += stride;          	\
    check(cnt == iterations,#fname,"hv",#test_operator,iterations,cnt,low,high,stride);\
    set_low(low); cnt = 0; set_high(high);			\
    while (lowv test_operator highv) cnt++, lowv += stride;	\
    check(cnt == iterations,#fname,"lh",#test_operator,iterations,cnt,low,high,stride);\
    }

#define testb(fname,low,high,stride,test_operator,iterations)	\
void fname() {							\
    int i,cnt;							\
    i = low; cnt = 0;						\
    do cnt++, i += stride; while (i test_operator high);	\
    check(cnt == iterations,#fname,"",#test_operator,iterations,cnt,low,high,stride);\
    i = low; cnt = 0; set_high(high);				\
    do cnt++, i += stride; while (i test_operator highv);	\
    check(cnt == iterations,#fname,"hv",#test_operator,iterations,cnt,low,high,stride);\
    set_low(low); cnt = 0; set_high(high);			\
    do cnt++, lowv += stride; while (lowv test_operator highv);	\
    check(cnt == iterations,#fname,"hv",#test_operator,iterations,cnt,low,high,stride);\
    }

#define testb2(fname,low,high,stride,test_operator,iterations)	\
void fname() {							\
    int i,cnt;							\
    i = low; cnt = 0;						\
    L: cnt++, i += stride; if (i test_operator high) goto L;	\
    check(cnt == iterations,#fname,"",#test_operator,iterations,cnt,low,high,stride);\
    i = low; cnt = 0; set_high(high);				\
    L2: cnt++, i += stride; if (i test_operator highv) goto L2;	\
    check(cnt == iterations,#fname,"hv",#test_operator,iterations,cnt,low,high,stride);\
    set_low(low); cnt = 0; set_high(high);			\
    L3: cnt++, lowv += stride; if (lowv test_operator highv) goto L3;	\
    check(cnt == iterations,#fname,"hv",#test_operator,iterations,cnt,low,high,stride);\
    }

/* # iterations given a loop with ranges [bottom,upper_open) */
/* -- i.e. the upper bound of the interval is open. */
/* #define floor(a,b) ((a)/(b)) */
int flor(int a, int b) {
    int c = a/b;
    if (c < 0 && b*c != a) c--;
    return c;
    }
#define ceil(a,b) (-flor(-(a),b))
#define closed(low,hi,inc) (flor((hi)-(low),inc)+1)
#define open(low,hi,inc) ceil((hi)-(low),inc)

testt(P1,1,10,1, < , open(1,10,1))
testt(P2,1,10,1, <=, closed(1,10,1))
testt(P3,1,10,1, > , 0)
testt(P4,1,10,1, >=, 0)
testt(P5,1,10,1, ==, 0)
testt(P6,1,10,1, !=, open(1,10,1))

testt(n1,10,1,-1, < , 0)
testt(n2,10,1,-1, <=, 0)
testt(n3,10,1,-1, > , open(10,1,-1))
testt(n4,10,1,-1, >=, closed(10,1,-1))
testt(n5,10,1,-1, ==, 0)
testt(n6,10,1,-1, !=, open(10,1,-1))

testt(p21,1,10,2, < , open(1,10,2))
testt(p22,1,10,2, <=, closed(1,10,2))
testt(p23,1,10,2, > , 0)
testt(p24,1,10,2, >=, 0)
testt(p25,1,10,2, ==, 0)
testt(p26,1,11,2, !=, open(1,11,2))	/* Avoid infinite loop: use 11. */

testt(n21,10,1,-2, < , 0)
testt(n22,10,1,-2, <=, 0)
testt(n23,10,1,-2, > , open(10,1,-2))
testt(n24,10,1,-2, >=, closed(10,1,-2))
testt(n25,10,1,-2, ==, 0)
testt(n26,11,1,-2, !=, open(11,1,-2))

testb(bp1,1,10,1, < , open(1,10,1))
testb(bp2,1,10,1, <=, closed(1,10,1))
testb(bp3,1,10,1, > , 1)
testb(bp4,1,10,1, >=, 1)
testb(bp5,1,10,1, ==, 1)
testb(bp6,1,10,1, !=, open(1,10,1))

testb(bn1,10,1,-1, < , 1)
testb(bn2,10,1,-1, <=, 1)
testb(bn3,10,1,-1, > , open(10,1,-1))
testb(bn4,10,1,-1, >=, closed(10,1,-1))
testb(bn5,10,1,-1, ==, 1)
testb(bn6,10,1,-1, !=, open(10,1,-1))

testb(bp21,1,10,2, < , open(1,10,2))
testb(bp22,1,10,2, <=, closed(1,10,2))
testb(bp23,1,10,2, > , 1)
testb(bp24,1,10,2, >=, 1)
testb(bp25,1,10,2, ==, 1)
testb(bp26,1,11,2, !=, open(1,11,2))

testb(bn21,10,1,-2, < , 1)
testb(bn22,10,1,-2, <=, 1)
testb(bn23,10,1,-2, > , open(10,1,-2))
testb(bn24,10,1,-2, >=, closed(10,1,-2))
testb(bn25,10,1,-2, ==, 1)
testb(bn26,11,1,-2, !=, open(11,1,-2))
testb(bn27,9,6,-2, >, open(9,6,-2))

testb2(b2p1,1,10,1, < , open(1,10,1))
testb2(b2p2,1,10,1, <=, closed(1,10,1))
testb2(b2p3,1,10,1, > , 1)
testb2(b2p4,1,10,1, >=, 1)
testb2(b2p5,1,10,1, ==, 1)
testb2(b2p5a,1,2,1, ==, 2)
testb2(b2p6,1,10,1, !=, open(1,10,1))

testb2(b2n1,10,1,-1, < , 1)
testb2(b2n2,10,1,-1, <=, 1)
testb2(b2n3,10,1,-1, > , open(10,1,-1))
testb2(b2n4,10,1,-1, >=, closed(10,1,-1))
testb2(b2n5,10,1,-1, ==, 1)
testb2(b2n5a,2,1,-1, ==, 2)
testb2(b2n6,10,1,-1, !=, open(10,1,-1))

testb2(b2p21,1,10,2, < , open(1,10,2))
testb2(b2p22,1,10,2, <=, closed(1,10,2))
testb2(b2p23,1,10,2, > , 1)
testb2(b2p24,1,10,2, >=, 1)
testb2(b2p25,1,10,2, ==, 1)
testb2(b2p26,1,11,2, !=, open(1,11,2))

testb2(b2n21,10,1,-2, < , 1)
testb2(b2n22,10,1,-2, <=, 1)
testb2(b2n23,10,1,-2, > , open(10,1,-2))
testb2(b2n24,10,1,-2, >=, closed(10,1,-2))
testb2(b2n25,10,1,-2, ==, 1)
testb2(b2n26,11,1,-2, !=, open(11,1,-2))


loop_boundary_tests() {
    static void (*tests[])() = {
	P1,P2,P3,P4,P5,P6,
	n1,n2,n3,n4,n5,n6,
	p21,p22,p23,p24,p25,p26,
	n21,n22,n23,n24,n25,n26,
	bp1,bp2,bp3,bp4,bp5,bp6,
	bn1,bn2,bn3,bn4,bn5,bn6,
	bp21,bp22,bp23,bp24,bp25,bp26,
	bn21,bn22,bn23,bn24,bn25,bn26,bn27,
	b2p1,b2p2,b2p3,b2p4,b2p5,b2p5a,b2p6,
	b2n1,b2n2,b2n3,b2n4,b2n5,b2n5a,b2n6,
	b2p21,b2p22,b2p23,b2p24,b2p25,b2p26,
	b2n21,b2n22,b2n23,b2n24,b2n25,b2n26,
	0};
    void (**p)() = tests;
    while (*p) (*p)(), p++;
    /* printf("%d tests executed.\n",loop_tcnt); */
    }

#define ms1(size) struct s1_##size { char   x; char a[size]; char slop; } x,y; char z;
#define ms2(size) struct s2_##size { short  x; char a[size]; char slop; } x,y; char z;
#define ms4(size) struct s4_##size { float  x; char a[size]; char slop; } x,y; char z;
#define ms8(size) struct s8_##size { double x; char a[size]; char slop; } x,y; char z;
static void init(char *a, char *b, int size) {
    int i;   
    for (i = 0; i < size; i++) a[i] = i, b[i] = 0xff;
    }
static void czech(char *b, int size, int slop, int where) {
    int i;
    for (i = 0; i < size; i++)
    	if (b[i] != i) (equal)(b[i],i,"blockmove",where);
    if (slop != 0x7e) (equal)(slop,0x7e,"slop",where);
    }
#define test(aln,size) { \
    ms##aln(size); init(x.a,y.a,size); z = 0x7e; \
    y = x; czech(y.a,size,z,__LINE__); \
    {char A[size], B[size], slop2 = 0x7e; \
    init(A,B,size); memcpy(B,A,size); czech(B,size,slop2,__LINE__); }}

test_t1() {
    test(1,1);
    test(1,2);
    test(1,3);
    test(1,4);
    test(1,5);
    test(1,6);
    test(1,7);
    test(1,8);
    test(1,9);
    test(1,10);
    test(1,11);
    test(1,12);
    test(1,13);
    test(1,14);
    test(1,15);
    test(1,16);
    test(1,100);
    }
test_t2() {    
    test(2,1);
    test(2,2);
    test(2,3);
    test(2,4);
    test(2,5);
    test(2,6);
    test(2,7);
    test(2,8);
    test(2,9);
    test(2,10);
    test(2,11);
    test(2,12);
    test(2,13);
    test(2,14);
    test(2,15);
    test(2,16);
    test(2,20);
    test(2,21);
    test(2,22);
    test(2,30);
    test(2,31);
    test(2,32);
    test(2,33);
    test(2,34);
    test(2,100);
    test(2,101);
    }
test_t4() {
    test(4,1);
    test(4,2);
    test(4,3);
    test(4,4);
    test(4,5);
    test(4,6);
    test(4,7);
    test(4,8);
    test(4,9);
    test(4,10);
    test(4,11);
    test(4,12);
    test(4,13);
    test(4,14);
    test(4,15);
    test(4,16);
    test(4,20);
    test(4,21);
    test(4,22);
    test(4,30);
    test(4,31);
    test(4,32);
    test(4,33);
    test(4,34);
    test(4,40);
    test(4,41);
    test(4,42);
    test(4,43);
    test(4,44);
    test(4,50);
    test(4,51);
    test(4,52);
    test(4,53);
    test(4,54);
    test(4,100);
    test(4,101);
    test(4,102);
    }
test_t8 () {
    test(8,1);
    test(8,2);
    test(8,3);
    test(8,4);
    test(8,5);
    test(8,6);
    test(8,7);
    test(8,8);
    test(8,9);
    test(8,10);
    test(8,11);
    test(8,12);
    test(8,13);
    test(8,14);
    test(8,15);
    test(8,16);
    test(8,20);
    test(8,21);
    test(8,22);
    test(8,30);
    test(8,31);
    test(8,32);
    test(8,33);
    test(8,34);
    test(8,40);
    test(8,41);
    test(8,42);
    test(8,43);
    test(8,44);
    test(8,50);
    test(8,51);
    test(8,52);
    test(8,53);
    test(8,54);
    test(8,100);
    test(8,101);
    test(8,102);
    test(8,103);
    test(8,104);
    test(8,105);
    test(8,106);
    test(8,107);
    }
#undef test

block_copy_tests () { test_t1(), test_t2(), test_t4(), test_t8(); }

long _0001_0002 = 0x0001_0002;
test_mask () {
    long i = _0001_0002;
    #define Z(x) ((x)==0)
    #define NZ(x) ((x)!=0)
    #define g(i) ((i==0) && (equal(__LINE__,0,"test&"),0))
    #define test(which,con,result) \
    	if which(i & con) g(result); else g(1-result);
    test(Z,0x0001_0002,0);
    test(NZ,0x0001_0002,1);
    /* 16-bits worth: */
    test(Z,0x0001_0000,0);
    test(NZ,0x0001_0000,1);
    test(Z,0x0000_0002,0);
    test(NZ,0x0000_0002,1);
    #undef Z
    #undef NZ
    #undef test
    #undef g
    }


main(int argc) {
    announce("START OF TESTS, suite5");
    Silent = argc <= 1;
    test_bd5();
    test_0508();
    test_misaligned_doubles(1.0,2.0);
    test_moves();
    test_pairs(1,3.5);
    test_pseudos();
    test_add3();
    test_stdarg("cisdufb130",(char)1,(int)2,(short)-3,
				    -2.0,
			    (unsigned short)65535,
			    1.0F,
			    (char)254,
			    struct1,
			    struct3,
			    struct10);
    test_struct_ret(1);
    vtest();
    test_macro();
    test_setjmp();
    test_autoinc();
    #ifdef GOC
    test_up();
    #endif
    #ifdef __HIGHC__
        test_ncr_failure();
    #endif
    test_folding();
    test_mod();
    test_wchar();
    if (test_wchar) 
	equal(test_mod != 0, 1,"f-cmp");
    test_memcpy();
    test_segbug();
    test_init();
    test_sincos();
    test_math();
    test_inline();
    test_memset();
    #if __HIGHC__ && !defined(_LOC)
    test_quote();
    #endif
    #if !(_ATT && _I386)
    test_string_init();
    #endif
    loop_boundary_tests();
    block_copy_tests();
    test_mask();
    announce("END OF TESTS, suite5");
    exit(0);
    }
int L01 = 1;	/* confound compilers that use L01 as temp label */
