#ifndef lint
static const char rcsid[] = "$Header: /sun3/tlib/suite_c/RCS/suite7.c,v 1.15 1994/01/25 18:32:06 miker Exp $";
#endif

/*
 * $Log: suite7.c,v $
 * Revision 1.15  1994/01/25  18:32:06  miker
 * add #define to force correct version of
 * va_args for big-endian i860 on Sys Vr3
 * (CSPI)
 *
 * Revision 1.14  1994/01/04  18:04:28  reedk
 * modificatins for va_start for NT
 *
 * Revision 1.13  1993/08/20  00:24:55  pickens
 * Turn behaved off to reset of module
 *
 * Revision 1.12  1993/08/20  00:13:33  pickens
 * Turned off behaved switch around a test that violates it
 *
 * Revision 1.11  1993/07/01  18:02:00  mj
 * took out alloca for _HOBBIT
 *
 * Revision 1.10  1993/02/17  01:57:51  marcusm
 * Avoided va_dcl usage for _MSDOS.
 *
 * Revision 1.9  1993/02/17  00:04:29  pickens
 * New tests added
 *
 * Revision 1.8  1992/12/24  22:58:49  marcusm
 * Exclude test using _sbrk on _MSNT
 *
 * Revision 1.7  1992/12/21  22:53:37  pickens
 * added 9132
 *
 * Revision 1.6  1992/12/16  23:47:15  pickens
 * NOLONGDOUBLE
 *
 * Revision 1.5  1992/08/27  21:04:53  tom
 * Inline bug.
 *
 * Revision 1.4  1992/08/21  19:36:16  mj
 * added hobbit test for struct passing.
 *
 * Revision 1.3  1992/07/31  01:13:37  tom
 * Make suite7 ANSI.
 * Improve paragraphing, which was random.
 *
 * Revision 1.2  1992/06/19  15:47:35  pickens
 * Removed // comment
 *
 * Revision 1.1  1992/06/19  00:16:11  mj
 * Initial revision
 *
 * 
 */

#if (_I860BE && _ATT)
#define __TO_WORDS 1
#endif
/*
 * The following tests should be added. They are failures caught by
 * HCR suite when run agains new HC.
 * Use define _LOC to turn off stuff supported only by HC2x.
 */
#include "which.h"
#include "globals.h"
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
#include <setjmp.h>
#include <stdarg.h>
#include <errno.h>
#include <math.h>

#ifdef NOLONGDOUBLE
# define LONG_DOUBLE double
#else
# define LONG_DOUBLE long double
#endif


/*
 * the purpose of this test is to spot-check compilers
 * that do something clever with signed integer division
 * by powers of two.
 */
static int div2147483648(x) register x; {
    return x / (int) 2147483648;
    }

static int divem(x, y) register x, y; {
    return x / y;
    }

test_div2147483648() {
    int n;
    n=0x80000000;
    equal(div2147483648(n),divem(n, 2147483648),"div2147483648");
    }


static int zero();

static void test_neg2147483648() {
    int a[300];
    int n;

    a[0] = 0x7fffffff;
    a[zero()] = a[zero()] + 1;      /* requires at least 1 temporary */
    n = a[0];
    assert(n < 0);
    n = -n;
    if (n >= 0)	/*386 failed to test result of negate*/
	equal(1,0,"neg8000...");
    else
	equal(1,1,"neg8000...");
    }

static int zero() {
    return 0;
    }
#define	SHORT_SEQ_LT(a,b)	(((short)((a)-(b))) < 0)
#define	SHORT_SSEQ_LT(a,b)	((util = (short)((a)-(b))) < 0)

static void test_short_ushort(void) {
    short util;
    unsigned short a , b;
    short c , d;

    a = c = 0x7fff;
    b = d = 0x8001;

    if (!SHORT_SEQ_LT(c,d))
	equal(1,0,"ushort");
    if (!SHORT_SSEQ_LT(c,d))
	equal(1,0,"ushort");
    equal(SHORT_SEQ_LT(a,b),1,"ushort");
    equal(SHORT_SSEQ_LT(a,b),1,"ushort");
    }

static jmp_buf state;

static void test_setjmp() {
    auto n;
    n = 0;
    if (setjmp(state) <= 2) {
	n++;
	fubar(n);
	}
    equal(n,3,"setjmp");
    }

fubar(n) {
    static int k = 0;
    equal(++k==4,0,"setjmp");
    longjmp(state,n);
    }

static void test_sbyte_ushort(void)
    {
    static signed char sc = -1;
    static unsigned short uc = -1;
    if (sizeof(short) < sizeof(int))
	equal(sc==uc,0,"sbyteushort");
    }

#pragma on(use_up_rules)
static void test_up_div(void)
    {
    signed char sc = 255;
    signed short ss;
    unsigned char uc = 255;
    unsigned short us;
    uc /= sc;	/* Should be unsigned divide of 255/0xFFFFFFFFU == 0*/
    equal(uc,0,"updivC");
    uc = 255;
    sc = -1;
    uc = uc / sc;	/* Should be unsigned divide of 255/0xFFFFFFFFU == 0*/
    equal(uc,0,"updivC");
    us = 65535;
    uc = 255;
    us = us / (signed char)uc;
    equal(us,0,"updivS");
    us = 65535;
    ss = 32767;
    us = us / (signed char)sc;
    equal(us,0,"updivS");
    }
#pragma pop(use_up_rules);


static void test_sub(void) {
    static long x = 0x7FFFFFFF;
    /* On 386, we must explicitly test the result of an ADD/SUB because
     * an overflow messes up the condition codes.
     */
    equal(x+1<0,1,"sub");
    }

static void test_bytediv(void) {
    unsigned char uc = 128;
    char c = 20;
    equal(uc /= c,6,"bytediv");
    }

#if 0

 CSR 9096 from NCR.
#endif

struct x {
    struct x	*left;
    struct x	*right;
    char		buf[100];
    } Qtr, Left, Target, Tleft;
		
static void test_9096(void) {
    Qtr.left = &Left;
    Left.left = 0;
    Left.right = 0;
    Target.left = &Tleft;
    Tleft.left = (struct x *) 1;
    Tleft.right = (struct x *) 2;
    sqlfill(&Qtr);
    }
    
sqlfill(qtr) struct x *qtr; {
    struct x	*target, *head;
    target = &Target;
    head = target->left;
    target->left = qtr->left;
    memcpy(qtr, head, sizeof(struct x));
    equal((int)qtr->left,1,"9096.1");
    equal((int)qtr->right,2,"9096.2");
    }


static void test_bug2(void)	/* failed with -Os on 386 */
    {
    auto long Bl = 14;
    auto long *pBl = &Bl;
    auto LONG_DOUBLE Ild[12];
    auto unsigned long Bul = 15;
    auto unsigned long *pBul = &Bul;
    auto signed char Isc[12];
    auto float Bf = 16;
    auto float *pBf = &Bf;
    int x_11 = 11;
    int x_1 = 1;
    int true = 1, false = 0;
    Ild[x_11] = 14;
    Isc[x_1] = 15;

    equal(*pBl == Ild[x_11], 1,"bug2");
    equal(Ild[x_11] == *pBl, 1,"bug2");
    equal(*pBul == Isc[x_1], 1,"bug2");
    equal(Isc[x_1] == *pBul, 1,"bug2");
    }

#include <assert.h>

static void test_bug3(void) {
    struct s { int :0; int x:32; };
    union { struct s s; long word; } u;
    u.word = 0x12345678;
    u.s.x=0xffffffff;
    if (u.s.x++ != 0xFFFFFFFF)
	equal(0,0xFFFFFFFF,":32.2");
    equal(u.word,0,":32.3");
    }

static void test_bit_incr(void) {
    struct s { int :0; int x:4,y:28; };
    union { struct s s; long word; } u,u1;
    u.s.y = 0;
    u.s.x=0xf;
    if (u.s.x++ != 0xF)
	equal(0,0xF,"bit++");
    equal(u.s.x,0,"bit++");
    equal(u.word,0,"bit++");
    u1.s.y = -1;
    u1.s.x = 0;
    if (u1.s.y++ != 0xFFFFFFF) equal(u.s.y-1,0xFFFFFFF,"bit+++");
    equal(u1.s.x,0,"bit++");
    equal(u1.s.y,0,"bit++");
    equal(u1.word,0,"bit++");
    }
/* test name is sunc_optimizer.1016219_O4.c */
/* failed with the option O4 because of loopmem problem. */

#if _SOL || _MSDOS || _MSNT	/*varargs clashes with stdarg on Solaris*/

#include <stdarg.h>
void test_loopmem(char *fmt,...)

#else

#include <varargs.h>

/* VARARGS */
void test_loopmem(va_alist) va_dcl
#endif
    {
    va_list argp;
    int *which;
    int flag;
    int i;

#if _SOL || _MSDOS || _MSNT
    va_start(argp,fmt);
#else
    va_start(argp);
#endif
    which = va_arg(argp, int*);

    for (i = 0; i < 10; i++) {
	flag = fun();
	if (flag && which && (*which < 0))
	   *which = i;
	}
    }

fun() { return 1; }

static char fsub0(const char *s){ return s[0]; }

static void test_macro(void)
    {
#define lpar (
#define fsub0(a) a
    (equal)(fsub0 lpar "abc" ), 'a',"macro",__LINE__);
    }
 
static unsigned char trunc_char(unsigned char x) {
    return x + 0xFF;  /* does not truncate return value Line 1*/
    }
 
static void test_trunc() {
    equal(trunc_char(1),0,"chartrunc");
    }


struct INFO {long dummy[7];};
struct PARAMETERS { int index; char *buffer; };

struct INFO * Array;
void copyFromArrayToBuffer(struct PARAMETERS *parameterPointer)
	{ struct INFO *destination;
	  struct INFO * source;
	  destination = (struct INFO *) parameterPointer ->buffer;
	  source      = &Array[parameterPointer -> index];
	  *destination = *source;
}

#pragma off(behaved)
void test_386bug(void)
    {
    struct PARAMETERS p;
    char buffer[100];
    static struct INFO a[10] = {
	{11,12,13,14,15,16,17},
	{21,22,23,24,25,26,27},
	{31,32,33,34,35,36,37},
	};
    p.buffer = buffer;
    p.index = 1;
    Array  = a;
    copyFromArrayToBuffer(&p);
    equal( ((struct INFO *)buffer)->dummy[3],24,"386bug");
    }
/*#pragma pop(behaved) -- leave it off, in case its inlined*/


void test_longdouble() {
    auto LONG_DOUBLE Jld[12][12];
    int x_11 = 11;
    int y_11 = 11;
    Jld[x_11][y_11] = 18;
    {
    auto struct {
	unsigned int b1: 1;
	unsigned int b2: 2;
	unsigned int b3: 3;
	unsigned int b4: 4;
	unsigned int b5: 5;
	unsigned int b6: 6;
	unsigned int b7: 7;
	unsigned int b8: 5;
	unsigned int b9: 4;
	unsigned int b10: 3;
	unsigned int b11: 2;
	unsigned int b12: 1;
	} K;
    K.b1 = 1;
    K.b2 = 2;
    K.b3 = 3;
    K.b4 = 4;
    K.b5 = 5;
    K.b6 = 6;
    K.b7 = 7;
    K.b8 = 5;
    K.b9 = 4;
    K.b10 = 3;
    K.b11 = 2;
    K.b12 = 1;

    {
    int true = 1, false = 0;
    le(__LINE__, false?Jld[x_11][y_11]:K.b5, 5.L);
    le(__LINE__, true?K.b5:Jld[x_11][y_11], 5.L);
    le(__LINE__, false?K.b5:Jld[x_11][y_11], 18.L);
    le(__LINE__, true?Jld[x_11][y_11]:K.b6, 18.L);
    le(__LINE__, false?Jld[x_11][y_11]:K.b6, 6.L);
    le(__LINE__, true?K.b6:Jld[x_11][y_11], 6.L);
    le(__LINE__, false?K.b6:Jld[x_11][y_11], 18.L);
    le(__LINE__, true?Jld[x_11][y_11]:K.b7, 18.L);
    le(__LINE__, false?Jld[x_11][y_11]:K.b7, 7.L);
    le(__LINE__, true?K.b7:Jld[x_11][y_11], 7.L);
    le(__LINE__, false?K.b7:Jld[x_11][y_11], 18.L);
    }}
    }

le(line, val1, val2)
    int line;
    LONG_DOUBLE val1;
    LONG_DOUBLE val2;
    {
    (equal)(val1==val2,1,"ldouble",line);
    }

#if 0

	   - A program core dumps when compiled with '-g' but
	     works  correctly when optimized.  Here is a test 
	     case:
#endif

# define BAD 1

# include <ctype.h>
		
# define tolower(c)	((c) - 'A' + 'a')
		
test_edge() {
#if !_MSDOS && !_OS2 && !_EPI && !_MSNT
    char	p;
    char	*str;
    int	i, j;

    /* find the current break location */
    i = (int) sbrk(0);
    /*printf("i is %xx\n", i);*/

    /* find the end of the page */
    if (j = (i & 4095)) i += (4096 - j);
    /*printf("i is now %xx\n", i);*/

    /* find the last byte on the page */
    str = (char *) (i - 1);
    /*printf("str contains %xx\n", *str);*/
	    
# if 1 
    /* this fails because *str uses movl, not movb */
    p = (isupper(*str) ? tolower(*str) : *str);
    equal(p,p,"edge");
# else
    /* this works no matter how it is compiled */
    if (isupper(*str))
	p = tolower(*str);
    else
	p = *str;
# endif

#endif
    }
/*****************************************************************************
				bug.c
*****************************************************************************/

typedef	float		scalar;

typedef	scalar 		mx3by3[3][3];

typedef	long			int4;
typedef	short		int2;

void mx3_viewport(int4 l, int4 r, int4 t, int4 b) { }
void	wf_charinfo(int4 *wf,char c,int2 *h,int2 *w,int2 *d) {
    *h = 14469;
    *w = 200;
    *d = 5900;
    }
void mx3_windxy(scalar l, scalar r, scalar t, scalar b, mx3by3 ct) {
    dequal(l,0.0,0.0,"l");
    dequal(r,20369,0.0,"r");
    dequal(t,14469,0.0,"t");
    dequal(b,-5900.0,0.0,"b");
    }

void	test_387() {
    mx3by3	ct;
    int2		h,w,d;
    scalar	sh,sd;
    int4		*wf;

    wf_charinfo(wf,'A',&h,&w,&d);
    mx3_viewport(20, 98, 464, 542);

    sh = h;		/* if the order of these two lines*/
    sd = d;		/* is reversed, the code compiles correctly*/

    mx3_windxy(0.0,sd+sh,sh,-sd,ct);	
		    /* sh is not pushed on the stack!!*/
		    /* a non negative sd is pushed instead*/
    }

/*
 * test boundary conditions in inplace arithmetic
 */
static int iii = 100;
static int jjj = 100;
static int kkk = 100;

static void dec_them(){
    iii += -4096;
    jjj += -32768;
    kkk += -128;
    }

static void test_4096(){
    dec_them();
    equal(iii,100-4096,"4096");
    equal(jjj,100-32768,"32768");
    equal(kkk,100-128,"128");
    }




static void test_scanf0()
    {
    /* This crept into _doscan. */
    char ver[] = "(0)";
    unsigned short version;
    sscanf(&ver[1], "%hd", &version);
    equal(version,0,"scanf0");
    }

extern double atan2(double,double);

double one() { return 1.0;};

double two() { return 2.0;};

double bad()  {
    double X = one();
    double Y = two();
    double param = atan2( Y, X );
    return param;
    } 

test_atan () {
    dequal(bad(),atan2(2.0,1.0),0.00001,"atan");
    }



long iv(long i) { return(i); }


static int ushort_func() {
    signed short ss;
    unsigned short us;
    ss = iv(-1);
    us = ss;
    return us;
    }

static void test_ushort() {
    equal(ushort_func(),65535,"ushort");
    }

#include <math.h>
double mod(double a, double b){ return a; }
static void test_atan2() {
    double d= atan2(mod(1,0),mod(0,0));
    dequal(d,atan2(1,0),0.000001,"atan2");
    }

static void dummy(int j){}
static void test_induct() {
    static unsigned limit = 100;
    unsigned i;
    int j = 0;
    for( i=1; i <= limit; i++,j++) dummy(j);
    equal(j,limit,"induct");
    }

/*
 * far-ptr call failed for 386 DOS. Added 6/30/92
 */
typedef struct of_TEST { void	(*routine)(void); } TEST;

typedef TEST _Far *LP_TEST;
int globv = 0;

void test_farptr(LP_TEST lpTest) {
    globv = 0;
    (*lpTest->routine)();
    equal(globv,100,"farptr");
    }

void routine(void){
    globv = 100;
    }

TEST fpx = {  routine };

/* End of far-ptr call test */

test_memset(){
    signed char x[100];
    memset(x,-1,100);
    memset(x,1,50);
    equal(x[50],-1,"memset");
    }

void test_more_flt() {
    static int flt_i = 1;
    dequal((double)flt_i, 1.0,0.0,"flt1");
    flt_i=5;
    dequal((double)flt_i, 5.0,0.0,"flt2");
    }

int test_ddiv() {
    auto short x[4];
    auto float y[4];
    auto LONG_DOUBLE Ald=2;

    y[0]=4; y[0] /= Ald;
    if (y[0] != 2.0) dequal(y[0],2.,0.0,"two");
    y[0]=4; y[0] /= Ald;
    if (y[0] != 2.0) dequal(y[0],2.0,0.0,"4/2");
    }

void test_fcmp() {
    struct {
	    char c;
	    } F;
    double Ad = 17;
    LONG_DOUBLE Ald = 18;
    F.c = 7;
    equal(F.c <= Ad, 1,"fcmp.1");
    equal(Ad <= F.c, 0,"fcmp.2");
    if (F.c <= Ad); else equal(1,0,"fcmp.3");
    if (Ad <= F.c) equal(2,1,"fcmp.4");
    equal(F.c <= Ald, 1, "fcmp.5");
    equal(Ald <= F.c, 0, "fcmp.6");
    if (F.c <= Ald); else equal(5,4,"fcmp.7");
    if (Ald <= F.c) equal(6,7,"fcmp.8");
    if (F.c <= Ald); else equal(7,8,"fcmp.9");
    if (Ald <= F.c) equal(8,9,"fcmp.10");
    }

/*
 * Added 7/29/92. CSR 9104 (from NCR)
 */
aliasing() {
    static int i = 0;
    char arr[20];
    char arr1[20];
    arr[0] = 0;
    arr[i] = 100;
    {char *p=i?arr1:arr;
    if (*p==100) return *p;
    p[1]++;
    return -1;
    }
    }

test_aliasing() { equal(aliasing(),100,"alias"); }

/*
 * The following failed to compile due to a front-end bug
 */
static test_ptr()
{
static int i = 1;
static void *p;
static void *q = (void *)123;
p = i?q:(printf("FAILED!\n"),0);
equal((int)p,123,"ptr");
}

char Fb(x,y) char x,y; { return x+y; }
static void test_inplace_mpy(void)
    {
    auto double pad0, pad1;
    auto char (*PFab0)();
    auto double (*Pad0), (*Pad1);

    pad0 = -1.00000000000000000000000000000;
    Pad0 = &pad0;
    PFab0 = Fb;
    (*Pad0) *= (*PFab0)(63, 64);
    dequal((*Pad0), -127.0,0.0,"*=");
    }


static double mylog (double x){

	double a,b,s,y;
	register n;
	int i;

	if(x > 1) return -mylog(1/x);
	if(x == 1) return 0;
	y = 1/x;
	a = 1;
	n = -1;
	while(a < y) {
		a *= 2;
		n++;
	}
	x *= a/2;
	x -= 1;
	s = b = x;
	for (i = 2; fabs(b) >= fabs(s) * 1e-15; ) {
		b *= -x;
		s += b/i++;
	}
	return s - n*0.6931471805599453094;
}


void test_log() {
	register long q = 0;
	register long i;
	double x,y,z;

	for (i = -150; i < 150; i++) {
		x = pow(3., i*.04);
		y = mylog(x);
		z = log(x);
		dequal(y,z,1e-10,"log");

		y /= 2.3025850929940456840;
		z = log10(x);
		dequal(y,z,1e-10,"log10");
	}
}

struct bitss {
     signed int i8:8;
     signed int i9:8;
     signed int i16:16;
     } bits = {255,255,65535};

void test_bitfields()
    {
    lequal(bits.i8,-1,"i8");
    lequal(bits.i16,-1,"i16");
    }

void test_float_again()
    {
     register char rb0;
     register float rf0;
     register double rd0;
    
    
     rd0 = -1.00000000000000000000000000000000000;
     rb0 = 127;
     rd0 = rd0 + rb0;
     dequal(rd0, 126.0,0.0,"flt1");
    
     rd0 = 0.50000000000000000000000000000000000;
     rb0 = 127;
     rd0 = rd0 + rb0;
     dequal( rd0, 127.5,0.0,"flt2");
    
     rd0 = -1.00000000000000000000000000000000000;
     rb0 = 127;
     rd0 = rd0 +  (char) rb0;
     dequal( rd0, 126.0,0.0,"flt3");
    
     rd0 = 0.50000000000000000000000000000000000;
     rb0 = 127;
     rd0 = rd0 +  (char) rb0;
     dequal( rd0, 127.5,0.0,"flt4");
    
     rd0 = -1.00000000000000000000000000000000000;
     rf0 = 0.50000000000000000000000000000000000;
     rd0 = rd0 +  (char) rf0;
     dequal(rd0, -1.0, 0.0,"flt5");
    }

static void test_and()
{
static long l = 0xAAAAAA00;
long m;
if ( (m = l  & 0xFFFFFF00) == 0) equal(1,0,"and");
}





/*
 * This failed on hobbit, because the called routine didn't think a
 * hidden struct result address was passed when one was.
 */
enum Color {red, green};
struct foo {
	enum Color foo1;
	enum Color foo2;
};
struct foo proc (struct foo mem)
{
	if(mem.foo1 < green) {
		mem.foo2 = red;
	}
	return mem;
}
	
test_struct_args()
{
	struct foo abc, xyz;
	abc.foo1 = red;
	abc.foo2 = green;

	xyz = proc (abc);
	equal(xyz.foo2,red,"struct args");
}

test_bits()
    {
    struct O{
	char a;
	unsigned char b:1,c:1,d:1,e:1;
	int f:2;
	char h:1,i:1;
	short g;
	} x;
    equal(sizeof(x),4,"bits");
    equal(offsetof(struct  O,g),2,"bits");
    }

void atan_bug(double user[]) {
    double x,y, angle_r;
    angle_r = atan2(user[5] - user[1], user[4] -user[0]);
    dequal(0.127510,angle_r,0.00001,"atan2");
    }

void test_atan2_again() {
   double angler_r, user[8], x = 0.25, y = 0.33;
   user[5] = .3;
   user[1] = .25;
   user[4] = .77;
   user[0] = .38;
   atan_bug(user);
   angler_r = atan2(y,x);
   dequal(0.922464,angler_r,0.000001,"atan2");
   }

#if __HIGHC__
_Inline void zinline(int *p){}
void Xvoid(int i,...){}	// Be sure it's not inlined.
break_inline () {
    int v;
    // Old inliner made bad assumption that comma nodes always had a value.
    int x = ((Xvoid(1),zinline(&v)),1);
    }
#else
break_inline () {}
#endif

/*
# ANSI  2.2.4.1  Translation Limits   Sec2/2_4_1/P20045.c
# Note:  This passes if string is L"aa"; the concatenation seems 
#         to be the problem
*/

#include <stddef.h>

static int wf(wchar_t * wstr);


test_LL()	/* Make sure this compiles */
{
equal(wf( L"a" L"a"),0,"LL");
}

static int wf(wchar_t * wstr)
{
equal(L'a',wstr[1],"LL");
return 0;
}

#include <float.h>

test_divmul()
{
   double x, y, z;
   x = 1. / 3;
   y = x * FLT_RADIX;
   z = y / FLT_RADIX;
   dequal(x,z,0.0,"*/");
}


test_wide(void)
{
equal(L"\x12" L"3" [1], L'3',"wide");
equal(L"pqr" L"tuv" [6], L'\0',"wide.1");
equal(L"pqrs" L"tuvw" [8], L'\0',"wide.2");
}

#include <string.h>

#define str(x) #x

/*
# ANSI  3.8.3.2 The # operator  Sec3/8_3_2/P31109.c
#  Standard states that all White Space should be reduced to 1 space,
#  this includes EOL.
*/

test_preproc(void)
{
   /*
    * Testing # with a new-line within the string.
    */
   int b = strcmp("one--> <-- new-line", str(one-->
<-- new-line));
   if (b)
	printf("Expected (%s), got (%s)\n",
         "one--> <-- new-line",
         str(one-->
<-- new-line));
   equal(b,0,"preproc");
}

static void test_char(void)
    {
    if ((char) (-1) < 0){
	equal('\xff',-1,"char");
	equal((char)-1,-1,"char");
	equal('\xff' < 0,1,"char");
	}
    else{
	equal('\xff',(unsigned char)-1,"char");
	equal((unsigned char)-1,(char)-1,"char");
	equal((unsigned char)-1,(char)0xFFFFF,"char");
	equal((unsigned char)-1,255,"char");
	}
    }

/*
 *********** START OF TEST OF LDBL_MANT_DIG
 *
*/

#include <float.h>

LONG_DOUBLE radpow( int );
LONG_DOUBLE power( int, int );

static void test_ldig(void)
{

LONG_DOUBLE x,y,z;

x = radpow(LDBL_MANT_DIG);
y = x + 1.;
z = y - x;

equal(z==1.,0,"MANTDIG");
/*if (z == 1.) 
   printf ("FAILED:  LONG_DOUBLE mantissa bad size."); */
}

LONG_DOUBLE power(int base, int n)
{
   int i;
   LONG_DOUBLE x = 1;

   if (n >= 0)
      for (i = 0; i < n; ++i)
         x *= base;
   else
      for (i = 0; i < -n; ++i)
         x /= base;

   return(x);
}

LONG_DOUBLE radpow(int n)
{
       return(power(FLT_RADIX,n));
}

/*********** END OF TEST OF LDBL_MANT_DIG*/

void test_leps()
{

  LONG_DOUBLE x,y,z;

   x = LDBL_EPSILON;
   x /= FLT_RADIX;
   y = 1 + x;
   z = y - 1;
   equal(z != 0 && z != LDBL_EPSILON,0,"EPS");
#if 0
   if (z != 0 && z != LDBL_EPSILON)
   {
	printf("FAIL:  LONG_DOUBLE epsilon too large\n");
	printf("FAIL:  z is %f\n",z);
   }
#endif
}

/*
 * Make sure compilers doesn't make wrong assumptions about
 * memcpy when inlining it.
 */
typedef struct Double { double d; } DT;
static void Double_copy(DT *dest, DT *src)
    {
    memcpy((char *)dest,(char *)src,sizeof(*dest));
    }

static void test_memcpy(void)
    {
    static char d[sizeof(DT)+1] = "XABCDEFGH";
    static char s[sizeof(DT)+1] = "xabcdefgh";
    Double_copy((DT*)(d+1),(DT*)(s+1));
    equal(strcmp(d,"Xabcdefgh"),0,"memcpy");
    }
struct ifss {short x,y;}nulls = {1,2},nullt={3,4};

struct ifss *ifptr(){
	return &nullt;
	}

static sscmp(struct ifss a, struct ifss b)
    {
    equal(a.x,b.x,"ifss");
    equal(a.y,b.y,"ifss");
    }

test_ifstruct(){
    static int i = 1;
    sscmp(nullt,i?*ifptr():nulls);
    }

/*
 * the following was broken on 386. Added October 2, 1992 by JDP
 */
test_CSR9116(){
    char a[20]= {1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9,0};
    char b[10] = {1,2,3,4,5,6,7,8,9,0};
    char *b1 = "123456789";
    
    char i = 'a';
    int j = 0;
    j = strlen(b1);
    memset(a, i, j);
    sequal(a,"aaaaaaaaa","9116.1");
    memset(a, i, strlen(b1));
    sequal(a,"aaaaaaaaa","9116.2");
    }

/*
 * The following wouldn't compile on 386. Added October 15, 1992 by JDP
 */
static test_CSR9118()
{
static long x,y=0x10ABCDEF;
x = y / 0x10000000;
y = y % 0x10000000;
equal(x,1,"divmod1");
equal(y,0xABCDEF,"divmod2");
}

static void test_misaligned()
    {
    typedef struct { char file,col; unsigned short line; } source_reference;
    typedef struct ttab_entry{
	long int a;
	/* This links types with same reps.  Also, for freed ttab nodes, */
	/* this links the free nodes.*/
	long int b;
	long int c;
	short tname;
	source_reference where;	/* Where type was declared.  Only for some.*/
	unsigned int stabno;	/* Associated stab number (debug output)*/
	}T;
    static T x  = {1,2,3,4,{100,200,300}};
    T *xp = &x;
    source_reference S = xp->where;
    equal(S.line,300,"sref");
    }

/*

This program illustrates a bug in the High C compiler.  Under ANSI-C
value-preserving rules, the division should be performed as:

	(int)255 / (int)65535

yielding a result of 0.  (Even under the old K&R promotion rules, the
result should be 0.)  However, the compiler generates a 16-bit signed
division, yielding a result of 255/-1 = -255 = 0xff01.  Truncation of
the result to unsigned char then gives a value of 1.

I believe that the problem lies in the library routines that build the
HLIL expression trees.  Here is the output from -Hon=opt_input:

ASSIGN  [kids=2] tc=unsigned len=1  su=1 &=81107a0 
. VAR  tc=unsigned var=9  ucQuotient common unsigned flags=0x0 su=0 &=8110838 
. UCVT  [kids=1] tc=unsigned len=1  tc=int len=2 su=1 &=81107b8 
. . DIVS  [kids=2] tc=int len=2  su=1 &=81107d4 
. . . UCVT  [kids=1] tc=unsigned len=2  tc=unsigned len=1 su=0 &=8110804 
. . . . VAR  tc=unsigned var=7  ucDividend export unsigned flags=0x0 su=0 &=8110820 
. . . VAR  tc=unsigned var=8  usDivisor export unsigned flags=0x0 su=0 &=81107ec 

As you can see, the tree is already incorrect when it comes out of the
front end.  This bug also occurs when using the SNI front end with the
ULS-to-HLIL converter.  What those two front ends have in common is the
library that builds the HLIL trees.


*/


unsigned char   ucDividend = 255;
unsigned short  usDivisor = 65535;
unsigned char	ucQuotient;

test_baddiv()
{
    ucQuotient = ucDividend / usDivisor;

    equal(ucQuotient,0,"baddiv");
}

test_shiftcast(void)
	{
	unsigned char c = 1;
	int count;
	for (count = 0; c; c <<= 1, ++count) ;
	equal(count,8,"shiftcast");
	}

static int longswitch(val)
int val;
{
 switch(val){
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		case 40:
		case 41:
		case 42:
		case 43:
		case 44:
		case 45:
		case 46:
		case 47:
		case 48:
		case 49:
		case 50:
		case 51:
		case 52:
		case 53:
		case 54:
		case 55:
		case 56:
		case 57:
		case 58:
		case 59:
		case 60:
		case 61:
		case 62:
		case 63:
		case 64:
		case 65:
		case 66:
		case 67:
		case 68:
		case 69:
		case 70:
		case 71:
		case 72:
		case 73:
		case 74:
		case 75:
		case 76:
		case 77:
		case 78:
		case 79:
		case 80:
		case 81:
		case 82:
		case 83:
		case 84:
		case 85:
		case 86:
		case 87:
		case 88:
		case 89:
		case 90:
		case 91:
		case 92:
		case 93:
		case 94:
		case 95:
		case 96:
		case 97:
		case 98:
		case 99:
		case 100:
		case 101:
		case 102:
		case 103:
		case 104:
		case 105:
		case 106:
		case 107:
		case 108:
		case 109:
		case 110:
		case 111:
		case 112:
		case 113:
		case 114:
		case 115:
		case 116:
		case 117:
		case 118:
		case 119:
		case 120:
		case 121:
		case 122:
		case 123:
		case 124:
		case 125:
		case 126:
		case 127:
		case 128:
		case 129:
		case 130:
		case 131:
		case 132:
		case 133:
		case 134:
		case 135:
		case 136:
		case 137:
		case 138:
		case 139:
		case 140:
		case 141:
		case 142:
		case 143:
		case 144:
		case 145:
		case 146:
		case 147:
		case 148:
		case 149:
		case 150:
		case 151:
		case 152:
		case 153:
		case 154:
		case 155:
		case 156:
		case 157:
		case 158:
		case 159:
		case 160:
		case 161:
		case 162:
		case 163:
		case 164:
		case 165:
		case 166:
		case 167:
		case 168:
		case 169:
		case 170:
		case 171:
		case 172:
		case 173:
		case 174:
		case 175:
		case 176:
		case 177:
		case 178:
		case 179:
		case 180:
		case 181:
		case 182:
		case 183:
		case 184:
		case 185:
		case 186:
		case 187:
		case 188:
		case 189:
		case 190:
		case 191:
		case 192:
		case 193:
		case 194:
		case 195:
		case 196:
		case 197:
		case 198:
		case 199:
		case 200:
		case 201:
		case 202:
		case 203:
		case 204:
		case 205:
		case 206:
		case 207:
		case 208:
		case 209:
		case 210:
		case 211:
		case 212:
		case 213:
		case 214:
		case 215:
		case 216:
		case 217:
		case 218:
		case 219:
		case 220:
		case 221:
		case 222:
		case 223:
		case 224:
		case 225:
		case 226:
		case 227:
		case 228:
		case 229:
		case 230:
		case 231:
		case 232:
		case 233:
		case 234:
		case 235:
		case 236:
		case 237:
		case 238:
		case 239:
		case 240:
		case 241:
		case 242:
		case 243:
		case 244:
		case 245:
		case 246:
		case 247:
		case 248:
		case 249:
		case 250:
		case 251:
		case 252:
		case 253:
		case 254:
		case 255:
		case 256:
		     return(val);
           }
    return -1;
  }

static void test_longswitch(void)
    {
    equal(longswitch(256),256,"switch");
    equal(longswitch(257),-1,"switch");
    }

static void test_livedead() 
    {
    typedef struct s { int  size; }s;
    int b= 0; void * A[1000]; s * p; 
    p = ( s * ) & A [ ( ( ( b == 0 ) ? 1 : 2 ) ) + 1 ]; 
    p -> size = 112; 
    /* Whoa!  Delete this line and the code works. */
    A [ 0 ] = p; 
    equal(p->size,112,"livedead");
    }

static void test_ifstruct2()
    {
    struct s { char a,b; short c; double d; };
    static struct s y={1,2,3,4.0},z={0,0,0,0.0};
    struct s x;
    x = 1?y:z;
    equal(x.a,1,"ifstruct2");
    equal(x.c,3,"ifstruct2");
    dequal(x.d,4.0,0.0,"ifstruct2");
    }

#if __HIGHC__
typedef void T(int)!;
static void test_elambda()
{
int uplevel = 0;
int uplevel1 = 0;
void func1(int x)
    {
    equal(uplevel,456,"efunc");
    equal(x,123,"efunc");
    }
T func(){
    uplevel1 += 925;
    return func1;
    }
uplevel = 456;

func()(123);
equal(uplevel1,925,"efunc.1");
}

#endif


/*
 * The following test was added 12/16/92. It formerly core-dumped
 * at runtime when compiled for 386
 */
#ifndef _HOBBIT
#include "alloca.h"

static int fa(), ga();

static void test_alloca(void) {
    register int i;
    int j;

    i = 5;
    j = fa(i);
    equal(i*j,30,"alloca");
}

static int fa(x)
register int x; {

    int *p, i;
    register double a;

    a = 6;
    p = (int*) alloca(x*sizeof (long));
    for(i = 0; i < x; i++) p[i] = a*(i+1);
    return ga(p, x)/(int) (a*x);
}

static int ga(q, x)
int *q, x;
{
    char *c;

    c = alloca(9);
    c[0] = 6;
    c[1] = q[4];
    c++;
    return *c * c[4-x];
}
#endif

/*
 * CSR 9132 (reported by AMD)
 * General optimizer bug.
 */
void Test2(Word)
    register long *Word;
    {
	while ( (*(Word ++)) -- != 0 );
	equal(*Word,56,"word1");
	equal(Word[-1],-1,"word2");
    }

void test_9132()
{
long x[] = { 10,9,8,7,0,56 };
Test2(x);
}
/*
 * Added 1/4/93 by DP
 * Failed if structs mapped into registers.
 */
struct ifs {int a,b; };
static void receive_ifs(struct ifs a, struct ifs b, char *msg)
    {
    equal(a.a,b.a,msg);
    equal(a.b,b.b,msg);
    }

static struct ifs struct3foo(struct ifs x);
void test_ifstruct3()
{
static int flag = 1;
static int flag1 = 1;
struct ifs s1 = {1,2};
struct ifs s2 = {3,4};
struct ifs s5 = {6,7};
struct ifs s3 = flag?s1:s2;
struct ifs s4 = !flag?s1:(flag1?s2:s5);
static struct ifs ss = {0xdead,0xbeef};
equal(s3.a,1,"ifstruct3");
equal(s3.b,2,"ifstruct3");
equal(s4.a,3,"ifstruct3");
equal(s4.b,4,"ifstruct3");
receive_ifs(flag1?s1:s2,s1,"struct3.1");
receive_ifs(!flag1?s1:s2,s2,"struct3.2");
receive_ifs(!flag1?s1:struct3foo(s2),s2,"struct3.3");
receive_ifs(flag1?s1:struct3foo(s2),s1,"struct3.4");
receive_ifs(flag1?ss:s1,ss,"struct3.5");
receive_ifs(!flag?ss:s1,s1,"struct3.6");
}
static struct ifs struct3foo(struct ifs x) { return x; }

struct b3 {char a,b,c; };
static struct b3 foo3byte(struct b3 s)
    {
    s.a++;
    s.b++;
    s.c++;
    return s;
    }
static void test_3byte()
    {
    struct b3 t,u;
    t.a = 10;
    t.b = 20;
    t.c = 30;
    u = foo3byte(t);
    equal(u.a,11,"3byte.1");
    equal(u.b,21,"3byte.2");
    equal(u.c,31,"3byte.3");
    equal(t.c,30,"3byte.4");
    equal(t.a,10,"3byte.4");
    }

/*
 * This messed up in 2.5 because of initialation lists being put out
 * that reference variables before "VARDEF" seend
 */
extern char *table[];

static char xx[4];
static char yy[4]="yyy";

char *table[] = {xx,yy,0};

test_xinit()
    {
    equal((int)table[0],(int)xx,"xx");
    equal((int)table[1],(int)yy,"xx");
    }

/*
 * Mean test of preprocessor. Took 8 hours to fix our preprocessor to 
 * properly take this!
 * Added 2/3/93 by JDP.
 */

#define append(a,b) helpAppend(a,b)
#define helpAppend(a,b) a##b

#define lpar (
#define rpar )

#define make_yes_(arg) helpMake_yes_(arg)

#define helpMake_yes_(dummyArg) not_yes_

#define not_yes_(dummyArg) no_

#define foo(x) hello

void test_preproc1()
    {
#define String(a) #a
#define Str(a) String(a)

    char a[] = Str(make_yes_(a rpar lpar b));
    char b[] = Str(append(foo lpar x rpar,yy));
    char c[] = String(foo lpar x rpar);
    char d[] = Str(foo lpar x rpar);
    char e[] = Str(append(make_yes_(a rpar lpar b), c));
    sequal(a,"no_","a");
    sequal(b,"helloyy","b");
    sequal(c,"foo lpar x rpar","c");
    sequal(d,"hello","d");
    sequal(e,"no_c","e");
    }

/*
 * test induction variable analysis
 */


#define  SIZE      511
#define  CLASSMAX  3
#define  TYPEMAX   12
#define  D         8

char   piececount[CLASSMAX+1];
char   class[TYPEMAX+1];
short  piecemax[TYPEMAX+1];
char   puzzl[SIZE+1];
char   p[TYPEMAX+1][SIZE+1];
short  m, n;
long   kount;



char fit (char i, short j)
{
   long k;
   for (k = 0; k <= piecemax[i]; k++)
      if (p[i][k] && puzzl[j + k])
	 return (0);
   return (1);
}


short place (char i, short j)
{
   long k;
   for (k = 0; k <= piecemax[i]; k++)
      if (p[i][k])
	 puzzl[j + k] = 1;
   piececount[class[i]]--;
   for (k = j; k <= SIZE; k++)
      if (!puzzl[k])
	 return (k);
   return (0);
}


void delete (char i, short j)
{
   long k;
   for (k = 0; k <= piecemax[i]; k++)
      if (p[i][k])
	 puzzl[j + k] = 0;
   piececount[class[i]]++;
}


char trial (short j)
{
   long i, k;

   kount = kount + 1;
   for (i = 0; i <= TYPEMAX; i++)
      if (piececount[class[i]] != 0)
	 if (fit (i, j)) {
	    k = place (i, j);
	    if (trial (k) || k == 0)
	       return (1);
	    delete (i, j);
	    }
   return (0);
}

static void oops(int i,int line)
    {
    (equal)(i+1,i,"induct",line);
    }

void test_induct1()
{
   long i, j, k, m;

   for (m=0; m<=SIZE; m++)
      puzzl[m] = 1;

   for (i=1; i<=5; i++)
   for (j=1; j<=5; j++)
   for (k=1; k<=5; k++)
       puzzl[i + D * (j + D * k)] = 0;

   for (i=0; i<=TYPEMAX; i++)
   for (m=0; m<=SIZE; m++)
      p[i][m] = 0;

   for (i=0; i<=3; i++)
   for (j=0; j<=1; j++)
   for (k=0; k<=0; k++)
      p[0][i + D * (j + D * k)] = 1;

   class[0] = 0;
   piecemax[0] = 3 + D * 1 + D * D * 0;

   for (i=0; i<=1; i++)
   for (j=0; j<=0; j++)
   for (k=0; k<=3; k++)
      p[1][i + D * (j + D * k)] = 1;

   class[1] = 0;
   piecemax[1] = 1 + D * 0 + D * D * 3;

   for (i=0; i<=0; i++)
   for (j=0; j<=3; j++)
   for (k=0; k<=1; k++)
      p[2][i + D * (j + D * k)] = 1;

   class[2] = 0;
   piecemax[2] = 0 + D * 3 + D * D * 1;

   for (i=0; i<=1; i++)
   for (j=0; j<=3; j++)
   for (k=0; k<=0; k++)
      p[3][i + D * (j + D * k)] = 1;

   class[3] = 0;
   piecemax[3] = 1 + D * 3 + D * D * 0;

   for (i=0; i<=3; i++)
   for (j=0; j<=0; j++)
   for (k=0; k<=1; k++)
      p[4][i + D * (j + D * k)] = 1;

   class[4] = 0;
   piecemax[4] = 3 + D * 0 + D * D * 1;

   for (i=0; i<=0; i++)
   for (j=0; j<=1; j++)
   for (k=0; k<=3; k++)
      p[5][i + D * (j + D * k)] = 1;

   class[5] = 0;
   piecemax[5] = 0 + D * 1 + D * D * 3;

   for (i=0; i<=2; i++)
   for (j=0; j<=0; j++)
   for (k=0; k<=0; k++)
      p[6][i + D * (j + D * k)] = 1;

   class[6] = 1;
   piecemax[6] = 2 + D * 0 + D * D * 0;

   for (i=0; i<=0; i++)
   for (j=0; j<=2; j++)
   for (k=0; k<=0; k++)
      p[7][i + D * (j + D * k)] = 1;

   class[7] = 1;
   piecemax[7] = 0 + D * 2 + D * D * 0;

   for (i=0; i<=0; i++)
   for (j=0; j<=0; j++)
   for (k=0; k<=2; k++)
      p[8][i + D * (j + D * k)] = 1;

   class[8] = 1;
   piecemax[8] = 0 + D * 0 + D * D * 2;

   for (i=0; i<=1; i++)
   for (j=0; j<=1; j++)
   for (k=0; k<=0; k++)
      p[9][i + D * (j + D * k)] = 1;

   class[9] = 2;
   piecemax[9] = 1 + D * 1 + D * D * 0;

   for (i=0; i<=1; i++)
   for (j=0; j<=0; j++)
   for (k=0; k<=1; k++)
      p[10][i + D * (j + D * k)] = 1;

   class[10] = 2;
   piecemax[10] = 1 + D * 0 + D * D * 1;

   for (i=0; i<=0; i++)
   for (j=0; j<=1; j++)
   for (k=0; k<=1; k++)
      p[11][i + D * (j + D * k)] = 1;

   class[11] = 2;
   piecemax[11] = 0 + D * 1 + D * D * 1;

   for (i=0; i<=1; i++)
   for (j=0; j<=1; j++)
   for (k=0; k<=1; k++)
      p[12][i + D * (j + D * k)] = 1;

   class[12] = 3;
   piecemax[12] = 1 + D * 1 + D * D * 1;

   piececount[0] = 13;
   piececount[1] = 3;
   piececount[2] = 1;
   piececount[3] = 1;
   m = 1 + D * (1 + D * 1);
   kount = 0;
   if (fit (0, m))
      n = place (0, m);
   else
      oops(1,__LINE__);

   if (!trial (n))
      oops(2,__LINE__);
   else 
       equal(kount,2005,"induct");
}

/*
 * With options -Hi and -O1, the test_inline3() test below generated
 * incorrect code that core-dumped.
 *
 * Added 2/17/93 by D.P.
 */

confuse (a,b)
{
   int i;

   for (i = 0; i < 10; i++)
      if (i > 10)
	 confuse (a,b);
}


int patat;
int a[] = { 0,1,2,3 };

static void do_it ()
{
   register r1,r2;

   r2 = 3;
   r1 = 0;
   confuse (r1,r2);
   r2 = r1;
   patat = ( (r2 == a[r2]) ? 1 : 0);
}

test_inline3()
{
   do_it();
   equal(patat,1,"inline3");
}



/*
    Following test case generated incorrect code  when compiled with -486
    and Use_frame_pointer toggle turned off.
    Added 2/18/93 by D.P. (CSR 20048)
*/
#if _I386
#pragma Off(Use_frame_pointer)
#endif
extern int ivalue(int i);
void test_frame()
	{
	int iarray[10], *pi = iarray, i, j, k;
	int i3d[2][3][4];
	i3d[1][0][0] = 12;
	i3d[1][2][0] = 20;
	i3d[1][2][3] = 23;

	i = ivalue(1);
	j = ivalue(2);
	k = ivalue(3);
	pi = (int *)i3d[i];
	equal(*pi, 12,"frame.1");
	pi = (int *)i3d[i][j];
	equal(*pi, 20,"frame.2");

	pi = (int *)((((char *)i3d + i*48) + j*16) + k*4);    /*problem*/

	equal(*pi, 23,"frame.3");

	equal((long)(i3d+2), (long)&i3d[i][j][k+1],"frame.4");
	equal((long)i3d[i][j], (long)&i3d[1][2][0],"frame.5");
	equal((long)(i3d[i][j]+1), (long)&i3d[1][2][1],"frame.6");
	}
int ivalue(int i){ return i; }
#if _I386
#pragma Pop(Use_frame_pointer)
#endif

/*
# ANSI  3.8.4 LINE CONTROL 
#  __FILE__ should be set equal to FNAME, but FNAME is not getting substituted
#  in the #define only LINE gets substituted.  Run with -P to see a very 
#  interesting #line directive in the .i file.  Must be bug in the preprocessor.
#
#  NOTE:  Requiring use of -Hsrc is NOT an option.  The ANSI starnadrd 
#         clearly states that all occurrences of a character string following
#         number in a #line directive cause __FILE__ to be set equal to
#         that character string.
*/

test_line(void)
{
      int i;
#     define   NUMBER   2000
#     define   FNAME "file.c"
#     line NUMBER FNAME
      i = __LINE__;
      equal(i,2000,"line");
      equal(strcmp(__FILE__,"file.c"),0,"file");
      if (i != 2000 || strcmp(__FILE__,"file.c")) {
printf("FAILED: i is %d should be 2000,  __FILE__ is %s should be file.c\n",
        i, __FILE__);
      }
#     undef NUMBER
#     undef FNAME
}


/*
 * Bug in %f format of printf.  -1 was passed to memcpy as length
 * causing coredump.
 */
test_printf()
{
	char buf[256];
	union{
		double d;
		long l[2];
	} double_trouble;

	int a = 1;
	if (*((char *)&a) == 1)		/* little endian */
	    {
	    double_trouble.l[1] = 0x3FB3F7CE;
	    double_trouble.l[0] = 0xE0000000;
	    }
	else
	    {
	    double_trouble.l[0] = 0x3FB3F7CE;
	    double_trouble.l[1] = 0xE0000000;
	    }
	sprintf(buf, "%.1f", double_trouble.d);
}


main(int argc) {
    announce("START OF TESTS, suite7");
    Silent = argc <= 1;
    #if ANNOUNCE_TESTS
    #define Z(x) (printf("%s\n",#x), x)
    #else
    #define Z(x) x
    #endif
    Z(test_div2147483648());
    Z(test_neg2147483648());
    Z(test_short_ushort());
    Z(test_setjmp());
    Z(test_sbyte_ushort());
    Z(test_up_div());
    Z(test_sub());
    Z(test_bytediv());
    Z(test_9096());
    Z(test_bug2());
    Z(test_bug3());
    Z(test_bit_incr());
    Z(test_loopmem(0,0));
    Z(test_macro());
    Z(test_trunc());
    Z(test_386bug());
    Z(test_longdouble());
    Z(test_edge());
    Z(test_387());
    Z(test_4096());
    Z(test_atan());
    Z(test_ushort());
    Z(test_atan2());
    Z(test_induct());
    Z(test_farptr(&fpx));
    Z(test_memset());
    Z(test_more_flt());
    Z(test_ddiv());
    Z(test_fcmp());
    Z(test_aliasing());
    Z(test_ptr());
    Z(test_inplace_mpy());
    Z(test_log());
    Z(test_bitfields());
    Z(test_float_again());
    Z(test_and());
    Z(test_struct_args());
    Z(test_bits());
    Z(test_atan2_again());
    Z(break_inline());
    Z(test_LL());
    Z(test_divmul());
    Z(test_wide());
    Z(test_wide());
    Z(test_preproc());
    Z(test_line());
    Z(test_char());
    Z(test_ldig());
    Z(test_leps());
    Z(test_memcpy());
    Z(test_ifstruct());
    Z(test_CSR9116());
    Z(test_CSR9118());
    Z(test_misaligned());
    Z(test_baddiv());
    Z(test_shiftcast());
    Z(test_longswitch());
    Z(test_livedead());
    Z(test_ifstruct2());
#if __HIGHC__
    Z(test_elambda());
#endif
    Z(test_printf());
#ifndef _HOBBIT
    Z(test_alloca());
#endif
    Z(test_9132());
    Z(test_ifstruct3());
    Z(test_3byte());
    Z(test_xinit());
    Z(test_preproc1());
    Z(test_induct1());
    Z(test_inline3());
    Z(test_frame());
    announce("END OF TESTS, suite7");
    exit(0);
    }
