//******************************************************************************
//
//	File:		main.h
//
//	Description:	Header file for text editor program.
//
//	Written by:	David Ramsey
//
//	Copyright 1993, Be Incorporated
//
//	Change History:
//
//	9/6/92		ehk	new today
//	11/08/93	jdr	started hacking
//
//******************************************************************************
 
#ifndef __EDITOR__
#define __EDITOR__

#ifndef INTERFACE_KIT_H
#include "InterfaceKit.h"
#endif

#ifndef OPEN_H
#include "open.h"
#endif

#define kWindowH 630
#define kWindowV 550
/*------------------------------------------------------------*/
/* Those are the menu item id's of the main window	      */

#define	ABOUT	1
#define	QUIT	2
#define	CUT	3
#define	COPY	4
#define	PASTE	5
#define	DELETE	6
#define	LEFT	7
#define	RIGHT	8
#define	CENTER	9
#define	SINGLE	10
#define	DOUBLE	11
#define	AUTO	13
#define	WRAP	14
#define	NEW	15
#define	OPEN	16
#define	SAVE	17
#define	SAVEAS	18
#define SELECTALL 19
#define NINE	20
#define TEN	21
#define TWELVE	22
#define FOURTEEN	23
#define EIGHTEEN	24
#define TWENTY		25
#define TWENTYFOUR	26
#define SEARCH		27
#define REPLACE 	28
#define FINDAGAIN	29
#define JUMPTOP		30
#define JUMPBOTTOM	31

//----------------------------------------------------
// Custom version of FileOpenWindow
//----------------------------------------------------
class MySFDialog : public FileOpenWindow{
public:
		MySFDialog( char *title, bool save );
		
virtual void 	FileOpened(long volID, long dirID, char *fileName);
virtual void 	FileSaved(long volID, long dirID, char *fileName);
};

//----------------------------------------------------
// Custom version of BTextView with search capability
//----------------------------------------------------

class MyTextView : public BTextView {
public:
		char	*fSearchString;
		bool	fCaseSensitive;
		
		MyTextView(BRect *frame, char *name, BRect *textRect,
				long resizeMode, long flags);
virtual bool	SearchFor( char *target, long startPosition, short direction );
virtual bool	ParcelDropped( BParcel *parcel );
	void	CaseSensitive( bool option );
};

/*------------------------------------------------------------*/
/* This is the main window definition. We need to override the*/
/* close handle_menu routine to respond to menu items	      */
/*------------------------------------------------------------*/

class	TDocWindow : public BWindow {
public:
		MyTextView*	fEditView;
		TMenuBar*	fMenuBar;
		long		fTextSize;
		ulong		checksum;	// Checksum for doc
		long		fDirID;		// Where this file...
		long		fVolID;		// lives.
		
		TDocWindow(char* fileName, BRect *bound, window_type type, long flags, char *name);
virtual	void	CommandReceived(BCommandEvent *an_event);
virtual	void	CloseRequested( void );
	ulong	ComputeChecksum( void );
	bool	Dirty( void );
	bool	OKToOpenOrQuit( void );
	void	OpenFile( void );
	void	PutFile( void );
	void	SaveFile( char* fileName );
	void	Find( void );
};

#endif
