//-----------------------------------------------------------------
//
// File: Modal.cpp
// Date: 11/10/93
// Auth: jdr
//-----------------------------------------------------------------
#ifndef __MODAL__
#include "modal.h"
#endif

#ifndef	_EVENT_H
#include "Event.h"
#endif

#include <stdio.h>
#include <string.h>

bool AskUser( char *text )
{
	BRect		theBounds;
	TConfirmDialog	*theConfirmDialog;
	bool		result;
			
	theBounds.Set(100,100,450,200);
	theConfirmDialog = new TConfirmDialog(&theBounds, text);
	theConfirmDialog->Show();
	while (theConfirmDialog->fPressed == 1)
		sleept(10);
	result = theConfirmDialog->fPressed;
	theConfirmDialog->Close();
	return result;
}

void TellUser( char *text )
{
	BRect		theBounds;
	TMessageDialog	*theMessageDialog;
			
	theBounds.Set(100,100,450,200);
	theMessageDialog = new TMessageDialog(&theBounds, text);
	theMessageDialog->Show();
	while (theMessageDialog->fPressed == 1)
		sleept(10);
	theMessageDialog->Close();
}

bool GetFileName( char *text, char *fileName)
{
	BRect		theBounds;
	TSFDialog	*theSFDialog;
	bool		result;
	long		tLength;
			
	theBounds.Set(100,100,450,200);
	theSFDialog = new TSFDialog(&theBounds, text, fileName);
	theSFDialog->Show();
	while (theSFDialog->fPressed == 1)
		sleept(10);
	result = theSFDialog->fPressed;
	tLength = theSFDialog->fFileName->TextLength();
	strncpy(fileName, theSFDialog->fFileName->Text(), tLength);
	*(fileName + tLength) = 0;
	theSFDialog->Close();
	if ( result != 0 )
		return TRUE;
	else
		return FALSE;
//	return ( result == 0 );		Why doesn't this work?
}

//-------------------------------------------------------------------
// T M E S S A G E D I A L O G
//-------------------------------------------------------------------
void TMessageDialog::TMessageDialog( BRect *bounds, char *message) :
		     BWindow(bounds, "", MODAL_WINDOW, NOT_MOVABLE | NOT_RESIZABLE)
{
	BButton	*theButton;
	TStaticTextView		*thePrompt;
	BRect	*theRect;			// Junk rect used to init views
	char	*OK = "OK";
	const short	kButtonfHeight = 20;
	const short	kButtonfWidth = 60;
	
	fPressed = 1;	// No button pressed yet
	fWidth = bounds->right - bounds->left;
	fHeight = bounds->bottom - bounds->top;
		
	//
	// We want the "OK" button to be positioned at
	// the bottom right of the dialog, whatever size it is
	//
	theRect = new BRect(fWidth - kButtonfWidth - 10,
			   fHeight - kButtonfHeight - 10,
			   fWidth - 10, fHeight - 10);
	theButton = new BButton(theRect, OK, OK, -1l);
	this->AddChild(theButton);

	// Now add the message
	theRect = new BRect(20,10,fWidth - 20, 25);
	thePrompt = new TStaticTextView(theRect, message);
	this->AddChild(thePrompt);
	
};

//---------------------------------------------------------------
bool TMessageDialog::FilterKeyDown( ulong* key )
{
	switch ( *key )
	{
		case RETURN : this->fPressed = -1;	// Same as pressing OK
		default: return TRUE;
	}
} 

//---------------------------------------------------------------
void TMessageDialog::CommandReceived(BCommandEvent *an_event)
{
	this->fPressed = an_event->what;
}	

//-------------------------------------------------------------------
// T C O N F I R M D I A L O G
//-------------------------------------------------------------------
void TConfirmDialog::TConfirmDialog( BRect *bounds, char *message) :
		     TMessageDialog( bounds, message )
{
	BButton	*theButton;
	BRect	*theRect;			// Junk rect used to init views
	char	*Cancel = "Cancel";
	const short	kButtonfHeight = 20;
	const short	kButtonfWidth = 60;
		
	// Now do the "Cancel" button...
	theRect = new BRect(fWidth - (2 * kButtonfWidth) - 20,
			   fHeight - kButtonfHeight - 10,
			   fWidth - kButtonfWidth - 20, fHeight - 10);
	theButton = new BButton(theRect, Cancel, Cancel, 0l);
	this->AddChild(theButton);
	
};

//---------------------------------------------------------------
bool TConfirmDialog::FilterKeyDown( ulong* key )
{
	switch ( *key )
	{
		case RETURN : this->fPressed = -1;	// Same as pressing OK
			      return FALSE;
		case ESCAPE : this->fPressed = 0;	// Same as pressing Cancel
			      return FALSE;
		default: return TRUE;
	}
} 
			
//-------------------------------------------------------------------
// T S F D I A L O G
//-------------------------------------------------------------------
void TSFDialog::TSFDialog (BRect *bounds, char *message, char *fileName) :
		     TMessageDialog( bounds, message )
{
	TFileNameView	*theFile;
	BRect		*theRect;	// Junk rect used to init views
	BRect		*textRect;
	BScrollView	*theScrollView;

	//
	// Create the BTextView for the user to enter the file name
	//
	theRect = new BRect(20,30,fWidth - 20,45);
	textRect = new BRect(0,0,100,20);
	theFile = new TFileNameView(theRect, "FN", textRect, FOLLOW_NONE, WILL_DRAW);
	this->fFileName = theFile;	// For easy reference
	theScrollView = new BScrollView("Hooter",theFile);
	this->AddChild(theScrollView);
	theFile->SetText( fileName, strlen( fileName) );
	theFile->SelectAll();
	theFile->MakeFocus();
};
	

//-------------------------------------------------------------------
// T F I L E N A M E V I E W
//-------------------------------------------------------------------
void TFileNameView::TFileNameView( BRect *frame, char *name, BRect *textRect,
				   long resizeMode, long flags ) :
		    BTextView( frame, name, textRect, resizeMode, flags )
{
};

//-------------------------------------------------------------------
bool TFileNameView::AcceptsChar( ulong aChar )
{
	if ( aChar == 0x0a )
		return FALSE;
	else
		return TRUE;
//	return !( aChar == 0x0A );  // Disallow C/R
};

//-------------------------------------------------------------------
// T S T A T I C T E X T V I E W
//-------------------------------------------------------------------
void TStaticTextView::TStaticTextView( BRect *bounds, char *msg) :
		      BView( bounds, "ST", FOLLOW_NONE, WILL_DRAW)
{
	text = msg;
}

//-----------------------------------------------------------------
void TStaticTextView::BecomeAttached()
{
	SetFontName("csbl____.pfb");  // TrueType fonts have problems with spaces
	SetFontSize(12);
}

//-----------------------------------------------------------------
void TStaticTextView::Draw( BRect *updateRect)
{
	BRect	bounds;
	
	GetBounds( &bounds );
	MovePenTo(BPoint(5,11));
	DrawString(this->text);
}
