//------------------------------------------------------------------
//
// A quick hack to give me some basic modal dialog functionality
//
// First cut: 11/10/93 	jdr
//------------------------------------------------------------------
#ifndef __MODAL__
#define __MODAL__
 
#ifndef	_EVENT_H
#include "Event.h"
#endif

#ifndef INTERFACE_KIT_H
#include "InterfaceKit.h"
#endif

//
// Global routines to simplify interface to modal dialogs
//
extern "C" {
bool	AskUser( char *text );
void	TellUser( char *text );
bool	GetFileName( char *text, char *fileName );
};

//--------------------------------------------------------------
// This view is just the "static text" view (in Mac parlance)
// that we use to display prompts in dialogs.
//--------------------------------------------------------------
class TStaticTextView : public BView{
public:
		TStaticTextView( BRect *bounds, char *msg );
virtual void	Draw( BRect *updateRect );
virtual void	BecomeAttached( void );

private:
	char	*text;
};

//--------------------------------------------------------------
class TMessageDialog : public BWindow {
friend class TConfirmDialog;
friend class TSFDialog;
public:
		TMessageDialog( BRect *bounds, char *message );
virtual	void	CommandReceived(BCommandEvent *an_event);
virtual bool	FilterKeyDown( ulong* key );
	long	fPressed;
private:
	short	fWidth;	// For convenience
	short 	fHeight;
};

//-------------------------------------------------------------
// This a generic "OK/cancel" dialog. It takes one argument, a
// static text item displayed for the user, and provides "OK" 
// and "Cancel" buttons. You use this to ask the user questions
// such as "Do you really want to quit without saving this file?"
//--------------------------------------------------------------

class TConfirmDialog : public TMessageDialog {
friend class TSFDialog;
public:
		TConfirmDialog( BRect *bounds, char *message );
virtual bool	FilterKeyDown( ulong* key );
};

//--------------------------------------------------
// This version of BTextView disallows the inclusion
// of carriage returns in the text.
//--------------------------------------------------
class TFileNameView : public BTextView {
public:
		      TFileNameView( BRect *frame, char *name, 
		      		     BRect *textRect, long resizeMode,
		      		     long flags);
virtual bool AcceptsChar( ulong aChar );
};

//---------------------------------------------------------------
// This is the definition for the save/load file dialog. It's
// modal, so we have to implement CommandReceived for it. It
// returns TRUE if the user pressed "OK" and FALSE if he presses
// "Cancel".
//---------------------------------------------------------------
class TSFDialog : public TMessageDialog {
public:
		TSFDialog( BRect *bounds, char *message, char*fileName );
	BTextView	*fFileName;
};

#endif